L 1 "progSpi.c"
N/*===========================================================================*/
N/* This software is provided under the following                             */
N/* License Agreement:                                                        */
N/*===========================================================================*/
N/* THIS PROGRAM IS PROVIDED "AS IS". TI MAKES NO WARRANTIES OR               */
N/* REPRESENTATIONS, EITHER EXPRESS, IMPLIED OR STATUTORY,                    */
N/* INCLUDING ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS              */
N/* FOR A PARTICULAR PURPOSE, LACK OF VIRUSES, ACCURACY OR                    */
N/* COMPLETENESS OF RESPONSES, RESULTS AND LACK OF NEGLIGENCE.                */
N/* TI DISCLAIMS ANY WARRANTY OF TITLE, QUIET ENJOYMENT, QUIET                */
N/* POSSESSION, AND NON-INFRINGEMENT OF ANY THIRD PARTY                       */
N/* INTELLECTUAL PROPERTY RIGHTS WITH REGARD TO THE PROGRAM OR                */
N/* YOUR USE OF THE PROGRAM.                                                  */
N/*                                                                           */
N/* IN NO EVENT SHALL TI BE LIABLE FOR ANY SPECIAL, INCIDENTAL,               */
N/* CONSEQUENTIAL OR INDIRECT DAMAGES, HOWEVER CAUSED, ON ANY                 */
N/* THEORY OF LIABILITY AND WHETHER OR NOT TI HAS BEEN ADVISED                */
N/* OF THE POSSIBILITY OF SUCH DAMAGES, ARISING IN ANY WAY OUT                */
N/* OF THIS AGREEMENT, THE PROGRAM, OR YOUR USE OF THE PROGRAM.               */
N/* EXCLUDED DAMAGES INCLUDE, BUT ARE NOT LIMITED TO, COST OF                 */
N/* REMOVAL OR REINSTALLATION, COMPUTER TIME, LABOR COSTS, LOSS               */
N/* OF GOODWILL, LOSS OF PROFITS, LOSS OF SAVINGS, OR LOSS OF                 */
N/* USE OR INTERRUPTION OF BUSINESS. IN NO EVENT WILL TI'S                    */
N/* AGGREGATE LIABILITY UNDER THIS AGREEMENT OR ARISING OUT OF                */
N/* YOUR USE OF THE PROGRAM EXCEED FIVE HUNDRED DOLLARS                       */
N/* (U.S.$500).                                                               */
N/*                                                                           */
N/* Unless otherwise stated, the Program written and copyrighted              */
N/* by Texas Instruments is distributed as "freeware".  You may,              */
N/* only under TI's copyright in the Program, use and modify the              */
N/* Program without any charge or restriction.  You may                       */
N/* distribute to third parties, provided that you transfer a                 */
N/* copy of this license to the third party and the third party               */
N/* agrees to these terms by its first use of the Program. You                */
N/* must reproduce the copyright notice and any other legend of               */
N/* ownership on each copy or partial copy, of the Program.                   */
N/*                                                                           */
N/* You acknowledge and agree that the Program contains                       */
N/* copyrighted material, trade secrets and other TI proprietary              */
N/* information and is protected by copyright laws,                           */
N/* international copyright treaties, and trade secret laws, as               */
N/* well as other intellectual property laws.  To protect TI's                */
N/* rights in the Program, you agree not to decompile, reverse                */
N/* engineer, disassemble or otherwise translate any object code              */
N/* versions of the Program to a human-readable form.  You agree              */
N/* that in no event will you alter, remove or destroy any                    */
N/* copyright notice included in the Program.  TI reserves all                */
N/* rights not specifically granted under this license. Except                */
N/* as specifically provided herein, nothing in this agreement                */
N/* shall be construed as conferring by implication, estoppel,                */
N/* or otherwise, upon you, any license or other right under any              */
N/* TI patents, copyrights or trade secrets.                                  */
N/*                                                                           */
N/* You may not use the Program in non-TI devices.                            */
N/*===========================================================================*/
N
N/**============================================================================
N*@file progSpi.c
N*@desc This file contains code to program the Atmel 25LC640 SPI Eeprom on PADK with
N*      data generated by TMS320C672xx bootloader genAIS utility.
N*
N*      genAis -i blinkLed4.out -o blinkLed4.ais -bootmode spimaster -otype ascii
N*
N*==============================================================================
N* Copyright (C) 2004-2005 Texas Instruments Incorporated. 
N* Use of this software us controlled by the terms and conditions found in the
N* license agreement under which this software has been supplied
N*=============================================================================*/
N
N#include <stdio.h>
L 1 "C:/CCStudio_v3.1/C6000/cgtools_530/include/stdio.h" 1
N/*****************************************************************************/
N/* STDIO.H v5.3.0                                                            */
N/* Copyright (c) 1993-2005 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDIO 
N#define _STDIO
N
N#include <linkage.h>
L 1 "C:/CCStudio_v3.1/C6000/cgtools_530/include/linkage.h" 1
N/*****************************************************************************/
N/* linkage.h   v5.3.0                                                        */
N/* Copyright (c) 1998-2005 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _LINKAGE
N#define _LINKAGE
N
N/*--------------------------------------------------------------------------*/
N/* Define _CODE_ACCESS ==> how to call RTS functions                        */
N/*--------------------------------------------------------------------------*/
N#ifndef _FAR_RTS
N#define _CODE_ACCESS
N#elif _FAR_RTS == 0
S#define _CODE_ACCESS near
S#else
S#define _CODE_ACCESS far
N#endif
N
N/*--------------------------------------------------------------------------*/
N/* Define _DATA_ACCESS ==> how to access RTS global or static data          */
N/*--------------------------------------------------------------------------*/
N#define _DATA_ACCESS far
N
N/*--------------------------------------------------------------------------*/
N/* Define _IDECL ==> how inline functions are declared                      */
N/*--------------------------------------------------------------------------*/
N#ifdef _INLINE
S#define _IDECL static __inline
S#define _IDEFN static __inline
N#else
N#ifdef __cplusplus
S#define _IDECL extern "C" _CODE_ACCESS
N#else
N#define _IDECL extern _CODE_ACCESS
N#endif
N#define _IDEFN _CODE_ACCESS
N#endif
N
N#endif /* ifndef _LINKAGE */
L 9 "C:/CCStudio_v3.1/C6000/cgtools_530/include/stdio.h" 2
N#include <stdarg.h>
L 1 "C:/CCStudio_v3.1/C6000/cgtools_530/include/stdarg.h" 1
N/*****************************************************************************/
N/* stdarg.h   v5.3.0                                                         */
N/* Copyright (c) 1993-2005 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDARG
N#define _STDARG
N
N#ifdef __cplusplus
Snamespace std
S{
N#endif
N   typedef char *va_list;
N#ifdef __cplusplus
S}
N#endif
N
N/********************************************************************/
N/* WARNING - va_arg will not work for "float" type, must use double */
N/* ALSO NOTE THAT DOUBLES MUST BE DOUBLE WORD ALIGNED               */
N/********************************************************************/
N#define va_end(_ap)
N  
N#define va_start(_ap, _parmN) 					 \
N         (_ap = ((char *)__va_parmadr(_parmN)) + 		 \
N	  	(__va_argref(_parmN) ? sizeof(&_parmN) : 	 \
N	   		(sizeof(_parmN) < 4 ? 4 : sizeof(_parmN))))
X#define va_start(_ap, _parmN) 					          (_ap = ((char *)__va_parmadr(_parmN)) + 		 	  	(__va_argref(_parmN) ? sizeof(&_parmN) : 	 	   		(sizeof(_parmN) < 4 ? 4 : sizeof(_parmN))))
N
N#ifdef _BIG_ENDIAN
S#define va_arg(_ap, _type)                                       \
S	(__va_argref(_type) 					 \
S	 ? ((_ap += 4), (**(_type **)(_ap-4))) 			 \
S         : ((sizeof(_type) == sizeof(double)                     \
S             ? ((_ap = (char *)(((int)_ap + 7) & ~7)),           \
S	        (_ap += 8), (*(_type *)(_ap - 8)))               \
S             : ((_ap += 4), (*(_type *)(_ap - (sizeof(_type))))))))
X#define va_arg(_ap, _type)                                       	(__va_argref(_type) 					 	 ? ((_ap += 4), (**(_type **)(_ap-4))) 			          : ((sizeof(_type) == sizeof(double)                                  ? ((_ap = (char *)(((int)_ap + 7) & ~7)),           	        (_ap += 8), (*(_type *)(_ap - 8)))                            : ((_ap += 4), (*(_type *)(_ap - (sizeof(_type))))))))
N#else
N#define va_arg(_ap, _type)                                       \
N	(__va_argref(_type) 					 \
N	 ? ((_ap += 4), (**(_type **)(_ap - 4))) 		 \
N         : ((sizeof(_type) == sizeof(double)                     \
N             ? ((_ap = (char *)(((int)_ap + 7) & ~7)),           \
N	        (_ap += 8), (*(_type *)(_ap - 8)))               \
N             : ((_ap += 4), (*(_type *)(_ap - 4))))))
X#define va_arg(_ap, _type)                                       	(__va_argref(_type) 					 	 ? ((_ap += 4), (**(_type **)(_ap - 4))) 		          : ((sizeof(_type) == sizeof(double)                                  ? ((_ap = (char *)(((int)_ap + 7) & ~7)),           	        (_ap += 8), (*(_type *)(_ap - 8)))                            : ((_ap += 4), (*(_type *)(_ap - 4))))))
N#endif
N
N#ifdef __cplusplus
S
S#ifndef _CPP_STYLE_HEADER
Susing std::va_list;
S#endif /* _CPP_STYLE_HEADER */
S
N#endif /* __cplusplus */
N
N#else
S
S#ifdef __cplusplus
S
S#ifndef _CPP_STYLE_HEADER
Susing std::va_list;
S#endif /* _CPP_STYLE_HEADER */
S
S#endif /* __cplusplus */
S
N#endif /* _STDARG */
L 10 "C:/CCStudio_v3.1/C6000/cgtools_530/include/stdio.h" 2
N
N#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdio> IS RECOMMENDED OVER <stdio.h>.  <stdio.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
N#endif
N
N/****************************************************************************/
N/* TYPES THAT ANSI REQUIRES TO BE DEFINED                                   */
N/****************************************************************************/
N#ifndef _SIZE_T
N#define _SIZE_T
Ntypedef __SIZE_T_TYPE__ size_t;
Xtypedef unsigned size_t;
N#endif
N
Ntypedef struct {
N      int fd;                    /* File descriptor */
N      unsigned char* buf;        /* Pointer to start of buffer */
N      unsigned char* pos;        /* Position in buffer */
N      unsigned char* bufend;     /* Pointer to end of buffer */
N      unsigned char* buff_stop;  /* Pointer to last read char in buffer */
N      unsigned int   flags;      /* File status flags (see below) */
N} FILE;
N
N#ifndef _FPOS_T
N#define _FPOS_T
Ntypedef int fpos_t;
N#endif /* _FPOS_T */
N
N/****************************************************************************/
N/* MACROS THAT DEFINE AND USE FILE STATUS FLAGS                             */
N/****************************************************************************/
N#define _IOFBF       0x0001
N#define _IOLBF       0x0002
N#define _IONBF       0x0004
N#define _BUFFALOC    0x0008
N#define _MODER       0x0010
N#define _MODEW       0x0020
N#define _MODERW      0x0040
N#define _MODEA       0x0080
N#define _MODEBIN     0x0100
N#define _STATEOF     0x0200
N#define _STATERR     0x0400
N#define _UNGETC      0x0800
N#define _TMPFILE     0x1000
N
N#define _SET(_fp, _b)      (((_fp)->flags) |= (_b))
N#define _UNSET(_fp, _b)    (((_fp)->flags) &= ~(_b))
N#define _STCHK(_fp, _b)    (((_fp)->flags) & (_b))
N#define _BUFFMODE(_fp)     (((_fp)->flags) & (_IOFBF | _IOLBF | _IONBF))
N#define _ACCMODE(_fp)      (((_fp)->flags) & (_MODER | _MODEW))
N
N/****************************************************************************/
N/* MACROS THAT ANSI REQUIRES TO BE DEFINED                                  */
N/****************************************************************************/
N#define BUFSIZ          256 
N
N#define FOPEN_MAX       _NFILE
N#define FILENAME_MAX    256  
N#define TMP_MAX         65535
N
N#define SEEK_SET  (0x0000)
N#define SEEK_CUR  (0x0001)
N#define SEEK_END  (0x0002)
N
N#ifndef NULL
N#define NULL 0
N#endif
N
N#ifndef EOF
N#define EOF    (-1)
N#endif
N
N#define stdin     (&_ftable[0])      
N#define stdout    (&_ftable[1])
N#define stderr    (&_ftable[2])
N
N#define L_tmpnam  (sizeof(P_tmpdir) + 15)
N
N/******** END OF ANSI MACROS ************************************************/
N
N#define P_tmpdir        ""                   /* Path for temp files         */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED DATA STRUCTURES AND MACROS                     */
N/****************************************************************************/
N#define _NFILE          10                   /* Max number of files open    */
N
Nextern _DATA_ACCESS FILE _ftable[_NFILE];
Xextern far FILE _ftable[10];
Nextern _DATA_ACCESS char _tmpnams[_NFILE][L_tmpnam];
Xextern far char _tmpnams[10][(sizeof("") + 15)];
N
N/****************************************************************************/
N/*   FUNCTION DEFINITIONS  - ANSI                                           */
N/****************************************************************************/
N/****************************************************************************/
N/* OPERATIONS ON FILES                                                      */
N/****************************************************************************/
Nextern _CODE_ACCESS int     remove(const char *_file);
Xextern  int     remove(const char *_file);
Nextern _CODE_ACCESS int     rename(const char *_old, const char *_new);
Xextern  int     rename(const char *_old, const char *_new);
Nextern _CODE_ACCESS FILE   *tmpfile(void);
Xextern  FILE   *tmpfile(void);
Nextern _CODE_ACCESS char   *tmpnam(char *_s);
Xextern  char   *tmpnam(char *_s);
N
N/****************************************************************************/
N/* FILE ACCESS FUNCTIONS                                                    */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fclose(FILE *_fp); 
Xextern  int     fclose(FILE *_fp); 
Nextern _CODE_ACCESS FILE   *fopen(const char *_fname, const char *_mode);
Xextern  FILE   *fopen(const char *_fname, const char *_mode);
Nextern _CODE_ACCESS FILE   *freopen(const char *_fname, const char *_mode,
Xextern  FILE   *freopen(const char *_fname, const char *_mode,
N			            register FILE *_fp);
Nextern _CODE_ACCESS void    setbuf(register FILE *_fp, char *_buf);
Xextern  void    setbuf(register FILE *_fp, char *_buf);
Nextern _CODE_ACCESS int     setvbuf(register FILE *_fp, register char *_buf, 
Xextern  int     setvbuf(register FILE *_fp, register char *_buf, 
N			            register int _type, register size_t _size);
Nextern _CODE_ACCESS int     fflush(register FILE *_fp); 
Xextern  int     fflush(register FILE *_fp); 
N
N/****************************************************************************/
N/* FORMATTED INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int fprintf(FILE *_fp, const char *_format, ...);
Xextern  int fprintf(FILE *_fp, const char *_format, ...);
Nextern _CODE_ACCESS int fscanf(FILE *_fp, const char *_fmt, ...);
Xextern  int fscanf(FILE *_fp, const char *_fmt, ...);
Nextern _CODE_ACCESS int printf(const char *_format, ...);
Xextern  int printf(const char *_format, ...);
Nextern _CODE_ACCESS int scanf(const char *_fmt, ...);
Xextern  int scanf(const char *_fmt, ...);
Nextern _CODE_ACCESS int sprintf(char *_string, const char *_format, ...);
Xextern  int sprintf(char *_string, const char *_format, ...);
Nextern _CODE_ACCESS int snprintf(char *_string, size_t _n, 
Xextern  int snprintf(char *_string, size_t _n, 
N				 const char *_format, ...);
Nextern _CODE_ACCESS int sscanf(const char *_str, const char *_fmt, ...);
Xextern  int sscanf(const char *_str, const char *_fmt, ...);
Nextern _CODE_ACCESS int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Xextern  int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vprintf(const char *_format, va_list _ap);
Xextern  int vprintf(const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vsprintf(char *_string, const char *_format,
Xextern  int vsprintf(char *_string, const char *_format,
N				 va_list _ap);
Nextern _CODE_ACCESS int vsnprintf(char *_string, size_t _n, 
Xextern  int vsnprintf(char *_string, size_t _n, 
N				  const char *_format, va_list _ap);
N
N/****************************************************************************/
N/* CHARACTER INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetc(register FILE *_fp);
Xextern  int     fgetc(register FILE *_fp);
Nextern _CODE_ACCESS char   *fgets(char *_ptr, register int _size,
Xextern  char   *fgets(char *_ptr, register int _size,
N				  register FILE *_fp);
Nextern _CODE_ACCESS int     fputc(int _c, register FILE *_fp);
Xextern  int     fputc(int _c, register FILE *_fp);
Nextern _CODE_ACCESS int     fputs(const char *_ptr, register FILE *_fp);
Xextern  int     fputs(const char *_ptr, register FILE *_fp);
Nextern _CODE_ACCESS int     getc(FILE *_p);
Xextern  int     getc(FILE *_p);
Nextern _CODE_ACCESS int     getchar(void);
Xextern  int     getchar(void);
Nextern _CODE_ACCESS char   *gets(char *_ptr); 
Xextern  char   *gets(char *_ptr); 
Nextern _CODE_ACCESS int     putc(int _x, FILE *_fp);
Xextern  int     putc(int _x, FILE *_fp);
Nextern _CODE_ACCESS int     putchar(int _x);
Xextern  int     putchar(int _x);
Nextern _CODE_ACCESS int     puts(const char *_ptr); 
Xextern  int     puts(const char *_ptr); 
Nextern _CODE_ACCESS int     ungetc(int _c, register FILE *_fp);
Xextern  int     ungetc(int _c, register FILE *_fp);
N
N/****************************************************************************/
N/* DIRECT INPUT/OUTPUT FUNCTIONS                                            */
N/****************************************************************************/
Nextern _CODE_ACCESS size_t  fread(void *_ptr, size_t _size, size_t _count,
Xextern  size_t  fread(void *_ptr, size_t _size, size_t _count,
N				  FILE *_fp);
Nextern _CODE_ACCESS size_t  fwrite(const void *_ptr, size_t _size,
Xextern  size_t  fwrite(const void *_ptr, size_t _size,
N				   size_t _count, register FILE *_fp); 
N
N/****************************************************************************/
N/* FILE POSITIONING FUNCTIONS                                               */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetpos(FILE *_fp, fpos_t *_pos);
Xextern  int     fgetpos(FILE *_fp, fpos_t *_pos);
Nextern _CODE_ACCESS int     fseek(register FILE *_fp, long _offset,
Xextern  int     fseek(register FILE *_fp, long _offset,
N				  int _ptrname);
Nextern _CODE_ACCESS int     fsetpos(FILE *_fp, const fpos_t *_pos);
Xextern  int     fsetpos(FILE *_fp, const fpos_t *_pos);
Nextern _CODE_ACCESS long    ftell(FILE *_fp);
Xextern  long    ftell(FILE *_fp);
Nextern _CODE_ACCESS void    rewind(register FILE *_fp); 
Xextern  void    rewind(register FILE *_fp); 
N
N/****************************************************************************/
N/* ERROR-HANDLING FUNCTIONS                                                 */
N/****************************************************************************/
Nextern _CODE_ACCESS void    clearerr(FILE *_fp);
Xextern  void    clearerr(FILE *_fp);
Nextern _CODE_ACCESS int     feof(FILE *_fp);
Xextern  int     feof(FILE *_fp);
Nextern _CODE_ACCESS int     ferror(FILE *_fp);
Xextern  int     ferror(FILE *_fp);
Nextern _CODE_ACCESS void    perror(const char *_s);
Xextern  void    perror(const char *_s);
N
N#define _getchar()      getc(stdin)
N#define _putchar(_x)    putc((_x), stdout)
N#define _clearerr(_fp)   ((void) ((_fp)->flags &= ~(_STATERR | _STATEOF)))
N
N#define _ferror(_x)     ((_x)->flags & _STATERR)
N
N#define _remove(_fl)    (unlink((_fl)))
N
N#ifdef __cplusplus
S} /* extern "C" namespace std */
S
S#ifndef _CPP_STYLE_HEADER
Susing std::size_t;
Susing std::FILE;
Susing std::fpos_t;
Susing std::_ftable;
Susing std::_tmpnams;
Susing std::remove;
Susing std::rename;
Susing std::tmpfile;
Susing std::tmpnam;
Susing std::fclose;
Susing std::fopen;
Susing std::freopen;
Susing std::setbuf;
Susing std::setvbuf;
Susing std::fflush;
Susing std::fprintf;
Susing std::fscanf;
Susing std::printf;
Susing std::scanf;
Susing std::sprintf;
Susing std::sscanf;
Susing std::vfprintf;
Susing std::vprintf;
Susing std::vsprintf;
Susing std::fgetc;
Susing std::fgets;
Susing std::fputc;
Susing std::fputs;
Susing std::getc;
Susing std::getchar;
Susing std::gets;
Susing std::putc;
Susing std::putchar;
Susing std::puts;
Susing std::ungetc;
Susing std::fread;
Susing std::fwrite;
Susing std::fgetpos;
Susing std::fseek;
Susing std::fsetpos;
Susing std::ftell;
Susing std::rewind;
Susing std::clearerr;
Susing std::feof;
Susing std::ferror;
Susing std::perror;
S#endif  /* _CPP_STYLE_HEADER */
S
N#endif  /* __cplusplus */
N
N#else
S
S#ifdef __cplusplus
S
S#ifndef _CPP_STYLE_HEADER
Susing std::size_t;
Susing std::FILE;
Susing std::fpos_t;
Susing std::_ftable;
Susing std::_tmpnams;
Susing std::remove;
Susing std::rename;
Susing std::tmpfile;
Susing std::tmpnam;
Susing std::fclose;
Susing std::fopen;
Susing std::freopen;
Susing std::setbuf;
Susing std::setvbuf;
Susing std::fflush;
Susing std::fprintf;
Susing std::fscanf;
Susing std::printf;
Susing std::scanf;
Susing std::sprintf;
Susing std::sscanf;
Susing std::vfprintf;
Susing std::vprintf;
Susing std::vsprintf;
Susing std::fgetc;
Susing std::fgets;
Susing std::fputc;
Susing std::fputs;
Susing std::getc;
Susing std::getchar;
Susing std::gets;
Susing std::putc;
Susing std::putchar;
Susing std::puts;
Susing std::ungetc;
Susing std::fread;
Susing std::fwrite;
Susing std::fgetpos;
Susing std::fseek;
Susing std::fsetpos;
Susing std::ftell;
Susing std::rewind;
Susing std::clearerr;
Susing std::feof;
Susing std::ferror;
Susing std::perror;
S#endif  /* _CPP_STYLE_HEADER */
S
S#endif  /* __cplusplus */
S
N#endif  /* #ifndef _STDIO */
N
L 71 "progSpi.c" 2
N#include <csl.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/csl.h" 1
N/*****************************************************\
N *  Copyright 2003, Texas Instruments Incorporated.  *
X
N *  All rights reserved.                             *
N *  Restricted rights to use, duplicate or disclose  *
N *  this   code   are  granted   through  contract.  *
N \*****************************************************/
N
N#ifndef _CSL_H_
N#define _CSL_H_
N
N#include <csl_types.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/csl_types.h" 1
N/*****************************************************\
N *  Copyright 2003, Texas Instruments Incorporated.  *
X
N *  All rights reserved.                             *
N *  Restricted rights to use, duplicate or disclose  *
N *  this   code   are  granted   through  contract.  *
N\*****************************************************/
N
N#ifndef _CSL_TYPES_H_
N#define _CSL_TYPES_H_
N
N#include <tistdtypes.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/tistdtypes.h" 1
N/*
N *  ======== tistdtypes.h ========
N */
N
N/*
N * These types are also defined by other TI components.  They are bracketed
N * with _TI_STD_TYPES to avoid warnings for duplicate definition.
N *
N * You may get warnings about duplicate type definitions when using this
N * header file with earlier versions of DSP/BIOS and CSL.
N *
N * You can use the '-pds303' compiler option to suppress these warnings.
N */
N#ifndef _TI_STD_TYPES
N#define _TI_STD_TYPES
N
N/*
N * This '#ifndef STD_' is needed to protect from duplicate definitions
N * of Int, Uns, etc. in DSP/BIOS v4.x (e.g. 4.90, 4.80) since these versions
N * of DSP/BIOS did not contain the '#ifndef_TI_STD_TYPES' logic.
N */
N#ifndef STD_
N
N/*
N * Aliases for standard C types
N */
Ntypedef int			Int;
Ntypedef unsigned		Uns;
Ntypedef char			Char;
N
N/* pointer to null-terminated character sequence */
Ntypedef char			*String;
N
Ntypedef void			*Ptr;		/* pointer to arbitrary type */
N
Ntypedef unsigned short		Bool;		/* boolean */
N
N#endif /* STD_ */
N
N/*
N * Uint8, Uint16, Uint32, etc are defined to be "smallest unit of
N * available storage that is large enough to hold unsigned or integer
N * of specified size".
N */
N
N/* Handle the 6x ISA */
N#if defined(_TMS320C6X)
X#if 1L
N    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef unsigned int	Uint32;
N    typedef unsigned short	Uint16;
N    typedef unsigned char	Uint8;
N
N    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef int			Int32;
N    typedef short		Int16;
N    typedef char		Int8;
N
N/* Handle the 54x, 55x and 28x ISAs */
N#elif defined(_TMS320C5XX) || defined(__TMS320C55X__) || defined(_TMS320C28X)
S    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef unsigned long	Uint32;
S    typedef unsigned short	Uint16;
S    typedef unsigned char	Uint8;
S
S    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef long		Int32;
S    typedef short		Int16;
S    typedef char		Int8;
S
S#else
S    /* Other ISAs not supported */
S    #error <tistdtypes.h> is not supported for this target
N#endif  /* defined(_6x_) */
N
N#endif  /* _TI_STD_TYPES */
N
L 12 "C:/CCStudio_v3.1/C6000/csl/include/csl_types.h" 2
N
Ntypedef Int16           CSL_Uid;
Ntypedef Int16           CSL_ModuleId;
Ntypedef Uint32          CSL_Xio;
N
Ntypedef Uint16          CSL_BitMask16;
Ntypedef Uint32          CSL_BitMask32;
N
Ntypedef volatile Uint8  CSL_Reg8;
Ntypedef volatile Uint16 CSL_Reg16;
Ntypedef volatile Uint32 CSL_Reg32;
N
Ntypedef Int16           CSL_Status;
Ntypedef Int16           CSL_InstNum;
Ntypedef Int16           CSL_ChaNum;
N
Ntypedef enum {
N  CSL_EXCLUSIVE = 0,
N  CSL_SHARED    = 1
N} CSL_OpenMode;
N
Ntypedef enum {
N  CSL_FAIL      = 0,
N  CSL_PASS      = 1
N} CSL_Test;
N
N
N#define TRUE		((Bool) 1)
N#define FALSE		((Bool) 0)
N
N#ifndef NULL
S#define NULL            (0)
N#endif
N
N#endif /* _CSL_TYPES_H_ */
N
L 12 "C:/CCStudio_v3.1/C6000/csl/include/csl.h" 2
N#include <csl_resId.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/csl_resId.h" 1
N/*   ==========================================================================
N *   Copyright (c) Texas Instruments Inc , 2005
N *
N *   Use of this software is controlled by the terms and conditions found
N *   in the license agreement under which this software has been supplied
N *   provided
N *   ==========================================================================
N */
N
N/* ---- File: <csl_resId.h> ---- */
N/* for the ARM-side of Hibari */
N#ifndef _CSL_RESID_H_
N#define _CSL_RESID_H_
N
N/* ---- Total number of modues : CSL Abstraction ---- */
N/* Module ID 0 is reserved. */
N#define CSL_CHIP_NUM_MODULES   (14)
N
N#define CSL_LCDC_ID                (1)
N#define CSL_PWM_ID                 (2)
N#define CSL_UART_ID                (3)
N#define CSL_MMCSD_ID               (4)
N#define CSL_SPI_ID                 (5)
N#define CSL_ATA_ID                 (6)
N#define CSL_DMA_ID                 (7)
N#define CSL_I2C_ID                 (8)
N#define CSL_INTC_ID                (9)
N#define CSL_GPIO_ID                (10)
N#define CSL_MS_ID                  (11)
N#define CSL_EMIF_ID                (12)
N#define CSL_NTSC_ID                (13)
N#define CSL_NAND_ID                (14)
N
N/* ---- Total Number of Resource, one-to-one correspondence with H/W resource */
N/* Resource ID - 0 is resvd. */
N#define CSL_CHIP_NUM_RESOURCES  (20)
N
N#define CSL_LCDC_0_UID              (1)
N#define CSL_PWM_0_UID               (2)
N#define CSL_PWM_1_UID               (3)
N#define CSL_UART_0_UID              (4)
N#define CSL_UART_1_UID              (5)
N#define CSL_MMCSD_0_UID             (6)
N#define CSL_SPI_0_UID               (7)
N#define CSL_ATA_0_UID               (8)
N#define CSL_DMA_0_UID               (9)
N	#define CSL_DMA_CHA0_UID        (10)
N	#define CSL_DMA_CHA1_UID        (11)
N	#define CSL_DMA_CHA2_UID        (12)
N#define CSL_I2C_0_UID               (13)	
N#define CSL_INTC_0_UID              (14)	
N#define CSL_GPIO_UID                (15)	
N#define CSL_MGPIO_UID               (16)	
N#define CSL_MS_0_UID                (17)	
N#define CSL_EMIF_0_UID              (18)	
N#define CSL_NTSC_0_UID              (19)	
N#define CSL_NAND_0_UID              (20)	
N
N
N/*----  XIO masks for peripheral instances ---- */
N#define CSL_LCDC_0_XIO              (0x00000000) 
N#define CSL_PWM_0_XIO               (0x00000000) 
N#define CSL_PWM_1_XIO               (0x00000000) 
N#define CSL_UART_0_XIO              (0x00000000) 
N#define CSL_UART_1_XIO              (0x00000000) 
N#define CSL_MMCSD_0_XIO           (0x00000000) 
N#define CSL_SPI_0_XIO                (0x00000000) 
N#define CSL_ATA_0_XIO               (0x00000000) 
N#define CSL_DMA_0_XIO               (0x00000000) 
N	#define CSL_DMA_CHA0_XIO               (0x00000000) 
N	#define CSL_DMA_CHA1_XIO               (0x00000000) 
N	#define CSL_DMA_CHA2_XIO               (0x00000000) 
N#define CSL_I2C_0_XIO               (0x00000000) 	
N#define CSL_INTC_0_XIO              (0x00000000) 	
N#define CSL_GPIO_XIO                (0x00000000) 	
N#define CSL_MGPIO_XIO               (0x00000000) 	
N#define CSL_MS_0_XIO                (0x00000000) 	
N#define CSL_EMIF_0_XIO              (0x00000000) 	
N#define CSL_NTSC_0_XIO              (0x00000000) 	
N#define CSL_NAND_0_XIO              (0x00000000) 	
N
N#endif /* _CSL_RESOURCE_H_ */
N
L 13 "C:/CCStudio_v3.1/C6000/csl/include/csl.h" 2
N#include <csl_error.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/csl_error.h" 1
N/*   ==========================================================================
N *   Copyright (c) Texas Instruments Inc , 2005
N *
N *   Use of this software is controlled by the terms and conditions found
N *   in the license agreement under which this software has been supplied
N *   provided
N *   ==========================================================================
N*/
N
N/* ---- File: <csl_error.h> ---- */
N/* Error file for Hibari: ARM side */
N#ifndef _CSL_ERROR_H_
N#define _CSL_ERROR_H_
N
N#include <csl_resId.h>
N
N/* Below Error codes are Global across all CSL Modules. */
N#define CSL_SOK                 (1)         /* Success */
N#define CSL_ESYS_FAIL           (-1)        /* Generic failure */
N#define CSL_ESYS_INUSE          (-2)        /* Peripheral resource is already in use */
N#define CSL_ESYS_XIO            (-3)        /* Encountered a shared I/O(XIO) pin conflict */
N#define CSL_ESYS_OVFL           (-4)        /* Encoutered CSL system resource overflow */
N#define CSL_ESYS_BADHANDLE      (-5)        /* Handle passed to CSL was invalid */
N#define CSL_ESYS_INVPARAMS      (-6)        /* invalid parameters */
N#define CSL_ESYS_INVCMD         (-7)        /* invalid command */
N#define CSL_ESYS_INVQUERY       (-8)        /* invalid query */
N#define CSL_ESYS_NOTSUPPORTED   (-9)        /* action not supported */
N#define CSL_ESYS_ALREADY_INITIALIZED	(-10)	/* Module already initialized */ 
N
N/* Error codes individual to various modules. */
N
N/* Error code for DMA, individual error would be assigned as
N * eg: #define CSL_E<Peripheral name>_<error code>  CSL_EDMA_FIRST - 1
N */
N
N
N#define CSL_ELCDC_FIRST     -( ((CSL_LCDC_ID + 1) << 5 ) + 1 )
N#define CSL_ELCDC_LAST      -( (CSL_LCDC_ID + 1) << 6 )
N
N#define CSL_EPWM_FIRST      -( ((CSL_PWM_ID + 1) << 5 ) + 1 )
N#define CSL_EPWM_LAST       -( (CSL_PWM_ID + 1) << 6 )
N
N#define CSL_EUART_FIRST     -( ((CSL_UART_ID + 1) << 5 ) + 1 )
N#define CSL_EUART_LAST      -( (CSL_UART_ID + 1) << 6 )
N
N#define CSL_ESPI_FIRST      -( ((CSL_SPI_ID + 1) << 5 ) + 1 )
N#define CSL_ESPI_LAST       -( (CSL_SPI_ID + 1) << 6 )
N
N#define CSL_EATA_FIRST      -( ((CSL_ATA_ID + 1) << 5 ) + 1 )
N#define CSL_EATA_LAST       -( (CSL_ATA_ID + 1) << 6 )
N
N#define CSL_EMMCSD_FIRST    -( ((CSL_MMCSD_ID + 1) << 5 ) + 1 )
N#define CSL_EMMCSD_LAST     -( (CSL_MMCSD_ID + 1) << 6 )
N
N#define CSL_EDMA_FIRST      -( ((CSL_DMA_ID + 1) << 5 ) + 1 )
N#define CSL_EDMA_LAST       -( (CSL_DMA_ID + 1) << 6 )
N
N#define CSL_EI2C_FIRST      -( ((CSL_I2C_ID + 1) << 5 ) + 1 )
N#define CSL_EI2C_LAST       -( (CSL_I2C_ID + 1) << 6 )
N
N#define CSL_EINTC_FIRST     -( ((CSL_INTC_ID + 1) << 5 ) + 1 )
N#define CSL_EINTC_LAST      -( (CSL_INTC_ID + 1) << 6 )
N
N#define CSL_EGPIO_FIRST     -( ((CSL_GPIO_ID + 1) << 5 ) + 1 )
N#define CSL_EGPIO_LAST      -( (CSL_GPIO_ID + 1) << 6 )
N
N#define CSL_EMS_FIRST       -( ((CSL_MS_ID + 1) << 5 ) + 1 )
N#define CSL_EMS_LAST        -( (CSL_MS_ID + 1) << 6 )
N
N#define CSL_EEMIF_FIRST     -( ((CSL_EMIF_ID + 1) << 5 ) + 1 )
N#define CSL_EEMIF_LAST      -( (CSL_EMIF_ID + 1) << 6 )
N
N#define CSL_ENTSC_FIRST     -( ((CSL_NTSC_ID + 1) << 5 ) + 1 )
N#define CSL_ENTSC_LAST      -( (CSL_NTSC_ID + 1) << 6 )
N
N#define CSL_ENAND_FIRST     -( ((CSL_NAND_ID + 1) << 5 ) + 1 )
N#define CSL_ENAND_LAST      -( (CSL_NAND_ID + 1) << 6 )
N
N#endif /* _CSL_ERROR_H_ */
N
L 14 "C:/CCStudio_v3.1/C6000/csl/include/csl.h" 2
N#include <cslr.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/cslr.h" 1
N/*****************************************************\
N *  Copyright 2003, Texas Instruments Incorporated.  *
X
N *  All rights reserved.                             *
N *  Restricted rights to use, duplicate or disclose  *
N *  this   code   are  granted   through  contract.  *
N *                                                   *
N * "@(#) PSP/CSL  3.0.0.0  (2003-09-30)              *
N\*****************************************************/
N
N/* Register layer central -- contains field-manipulation macro definitions */
N
N#ifndef _CSLR_H_
N#define _CSLR_H_
N
N/* the "expression" macros */
N
N/* the Field MaKe macro */
N#define CSL_FMK(PER_REG_FIELD, val)                                         \
N    (((val) << CSL_##PER_REG_FIELD##_SHIFT) & CSL_##PER_REG_FIELD##_MASK)
X#define CSL_FMK(PER_REG_FIELD, val)                                             (((val) << CSL_##PER_REG_FIELD##_SHIFT) & CSL_##PER_REG_FIELD##_MASK)
N
N/* the Field EXTract macro */
N#define CSL_FEXT(reg, PER_REG_FIELD)                                        \
N    (((reg) & CSL_##PER_REG_FIELD##_MASK) >> CSL_##PER_REG_FIELD##_SHIFT)
X#define CSL_FEXT(reg, PER_REG_FIELD)                                            (((reg) & CSL_##PER_REG_FIELD##_MASK) >> CSL_##PER_REG_FIELD##_SHIFT)
N
N/* the Field INSert macro */
N#define CSL_FINS(reg, PER_REG_FIELD, val)                                   \
N    ((reg) = ((reg) & ~CSL_##PER_REG_FIELD##_MASK)                          \
N    | CSL_FMK(PER_REG_FIELD, val))
X#define CSL_FINS(reg, PER_REG_FIELD, val)                                       ((reg) = ((reg) & ~CSL_##PER_REG_FIELD##_MASK)                              | CSL_FMK(PER_REG_FIELD, val))
N
N
N/* the "token" macros */
N
N/* the Field MaKe (Token) macro */
N#define CSL_FMKT(PER_REG_FIELD, TOKEN)                                      \
N    CSL_FMK(PER_REG_FIELD, CSL_##PER_REG_FIELD##_##TOKEN)
X#define CSL_FMKT(PER_REG_FIELD, TOKEN)                                          CSL_FMK(PER_REG_FIELD, CSL_##PER_REG_FIELD##_##TOKEN)
N
N/* the Field INSert (Token) macro */
N#define CSL_FINST(reg, PER_REG_FIELD, TOKEN)                                \
N    CSL_FINS((reg), PER_REG_FIELD, CSL_##PER_REG_FIELD##_##TOKEN)
X#define CSL_FINST(reg, PER_REG_FIELD, TOKEN)                                    CSL_FINS((reg), PER_REG_FIELD, CSL_##PER_REG_FIELD##_##TOKEN)
N
N
N/* the "raw" macros */
N
N/* the Field MaKe (Raw) macro */
N#define CSL_FMKR(msb, lsb, val)                                             \
N    (((val) & ((1 << ((msb) - (lsb) + 1)) - 1)) << (lsb))
X#define CSL_FMKR(msb, lsb, val)                                                 (((val) & ((1 << ((msb) - (lsb) + 1)) - 1)) << (lsb))
N
N/* the Field EXTract (Raw) macro */
N#define CSL_FEXTR(reg, msb, lsb)                                            \
N    (((reg) >> (lsb)) & ((1 << ((msb) - (lsb) + 1)) - 1))
X#define CSL_FEXTR(reg, msb, lsb)                                                (((reg) >> (lsb)) & ((1 << ((msb) - (lsb) + 1)) - 1))
N
N/* the Field INSert (Raw) macro */
N#define CSL_FINSR(reg, msb, lsb, val)                                       \
N    ((reg) = ((reg) &~ (((1 << ((msb) - (lsb) + 1)) - 1) << (lsb)))         \
N    | CSL_FMKR(msb, lsb, val))
X#define CSL_FINSR(reg, msb, lsb, val)                                           ((reg) = ((reg) &~ (((1 << ((msb) - (lsb) + 1)) - 1) << (lsb)))             | CSL_FMKR(msb, lsb, val))
N
N#endif /* _CSLR_H_ */
N
L 15 "C:/CCStudio_v3.1/C6000/csl/include/csl.h" 2
N
N
Ntypedef void *  CSL_ResHandle;
N
Ntypedef struct {
N    CSL_OpenMode openMode;
N    CSL_Uid uid;
N    CSL_Xio xio;
N} CSL_ResAttrs;
Ntypedef void (* CSL_Phy2VirtHandler)(CSL_ResHandle);
Ntypedef void (* CSL_Virt2PhyHandler)(CSL_ResHandle);
Ntypedef void (* CSL_AltRouteHandler)(CSL_ResHandle);
N
Nvoid
N    CSL_sysInit (
N        void
N);
N
N#endif /* _CSL_H_ */
N
N
L 72 "progSpi.c" 2
N#include <csl_spi.h>
L 1 ".\csl_spi.h" 1
N/*  ============================================================================
N *   Copyright (c) Texas Instruments Inc 2002, 2003, 2004, 2005
N *
N *   Use of this software is controlled by the terms and conditions found
N *   in the license agreement under which this software has been supplied.
N *   ===========================================================================
N */
N
N/** @mainpage SPI
N*
N* @section Introduction
N*
N* @subsection xxx Purpose and Scope
N* The purpose of this document is to identify a set of common CSL APIs for
N* the SPI Module across various devices. The CSL developer is expected
N* to refer to this document while designing APIs for these modules. Some
N* of the listed APIs may not be applicable to a given SPI Module. While
N* in other cases this list of APIs may not be sufficient to cover all the
N* features of a particular SPI Module. The CSL developer should use his
N* discretion in designing new APIs or extending the existing ones to cover
N* these.
N*
N*
N* @subsection aaa Terms and Abbreviations
N*   -# CSL:  Chip Support Library
N*   -# API:  Application Programmer Interface
N*   -# SPI:  Serial Port Interface
N*
N* @subsection References
N*    -# CSL 3.x Technical Requirements Specifications Version 0.5, dated
N*       May 14th, 2003
N*
N*/
N
N/** @file csl_spi.h
N *
N * @brief   Header file for functional layer of CSL
N *
N * Description
N *    - The defines inline function definitions
N *
N */
N
N#ifndef _CSL_SPI_H_
N#define _CSL_SPI_H_
N
N#ifdef __cplusplus
Sextern "C" {
N#endif
N
N#include <cslr.h>
N#include <csl_error.h>
N#include <csl_types.h>
N#include <soc.h>
L 1 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 1
N/*   ==========================================================================
N *   Copyright (c) Texas Instruments Inc , 2005
N *
N *   Use of this software is controlled by the terms and conditions found
N *   in the license agreement under which this software has been supplied
N *   provided
N *   ==========================================================================
N*/
N
N/* =============================================================================
N *  Revision History
N *  ===============
N *  dd-mmm-yyyy author  created 
N *
N * =============================================================================
N */
N
N#ifndef _SOC_H
N#define _SOC_H
N
N/*****************************************************************************/
N/** \file soc.h
N *
N * \brief This file contains the Chip Description for C672x
N *
N *****************************************************************************/
N
N#include <cslr.h>
N#include <tistdtypes.h>
N
N/*****************************************************************************\
N* Include files for all the modules in the device
X
N\*****************************************************************************/
N#include "cslr_pllc.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_pllc.h" 1
N#ifndef _CSLR_PLLC_H_
N#define _CSLR_PLLC_H_
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_pllc.h
N * 
N * \brief This file contains the Register Desciptions for PLLC
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 PLLPID;
N    volatile Uint32 RSVD0[63];
N    volatile Uint32 PLLCSR;
N    volatile Uint32 RSVD1[3];
N    volatile Uint32 PLLM;
N    volatile Uint32 PLLDIV0;
N    volatile Uint32 PLLDIV1;
N    volatile Uint32 PLLDIV2;
N    volatile Uint32 PLLDIV3;
N    volatile Uint32 RSVD2[5];
N    volatile Uint32 PLLCMD;
N    volatile Uint32 PLLSTAT;
N    volatile Uint32 ALNCTL;
N    volatile Uint32 RSVD3[1];
N    volatile Uint32 CKEN;
N    volatile Uint32 CKSTAT;
N    volatile Uint32 SYSTAT;
N} CSL_PllcRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* PLLPID */
N
N#define CSL_PLLC_PLLPID_TYPE_MASK        (0x00FF0000u)
N#define CSL_PLLC_PLLPID_TYPE_SHIFT       (0x00000010u)
N#define CSL_PLLC_PLLPID_TYPE_RESETVAL    (0x00000001u)
N
N#define CSL_PLLC_PLLPID_CLASS_MASK       (0x0000FF00u)
N#define CSL_PLLC_PLLPID_CLASS_SHIFT      (0x00000008u)
N#define CSL_PLLC_PLLPID_CLASS_RESETVAL   (0x00000008u)
N
N#define CSL_PLLC_PLLPID_REV_MASK         (0x000000FFu)
N#define CSL_PLLC_PLLPID_REV_SHIFT        (0x00000000u)
N#define CSL_PLLC_PLLPID_REV_RESETVAL     (0x00000001u)
N
N#define CSL_PLLC_PLLPID_RESETVAL         (0x00010801u)
N
N/* PLLCSR */
N
N#define CSL_PLLC_PLLCSR_STABLE_MASK      (0x00000040u)
N#define CSL_PLLC_PLLCSR_STABLE_SHIFT     (0x00000006u)
N#define CSL_PLLC_PLLCSR_STABLE_RESETVAL  (0x00000001u)
N
N/*----STABLE Tokens----*/
N#define CSL_PLLC_PLLCSR_STABLE_NOT_STABLE (0x00000000u)
N#define CSL_PLLC_PLLCSR_STABLE_STABLE    (0x00000000u)
N
N#define CSL_PLLC_PLLCSR_PLLPWRDN_MASK    (0x00000010u)
N#define CSL_PLLC_PLLCSR_PLLPWRDN_SHIFT   (0x00000004u)
N#define CSL_PLLC_PLLCSR_PLLPWRDN_RESETVAL (0x00000004u)
N
N/*----PLLPWRDN Tokens----*/
N#define CSL_PLLC_PLLCSR_PLLPWRDN_NO      (0x00000000u)
N#define CSL_PLLC_PLLCSR_PLLPWRDN_YES      (0x00000001u)
N
N#define CSL_PLLC_PLLCSR_PLLRST_MASK      (0x00000008u)
N#define CSL_PLLC_PLLCSR_PLLRST_SHIFT     (0x00000003u)
N#define CSL_PLLC_PLLCSR_PLLRST_RESETVAL  (0x00000000u)
N
N/*----PLLRST Tokens----*/
N#define CSL_PLLC_PLLCSR_PLLRST_RELEASED  (0x00000000u)
N#define CSL_PLLC_PLLCSR_PLLRST_ASSERTED  (0x00000001u)
N
N#define CSL_PLLC_PLLCSR_OSCPWRDN_MASK    (0x00000004u)
N#define CSL_PLLC_PLLCSR_OSCPWRDN_SHIFT   (0x00000002u)
N#define CSL_PLLC_PLLCSR_OSCPWRDN_RESETVAL (0x00000000u)
N
N/*----OSCPWRDN Tokens----*/
N#define CSL_PLLC_PLLCSR_OSCPWRDN_CMD     (0x00000001u)
N
N#define CSL_PLLC_PLLCSR_PLLEN_MASK       (0x00000001u)
N#define CSL_PLLC_PLLCSR_PLLEN_SHIFT      (0x00000000u)
N#define CSL_PLLC_PLLCSR_PLLEN_RESETVAL   (0x00000000u)
N
N/*----PLLEN Tokens----*/
N#define CSL_PLLC_PLLCSR_PLLEN_BYPASS     (0x00000000u)
N#define CSL_PLLC_PLLCSR_PLLEN_PLL        (0x00000001u)
N
N#define CSL_PLLC_PLLCSR_RESETVAL         (0x00000040u)
N
N/* PLLM */
N
N#define CSL_PLLC_PLLM_PLLM_MASK          (0x0000003Fu)
N#define CSL_PLLC_PLLM_PLLM_SHIFT         (0x00000000u)
N#define CSL_PLLC_PLLM_PLLM_RESETVAL      (0x0000000Du)
N
N#define CSL_PLLC_PLLM_RESETVAL           (0x0000000Du)
N
N/* PLLDIV0 */
N
N#define CSL_PLLC_PLLDIV0_D0EN_MASK       (0x00008000u)
N#define CSL_PLLC_PLLDIV0_D0EN_SHIFT      (0x0000000Fu)
N#define CSL_PLLC_PLLDIV0_D0EN_RESETVAL   (0x00000000u)
N
N/*----D0EN Tokens----*/
N#define CSL_PLLC_PLLDIV0_D0EN_DISABLE    (0x00000000u)
N#define CSL_PLLC_PLLDIV0_D0EN_ENABLE     (0x00000001u)
N
N#define CSL_PLLC_PLLDIV0_RATIO_MASK      (0x0000001Fu)
N#define CSL_PLLC_PLLDIV0_RATIO_SHIFT     (0x00000000u)
N#define CSL_PLLC_PLLDIV0_RATIO_RESETVAL  (0x00000000u)
N
N#define CSL_PLLC_PLLDIV0_RESETVAL        (0x00000000u)
N
N/* PLLDIV1 */
N
N#define CSL_PLLC_PLLDIV1_D1EN_MASK       (0x00008000u)
N#define CSL_PLLC_PLLDIV1_D1EN_SHIFT      (0x0000000Fu)
N#define CSL_PLLC_PLLDIV1_D1EN_RESETVAL   (0x00000000u)
N
N/*----D1EN Tokens----*/
N#define CSL_PLLC_PLLDIV1_D1EN_DISABLE    (0x00000000u)
N#define CSL_PLLC_PLLDIV1_D1EN_ENABLE     (0x00000001u)
N
N#define CSL_PLLC_PLLDIV1_RATIO_MASK      (0x0000001Fu)
N#define CSL_PLLC_PLLDIV1_RATIO_SHIFT     (0x00000000u)
N#define CSL_PLLC_PLLDIV1_RATIO_RESETVAL  (0x00000000u)
N
N#define CSL_PLLC_PLLDIV1_RESETVAL        (0x00000000u)
N
N/* PLLDIV2 */
N
N#define CSL_PLLC_PLLDIV2_D2EN_MASK       (0x00008000u)
N#define CSL_PLLC_PLLDIV2_D2EN_SHIFT      (0x0000000Fu)
N#define CSL_PLLC_PLLDIV2_D2EN_RESETVAL   (0x00000000u)
N
N/*----D2EN Tokens----*/
N#define CSL_PLLC_PLLDIV2_D2EN_DISABLE    (0x00000000u)
N#define CSL_PLLC_PLLDIV2_D2EN_ENABLE     (0x00000001u)
N
N#define CSL_PLLC_PLLDIV2_RATIO_MASK      (0x0000001Fu)
N#define CSL_PLLC_PLLDIV2_RATIO_SHIFT     (0x00000000u)
N#define CSL_PLLC_PLLDIV2_RATIO_RESETVAL  (0x00000000u)
N
N#define CSL_PLLC_PLLDIV2_RESETVAL        (0x00000000u)
N
N/* PLLDIV3 */
N
N#define CSL_PLLC_PLLDIV3_D3EN_MASK       (0x00008000u)
N#define CSL_PLLC_PLLDIV3_D3EN_SHIFT      (0x0000000Fu)
N#define CSL_PLLC_PLLDIV3_D3EN_RESETVAL   (0x00000000u)
N
N/*----D3EN Tokens----*/
N#define CSL_PLLC_PLLDIV3_D3EN_DISABLE    (0x00000000u)
N#define CSL_PLLC_PLLDIV3_D3EN_ENABLE     (0x00000001u)
N
N#define CSL_PLLC_PLLDIV3_RATIO_MASK      (0x0000001Fu)
N#define CSL_PLLC_PLLDIV3_RATIO_SHIFT     (0x00000000u)
N#define CSL_PLLC_PLLDIV3_RATIO_RESETVAL  (0x00000000u)
N
N#define CSL_PLLC_PLLDIV3_RESETVAL        (0x00000000u)
N
N/* PLLCMD */
N
N#define CSL_PLLC_PLLCMD_GOSET_MASK       (0x00000001u)
N#define CSL_PLLC_PLLCMD_GOSET_SHIFT      (0x00000000u)
N#define CSL_PLLC_PLLCMD_GOSET_RESETVAL   (0x00000000u)
N
N/*----GOSET Tokens----*/
N#define CSL_PLLC_PLLCMD_GOSET_CLRBIT     (0x00000000u)
N#define CSL_PLLC_PLLCMD_GOSET_SET        (0x00000001u)
N
N#define CSL_PLLC_PLLCMD_RESETVAL         (0x00000000u)
N
N/* PLLSTAT */
N
N#define CSL_PLLC_PLLSTAT_GOSTAT_MASK     (0x00000001u)
N#define CSL_PLLC_PLLSTAT_GOSTAT_SHIFT    (0x00000000u)
N#define CSL_PLLC_PLLSTAT_GOSTAT_RESETVAL (0x00000000u)
N
N/*----GOSTAT Tokens----*/
N#define CSL_PLLC_PLLSTAT_GOSTAT_NOT_PROGRESS (0x00000000u)
N#define CSL_PLLC_PLLSTAT_GOSTAT_INPROG   (0x00000001u)
N
N#define CSL_PLLC_PLLSTAT_RESETVAL        (0x00000000u)
N
N/* ALNCTL */
N
N#define CSL_PLLC_ALNCTL_ALN3_MASK        (0x00000004u)
N#define CSL_PLLC_ALNCTL_ALN3_SHIFT       (0x00000002u)
N#define CSL_PLLC_ALNCTL_ALN3_RESETVAL    (0x00000000u)
N
N/*----ALN3 Tokens----*/
N#define CSL_PLLC_ALNCTL_ALN3_ALIGN       (0x00000001u)
N
N#define CSL_PLLC_ALNCTL_ALN2_MASK        (0x00000002u)
N#define CSL_PLLC_ALNCTL_ALN2_SHIFT       (0x00000001u)
N#define CSL_PLLC_ALNCTL_ALN2_RESETVAL    (0x00000000u)
N
N/*----ALN2 Tokens----*/
N#define CSL_PLLC_ALNCTL_ALN2_ALIGN       (0x00000001u)
N
N#define CSL_PLLC_ALNCTL_ALN1_MASK        (0x00000001u)
N#define CSL_PLLC_ALNCTL_ALN1_SHIFT       (0x00000000u)
N#define CSL_PLLC_ALNCTL_ALN1_RESETVAL    (0x00000000u)
N
N/*----ALN1 Tokens----*/
N#define CSL_PLLC_ALNCTL_ALN1_ALIGN       (0x00000001u)
N
N#define CSL_PLLC_ALNCTL_RESETVAL         (0x00000000u)
N
N/* CKEN */
N
N#define CSL_PLLC_CKEN_AUXEN_MASK         (0x00000001u)
N#define CSL_PLLC_CKEN_AUXEN_SHIFT        (0x00000000u)
N#define CSL_PLLC_CKEN_AUXEN_RESETVAL     (0x00000000u)
N
N/*----AUXEN Tokens----*/
N#define CSL_PLLC_CKEN_AUXEN_DISABLE      (0x00000000u)
N#define CSL_PLLC_CKEN_AUXEN_ENABLE       (0x00000001u)
N
N#define CSL_PLLC_CKEN_RESETVAL           (0x00000004u)
N
N/* CKSTAT */
N
N#define CSL_PLLC_CKSTAT_AUXON_MASK       (0x00000001u)
N#define CSL_PLLC_CKSTAT_AUXON_SHIFT      (0x00000000u)
N#define CSL_PLLC_CKSTAT_AUXON_RESETVAL   (0x00000000u)
N
N/*----AUXON Tokens----*/
N#define CSL_PLLC_CKSTAT_AUXON_GATED      (0x00000000u)
N#define CSL_PLLC_CKSTAT_AUXON_ON         (0x00000001u)
N
N#define CSL_PLLC_CKSTAT_RESETVAL         (0x00000000u)
N
N/* SYSTAT */
N
N#define CSL_PLLC_SYSTAT_SYS3ON_MASK      (0x00000004u)
N#define CSL_PLLC_SYSTAT_SYS3ON_SHIFT     (0x00000002u)
N#define CSL_PLLC_SYSTAT_SYS3ON_RESETVAL  (0x00000000u)
N
N/*----SYS3ON Tokens----*/
N#define CSL_PLLC_SYSTAT_SYS3ON_GATED     (0x00000000u)
N#define CSL_PLLC_SYSTAT_SYS3ON_ON        (0x00000001u)
N
N#define CSL_PLLC_SYSTAT_SYS2ON_MASK      (0x00000002u)
N#define CSL_PLLC_SYSTAT_SYS2ON_SHIFT     (0x00000001u)
N#define CSL_PLLC_SYSTAT_SYS2ON_RESETVAL  (0x00000000u)
N
N/*----SYS2ON Tokens----*/
N#define CSL_PLLC_SYSTAT_SYS2ON_GATED     (0x00000000u)
N#define CSL_PLLC_SYSTAT_SYS2ON_ON        (0x00000001u)
N
N#define CSL_PLLC_SYSTAT_SYS1ON_MASK      (0x00000001u)
N#define CSL_PLLC_SYSTAT_SYS1ON_SHIFT     (0x00000000u)
N#define CSL_PLLC_SYSTAT_SYS1ON_RESETVAL  (0x00000000u)
N
N/*----SYS1ON Tokens----*/
N#define CSL_PLLC_SYSTAT_SYS1ON_GATED     (0x00000000u)
N#define CSL_PLLC_SYSTAT_SYS1ON_ON        (0x00000001u)
N
N#define CSL_PLLC_SYSTAT_RESETVAL         (0x00000000u)
N
N#endif
L 35 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_chip.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_chip.h" 1
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N/** @file  cslr_chip.h 
N * 
N * \brief This file contains the Register Desciptions for CHIP
N * 
N *********************************************************************/
N#ifndef _CSLR_CHIP_H_
N#define _CSLR_CHIP_H_
N
N#include <cslr.h>  
N#include <csl_types.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
N/**
N * Register Overlay structure for memory mapped chip registers
N */
N
Ntypedef struct  {
N    /** CFGPIN0 */
N    volatile Uint32 CFGPIN0;
N    /** CFGPIN1 */
N    volatile Uint32 CFGPIN1;
N    /** CFGHPI */
N    volatile Uint32 CFGHPI;
N    /** CFGHPIAMSB */
N    volatile Uint32 CFGHPIAMSB;
N    /** CFGHPIAUMB */
N    volatile Uint32 CFGHPIAUMB;
N	/** CFGRTI */
N    volatile Uint32 CFGRTI;
N    /** CGFMCASP0 */
N    volatile Uint32 CFGMCASP0;
N    /** CGFMCASP1 */
N    volatile Uint32 CFGMCASP1;
N    /** CGFMCASP2 */
N    volatile Uint32 CFGMCASP2;
N    /** CGFBRIDGE */
N    volatile Uint32 CFGBRIDGE;
N    volatile Uint8 RSVD0[88];
N    /** IDREG */
N    volatile Uint32 IDREG;
N} CSL_ChipRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* CFGPIN0 */
N
N#define CSL_CHIP_CFGPIN0_PINCAP7_MASK    (0x00000080u)
N#define CSL_CHIP_CFGPIN0_PINCAP7_SHIFT   (0x00000007u)
N#define CSL_CHIP_CFGPIN0_PINCAP7_RESETVAL (0x00000000u)
N
N/*----PINCAP7 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP7_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP7_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP6_MASK    (0x00000040u)
N#define CSL_CHIP_CFGPIN0_PINCAP6_SHIFT   (0x00000006u)
N#define CSL_CHIP_CFGPIN0_PINCAP6_RESETVAL (0x00000000u)
N
N/*----PINCAP6 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP6_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP6_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP5_MASK    (0x00000020u)
N#define CSL_CHIP_CFGPIN0_PINCAP5_SHIFT   (0x00000005u)
N#define CSL_CHIP_CFGPIN0_PINCAP5_RESETVAL (0x00000000u)
N
N/*----PINCAP5 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP5_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP5_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP4_MASK    (0x00000010u)
N#define CSL_CHIP_CFGPIN0_PINCAP4_SHIFT   (0x00000004u)
N#define CSL_CHIP_CFGPIN0_PINCAP4_RESETVAL (0x00000000u)
N
N/*----PINCAP4 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP4_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP4_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP3_MASK    (0x00000008u)
N#define CSL_CHIP_CFGPIN0_PINCAP3_SHIFT   (0x00000003u)
N#define CSL_CHIP_CFGPIN0_PINCAP3_RESETVAL (0x00000000u)
N
N/*----PINCAP3 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP3_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP3_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP2_MASK    (0x00000004u)
N#define CSL_CHIP_CFGPIN0_PINCAP2_SHIFT   (0x00000002u)
N#define CSL_CHIP_CFGPIN0_PINCAP2_RESETVAL (0x00000000u)
N
N/*----PINCAP2 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP2_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP2_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP1_MASK    (0x00000002u)
N#define CSL_CHIP_CFGPIN0_PINCAP1_SHIFT   (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP1_RESETVAL (0x00000000u)
N
N/*----PINCAP1 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP1_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP1_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_PINCAP0_MASK    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP0_SHIFT   (0x00000000u)
N#define CSL_CHIP_CFGPIN0_PINCAP0_RESETVAL (0x00000000u)
N
N/*----PINCAP0 Tokens----*/
N#define CSL_CHIP_CFGPIN0_PINCAP0_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN0_PINCAP0_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN0_RESETVAL        (0x00000000u)
N
N/* CFGPIN1 */
N
N#define CSL_CHIP_CFGPIN1_PINCAP15_MASK   (0x00000080u)
N#define CSL_CHIP_CFGPIN1_PINCAP15_SHIFT  (0x00000007u)
N#define CSL_CHIP_CFGPIN1_PINCAP15_RESETVAL (0x00000000u)
N
N/*----PINCAP15 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP15_HIGH   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP15_LOW    (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP14_MASK   (0x00000040u)
N#define CSL_CHIP_CFGPIN1_PINCAP14_SHIFT  (0x00000006u)
N#define CSL_CHIP_CFGPIN1_PINCAP14_RESETVAL (0x00000000u)
N
N/*----PINCAP14 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP14_HIGH   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP14_LOW    (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP13_MASK   (0x00000020u)
N#define CSL_CHIP_CFGPIN1_PINCAP13_SHIFT  (0x00000005u)
N#define CSL_CHIP_CFGPIN1_PINCAP13_RESETVAL (0x00000000u)
N
N/*----PINCAP13 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP13_HIGH   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP13_LOW    (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP12_MASK   (0x00000010u)
N#define CSL_CHIP_CFGPIN1_PINCAP12_SHIFT  (0x00000004u)
N#define CSL_CHIP_CFGPIN1_PINCAP12_RESETVAL (0x00000000u)
N
N/*----PINCAP12 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP12_HIGH   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP12_LOW    (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP11_MASK   (0x00000008u)
N#define CSL_CHIP_CFGPIN1_PINCAP11_SHIFT  (0x00000003u)
N#define CSL_CHIP_CFGPIN1_PINCAP11_RESETVAL (0x00000000u)
N
N/*----PINCAP11 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP11_HIGH   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP11_LOW    (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP10_MASK   (0x00000004u)
N#define CSL_CHIP_CFGPIN1_PINCAP10_SHIFT  (0x00000002u)
N#define CSL_CHIP_CFGPIN1_PINCAP10_RESETVAL (0x00000000u)
N
N/*----PINCAP10 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP10_HIGH   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP10_LOW    (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP9_MASK    (0x00000002u)
N#define CSL_CHIP_CFGPIN1_PINCAP9_SHIFT   (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP9_RESETVAL (0x00000000u)
N
N/*----PINCAP9 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP9_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP9_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_PINCAP8_MASK    (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP8_SHIFT   (0x00000000u)
N#define CSL_CHIP_CFGPIN1_PINCAP8_RESETVAL (0x00000000u)
N
N/*----PINCAP8 Tokens----*/
N#define CSL_CHIP_CFGPIN1_PINCAP8_HIGH    (0x00000001u)
N#define CSL_CHIP_CFGPIN1_PINCAP8_LOW     (0x00000000u)
N
N#define CSL_CHIP_CFGPIN1_RESETVAL        (0x00000000u)
N
N/* CFGHPI */
N
N#define CSL_CHIP_CFGHPI_BYTEAD_MASK      (0x00000010u)
N#define CSL_CHIP_CFGHPI_BYTEAD_SHIFT     (0x00000004u)
N#define CSL_CHIP_CFGHPI_BYTEAD_RESETVAL  (0x00000000u)
N
N/*----BYTEAD Tokens----*/
N#define CSL_CHIP_CFGHPI_BYTEAD_WADDR     (0x00000000u)
N#define CSL_CHIP_CFGHPI_BYTEAD_BADDR     (0x00000001u)
N
N#define CSL_CHIP_CFGHPI_FULL_MASK        (0x00000008u)
N#define CSL_CHIP_CFGHPI_FULL_SHIFT       (0x00000003u)
N#define CSL_CHIP_CFGHPI_FULL_RESETVAL    (0x00000000u)
N
N/*----FULL Tokens----*/
N#define CSL_CHIP_CFGHPI_FULL_HALF        (0x00000000u)
N#define CSL_CHIP_CFGHPI_FULL_FULL        (0x00000001u)
N
N#define CSL_CHIP_CFGHPI_NMUX_MASK        (0x00000004u)
N#define CSL_CHIP_CFGHPI_NMUX_SHIFT       (0x00000002u)
N#define CSL_CHIP_CFGHPI_NMUX_RESETVAL    (0x00000000u)
N
N/*----NMUX Tokens----*/
N#define CSL_CHIP_CFGHPI_NMUX_DISABLE     (0x00000000u)
N#define CSL_CHIP_CFGHPI_NMUX_ENABLE      (0x00000001u)
N
N#define CSL_CHIP_CFGHPI_PAGEM_MASK       (0x00000002u)
N#define CSL_CHIP_CFGHPI_PAGEM_SHIFT      (0x00000001u)
N#define CSL_CHIP_CFGHPI_PAGEM_RESETVAL   (0x00000000u)
N
N/*----PAGEM Tokens----*/
N#define CSL_CHIP_CFGHPI_PAGEM_VBUS_NOT_OVRRIDE (0x00000000u)
N#define CSL_CHIP_CFGHPI_PAGEM_VBUS_OVRRIDE (0x00000001u)
N
N#define CSL_CHIP_CFGHPI_ENA_MASK         (0x00000001u)
N#define CSL_CHIP_CFGHPI_ENA_SHIFT        (0x00000000u)
N#define CSL_CHIP_CFGHPI_ENA_RESETVAL     (0x00000000u)
N
N/*----ENA Tokens----*/
N#define CSL_CHIP_CFGHPI_ENA_HPIENA_CLR   (0x00000000u)
N#define CSL_CHIP_CFGHPI_ENA_HPIENA_SET   (0x00000001u)
N
N#define CSL_CHIP_CFGHPI_RESETVAL         (0x00000000u)
N
N/* CFGHPIAMSB */
N
N#define CSL_CHIP_CFGHPIAMSB_HPIAMSB_MASK (0x000000FFu)
N#define CSL_CHIP_CFGHPIAMSB_HPIAMSB_SHIFT (0x00000000u)
N#define CSL_CHIP_CFGHPIAMSB_HPIAMSB_RESETVAL (0x00000000u)
N
N#define CSL_CHIP_CFGHPIAMSB_RESETVAL     (0x00000000u)
N
N/* CFGHPIAUMB */
N
N#define CSL_CHIP_CFGHPIAUMB_HPIAUMB_MASK (0x000000FFu)
N#define CSL_CHIP_CFGHPIAUMB_HPIAUMB_SHIFT (0x00000000u)
N#define CSL_CHIP_CFGHPIAUMB_HPIAUMB_RESETVAL (0x00000000u)
N
N#define CSL_CHIP_CFGHPIAUMB_RESETVAL     (0x00000000u)
N
N/* CFGRTI */
N
N#define CSL_CHIP_CFGRTI_CAPSEL1_MASK     (0x00000070u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_SHIFT    (0x00000004u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_RESETVAL (0x00000000u)
N
N/*----CAPSEL1 Tokens----*/
N#define CSL_CHIP_CFGRTI_CAPSEL1_MCASP0_TX_DMA_RQ (0x00000000u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_MCASP0_RX_DMA_RQ (0x00000001u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_MCASP1_TX_DMA_RQ (0x00000002u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_MCASP1_RX_DMA_RQ (0x00000003u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_MCASP2_TX_DMA_RQ (0x00000004u)
N#define CSL_CHIP_CFGRTI_CAPSEL1_MCASP2_RX_DMA_RQ (0x00000005u)
N
N#define CSL_CHIP_CFGRTI_CAPSEL0_MASK     (0x00000007u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_SHIFT    (0x00000000u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_RESETVAL (0x00000000u)
N
N/*----CAPSEL0 Tokens----*/
N#define CSL_CHIP_CFGRTI_CAPSEL0_MCASP0_TX_DMA_RQ (0x00000000u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_MCASP0_RX_DMA_RQ (0x00000001u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_MCASP1_TX_DMA_RQ (0x00000002u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_MCASP1_RX_DMA_RQ (0x00000003u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_MCASP2_TX_DMA_RQ (0x00000004u)
N#define CSL_CHIP_CFGRTI_CAPSEL0_MCASP2_RX_DMA_RQ (0x00000005u)
N
N#define CSL_CHIP_CFGRTI_RESETVAL         (0x00000000u)
N
N/* CFGMCASP0 */
N
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_MASK (0x00000007u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_SHIFT (0x00000000u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_RESETVAL (0x00000000u)
N
N/*----AMUTEIN0 Tokens----*/
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_ZERO (0x00000000u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_AXR0_7 (0x00000001u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_AXR0_8_AXR1_5 (0x00000002u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_AXR0_9_AXR1_4 (0x00000003u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_AHCLKR2 (0x00000004u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_SPI0SIMO (0x00000005u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_SPI0SCS_SCL1 (0x00000006u)
N#define CSL_CHIP_CFGMCASP0_AMUTEIN0_SPI0ENA_SDA1 (0x00000007u)
N
N#define CSL_CHIP_CFGMCASP0_RESETVAL      (0x00000000u)
N
N/* CFGMCASP1 */
N
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_MASK (0x00000007u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_SHIFT (0x00000000u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_RESETVAL (0x00000000u)
N
N/*----AMUTEIN1 Tokens----*/
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_ZERO (0x00000000u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_AXR0_7 (0x00000001u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_AXR0_8_AXR1_5 (0x00000002u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_AXR0_9_AXR1_4 (0x00000003u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_AHCLKR2 (0x00000004u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_SPI0SIMO (0x00000005u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_SPI0SCS_SCL1 (0x00000006u)
N#define CSL_CHIP_CFGMCASP1_AMUTEIN1_SPI0ENA_SDA1 (0x00000007u)
N
N#define CSL_CHIP_CFGMCASP1_RESETVAL      (0x00000000u)
N
N/* CFGMCASP2 */
N
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_MASK (0x00000007u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_SHIFT (0x00000000u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_RESETVAL (0x00000000u)
N
N/*----AMUTEIN2 Tokens----*/
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_ZERO (0x00000000u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_AXR0_7 (0x00000001u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_AXR0_8_AXR1_5 (0x00000002u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_AXR0_9_AXR1_4 (0x00000003u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_AHCLKR2 (0x00000004u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_SPI0SIMO (0x00000005u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_SPI0SCS_SCL1 (0x00000006u)
N#define CSL_CHIP_CFGMCASP2_AMUTEIN2_SPI0ENA_SDA1 (0x00000007u)
N
N#define CSL_CHIP_CFGMCASP2_RESETVAL      (0x00000000u)
N
N/* CFGBRIDGE */
N
N#define CSL_CHIP_CFGBRIDGE_CSPRST_MASK   (0x00000001u)
N#define CSL_CHIP_CFGBRIDGE_CSPRST_SHIFT  (0x00000000u)
N#define CSL_CHIP_CFGBRIDGE_CSPRST_RESETVAL (0x00000001u)
N
N/*----CSPRST Tokens----*/
N#define CSL_CHIP_CFGBRIDGE_CSPRST_DISABLE (0x00000000u)
N#define CSL_CHIP_CFGBRIDGE_CSPRST_ENABLE (0x00000001u)
N
N#define CSL_CHIP_CFGBRIDGE_RESETVAL      (0x00000001u)
N
N/* IDREG */
N
N#define CSL_CHIP_IDREG_REVISION_MASK     (0xF0000000u)
N#define CSL_CHIP_IDREG_REVISION_SHIFT    (0x0000001Cu)
N#define CSL_CHIP_IDREG_REVISION_RESETVAL (0x00000000u)
N
N#define CSL_CHIP_IDREG_ID_MASK           (0x0FFFFFFFu)
N#define CSL_CHIP_IDREG_ID_SHIFT          (0x00000000u)
N#define CSL_CHIP_IDREG_ID_RESETVAL       (0x0B6AB02Fu)
N
N#define CSL_CHIP_IDREG_RESETVAL          (0x0B6AB02Fu)
N
N/* AMR */
N
N#define CSL_CHIP_AMR_BK1_MASK            (0x3E00000u)
N#define CSL_CHIP_AMR_BK1_SHIFT           (0x15u)
N#define CSL_CHIP_AMR_BK1_RESETVAL        (0x0u)
N
N/*----BK1 Tokens----*/
N#define CSL_CHIP_AMR_BK1_2               (0x0u)
N#define CSL_CHIP_AMR_BK1_4               (0x1u)
N#define CSL_CHIP_AMR_BK1_8               (0x2u)
N#define CSL_CHIP_AMR_BK1_16              (0x3u)
N#define CSL_CHIP_AMR_BK1_32              (0x4u)
N#define CSL_CHIP_AMR_BK1_64              (0x5u)
N#define CSL_CHIP_AMR_BK1_128             (0x6u)
N#define CSL_CHIP_AMR_BK1_256             (0x7u)
N#define CSL_CHIP_AMR_BK1_512             (0x8u)
N#define CSL_CHIP_AMR_BK1_1K              (0x9u)
N#define CSL_CHIP_AMR_BK1_2K              (0xAu)
N#define CSL_CHIP_AMR_BK1_4K              (0xBu)
N#define CSL_CHIP_AMR_BK1_8K              (0xCu)
N#define CSL_CHIP_AMR_BK1_16K             (0xDu)
N#define CSL_CHIP_AMR_BK1_32K             (0xEu)
N#define CSL_CHIP_AMR_BK1_64K             (0xFu)
N#define CSL_CHIP_AMR_BK1_128K            (0x10u)
N#define CSL_CHIP_AMR_BK1_256K            (0x11u)
N#define CSL_CHIP_AMR_BK1_512K            (0x12u)
N#define CSL_CHIP_AMR_BK1_1M              (0x13u)
N#define CSL_CHIP_AMR_BK1_2M              (0x14u)
N#define CSL_CHIP_AMR_BK1_4M              (0x15u)
N#define CSL_CHIP_AMR_BK1_8M              (0x16u)
N#define CSL_CHIP_AMR_BK1_16M             (0x17u)
N#define CSL_CHIP_AMR_BK1_32M             (0x18u)
N#define CSL_CHIP_AMR_BK1_64M             (0x19u)
N#define CSL_CHIP_AMR_BK1_128M            (0x1Au)
N#define CSL_CHIP_AMR_BK1_256M            (0x1Bu)
N#define CSL_CHIP_AMR_BK1_512M            (0x1Cu)
N#define CSL_CHIP_AMR_BK1_1G              (0x1Du)
N#define CSL_CHIP_AMR_BK1_2G              (0x1Eu)
N#define CSL_CHIP_AMR_BK1_4G              (0x1Fu)
N
N#define CSL_CHIP_AMR_BK0_MASK            (0x1F0000u)
N#define CSL_CHIP_AMR_BK0_SHIFT           (0x10u)
N#define CSL_CHIP_AMR_BK0_RESETVAL        (0x0u)
N
N/*----BK0 Tokens----*/
N#define CSL_CHIP_AMR_BK0_2               (0x0u)
N#define CSL_CHIP_AMR_BK0_4               (0x1u)
N#define CSL_CHIP_AMR_BK0_8               (0x2u)
N#define CSL_CHIP_AMR_BK0_16              (0x3u)
N#define CSL_CHIP_AMR_BK0_32              (0x4u)
N#define CSL_CHIP_AMR_BK0_64              (0x5u)
N#define CSL_CHIP_AMR_BK0_128             (0x6u)
N#define CSL_CHIP_AMR_BK0_256             (0x7u)
N#define CSL_CHIP_AMR_BK0_512             (0x8u)
N#define CSL_CHIP_AMR_BK0_1K              (0x9u)
N#define CSL_CHIP_AMR_BK0_2K              (0xAu)
N#define CSL_CHIP_AMR_BK0_4K              (0xBu)
N#define CSL_CHIP_AMR_BK0_8K              (0xCu)
N#define CSL_CHIP_AMR_BK0_16K             (0xDu)
N#define CSL_CHIP_AMR_BK0_32K             (0xEu)
N#define CSL_CHIP_AMR_BK0_64K             (0xFu)
N#define CSL_CHIP_AMR_BK0_128K            (0x10u)
N#define CSL_CHIP_AMR_BK0_256K            (0x11u)
N#define CSL_CHIP_AMR_BK0_512K            (0x12u)
N#define CSL_CHIP_AMR_BK0_1M              (0x13u)
N#define CSL_CHIP_AMR_BK0_2M              (0x14u)
N#define CSL_CHIP_AMR_BK0_4M              (0x15u)
N#define CSL_CHIP_AMR_BK0_8M              (0x16u)
N#define CSL_CHIP_AMR_BK0_16M             (0x17u)
N#define CSL_CHIP_AMR_BK0_32M             (0x18u)
N#define CSL_CHIP_AMR_BK0_64M             (0x19u)
N#define CSL_CHIP_AMR_BK0_128M            (0x1Au)
N#define CSL_CHIP_AMR_BK0_256M            (0x1Bu)
N#define CSL_CHIP_AMR_BK0_512M            (0x1Cu)
N#define CSL_CHIP_AMR_BK0_1G              (0x1Du)
N#define CSL_CHIP_AMR_BK0_2G              (0x1Eu)
N#define CSL_CHIP_AMR_BK0_4G              (0x1Fu)
N
N#define CSL_CHIP_AMR_B7MODE_MASK         (0xC000u)
N#define CSL_CHIP_AMR_B7MODE_SHIFT        (0xEu)
N#define CSL_CHIP_AMR_B7MODE_RESETVAL     (0x0u)
N
N/*----B7MODE Tokens----*/
N#define CSL_CHIP_AMR_B7MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_B7MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_B7MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_B6MODE_MASK         (0x3000u)
N#define CSL_CHIP_AMR_B6MODE_SHIFT        (0xCu)
N#define CSL_CHIP_AMR_B6MODE_RESETVAL     (0x0u)
N
N/*----B6MODE Tokens----*/
N#define CSL_CHIP_AMR_B6MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_B6MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_B6MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_B5MODE_MASK         (0xC00u)
N#define CSL_CHIP_AMR_B5MODE_SHIFT        (0xAu)
N#define CSL_CHIP_AMR_B5MODE_RESETVAL     (0x0u)
N
N/*----B5MODE Tokens----*/
N#define CSL_CHIP_AMR_B5MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_B5MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_B5MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_B4MODE_MASK         (0x300u)
N#define CSL_CHIP_AMR_B4MODE_SHIFT        (0x8u)
N#define CSL_CHIP_AMR_B4MODE_RESETVAL     (0x0u)
N
N/*----B4MODE Tokens----*/
N#define CSL_CHIP_AMR_B4MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_B4MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_B4MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_A7MODE_MASK         (0xC0u)
N#define CSL_CHIP_AMR_A7MODE_SHIFT        (0x6u)
N#define CSL_CHIP_AMR_A7MODE_RESETVAL     (0x0u)
N
N/*----A7MODE Tokens----*/
N#define CSL_CHIP_AMR_A7MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_A7MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_A7MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_A6MODE_MASK         (0x30u)
N#define CSL_CHIP_AMR_A6MODE_SHIFT        (0x4u)
N#define CSL_CHIP_AMR_A6MODE_RESETVAL     (0x0u)
N
N/*----A6MODE Tokens----*/
N#define CSL_CHIP_AMR_A6MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_A6MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_A6MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_A5MODE_MASK         (0xCu)
N#define CSL_CHIP_AMR_A5MODE_SHIFT        (0x2u)
N#define CSL_CHIP_AMR_A5MODE_RESETVAL     (0x0u)
N
N/*----A5MODE Tokens----*/
N#define CSL_CHIP_AMR_A5MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_A5MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_A5MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_A4MODE_MASK         (0x3u)
N#define CSL_CHIP_AMR_A4MODE_SHIFT        (0x0u)
N#define CSL_CHIP_AMR_A4MODE_RESETVAL     (0x0u)
N
N/*----A4MODE Tokens----*/
N#define CSL_CHIP_AMR_A4MODE_LINEAR       (0x0u)
N#define CSL_CHIP_AMR_A4MODE_CIRCULAR0    (0x1u)
N#define CSL_CHIP_AMR_A4MODE_CIRCULAR1    (0x2u)
N
N#define CSL_CHIP_AMR_RESETVAL            (0x0u)
N
N/* CSR */
N
N#define CSL_CHIP_CSR_CPUID_MASK          (0xFF000000u)
N#define CSL_CHIP_CSR_CPUID_SHIFT         (0x18u)
N#define CSL_CHIP_CSR_CPUID_RESETVAL      (0x0u)
N
N#define CSL_CHIP_CSR_REVISIONID_MASK     (0xFF0000u)
N#define CSL_CHIP_CSR_REVISIONID_SHIFT    (0x10u)
N#define CSL_CHIP_CSR_REVISIONID_RESETVAL (0x0u)
N
N#define CSL_CHIP_CSR_PWRD_MASK           (0xFC00u)
N#define CSL_CHIP_CSR_PWRD_SHIFT          (0xAu)
N#define CSL_CHIP_CSR_PWRD_RESETVAL       (0x0u)
N
N#define CSL_CHIP_CSR_SAT_MASK            (0x200u)
N#define CSL_CHIP_CSR_SAT_SHIFT           (0x9u)
N#define CSL_CHIP_CSR_SAT_RESETVAL        (0x0u)
N
N/*----SAT Tokens----*/
N#define CSL_CHIP_CSR_SAT_CLR             (0x0u)
N#define CSL_CHIP_CSR_SAT_SET             (0x1u)
N
N#define CSL_CHIP_CSR_EN_MASK             (0x100u)
N#define CSL_CHIP_CSR_EN_SHIFT            (0x8u)
N#define CSL_CHIP_CSR_EN_RESETVAL         (0x1u)
N
N/*----EN Tokens----*/
N#define CSL_CHIP_CSR_EN_LITTLE           (0x1u)
N
N#define CSL_CHIP_CSR_PCC_MASK            (0xE0u)
N#define CSL_CHIP_CSR_PCC_SHIFT           (0x5u)
N#define CSL_CHIP_CSR_PCC_RESETVAL        (0x0u)
N
N/*----PCC Tokens----*/
N#define CSL_CHIP_CSR_PCC_CACHE_EN        (0x2u)
N#define CSL_CHIP_CSR_PCC_CACHE_FREEZE    (0x3u)
N#define CSL_CHIP_CSR_PCC_CACHE_BYPASS    (0x4u)
N
N#define CSL_CHIP_CSR_DCC_MASK            (0x1Cu)
N#define CSL_CHIP_CSR_DCC_SHIFT           (0x2u)
N#define CSL_CHIP_CSR_DCC_RESETVAL        (0x0u)
N
N#define CSL_CHIP_CSR_PGIE_MASK           (0x2u)
N#define CSL_CHIP_CSR_PGIE_SHIFT          (0x1u)
N#define CSL_CHIP_CSR_PGIE_RESETVAL       (0x0u)
N
N/*----PGIE Tokens----*/
N#define CSL_CHIP_CSR_PGIE_DISABLE        (0x0u)
N#define CSL_CHIP_CSR_PGIE_ENABLE         (0x1u)
N
N#define CSL_CHIP_CSR_GIE_MASK            (0x1u)
N#define CSL_CHIP_CSR_GIE_SHIFT           (0x0u)
N#define CSL_CHIP_CSR_GIE_RESETVAL        (0x0u)
N
N/*----GIE Tokens----*/
N#define CSL_CHIP_CSR_GIE_DISABLE         (0x0u)
N#define CSL_CHIP_CSR_GIE_ENABLE          (0x1u)
N
N#define CSL_CHIP_CSR_RESETVAL            (0x100u)
N
N/* FADCR */
N
N#define CSL_CHIP_FADCR_L2RMODE_MASK      (0x6000000u)
N#define CSL_CHIP_FADCR_L2RMODE_SHIFT     (0x19u)
N#define CSL_CHIP_FADCR_L2RMODE_RESETVAL  (0x0u)
N
N/*----L2RMODE Tokens----*/
N#define CSL_CHIP_FADCR_L2RMODE_RTOFP     (0x0u)
N#define CSL_CHIP_FADCR_L2RMODE_RTOZERO   (0x1u)
N#define CSL_CHIP_FADCR_L2RMODE_RTOINF    (0x2u)
N#define CSL_CHIP_FADCR_L2RMODE_RTONEGINF (0x3u)
N
N#define CSL_CHIP_FADCR_L2UNDER_MASK      (0x1000000u)
N#define CSL_CHIP_FADCR_L2UNDER_SHIFT     (0x18u)
N#define CSL_CHIP_FADCR_L2UNDER_RESETVAL  (0x0u)
N
N/*----L2UNDER Tokens----*/
N#define CSL_CHIP_FADCR_L2UNDER_NO_UDRFLW (0x0u)
N#define CSL_CHIP_FADCR_L2UNDER_UDRFLW    (0x1u)
N
N#define CSL_CHIP_FADCR_L2INEX_MASK       (0x800000u)
N#define CSL_CHIP_FADCR_L2INEX_SHIFT      (0x17u)
N#define CSL_CHIP_FADCR_L2INEX_RESETVAL   (0x0u)
N
N/*----L2INEX Tokens----*/
N#define CSL_CHIP_FADCR_L2INEX_CLR        (0x0u)
N#define CSL_CHIP_FADCR_L2INEX_SET        (0x1u)
N
N#define CSL_CHIP_FADCR_L2OVER_MASK       (0x400000u)
N#define CSL_CHIP_FADCR_L2OVER_SHIFT      (0x16u)
N#define CSL_CHIP_FADCR_L2OVER_RESETVAL   (0x0u)
N
N/*----L2OVER Tokens----*/
N#define CSL_CHIP_FADCR_L2OVER_NO_OVRFLW  (0x0u)
N#define CSL_CHIP_FADCR_L2OVER_OVRFLW     (0x1u)
N
N#define CSL_CHIP_FADCR_L2INFO_MASK       (0x200000u)
N#define CSL_CHIP_FADCR_L2INFO_SHIFT      (0x15u)
N#define CSL_CHIP_FADCR_L2INFO_RESETVAL   (0x0u)
N
N/*----L2INFO Tokens----*/
N#define CSL_CHIP_FADCR_L2INFO_NO_SIGNINF (0x0u)
N#define CSL_CHIP_FADCR_L2INFO_SIGNINF    (0x1u)
N
N#define CSL_CHIP_FADCR_L2INVAL_MASK      (0x100000u)
N#define CSL_CHIP_FADCR_L2INVAL_SHIFT     (0x14u)
N#define CSL_CHIP_FADCR_L2INVAL_RESETVAL  (0x0u)
N
N/*----L2INVAL Tokens----*/
N#define CSL_CHIP_FADCR_L2INVAL_NAN_NOSRC (0x0u)
N#define CSL_CHIP_FADCR_L2INVAL_NAN_SRC   (0x1u)
N
N#define CSL_CHIP_FADCR_L2DEN2_MASK       (0x80000u)
N#define CSL_CHIP_FADCR_L2DEN2_SHIFT      (0x13u)
N#define CSL_CHIP_FADCR_L2DEN2_RESETVAL   (0x0u)
N
N/*----L2DEN2 Tokens----*/
N#define CSL_CHIP_FADCR_L2DEN2_SRC2_NODNORM (0x0u)
N#define CSL_CHIP_FADCR_L2DEN2_SRC2_DNORM (0x1u)
N
N#define CSL_CHIP_FADCR_L2DEN1_MASK       (0x40000u)
N#define CSL_CHIP_FADCR_L2DEN1_SHIFT      (0x12u)
N#define CSL_CHIP_FADCR_L2DEN1_RESETVAL   (0x0u)
N
N/*----L2DEN1 Tokens----*/
N#define CSL_CHIP_FADCR_L2DEN1_SRC1_NODNORM (0x0u)
N#define CSL_CHIP_FADCR_L2DEN1_SRC1_DNORM (0x1u)
N
N#define CSL_CHIP_FADCR_L2NAN2_MASK       (0x20000u)
N#define CSL_CHIP_FADCR_L2NAN2_SHIFT      (0x11u)
N#define CSL_CHIP_FADCR_L2NAN2_RESETVAL   (0x0u)
N
N/*----L2NAN2 Tokens----*/
N#define CSL_CHIP_FADCR_L2NAN2_SRC2_NONAN (0x0u)
N#define CSL_CHIP_FADCR_L2NAN2_SRC2_NAN   (0x1u)
N
N#define CSL_CHIP_FADCR_L2NAN1_MASK       (0x10000u)
N#define CSL_CHIP_FADCR_L2NAN1_SHIFT      (0x10u)
N#define CSL_CHIP_FADCR_L2NAN1_RESETVAL   (0x0u)
N
N/*----L2NAN1 Tokens----*/
N#define CSL_CHIP_FADCR_L2NAN1_SRC1_NONAN (0x0u)
N#define CSL_CHIP_FADCR_L2NAN1_SRC1_NAN   (0x1u)
N
N#define CSL_CHIP_FADCR_L1RMODE_MASK      (0x600u)
N#define CSL_CHIP_FADCR_L1RMODE_SHIFT     (0x9u)
N#define CSL_CHIP_FADCR_L1RMODE_RESETVAL  (0x0u)
N
N/*----L1RMODE Tokens----*/
N#define CSL_CHIP_FADCR_L1RMODE_RTOFP     (0x0u)
N#define CSL_CHIP_FADCR_L1RMODE_RTOZERO   (0x1u)
N#define CSL_CHIP_FADCR_L1RMODE_RTOINF    (0x2u)
N#define CSL_CHIP_FADCR_L1RMODE_RTONEGINF (0x3u)
N
N#define CSL_CHIP_FADCR_L1UNDER_MASK      (0x100u)
N#define CSL_CHIP_FADCR_L1UNDER_SHIFT     (0x8u)
N#define CSL_CHIP_FADCR_L1UNDER_RESETVAL  (0x0u)
N
N/*----L1UNDER Tokens----*/
N#define CSL_CHIP_FADCR_L1UNDER_NO_UDRFLW (0x0u)
N#define CSL_CHIP_FADCR_L1UNDER_UDRFLW    (0x1u)
N
N#define CSL_CHIP_FADCR_L1INEX_MASK       (0x80u)
N#define CSL_CHIP_FADCR_L1INEX_SHIFT      (0x7u)
N#define CSL_CHIP_FADCR_L1INEX_RESETVAL   (0x0u)
N
N/*----L1INEX Tokens----*/
N#define CSL_CHIP_FADCR_L1INEX_CLR        (0x0u)
N#define CSL_CHIP_FADCR_L1INEX_SET        (0x1u)
N
N#define CSL_CHIP_FADCR_L1OVER_MASK       (0x40u)
N#define CSL_CHIP_FADCR_L1OVER_SHIFT      (0x6u)
N#define CSL_CHIP_FADCR_L1OVER_RESETVAL   (0x0u)
N
N/*----L1OVER Tokens----*/
N#define CSL_CHIP_FADCR_L1OVER_NO_OVRFLW  (0x0u)
N#define CSL_CHIP_FADCR_L1OVER_OVRFLW     (0x1u)
N
N#define CSL_CHIP_FADCR_L1INFO_MASK       (0x20u)
N#define CSL_CHIP_FADCR_L1INFO_SHIFT      (0x5u)
N#define CSL_CHIP_FADCR_L1INFO_RESETVAL   (0x0u)
N
N/*----L1INFO Tokens----*/
N#define CSL_CHIP_FADCR_L1INFO_NO_SIGNINF (0x0u)
N#define CSL_CHIP_FADCR_L1INFO_SIGNINF    (0x1u)
N
N#define CSL_CHIP_FADCR_L1INVAL_MASK      (0x10u)
N#define CSL_CHIP_FADCR_L1INVAL_SHIFT     (0x4u)
N#define CSL_CHIP_FADCR_L1INVAL_RESETVAL  (0x0u)
N
N/*----L1INVAL Tokens----*/
N#define CSL_CHIP_FADCR_L1INVAL_NAN_NOSRC (0x0u)
N#define CSL_CHIP_FADCR_L1INVAL_NAN_SRC   (0x1u)
N
N#define CSL_CHIP_FADCR_L1DEN2_MASK       (0x8u)
N#define CSL_CHIP_FADCR_L1DEN2_SHIFT      (0x3u)
N#define CSL_CHIP_FADCR_L1DEN2_RESETVAL   (0x0u)
N
N/*----L1DEN2 Tokens----*/
N#define CSL_CHIP_FADCR_L1DEN2_SRC2_NODNORM (0x0u)
N#define CSL_CHIP_FADCR_L1DEN2_SRC2_DNORM (0x1u)
N
N#define CSL_CHIP_FADCR_L1DEN1_MASK       (0x4u)
N#define CSL_CHIP_FADCR_L1DEN1_SHIFT      (0x2u)
N#define CSL_CHIP_FADCR_L1DEN1_RESETVAL   (0x0u)
N
N/*----L1DEN1 Tokens----*/
N#define CSL_CHIP_FADCR_L1DEN1_SRC1_NODNORM (0x0u)
N#define CSL_CHIP_FADCR_L1DEN1_SRC1_DNORM (0x1u)
N
N#define CSL_CHIP_FADCR_L1NAN2_MASK       (0x2u)
N#define CSL_CHIP_FADCR_L1NAN2_SHIFT      (0x1u)
N#define CSL_CHIP_FADCR_L1NAN2_RESETVAL   (0x0u)
N
N/*----L1NAN2 Tokens----*/
N#define CSL_CHIP_FADCR_L1NAN2_SRC2_NONAN (0x0u)
N#define CSL_CHIP_FADCR_L1NAN2_SRC2_NAN   (0x1u)
N
N#define CSL_CHIP_FADCR_L1NAN1_MASK       (0x1u)
N#define CSL_CHIP_FADCR_L1NAN1_SHIFT      (0x0u)
N#define CSL_CHIP_FADCR_L1NAN1_RESETVAL   (0x0u)
N
N/*----L1NAN1 Tokens----*/
N#define CSL_CHIP_FADCR_L1NAN1_SRC1_NONAN (0x0u)
N#define CSL_CHIP_FADCR_L1NAN1_SRC1_NAN   (0x1u)
N
N#define CSL_CHIP_FADCR_RESETVAL          (0x0u)
N
N/* FAUCR */
N
N#define CSL_CHIP_FAUCR_S2DIV0_MASK       (0x4000000u)
N#define CSL_CHIP_FAUCR_S2DIV0_SHIFT      (0x1Au)
N#define CSL_CHIP_FAUCR_S2DIV0_RESETVAL   (0x0u)
N
N/*----S2DIV0 Tokens----*/
N#define CSL_CHIP_FAUCR_S2DIV0_ZER0       (0x0u)
N#define CSL_CHIP_FAUCR_S2DIV0_NONZERO    (0x1u)
N
N#define CSL_CHIP_FAUCR_S2UNORD_MASK      (0x2000000u)
N#define CSL_CHIP_FAUCR_S2UNORD_SHIFT     (0x19u)
N#define CSL_CHIP_FAUCR_S2UNORD_RESETVAL  (0x0u)
N
N/*----S2UNORD Tokens----*/
N#define CSL_CHIP_FAUCR_S2UNORD_NAN_NOSRC (0x0u)
N#define CSL_CHIP_FAUCR_S2UNORD_NAN_SRC   (0x1u)
N
N#define CSL_CHIP_FAUCR_S2UNDER_MASK      (0x1000000u)
N#define CSL_CHIP_FAUCR_S2UNDER_SHIFT     (0x18u)
N#define CSL_CHIP_FAUCR_S2UNDER_RESETVAL  (0x0u)
N
N/*----S2UNDER Tokens----*/
N#define CSL_CHIP_FAUCR_S2UNDER_NO_UDRFLW (0x0u)
N#define CSL_CHIP_FAUCR_S2UNDER_UDRFLW    (0x1u)
N
N#define CSL_CHIP_FAUCR_S2INEX_MASK       (0x800000u)
N#define CSL_CHIP_FAUCR_S2INEX_SHIFT      (0x17u)
N#define CSL_CHIP_FAUCR_S2INEX_RESETVAL   (0x0u)
N
N/*----S2INEX Tokens----*/
N#define CSL_CHIP_FAUCR_S2INEX_CLR        (0x0u)
N#define CSL_CHIP_FAUCR_S2INEX_SET        (0x1u)
N
N#define CSL_CHIP_FAUCR_S2OVER_MASK       (0x400000u)
N#define CSL_CHIP_FAUCR_S2OVER_SHIFT      (0x16u)
N#define CSL_CHIP_FAUCR_S2OVER_RESETVAL   (0x0u)
N
N/*----S2OVER Tokens----*/
N#define CSL_CHIP_FAUCR_S2OVER_NO_OVRFLW  (0x0u)
N#define CSL_CHIP_FAUCR_S2OVER_OVRFLW     (0x1u)
N
N#define CSL_CHIP_FAUCR_S2INFO_MASK       (0x200000u)
N#define CSL_CHIP_FAUCR_S2INFO_SHIFT      (0x15u)
N#define CSL_CHIP_FAUCR_S2INFO_RESETVAL   (0x0u)
N
N/*----S2INFO Tokens----*/
N#define CSL_CHIP_FAUCR_S2INFO_NO_SIGNINF (0x0u)
N#define CSL_CHIP_FAUCR_S2INFO_SIGNINF    (0x1u)
N
N#define CSL_CHIP_FAUCR_S2INVAL_MASK      (0x100000u)
N#define CSL_CHIP_FAUCR_S2INVAL_SHIFT     (0x14u)
N#define CSL_CHIP_FAUCR_S2INVAL_RESETVAL  (0x0u)
N
N/*----S2INVAL Tokens----*/
N#define CSL_CHIP_FAUCR_S2INVAL_NAN_NOSRC (0x0u)
N#define CSL_CHIP_FAUCR_S2INVAL_NAN_SRC   (0x1u)
N
N#define CSL_CHIP_FAUCR_S2DEN2_MASK       (0x80000u)
N#define CSL_CHIP_FAUCR_S2DEN2_SHIFT      (0x13u)
N#define CSL_CHIP_FAUCR_S2DEN2_RESETVAL   (0x0u)
N
N/*----S2DEN2 Tokens----*/
N#define CSL_CHIP_FAUCR_S2DEN2_SRC2_NODNORM (0x0u)
N#define CSL_CHIP_FAUCR_S2DEN2_SRC2_DNORM (0x1u)
N
N#define CSL_CHIP_FAUCR_S2DEN1_MASK       (0x40000u)
N#define CSL_CHIP_FAUCR_S2DEN1_SHIFT      (0x12u)
N#define CSL_CHIP_FAUCR_S2DEN1_RESETVAL   (0x0u)
N
N/*----S2DEN1 Tokens----*/
N#define CSL_CHIP_FAUCR_S2DEN1_SRC1_NODNORM (0x0u)
N#define CSL_CHIP_FAUCR_S2DEN1_SRC1_DNORM (0x1u)
N
N#define CSL_CHIP_FAUCR_S2NAN2_MASK       (0x20000u)
N#define CSL_CHIP_FAUCR_S2NAN2_SHIFT      (0x11u)
N#define CSL_CHIP_FAUCR_S2NAN2_RESETVAL   (0x0u)
N
N/*----S2NAN2 Tokens----*/
N#define CSL_CHIP_FAUCR_S2NAN2_SRC2_NONAN (0x0u)
N#define CSL_CHIP_FAUCR_S2NAN2_SRC2_NAN   (0x1u)
N
N#define CSL_CHIP_FAUCR_S2NAN1_MASK       (0x10000u)
N#define CSL_CHIP_FAUCR_S2NAN1_SHIFT      (0x10u)
N#define CSL_CHIP_FAUCR_S2NAN1_RESETVAL   (0x0u)
N
N/*----S2NAN1 Tokens----*/
N#define CSL_CHIP_FAUCR_S2NAN1_SRC1_NONAN (0x0u)
N#define CSL_CHIP_FAUCR_S2NAN1_SRC1_NAN   (0x1u)
N
N#define CSL_CHIP_FAUCR_S1DIVO_MASK       (0x400u)
N#define CSL_CHIP_FAUCR_S1DIVO_SHIFT      (0xAu)
N#define CSL_CHIP_FAUCR_S1DIVO_RESETVAL   (0x0u)
N
N/*----S1DIVO Tokens----*/
N#define CSL_CHIP_FAUCR_S1DIVO_ZER0       (0x0u)
N#define CSL_CHIP_FAUCR_S1DIVO_NONZERO    (0x1u)
N
N#define CSL_CHIP_FAUCR_S1UNORD_MASK      (0x200u)
N#define CSL_CHIP_FAUCR_S1UNORD_SHIFT     (0x9u)
N#define CSL_CHIP_FAUCR_S1UNORD_RESETVAL  (0x0u)
N
N/*----S1UNORD Tokens----*/
N#define CSL_CHIP_FAUCR_S1UNORD_NAN_NOSRC (0x0u)
N#define CSL_CHIP_FAUCR_S1UNORD_NAN_SRC   (0x1u)
N
N#define CSL_CHIP_FAUCR_S1UNDER_MASK      (0x100u)
N#define CSL_CHIP_FAUCR_S1UNDER_SHIFT     (0x8u)
N#define CSL_CHIP_FAUCR_S1UNDER_RESETVAL  (0x0u)
N
N/*----S1UNDER Tokens----*/
N#define CSL_CHIP_FAUCR_S1UNDER_NO_UDRFLW (0x0u)
N#define CSL_CHIP_FAUCR_S1UNDER_UDRFLW    (0x1u)
N
N#define CSL_CHIP_FAUCR_S1INEX_MASK       (0x80u)
N#define CSL_CHIP_FAUCR_S1INEX_SHIFT      (0x7u)
N#define CSL_CHIP_FAUCR_S1INEX_RESETVAL   (0x0u)
N
N/*----S1INEX Tokens----*/
N#define CSL_CHIP_FAUCR_S1INEX_CLR        (0x0u)
N#define CSL_CHIP_FAUCR_S1INEX_SET        (0x1u)
N
N#define CSL_CHIP_FAUCR_S1OVER_MASK       (0x40u)
N#define CSL_CHIP_FAUCR_S1OVER_SHIFT      (0x6u)
N#define CSL_CHIP_FAUCR_S1OVER_RESETVAL   (0x0u)
N
N/*----S1OVER Tokens----*/
N#define CSL_CHIP_FAUCR_S1OVER_NO_OVRFLW  (0x0u)
N#define CSL_CHIP_FAUCR_S1OVER_OVRFLW     (0x1u)
N
N#define CSL_CHIP_FAUCR_S1INFO_MASK       (0x20u)
N#define CSL_CHIP_FAUCR_S1INFO_SHIFT      (0x5u)
N#define CSL_CHIP_FAUCR_S1INFO_RESETVAL   (0x0u)
N
N/*----S1INFO Tokens----*/
N#define CSL_CHIP_FAUCR_S1INFO_NO_SIGNINF (0x0u)
N#define CSL_CHIP_FAUCR_S1INFO_SIGNINF    (0x1u)
N
N#define CSL_CHIP_FAUCR_S1INVAL_MASK      (0x10u)
N#define CSL_CHIP_FAUCR_S1INVAL_SHIFT     (0x4u)
N#define CSL_CHIP_FAUCR_S1INVAL_RESETVAL  (0x0u)
N
N/*----S1INVAL Tokens----*/
N#define CSL_CHIP_FAUCR_S1INVAL_NAN_NOSRC (0x0u)
N#define CSL_CHIP_FAUCR_S1INVAL_NAN_SRC   (0x1u)
N
N#define CSL_CHIP_FAUCR_S1DEN2_MASK       (0x8u)
N#define CSL_CHIP_FAUCR_S1DEN2_SHIFT      (0x3u)
N#define CSL_CHIP_FAUCR_S1DEN2_RESETVAL   (0x0u)
N
N/*----S1DEN2 Tokens----*/
N#define CSL_CHIP_FAUCR_S1DEN2_SRC2_NDNORM (0x0u)
N#define CSL_CHIP_FAUCR_S1DEN2_SRC2_DNORM (0x1u)
N
N#define CSL_CHIP_FAUCR_S1DEN1_MASK       (0x4u)
N#define CSL_CHIP_FAUCR_S1DEN1_SHIFT      (0x2u)
N#define CSL_CHIP_FAUCR_S1DEN1_RESETVAL   (0x0u)
N
N/*----S1DEN1 Tokens----*/
N#define CSL_CHIP_FAUCR_S1DEN1_SRC1_NODNORM (0x0u)
N#define CSL_CHIP_FAUCR_S1DEN1_SRC1_DNORM (0x1u)
N
N#define CSL_CHIP_FAUCR_S1NAN2_MASK       (0x2u)
N#define CSL_CHIP_FAUCR_S1NAN2_SHIFT      (0x1u)
N#define CSL_CHIP_FAUCR_S1NAN2_RESETVAL   (0x0u)
N
N/*----S1NAN2 Tokens----*/
N#define CSL_CHIP_FAUCR_S1NAN2_SRC2_NONAN (0x0u)
N#define CSL_CHIP_FAUCR_S1NAN2_SRC2_NAN   (0x1u)
N
N#define CSL_CHIP_FAUCR_S1NAN1_MASK       (0x1u)
N#define CSL_CHIP_FAUCR_S1NAN1_SHIFT      (0x0u)
N#define CSL_CHIP_FAUCR_S1NAN1_RESETVAL   (0x0u)
N
N/*----S1NAN1 Tokens----*/
N#define CSL_CHIP_FAUCR_S1NAN1_SRC1_NONAN (0x0u)
N#define CSL_CHIP_FAUCR_S1NAN1_SRC1_NAN   (0x1u)
N
N#define CSL_CHIP_FAUCR_RESETVAL          (0x0u)
N
N/* FMCR */
N
N#define CSL_CHIP_FMCR_M2RMODE_MASK       (0x6000000u)
N#define CSL_CHIP_FMCR_M2RMODE_SHIFT      (0x19u)
N#define CSL_CHIP_FMCR_M2RMODE_RESETVAL   (0x0u)
N
N/*----M2RMODE Tokens----*/
N#define CSL_CHIP_FMCR_M2RMODE_RTOFP      (0x0u)
N#define CSL_CHIP_FMCR_M2RMODE_RTOZERO    (0x1u)
N#define CSL_CHIP_FMCR_M2RMODE_RTOINF     (0x2u)
N#define CSL_CHIP_FMCR_M2RMODE_RTONEGINF  (0x3u)
N
N#define CSL_CHIP_FMCR_M2UNDER_MASK       (0x1000000u)
N#define CSL_CHIP_FMCR_M2UNDER_SHIFT      (0x18u)
N#define CSL_CHIP_FMCR_M2UNDER_RESETVAL   (0x0u)
N
N/*----M2UNDER Tokens----*/
N#define CSL_CHIP_FMCR_M2UNDER_NO_UDRFLW  (0x0u)
N#define CSL_CHIP_FMCR_M2UNDER_UDRFLW     (0x1u)
N
N#define CSL_CHIP_FMCR_M2INEX_MASK        (0x800000u)
N#define CSL_CHIP_FMCR_M2INEX_SHIFT       (0x17u)
N#define CSL_CHIP_FMCR_M2INEX_RESETVAL    (0x0u)
N
N/*----M2INEX Tokens----*/
N#define CSL_CHIP_FMCR_M2INEX_CLR         (0x0u)
N#define CSL_CHIP_FMCR_M2INEX_SET         (0x1u)
N
N#define CSL_CHIP_FMCR_M2OVER_MASK        (0x400000u)
N#define CSL_CHIP_FMCR_M2OVER_SHIFT       (0x16u)
N#define CSL_CHIP_FMCR_M2OVER_RESETVAL    (0x0u)
N
N/*----M2OVER Tokens----*/
N#define CSL_CHIP_FMCR_M2OVER_NO_OVRFLW   (0x0u)
N#define CSL_CHIP_FMCR_M2OVER_OVRFLW      (0x1u)
N
N#define CSL_CHIP_FMCR_M2INFO_MASK        (0x200000u)
N#define CSL_CHIP_FMCR_M2INFO_SHIFT       (0x15u)
N#define CSL_CHIP_FMCR_M2INFO_RESETVAL    (0x0u)
N
N/*----M2INFO Tokens----*/
N#define CSL_CHIP_FMCR_M2INFO_NO_SIGNINF  (0x0u)
N#define CSL_CHIP_FMCR_M2INFO_SIGNINF     (0x1u)
N
N#define CSL_CHIP_FMCR_M2INVAL_MASK       (0x100000u)
N#define CSL_CHIP_FMCR_M2INVAL_SHIFT      (0x14u)
N#define CSL_CHIP_FMCR_M2INVAL_RESETVAL   (0x0u)
N
N/*----M2INVAL Tokens----*/
N#define CSL_CHIP_FMCR_M2INVAL_NAN_NOSRC  (0x0u)
N#define CSL_CHIP_FMCR_M2INVAL_NAN_SRC    (0x1u)
N
N#define CSL_CHIP_FMCR_M2DEN2_MASK        (0x80000u)
N#define CSL_CHIP_FMCR_M2DEN2_SHIFT       (0x13u)
N#define CSL_CHIP_FMCR_M2DEN2_RESETVAL    (0x0u)
N
N/*----M2DEN2 Tokens----*/
N#define CSL_CHIP_FMCR_M2DEN2_SRC2_NODNORM (0x0u)
N#define CSL_CHIP_FMCR_M2DEN2_SRC2_DNORM  (0x1u)
N
N#define CSL_CHIP_FMCR_M2DEN1_MASK        (0x40000u)
N#define CSL_CHIP_FMCR_M2DEN1_SHIFT       (0x12u)
N#define CSL_CHIP_FMCR_M2DEN1_RESETVAL    (0x0u)
N
N/*----M2DEN1 Tokens----*/
N#define CSL_CHIP_FMCR_M2DEN1_SRC1_NODNORM (0x0u)
N#define CSL_CHIP_FMCR_M2DEN1_SRC1_DNORM  (0x1u)
N
N#define CSL_CHIP_FMCR_M2NAN2_MASK        (0x20000u)
N#define CSL_CHIP_FMCR_M2NAN2_SHIFT       (0x11u)
N#define CSL_CHIP_FMCR_M2NAN2_RESETVAL    (0x0u)
N
N/*----M2NAN2 Tokens----*/
N#define CSL_CHIP_FMCR_M2NAN2_SRC2_NONAN  (0x0u)
N#define CSL_CHIP_FMCR_M2NAN2_SRC2_NAN    (0x1u)
N
N#define CSL_CHIP_FMCR_M2NAN1_MASK        (0x10000u)
N#define CSL_CHIP_FMCR_M2NAN1_SHIFT       (0x10u)
N#define CSL_CHIP_FMCR_M2NAN1_RESETVAL    (0x0u)
N
N/*----M2NAN1 Tokens----*/
N#define CSL_CHIP_FMCR_M2NAN1_SRC1_NONAN  (0x0u)
N#define CSL_CHIP_FMCR_M2NAN1_SRC1_NAN    (0x1u)
N
N#define CSL_CHIP_FMCR_M1RMODE_MASK       (0x600u)
N#define CSL_CHIP_FMCR_M1RMODE_SHIFT      (0x9u)
N#define CSL_CHIP_FMCR_M1RMODE_RESETVAL   (0x0u)
N
N/*----M1RMODE Tokens----*/
N#define CSL_CHIP_FMCR_M1RMODE_RTOFP      (0x0u)
N#define CSL_CHIP_FMCR_M1RMODE_RTOZERO    (0x1u)
N#define CSL_CHIP_FMCR_M1RMODE_RTOINF     (0x2u)
N#define CSL_CHIP_FMCR_M1RMODE_RTONEGINF  (0x3u)
N
N#define CSL_CHIP_FMCR_M1UNDER_MASK       (0x100u)
N#define CSL_CHIP_FMCR_M1UNDER_SHIFT      (0x8u)
N#define CSL_CHIP_FMCR_M1UNDER_RESETVAL   (0x0u)
N
N/*----M1UNDER Tokens----*/
N#define CSL_CHIP_FMCR_M1UNDER_NO_UDRFLW  (0x0u)
N#define CSL_CHIP_FMCR_M1UNDER_UDRFLW     (0x1u)
N
N#define CSL_CHIP_FMCR_M1INEX_MASK        (0x80u)
N#define CSL_CHIP_FMCR_M1INEX_SHIFT       (0x7u)
N#define CSL_CHIP_FMCR_M1INEX_RESETVAL    (0x0u)
N
N/*----M1INEX Tokens----*/
N#define CSL_CHIP_FMCR_M1INEX_CLR         (0x0u)
N#define CSL_CHIP_FMCR_M1INEX_SET         (0x1u)
N
N#define CSL_CHIP_FMCR_M1OVER_MASK        (0x40u)
N#define CSL_CHIP_FMCR_M1OVER_SHIFT       (0x6u)
N#define CSL_CHIP_FMCR_M1OVER_RESETVAL    (0x0u)
N
N/*----M1OVER Tokens----*/
N#define CSL_CHIP_FMCR_M1OVER_NO_OVRFLW   (0x0u)
N#define CSL_CHIP_FMCR_M1OVER_OVRFLW      (0x1u)
N
N#define CSL_CHIP_FMCR_M1INFO_MASK        (0x20u)
N#define CSL_CHIP_FMCR_M1INFO_SHIFT       (0x5u)
N#define CSL_CHIP_FMCR_M1INFO_RESETVAL    (0x0u)
N
N/*----M1INFO Tokens----*/
N#define CSL_CHIP_FMCR_M1INFO_NO_SIGNINF  (0x0u)
N#define CSL_CHIP_FMCR_M1INFO_SIGNINF     (0x1u)
N
N#define CSL_CHIP_FMCR_M1INVAL_MASK       (0x10u)
N#define CSL_CHIP_FMCR_M1INVAL_SHIFT      (0x4u)
N#define CSL_CHIP_FMCR_M1INVAL_RESETVAL   (0x0u)
N
N/*----M1INVAL Tokens----*/
N#define CSL_CHIP_FMCR_M1INVAL_NAN_NOSRC  (0x0u)
N#define CSL_CHIP_FMCR_M1INVAL_NAN_SRC    (0x1u)
N
N#define CSL_CHIP_FMCR_M1DEN2_MASK        (0x8u)
N#define CSL_CHIP_FMCR_M1DEN2_SHIFT       (0x3u)
N#define CSL_CHIP_FMCR_M1DEN2_RESETVAL    (0x0u)
N
N/*----M1DEN2 Tokens----*/
N#define CSL_CHIP_FMCR_M1DEN2_SRC2_NODNORM (0x0u)
N#define CSL_CHIP_FMCR_M1DEN2_SRC2_DNORM  (0x1u)
N
N#define CSL_CHIP_FMCR_M1DEN1_MASK        (0x4u)
N#define CSL_CHIP_FMCR_M1DEN1_SHIFT       (0x2u)
N#define CSL_CHIP_FMCR_M1DEN1_RESETVAL    (0x0u)
N
N/*----M1DEN1 Tokens----*/
N#define CSL_CHIP_FMCR_M1DEN1_SRC1_NODNORM (0x0u)
N#define CSL_CHIP_FMCR_M1DEN1_SRC1_DNORM  (0x1u)
N
N#define CSL_CHIP_FMCR_M1NAN2_MASK        (0x2u)
N#define CSL_CHIP_FMCR_M1NAN2_SHIFT       (0x1u)
N#define CSL_CHIP_FMCR_M1NAN2_RESETVAL    (0x0u)
N
N/*----M1NAN2 Tokens----*/
N#define CSL_CHIP_FMCR_M1NAN2_SRC2_NONAN  (0x0u)
N#define CSL_CHIP_FMCR_M1NAN2_SRC2_NAN    (0x1u)
N
N#define CSL_CHIP_FMCR_M1NAN1_MASK        (0x1u)
N#define CSL_CHIP_FMCR_M1NAN1_SHIFT       (0x0u)
N#define CSL_CHIP_FMCR_M1NAN1_RESETVAL    (0x0u)
N
N/*----M1NAN1 Tokens----*/
N#define CSL_CHIP_FMCR_M1NAN1_SRC1_NONAN  (0x0u)
N#define CSL_CHIP_FMCR_M1NAN1_SRC1_NAN    (0x1u)
N
N#define CSL_CHIP_FMCR_RESETVAL           (0x0u)
N
N#endif
L 36 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_emif.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_emif.h" 1
N#ifndef _CSLR_EMIF_H_
N#define _CSLR_EMIF_H_
N/*********************************************************************
N * Copyright (C) 2003-2006 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_emif.h
N * 
N * \brief This file contains the Register Desciptions for EMIF
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 RSVD0[1];
N    volatile Uint32 AWCCR;
N    volatile Uint32 SDCR;
N    volatile Uint32 SDRCR;
N    volatile Uint32 A1CR;
N    volatile Uint32 RSVD1[3];
N    volatile Uint32 SDTIMR;
N    volatile Uint32 RSVD2[6];
N    volatile Uint32 SDSRETR;
N    volatile Uint32 EIRR;
N    volatile Uint32 EIMR;
N    volatile Uint32 EIMSR;
N    volatile Uint32 EIMCR;
N    volatile Uint32 RSVD3[4];
N    volatile Uint32 NANDFCR;
N    volatile Uint32 NANDFSR;
N    volatile Uint32 RSVD4[2];
N    volatile Uint32 NANDF1ECC;
N} CSL_EmifRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* AWCCR */
N
N#define CSL_EMIF_AWCCR_WP0_MASK          (0x10000000u)
N#define CSL_EMIF_AWCCR_WP0_SHIFT         (0x0000001Cu)
N#define CSL_EMIF_AWCCR_WP0_RESETVAL      (0x00000001u)
N
N/*----WP0 Tokens----*/
N#define CSL_EMIF_AWCCR_WP0_LOW           (0x00000000u)
N#define CSL_EMIF_AWCCR_WP0_HIGHI         (0x00000001u)
N
N#define CSL_EMIF_AWCCR_MEWC_MASK         (0x000000FFu)
N#define CSL_EMIF_AWCCR_MEWC_SHIFT        (0x00000000u)
N#define CSL_EMIF_AWCCR_MEWC_RESETVAL     (0x00000080u)
N
N#define CSL_EMIF_AWCCR_RESETVAL          (0x10000080u)
N
N/* SDCR */
N
N#define CSL_EMIF_SDCR_SR_MASK            (0x80000000u)
N#define CSL_EMIF_SDCR_SR_SHIFT           (0x0000001Fu)
N#define CSL_EMIF_SDCR_SR_RESETVAL        (0x00000000u)
N
N/*----SR Tokens----*/
N#define CSL_EMIF_SDCR_SR_DISABLE         (0x00000000u)
N#define CSL_EMIF_SDCR_SR_ENABLE          (0x00000001u)
N
N#define CSL_EMIF_SDCR_NM_MASK            (0x00004000u)
N#define CSL_EMIF_SDCR_NM_SHIFT           (0x0000000Eu)
N#define CSL_EMIF_SDCR_NM_RESETVAL        (0x00000000u)
N
N/*----NM Tokens----*/
N#define CSL_EMIF_SDCR_NM_32BIT_DATA      (0x00000000u)
N#define CSL_EMIF_SDCR_NM_16BIT_DATA      (0x00000001u)
N
N#define CSL_EMIF_SDCR_CL_MASK            (0x00000E00u)
N#define CSL_EMIF_SDCR_CL_SHIFT           (0x00000009u)
N#define CSL_EMIF_SDCR_CL_RESETVAL        (0x00000003u)
N
N/*----CL Tokens----*/
N#define CSL_EMIF_SDCR_CL_LATENCY_2       (0x00000002u)
N#define CSL_EMIF_SDCR_CL_LATENCY_3       (0x00000003u)
N
N#define CSL_EMIF_SDCR_BIT11_9LOCK_MASK   (0x00000100u)
N#define CSL_EMIF_SDCR_BIT11_9LOCK_SHIFT  (0x00000008u)
N#define CSL_EMIF_SDCR_BIT11_9LOCK_RESETVAL (0x00000000u)
N
N/*----BIT11_9LOCK Tokens----*/
N#define CSL_EMIF_SDCR_BIT11_9LOCK_UNLOCK (0x00000001u)
N
N#define CSL_EMIF_SDCR_IBANK_MASK         (0x00000070u)
N#define CSL_EMIF_SDCR_IBANK_SHIFT        (0x00000004u)
N#define CSL_EMIF_SDCR_IBANK_RESETVAL     (0x00000002u)
N
N/*----IBANK Tokens----*/
N#define CSL_EMIF_SDCR_IBANK_NO_OF_BANK_1 (0x00000000u)
N#define CSL_EMIF_SDCR_IBANK_NO_OF_BANK_2 (0x00000001u)
N#define CSL_EMIF_SDCR_IBANK_NO_OF_BANK_4 (0x00000002u)
N
N#define CSL_EMIF_SDCR_PAGESIZE_MASK      (0x00000007u)
N#define CSL_EMIF_SDCR_PAGESIZE_SHIFT     (0x00000000u)
N#define CSL_EMIF_SDCR_PAGESIZE_RESETVAL  (0x00000000u)
N
N/*----PAGESIZE Tokens----*/
N#define CSL_EMIF_SDCR_PAGESIZE_256WORD_8COL_ADDR (0x00000000u)
N#define CSL_EMIF_SDCR_PAGESIZE_512WORD_9COL_ADDR (0x00000001u)
N#define CSL_EMIF_SDCR_PAGESIZE_1024WORD_10COL_ADDR (0x00000002u)
N#define CSL_EMIF_SDCR_PAGESIZE_2048WORD_11COL_ADDR (0x00000003u)
N
N#define CSL_EMIF_SDCR_RESETVAL           (0x00000620u)
N
N/* SDRCR */
N
N#define CSL_EMIF_SDRCR_RR_MASK           (0x00001FFFu)
N#define CSL_EMIF_SDRCR_RR_SHIFT          (0x00000000u)
N#define CSL_EMIF_SDRCR_RR_RESETVAL       (0x00000190u)
N
N/*----RR Tokens----*/
N#define CSL_EMIF_SDRCR_RR_DEFAULT        (0x00000190u)
N
N#define CSL_EMIF_SDRCR_RESETVAL          (0x00000190u)
N
N/* A1CR */
N
N#define CSL_EMIF_A1CR_SS_MASK            (0x80000000u)
N#define CSL_EMIF_A1CR_SS_SHIFT           (0x0000001Fu)
N#define CSL_EMIF_A1CR_SS_RESETVAL        (0x00000000u)
N
N/*----SS Tokens----*/
N#define CSL_EMIF_A1CR_SS_DISABLE         (0x00000000u)
N#define CSL_EMIF_A1CR_SS_ENABLE          (0x00000001u)
N
N#define CSL_EMIF_A1CR_EW_MASK            (0x40000000u)
N#define CSL_EMIF_A1CR_EW_SHIFT           (0x0000001Eu)
N#define CSL_EMIF_A1CR_EW_RESETVAL        (0x00000000u)
N
N/*----EW Tokens----*/
N#define CSL_EMIF_A1CR_EW_DISABLE         (0x00000000u)
N#define CSL_EMIF_A1CR_EW_ENABLE          (0x00000001u)
N
N#define CSL_EMIF_A1CR_W_SETUP_MASK       (0x3C000000u)
N#define CSL_EMIF_A1CR_W_SETUP_SHIFT      (0x0000001Au)
N#define CSL_EMIF_A1CR_W_SETUP_RESETVAL   (0x0000000Fu)
N
N#define CSL_EMIF_A1CR_W_STROBE_MASK      (0x03F00000u)
N#define CSL_EMIF_A1CR_W_STROBE_SHIFT     (0x00000014u)
N#define CSL_EMIF_A1CR_W_STROBE_RESETVAL  (0x0000003Fu)
N
N#define CSL_EMIF_A1CR_W_HOLD_MASK        (0x000E0000u)
N#define CSL_EMIF_A1CR_W_HOLD_SHIFT       (0x00000011u)
N#define CSL_EMIF_A1CR_W_HOLD_RESETVAL    (0x00000007u)
N
N#define CSL_EMIF_A1CR_R_SETUP_MASK       (0x0001E000u)
N#define CSL_EMIF_A1CR_R_SETUP_SHIFT      (0x0000000Du)
N#define CSL_EMIF_A1CR_R_SETUP_RESETVAL   (0x0000000Fu)
N
N#define CSL_EMIF_A1CR_R_STROBE_MASK      (0x00001F80u)
N#define CSL_EMIF_A1CR_R_STROBE_SHIFT     (0x00000007u)
N#define CSL_EMIF_A1CR_R_STROBE_RESETVAL  (0x0000003Fu)
N
N#define CSL_EMIF_A1CR_R_HOLD_MASK        (0x00000070u)
N#define CSL_EMIF_A1CR_R_HOLD_SHIFT       (0x00000004u)
N#define CSL_EMIF_A1CR_R_HOLD_RESETVAL    (0x00000007u)
N
N#define CSL_EMIF_A1CR_TA_MASK            (0x0000000Cu)
N#define CSL_EMIF_A1CR_TA_SHIFT           (0x00000002u)
N#define CSL_EMIF_A1CR_TA_RESETVAL        (0x00000003u)
N
N#define CSL_EMIF_A1CR_ASIZE_MASK         (0x00000003u)
N#define CSL_EMIF_A1CR_ASIZE_SHIFT        (0x00000000u)
N#define CSL_EMIF_A1CR_ASIZE_RESETVAL     (0x00000000u)
N
N/*----ASIZE Tokens----*/
N#define CSL_EMIF_A1CR_ASIZE_8_BIT        (0x00000000u)
N#define CSL_EMIF_A1CR_ASIZE_16_BIT       (0x00000001u)
N#define CSL_EMIF_A1CR_ASIZE_32_BIT       (0x00000002u)
N#define CSL_EMIF_A1CR_ASIZE_32_BIT       (0x00000002u)
N
N#define CSL_EMIF_A1CR_RESETVAL           (0x3FFFFFFCu)
N
N/* SDTIMR */
N
N#define CSL_EMIF_SDTIMR_T_RFC_MASK       (0xF8000000u)
N#define CSL_EMIF_SDTIMR_T_RFC_SHIFT      (0x0000001Bu)
N#define CSL_EMIF_SDTIMR_T_RFC_RESETVAL   (0x00000000u)
N
N#define CSL_EMIF_SDTIMR_T_RP_MASK        (0x07000000u)
N#define CSL_EMIF_SDTIMR_T_RP_SHIFT       (0x00000018u)
N#define CSL_EMIF_SDTIMR_T_RP_RESETVAL    (0x00000000u)
N
N#define CSL_EMIF_SDTIMR_T_RCD_MASK       (0x00700000u)
N#define CSL_EMIF_SDTIMR_T_RCD_SHIFT      (0x00000014u)
N#define CSL_EMIF_SDTIMR_T_RCD_RESETVAL   (0x00000002u)
N
N#define CSL_EMIF_SDTIMR_T_WR_MASK        (0x00070000u)
N#define CSL_EMIF_SDTIMR_T_WR_SHIFT       (0x00000010u)
N#define CSL_EMIF_SDTIMR_T_WR_RESETVAL    (0x00000001u)
N
N#define CSL_EMIF_SDTIMR_T_RAS_MASK       (0x0000F000u)
N#define CSL_EMIF_SDTIMR_T_RAS_SHIFT      (0x0000000Cu)
N#define CSL_EMIF_SDTIMR_T_RAS_RESETVAL   (0x0000000Cu)
N
N#define CSL_EMIF_SDTIMR_T_RC_MASK        (0x00000F00u)
N#define CSL_EMIF_SDTIMR_T_RC_SHIFT       (0x00000008u)
N#define CSL_EMIF_SDTIMR_T_RC_RESETVAL    (0x0000000Fu)
N
N#define CSL_EMIF_SDTIMR_T_RRD_MASK       (0x00000070u)
N#define CSL_EMIF_SDTIMR_T_RRD_SHIFT      (0x00000004u)
N#define CSL_EMIF_SDTIMR_T_RRD_RESETVAL   (0x00000000u)
N
N#define CSL_EMIF_SDTIMR_RESETVAL         (0x0021CF00u)
N
N/* SDSRETR */
N
N#define CSL_EMIF_SDSRETR_T_XS_MASK       (0x0000001Fu)
N#define CSL_EMIF_SDSRETR_T_XS_SHIFT      (0x00000000u)
N#define CSL_EMIF_SDSRETR_T_XS_RESETVAL   (0x00000019u)
N
N#define CSL_EMIF_SDSRETR_RESETVAL        (0x00000019u)
N
N/* EIRR */
N
N#define CSL_EMIF_EIRR_WR_MASK            (0x00000004u)
N#define CSL_EMIF_EIRR_WR_SHIFT           (0x00000002u)
N#define CSL_EMIF_EIRR_WR_RESETVAL        (0x00000000u)
N
N/*----WR Tokens----*/
N#define CSL_EMIF_EIRR_WR_NOT_OCCURED     (0x00000000u)
N#define CSL_EMIF_EIRR_WR_OCCURED         (0x00000001u)
N
N#define CSL_EMIF_EIRR_AT_MASK            (0x00000001u)
N#define CSL_EMIF_EIRR_AT_SHIFT           (0x00000000u)
N#define CSL_EMIF_EIRR_AT_RESETVAL        (0x00000000u)
N
N/*----AT Tokens----*/
N#define CSL_EMIF_EIRR_AT_NOT_OCCURED     (0x00000000u)
N#define CSL_EMIF_EIRR_AT_OCCURED         (0x00000001u)
N
N#define CSL_EMIF_EIRR_RESETVAL           (0x00000000u)
N
N/* EIMR */
N
N#define CSL_EMIF_EIMR_WRM_MASK           (0x00000004u)
N#define CSL_EMIF_EIMR_WRM_SHIFT          (0x00000002u)
N#define CSL_EMIF_EIMR_WRM_RESETVAL       (0x00000000u)
N
N/*----WRM Tokens----*/
N#define CSL_EMIF_EIMR_WRM_NOT_OCCURED    (0x00000000u)
N#define CSL_EMIF_EIMR_WRM_OCCURED        (0x00000001u)
N
N#define CSL_EMIF_EIMR_ATM_MASK           (0x00000001u)
N#define CSL_EMIF_EIMR_ATM_SHIFT          (0x00000000u)
N#define CSL_EMIF_EIMR_ATM_RESETVAL       (0x00000000u)
N
N/*----ATM Tokens----*/
N#define CSL_EMIF_EIMR_ATM_NOT_OCCURED    (0x00000000u)
N#define CSL_EMIF_EIMR_ATM_OCCURED        (0x00000001u)
N
N#define CSL_EMIF_EIMR_RESETVAL           (0x00000000u)
N
N/* EIMSR */
N
N#define CSL_EMIF_EIMSR_WRMSET_MASK       (0x00000004u)
N#define CSL_EMIF_EIMSR_WRMSET_SHIFT      (0x00000002u)
N#define CSL_EMIF_EIMSR_WRMSET_RESETVAL   (0x00000000u)
N
N/*----WRMSET Tokens----*/
N#define CSL_EMIF_EIMSR_WRMSET_ENABLE     (0x00000001u)
N#define CSL_EMIF_EIMSR_WRMSET_DISABLE    (0x00000000u)
N
N#define CSL_EMIF_EIMSR_ATMSET_MASK       (0x00000001u)
N#define CSL_EMIF_EIMSR_ATMSET_SHIFT      (0x00000000u)
N#define CSL_EMIF_EIMSR_ATMSET_RESETVAL   (0x00000000u)
N
N/*----ATMSET Tokens----*/
N#define CSL_EMIF_EIMSR_ATMSET_DISABLE    (0x00000000u)
N#define CSL_EMIF_EIMSR_ATMSET_ENABLE     (0x00000001u)
N
N#define CSL_EMIF_EIMSR_RESETVAL          (0x00000000u)
N
N/* EIMCR */
N
N#define CSL_EMIF_EIMCR_WRMCLEAR_MASK     (0x00000004u)
N#define CSL_EMIF_EIMCR_WRMCLEAR_SHIFT    (0x00000002u)
N#define CSL_EMIF_EIMCR_WRMCLEAR_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_EIMCR_ATMCLR_MASK       (0x00000001u)
N#define CSL_EMIF_EIMCR_ATMCLR_SHIFT      (0x00000000u)
N#define CSL_EMIF_EIMCR_ATMCLR_RESETVAL   (0x00000000u)
N
N#define CSL_EMIF_EIMCR_RESETVAL          (0x00000000u)
N
N/* NANDFCR */
N
N#define CSL_EMIF_NANDFCR_CS2ECC_MASK     (0x00000100u)
N#define CSL_EMIF_NANDFCR_CS2ECC_SHIFT    (0x00000008u)
N#define CSL_EMIF_NANDFCR_CS2ECC_RESETVAL (0x00000000u)
N
N/*----CS2ECC Tokens----*/
N#define CSL_EMIF_NANDFCR_CS2ECC_ENABLE   (0x00000001u)
N#define CSL_EMIF_NANDFCR_CS2ECC_DISABLE  (0x00000000u)
N
N#define CSL_EMIF_NANDFCR_CS2NAND_MASK    (0x00000001u)
N#define CSL_EMIF_NANDFCR_CS2NAND_SHIFT   (0x00000000u)
N#define CSL_EMIF_NANDFCR_CS2NAND_RESETVAL (0x00000000u)
N
N/*----CS2NAND Tokens----*/
N#define CSL_EMIF_NANDFCR_CS2NAND_ENABLE  (0x00000001u)
N#define CSL_EMIF_NANDFCR_CS2NAND_DISABLE (0x00000000u)
N
N#define CSL_EMIF_NANDFCR_RESETVAL        (0x00000000u)
N
N/* NANDFSR */
N
N#define CSL_EMIF_NANDFSR_WAITST_MASK     (0x00000001u)
N#define CSL_EMIF_NANDFSR_WAITST_SHIFT    (0x00000000u)
N#define CSL_EMIF_NANDFSR_WAITST_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDFSR_RESETVAL        (0x00000000u)
N
N/* NANDF1ECC */
N
N#define CSL_EMIF_NANDF1ECC_P2048O_MASK   (0x08000000u)
N#define CSL_EMIF_NANDF1ECC_P2048O_SHIFT  (0x0000001Bu)
N#define CSL_EMIF_NANDF1ECC_P2048O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P1024O_MASK   (0x04000000u)
N#define CSL_EMIF_NANDF1ECC_P1024O_SHIFT  (0x0000001Au)
N#define CSL_EMIF_NANDF1ECC_P1024O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P512O_MASK    (0x02000000u)
N#define CSL_EMIF_NANDF1ECC_P512O_SHIFT   (0x00000019u)
N#define CSL_EMIF_NANDF1ECC_P512O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P256O_MASK    (0x01000000u)
N#define CSL_EMIF_NANDF1ECC_P256O_SHIFT   (0x00000018u)
N#define CSL_EMIF_NANDF1ECC_P256O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P128O_MASK    (0x00800000u)
N#define CSL_EMIF_NANDF1ECC_P128O_SHIFT   (0x00000017u)
N#define CSL_EMIF_NANDF1ECC_P128O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P64O_MASK     (0x00400000u)
N#define CSL_EMIF_NANDF1ECC_P64O_SHIFT    (0x00000016u)
N#define CSL_EMIF_NANDF1ECC_P64O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P32O_MASK     (0x00200000u)
N#define CSL_EMIF_NANDF1ECC_P32O_SHIFT    (0x00000015u)
N#define CSL_EMIF_NANDF1ECC_P32O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P16O_MASK     (0x00100000u)
N#define CSL_EMIF_NANDF1ECC_P16O_SHIFT    (0x00000014u)
N#define CSL_EMIF_NANDF1ECC_P16O_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P8O_MASK      (0x00080000u)
N#define CSL_EMIF_NANDF1ECC_P8O_SHIFT     (0x00000013u)
N#define CSL_EMIF_NANDF1ECC_P8O_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P4O_MASK      (0x00040000u)
N#define CSL_EMIF_NANDF1ECC_P4O_SHIFT     (0x00000012u)
N#define CSL_EMIF_NANDF1ECC_P4O_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P2O_MASK      (0x00020000u)
N#define CSL_EMIF_NANDF1ECC_P2O_SHIFT     (0x00000011u)
N#define CSL_EMIF_NANDF1ECC_P2O_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P1O_MASK      (0x00010000u)
N#define CSL_EMIF_NANDF1ECC_P1O_SHIFT     (0x00000010u)
N#define CSL_EMIF_NANDF1ECC_P1O_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P2048E_MASK   (0x00000800u)
N#define CSL_EMIF_NANDF1ECC_P2048E_SHIFT  (0x0000000Bu)
N#define CSL_EMIF_NANDF1ECC_P2048E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P1024E_MASK   (0x00000400u)
N#define CSL_EMIF_NANDF1ECC_P1024E_SHIFT  (0x0000000Au)
N#define CSL_EMIF_NANDF1ECC_P1024E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P512E_MASK    (0x00000200u)
N#define CSL_EMIF_NANDF1ECC_P512E_SHIFT   (0x00000009u)
N#define CSL_EMIF_NANDF1ECC_P512E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P256E_MASK    (0x00000100u)
N#define CSL_EMIF_NANDF1ECC_P256E_SHIFT   (0x00000008u)
N#define CSL_EMIF_NANDF1ECC_P256E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P128E_MASK    (0x00000080u)
N#define CSL_EMIF_NANDF1ECC_P128E_SHIFT   (0x00000007u)
N#define CSL_EMIF_NANDF1ECC_P128E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P64E_MASK     (0x00000040u)
N#define CSL_EMIF_NANDF1ECC_P64E_SHIFT    (0x00000006u)
N#define CSL_EMIF_NANDF1ECC_P64E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P32E_MASK     (0x00000020u)
N#define CSL_EMIF_NANDF1ECC_P32E_SHIFT    (0x00000005u)
N#define CSL_EMIF_NANDF1ECC_P32E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P16E_MASK     (0x00000010u)
N#define CSL_EMIF_NANDF1ECC_P16E_SHIFT    (0x00000004u)
N#define CSL_EMIF_NANDF1ECC_P16E_RESETVAL (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P8E_MASK      (0x00000008u)
N#define CSL_EMIF_NANDF1ECC_P8E_SHIFT     (0x00000003u)
N#define CSL_EMIF_NANDF1ECC_P8E_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P4E_MASK      (0x00000004u)
N#define CSL_EMIF_NANDF1ECC_P4E_SHIFT     (0x00000002u)
N#define CSL_EMIF_NANDF1ECC_P4E_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P2E_MASK      (0x00000002u)
N#define CSL_EMIF_NANDF1ECC_P2E_SHIFT     (0x00000001u)
N#define CSL_EMIF_NANDF1ECC_P2E_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_P1E_MASK      (0x00000001u)
N#define CSL_EMIF_NANDF1ECC_P1E_SHIFT     (0x00000000u)
N#define CSL_EMIF_NANDF1ECC_P1E_RESETVAL  (0x00000000u)
N
N#define CSL_EMIF_NANDF1ECC_RESETVAL      (0x00000000u)
N
N#endif
L 37 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_rti.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_rti.h" 1
N#ifndef _CSLR_RTI_H_
N#define _CSLR_RTI_H_
N/*********************************************************************
N * Copyright (C) 2003-2004, 2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_rti.h
N * 
N * \brief This file contains the Register Desciptions for RTI
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 RTIGCTRL;
N    volatile Uint32 RSVD0[1];
N    volatile Uint32 RTICAPCTRL;
N    volatile Uint32 RTICOMPCTRL;
N    volatile Uint32 RTIFRC0;
N    volatile Uint32 RTIUC0;
N    volatile Uint32 RTICPUC0;
N    volatile Uint32 RSVD1[1];
N    volatile Uint32 RTICAFRC0;
N    volatile Uint32 RTICAUC0;
N    volatile Uint32 RSVD2[2];
N    volatile Uint32 RTIFRC1;
N    volatile Uint32 RTIUC1;
N    volatile Uint32 RTICPUC1;
N    volatile Uint32 RSVD3[1];
N    volatile Uint32 RTICAFRC1;
N    volatile Uint32 RTICAUC1;
N    volatile Uint32 RSVD4[2];
N    volatile Uint32 RTICOMP0;
N    volatile Uint32 RTIUDCP0;
N    volatile Uint32 RTICOMP1;
N    volatile Uint32 RTIUDCP1;
N    volatile Uint32 RTICOMP2;
N    volatile Uint32 RTIUDCP2;
N    volatile Uint32 RTICOMP3;
N    volatile Uint32 RTIUDCP3;
N    volatile Uint32 RSVD5[4];
N    volatile Uint32 RTISETINT;
N    volatile Uint32 RTICLEARINT;
N    volatile Uint32 RTIINTFLAG;
N    volatile Uint32 RSVD6[1];
N    volatile Uint32 RTIDWDCTRL;
N    volatile Uint32 RTIDWDPRLD;
N    volatile Uint32 RTIWDSTATUS;
N    volatile Uint32 RTIWDKEY;
N    volatile Uint32 RTIDWDCNTR;
N} CSL_RtiRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* RTIGCTRL */
N
N#define CSL_RTI_RTIGCTRL_COS_MASK        (0x00008000u)
N#define CSL_RTI_RTIGCTRL_COS_SHIFT       (0x0000000Fu)
N#define CSL_RTI_RTIGCTRL_COS_RESETVAL    (0x00000000u)
N
N#define CSL_RTI_RTIGCTRL_CNT1EN_MASK     (0x00000002u)
N#define CSL_RTI_RTIGCTRL_CNT1EN_SHIFT    (0x00000001u)
N#define CSL_RTI_RTIGCTRL_CNT1EN_RESETVAL (0x00000000u)
N
N/*----CNT1EN Tokens----*/
N#define CSL_RTI_RTIGCTRL_CNT1EN_STOPBLK1 (0x00000000u)
N#define CSL_RTI_RTIGCTRL_CNT1EN_STARTBLK1 (0x00000001u)
N
N#define CSL_RTI_RTIGCTRL_CNT0EN_MASK     (0x00000001u)
N#define CSL_RTI_RTIGCTRL_CNT0EN_SHIFT    (0x00000000u)
N#define CSL_RTI_RTIGCTRL_CNT0EN_RESETVAL (0x00000000u)
N
N/*----CNT0EN Tokens----*/
N#define CSL_RTI_RTIGCTRL_CNT0EN_STOPBLK0 (0x00000000u)
N#define CSL_RTI_RTIGCTRL_CNT0EN_STARTBLK0 (0x00000001u)
N
N#define CSL_RTI_RTIGCTRL_RESETVAL        (0x00000000u)
N
N/* RTICAPCTRL */
N
N#define CSL_RTI_RTICAPCTRL_CAPCNTR1_MASK (0x00000002u)
N#define CSL_RTI_RTICAPCTRL_CAPCNTR1_SHIFT (0x00000001u)
N#define CSL_RTI_RTICAPCTRL_CAPCNTR1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICAPCTRL_CAPCNTR0_MASK (0x00000001u)
N#define CSL_RTI_RTICAPCTRL_CAPCNTR0_SHIFT (0x00000000u)
N#define CSL_RTI_RTICAPCTRL_CAPCNTR0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICAPCTRL_RESETVAL      (0x00000000u)
N
N/* RTICOMPCTRL */
N
N#define CSL_RTI_RTICOMPCTRL_COMPSEL3_MASK (0x00001000u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL3_SHIFT (0x0000000Cu)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL3_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICOMPCTRL_COMPSEL2_MASK (0x00000100u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL2_SHIFT (0x00000008u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL2_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICOMPCTRL_COMPSEL1_MASK (0x00000010u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL1_SHIFT (0x00000004u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICOMPCTRL_COMPSEL0_MASK (0x00000001u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL0_SHIFT (0x00000000u)
N#define CSL_RTI_RTICOMPCTRL_COMPSEL0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICOMPCTRL_RESETVAL     (0x00000000u)
N
N/* RTIFRC0 */
N
N#define CSL_RTI_RTIFRC0_FRC0_MASK        (0xFFFFFFFFu)
N#define CSL_RTI_RTIFRC0_FRC0_SHIFT       (0x00000000u)
N#define CSL_RTI_RTIFRC0_FRC0_RESETVAL    (0x00000000u)
N
N#define CSL_RTI_RTIFRC0_RESETVAL         (0x00000000u)
N
N/* RTIUC0 */
N
N#define CSL_RTI_RTIUC0_UC0_MASK          (0xFFFFFFFFu)
N#define CSL_RTI_RTIUC0_UC0_SHIFT         (0x00000000u)
N#define CSL_RTI_RTIUC0_UC0_RESETVAL      (0x00000000u)
N
N#define CSL_RTI_RTIUC0_RESETVAL          (0x00000000u)
N
N/* RTICPUC0 */
N
N#define CSL_RTI_RTICPUC0_CPUC0_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICPUC0_CPUC0_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICPUC0_CPUC0_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICPUC0_RESETVAL        (0x00000000u)
N
N/* RTICAFRC0 */
N
N#define CSL_RTI_RTICAFRC0_CAFRC0_MASK    (0xFFFFFFFFu)
N#define CSL_RTI_RTICAFRC0_CAFRC0_SHIFT   (0x00000000u)
N#define CSL_RTI_RTICAFRC0_CAFRC0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICAFRC0_RESETVAL       (0x00000000u)
N
N/* RTICAUC0 */
N
N#define CSL_RTI_RTICAUC0_CAUC0_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICAUC0_CAUC0_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICAUC0_CAUC0_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICAUC0_RESETVAL        (0x00000000u)
N
N/* RTIFRC1 */
N
N#define CSL_RTI_RTIFRC1_FRC1_MASK        (0xFFFFFFFFu)
N#define CSL_RTI_RTIFRC1_FRC1_SHIFT       (0x00000000u)
N#define CSL_RTI_RTIFRC1_FRC1_RESETVAL    (0x00000000u)
N
N#define CSL_RTI_RTIFRC1_RESETVAL         (0x00000000u)
N
N/* RTIUC1 */
N
N#define CSL_RTI_RTIUC1_UC1_MASK          (0xFFFFFFFFu)
N#define CSL_RTI_RTIUC1_UC1_SHIFT         (0x00000000u)
N#define CSL_RTI_RTIUC1_UC1_RESETVAL      (0x00000000u)
N
N#define CSL_RTI_RTIUC1_RESETVAL          (0x00000000u)
N
N/* RTICPUC1 */
N
N#define CSL_RTI_RTICPUC1_CPUC1_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICPUC1_CPUC1_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICPUC1_CPUC1_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICPUC1_RESETVAL        (0x00000000u)
N
N/* RTICAFRC1 */
N
N#define CSL_RTI_RTICAFRC1_CAFRC1_MASK    (0xFFFFFFFFu)
N#define CSL_RTI_RTICAFRC1_CAFRC1_SHIFT   (0x00000000u)
N#define CSL_RTI_RTICAFRC1_CAFRC1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICAFRC1_RESETVAL       (0x00000000u)
N
N/* RTICAUC1 */
N
N#define CSL_RTI_RTICAUC1_CAUC1_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICAUC1_CAUC1_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICAUC1_CAUC1_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICAUC1_RESETVAL        (0x00000000u)
N
N/* RTICOMP0 */
N
N#define CSL_RTI_RTICOMP0_COMP0_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICOMP0_COMP0_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICOMP0_COMP0_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICOMP0_RESETVAL        (0x00000000u)
N
N/* RTIUDCP0 */
N
N#define CSL_RTI_RTIUDCP0_UDCP0_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTIUDCP0_UDCP0_SHIFT     (0x00000000u)
N#define CSL_RTI_RTIUDCP0_UDCP0_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTIUDCP0_RESETVAL        (0x00000000u)
N
N/* RTICOMP1 */
N
N#define CSL_RTI_RTICOMP1_COMP1_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICOMP1_COMP1_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICOMP1_COMP1_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICOMP1_RESETVAL        (0x00000000u)
N
N/* RTIUDCP1 */
N
N#define CSL_RTI_RTIUDCP1_UDCP1_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTIUDCP1_UDCP1_SHIFT     (0x00000000u)
N#define CSL_RTI_RTIUDCP1_UDCP1_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTIUDCP1_RESETVAL        (0x00000000u)
N
N/* RTICOMP2 */
N
N#define CSL_RTI_RTICOMP2_COMP2_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICOMP2_COMP2_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICOMP2_COMP2_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICOMP2_RESETVAL        (0x00000000u)
N
N/* RTIUDCP2 */
N
N#define CSL_RTI_RTIUDCP2_UDCP2_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTIUDCP2_UDCP2_SHIFT     (0x00000000u)
N#define CSL_RTI_RTIUDCP2_UDCP2_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTIUDCP2_RESETVAL        (0x00000000u)
N
N/* RTICOMP3 */
N
N#define CSL_RTI_RTICOMP3_COMP3_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTICOMP3_COMP3_SHIFT     (0x00000000u)
N#define CSL_RTI_RTICOMP3_COMP3_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTICOMP3_RESETVAL        (0x00000000u)
N
N/* RTIUDCP3 */
N
N#define CSL_RTI_RTIUDCP3_UDCP3_MASK      (0xFFFFFFFFu)
N#define CSL_RTI_RTIUDCP3_UDCP3_SHIFT     (0x00000000u)
N#define CSL_RTI_RTIUDCP3_UDCP3_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTIUDCP3_RESETVAL        (0x00000000u)
N
N/* RTISETINT */
N
N#define CSL_RTI_RTISETINT_SETOVL1INT_MASK (0x00040000u)
N#define CSL_RTI_RTISETINT_SETOVL1INT_SHIFT (0x00000012u)
N#define CSL_RTI_RTISETINT_SETOVL1INT_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETOVL0INT_MASK (0x00020000u)
N#define CSL_RTI_RTISETINT_SETOVL0INT_SHIFT (0x00000011u)
N#define CSL_RTI_RTISETINT_SETOVL0INT_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETDMA3_MASK   (0x00000800u)
N#define CSL_RTI_RTISETINT_SETDMA3_SHIFT  (0x0000000Bu)
N#define CSL_RTI_RTISETINT_SETDMA3_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETDMA2_MASK   (0x00000400u)
N#define CSL_RTI_RTISETINT_SETDMA2_SHIFT  (0x0000000Au)
N#define CSL_RTI_RTISETINT_SETDMA2_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETDMA1_MASK   (0x00000200u)
N#define CSL_RTI_RTISETINT_SETDMA1_SHIFT  (0x00000009u)
N#define CSL_RTI_RTISETINT_SETDMA1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETDMA0_MASK   (0x00000100u)
N#define CSL_RTI_RTISETINT_SETDMA0_SHIFT  (0x00000008u)
N#define CSL_RTI_RTISETINT_SETDMA0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETINT3_MASK   (0x00000008u)
N#define CSL_RTI_RTISETINT_SETINT3_SHIFT  (0x00000003u)
N#define CSL_RTI_RTISETINT_SETINT3_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETINT2_MASK   (0x00000004u)
N#define CSL_RTI_RTISETINT_SETINT2_SHIFT  (0x00000002u)
N#define CSL_RTI_RTISETINT_SETINT2_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETINT1_MASK   (0x00000002u)
N#define CSL_RTI_RTISETINT_SETINT1_SHIFT  (0x00000001u)
N#define CSL_RTI_RTISETINT_SETINT1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_SETINT0_MASK   (0x00000001u)
N#define CSL_RTI_RTISETINT_SETINT0_SHIFT  (0x00000000u)
N#define CSL_RTI_RTISETINT_SETINT0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTISETINT_RESETVAL       (0x00000000u)
N
N/* RTICLEARINT */
N
N#define CSL_RTI_RTICLEARINT_CLEAROVL1INT_MASK (0x00040000u)
N#define CSL_RTI_RTICLEARINT_CLEAROVL1INT_SHIFT (0x00000012u)
N#define CSL_RTI_RTICLEARINT_CLEAROVL1INT_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEAROVL0INT_MASK (0x00020000u)
N#define CSL_RTI_RTICLEARINT_CLEAROVL0INT_SHIFT (0x00000011u)
N#define CSL_RTI_RTICLEARINT_CLEAROVL0INT_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARDMA3_MASK (0x00000800u)
N#define CSL_RTI_RTICLEARINT_CLEARDMA3_SHIFT (0x0000000Bu)
N#define CSL_RTI_RTICLEARINT_CLEARDMA3_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARDMA2_MASK (0x00000400u)
N#define CSL_RTI_RTICLEARINT_CLEARDMA2_SHIFT (0x0000000Au)
N#define CSL_RTI_RTICLEARINT_CLEARDMA2_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARDMA1_MASK (0x00000200u)
N#define CSL_RTI_RTICLEARINT_CLEARDMA1_SHIFT (0x00000009u)
N#define CSL_RTI_RTICLEARINT_CLEARDMA1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARDMA0_MASK (0x00000100u)
N#define CSL_RTI_RTICLEARINT_CLEARDMA0_SHIFT (0x00000008u)
N#define CSL_RTI_RTICLEARINT_CLEARDMA0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARINT3_MASK (0x00000008u)
N#define CSL_RTI_RTICLEARINT_CLEARINT3_SHIFT (0x00000003u)
N#define CSL_RTI_RTICLEARINT_CLEARINT3_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARINT2_MASK (0x00000004u)
N#define CSL_RTI_RTICLEARINT_CLEARINT2_SHIFT (0x00000002u)
N#define CSL_RTI_RTICLEARINT_CLEARINT2_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARINT1_MASK (0x00000002u)
N#define CSL_RTI_RTICLEARINT_CLEARINT1_SHIFT (0x00000001u)
N#define CSL_RTI_RTICLEARINT_CLEARINT1_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_CLEARINT0_MASK (0x00000001u)
N#define CSL_RTI_RTICLEARINT_CLEARINT0_SHIFT (0x00000000u)
N#define CSL_RTI_RTICLEARINT_CLEARINT0_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTICLEARINT_RESETVAL     (0x00000000u)
N
N/* RTIINTFLAG */
N
N#define CSL_RTI_RTIINTFLAG_OVL1INT_MASK  (0x00040000u)
N#define CSL_RTI_RTIINTFLAG_OVL1INT_SHIFT (0x00000012u)
N#define CSL_RTI_RTIINTFLAG_OVL1INT_RESETVAL (0x00000000u)
N
N/*----OVL1INT Tokens----*/
N#define CSL_RTI_RTIINTFLAG_OVL1INT_CLEAROVFINT1 (0x00000001u)
N
N#define CSL_RTI_RTIINTFLAG_OVL0INT_MASK  (0x00020000u)
N#define CSL_RTI_RTIINTFLAG_OVL0INT_SHIFT (0x00000011u)
N#define CSL_RTI_RTIINTFLAG_OVL0INT_RESETVAL (0x00000000u)
N
N/*----OVL0INT Tokens----*/
N#define CSL_RTI_RTIINTFLAG_OVL0INT_CLEAROVFINT0 (0x00000001u)
N
N#define CSL_RTI_RTIINTFLAG_INT3_MASK     (0x00000008u)
N#define CSL_RTI_RTIINTFLAG_INT3_SHIFT    (0x00000003u)
N#define CSL_RTI_RTIINTFLAG_INT3_RESETVAL (0x00000000u)
N
N/*----INT3 Tokens----*/
N#define CSL_RTI_RTIINTFLAG_INT3_CLEARINT3 (0x00000001u)
N
N#define CSL_RTI_RTIINTFLAG_INT2_MASK     (0x00000004u)
N#define CSL_RTI_RTIINTFLAG_INT2_SHIFT    (0x00000002u)
N#define CSL_RTI_RTIINTFLAG_INT2_RESETVAL (0x00000000u)
N
N/*----INT2 Tokens----*/
N#define CSL_RTI_RTIINTFLAG_INT2_CLEARINT2 (0x00000001u)
N
N#define CSL_RTI_RTIINTFLAG_INT1_MASK     (0x00000002u)
N#define CSL_RTI_RTIINTFLAG_INT1_SHIFT    (0x00000001u)
N#define CSL_RTI_RTIINTFLAG_INT1_RESETVAL (0x00000000u)
N
N/*----INT1 Tokens----*/
N#define CSL_RTI_RTIINTFLAG_INT1_CLEARINT1 (0x00000001u)
N
N#define CSL_RTI_RTIINTFLAG_INT0_MASK     (0x00000001u)
N#define CSL_RTI_RTIINTFLAG_INT0_SHIFT    (0x00000000u)
N#define CSL_RTI_RTIINTFLAG_INT0_RESETVAL (0x00000000u)
N
N/*----INT0 Tokens----*/
N#define CSL_RTI_RTIINTFLAG_INT0_CLEARINT0 (0x00000001u)
N
N#define CSL_RTI_RTIINTFLAG_RESETVAL      (0x00000000u)
N
N/* RTIDWDCTRL */
N
N#define CSL_RTI_RTIDWDCTRL_DWDCTRL_MASK  (0xFFFFFFFFu)
N#define CSL_RTI_RTIDWDCTRL_DWDCTRL_SHIFT (0x00000000u)
N#define CSL_RTI_RTIDWDCTRL_DWDCTRL_RESETVAL (0x5312ACEDu)
N
N#define CSL_RTI_RTIDWDCTRL_RESETVAL      (0x5312ACEDu)
N
N/* RTIDWDPRLD */
N
N#define CSL_RTI_RTIDWDPRLD_DWDPRLD_MASK  (0x00001FFFu)
N#define CSL_RTI_RTIDWDPRLD_DWDPRLD_SHIFT (0x00000000u)
N#define CSL_RTI_RTIDWDPRLD_DWDPRLD_RESETVAL (0x00001FFFu)
N
N#define CSL_RTI_RTIDWDPRLD_RESETVAL      (0x00001FFFu)
N
N/* RTIWDSTATUS */
N
N#define CSL_RTI_RTIWDSTATUS_KEYST_MASK   (0x00000004u)
N#define CSL_RTI_RTIWDSTATUS_KEYST_SHIFT  (0x00000002u)
N#define CSL_RTI_RTIWDSTATUS_KEYST_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTIWDSTATUS_DWDST_MASK   (0x00000002u)
N#define CSL_RTI_RTIWDSTATUS_DWDST_SHIFT  (0x00000001u)
N#define CSL_RTI_RTIWDSTATUS_DWDST_RESETVAL (0x00000000u)
N
N/*----DWDST Tokens----*/
N#define CSL_RTI_RTIWDSTATUS_DWDST_CLEARDWD (0x00000001u)
N
N#define CSL_RTI_RTIWDSTATUS_RESETVAL     (0x00000000u)
N
N/* RTIWDKEY */
N
N#define CSL_RTI_RTIWDKEY_WDKEY_MASK      (0x0000FFFFu)
N#define CSL_RTI_RTIWDKEY_WDKEY_SHIFT     (0x00000000u)
N#define CSL_RTI_RTIWDKEY_WDKEY_RESETVAL  (0x00000000u)
N
N#define CSL_RTI_RTIWDKEY_RESETVAL        (0x00000000u)
N
N/* RTIDWDCNTR */
N
N#define CSL_RTI_RTIDWDCNTR_DWDCNTR_MASK  (0x01FFFFFFu)
N#define CSL_RTI_RTIDWDCNTR_DWDCNTR_SHIFT (0x00000000u)
N#define CSL_RTI_RTIDWDCNTR_DWDCNTR_RESETVAL (0x00000000u)
N
N#define CSL_RTI_RTIDWDCNTR_RESETVAL      (0x00000000u)
N
N#endif
L 38 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_i2c.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_i2c.h" 1
N#ifndef _CSLR_I2C_H_
N#define _CSLR_I2C_H_
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_i2c.h
N * 
N * \brief This file contains the Register Desciptions for I2C
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint16 ICOAR;
N    volatile Uint8 RSVD0[2];
N    volatile Uint16 ICIMR;
N    volatile Uint8 RSVD1[2];
N    volatile Uint16 ICSTR;
N    volatile Uint8 RSVD2[2];
N    volatile Uint16 ICCLKL;
N    volatile Uint8 RSVD3[2];
N    volatile Uint16 ICCLKH;
N    volatile Uint8 RSVD4[2];
N    volatile Uint16 ICCNT;
N    volatile Uint8 RSVD5[2];
N    volatile Uint16 ICDRR;
N    volatile Uint8 RSVD6[2];
N    volatile Uint16 ICSAR;
N    volatile Uint8 RSVD7[2];
N    volatile Uint16 ICDXR;
N    volatile Uint8 RSVD8[2];
N    volatile Uint16 ICMDR;
N    volatile Uint8 RSVD9[2];
N    volatile Uint16 ICIVR;
N    volatile Uint8 RSVD10[2];
N    volatile Uint16 ICEMDR;
N    volatile Uint8 RSVD11[2];
N    volatile Uint16 ICPSC;
N    volatile Uint8 RSVD12[2];
N    volatile Uint16 ICPID1;
N    volatile Uint8 RSVD13[2];
N    volatile Uint16 ICPID2;
N    volatile Uint8 RSVD14[14];
N    volatile Uint32 ICPFUNC;
N    volatile Uint32 ICPDIR;
N    volatile Uint32 ICPDIN;
N    volatile Uint32 ICPDOUT;
N    volatile Uint32 ICPDSET;
N    volatile Uint32 ICPDCLR;
N} CSL_I2cRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* ICOAR */
N
N#define CSL_I2C_ICOAR_A_MASK             (0x03FFu)
N#define CSL_I2C_ICOAR_A_SHIFT            (0x0000u)
N#define CSL_I2C_ICOAR_A_RESETVAL         (0x0000u)
N
N#define CSL_I2C_ICOAR_RESETVAL           (0x0000u)
N
N/* ICIMR */
N
N#define CSL_I2C_ICIMR_AAS_MASK           (0x0040u)
N#define CSL_I2C_ICIMR_AAS_SHIFT          (0x0006u)
N#define CSL_I2C_ICIMR_AAS_RESETVAL       (0x0000u)
N
N/*----AAS Tokens----*/
N#define CSL_I2C_ICIMR_AAS_DISABLE        (0x0000u)
N#define CSL_I2C_ICIMR_AAS_ENABLE         (0x0001u)
N
N#define CSL_I2C_ICIMR_SCD_MASK           (0x0020u)
N#define CSL_I2C_ICIMR_SCD_SHIFT          (0x0005u)
N#define CSL_I2C_ICIMR_SCD_RESETVAL       (0x0000u)
N
N/*----SCD Tokens----*/
N#define CSL_I2C_ICIMR_SCD_DISABLE        (0x0000u)
N#define CSL_I2C_ICIMR_SCD_ENABLE         (0x0001u)
N
N#define CSL_I2C_ICIMR_ICXRDY_MASK        (0x0010u)
N#define CSL_I2C_ICIMR_ICXRDY_SHIFT       (0x0004u)
N#define CSL_I2C_ICIMR_ICXRDY_RESETVAL    (0x0000u)
N
N/*----ICXRDY Tokens----*/
N#define CSL_I2C_ICIMR_ICXRDY_DISABLE     (0x0000u)
N#define CSL_I2C_ICIMR_ICXRDY_ENABLE      (0x0001u)
N
N#define CSL_I2C_ICIMR_ICRRDY_MASK        (0x0008u)
N#define CSL_I2C_ICIMR_ICRRDY_SHIFT       (0x0003u)
N#define CSL_I2C_ICIMR_ICRRDY_RESETVAL    (0x0000u)
N
N/*----ICRRDY Tokens----*/
N#define CSL_I2C_ICIMR_ICRRDY_DISABLE     (0x0000u)
N#define CSL_I2C_ICIMR_ICRRDY_ENABLE      (0x0001u)
N
N#define CSL_I2C_ICIMR_ARDY_MASK          (0x0004u)
N#define CSL_I2C_ICIMR_ARDY_SHIFT         (0x0002u)
N#define CSL_I2C_ICIMR_ARDY_RESETVAL      (0x0000u)
N
N/*----ARDY Tokens----*/
N#define CSL_I2C_ICIMR_ARDY_DISABLE       (0x0000u)
N#define CSL_I2C_ICIMR_ARDY_ENABLE        (0x0001u)
N
N#define CSL_I2C_ICIMR_NACK_MASK          (0x0002u)
N#define CSL_I2C_ICIMR_NACK_SHIFT         (0x0001u)
N#define CSL_I2C_ICIMR_NACK_RESETVAL      (0x0000u)
N
N/*----NACK Tokens----*/
N#define CSL_I2C_ICIMR_NACK_DISABLE       (0x0000u)
N#define CSL_I2C_ICIMR_NACK_ENABLE        (0x0001u)
N
N#define CSL_I2C_ICIMR_AL_MASK            (0x0001u)
N#define CSL_I2C_ICIMR_AL_SHIFT           (0x0000u)
N#define CSL_I2C_ICIMR_AL_RESETVAL        (0x0000u)
N
N/*----AL Tokens----*/
N#define CSL_I2C_ICIMR_AL_DISABLE         (0x0000u)
N#define CSL_I2C_ICIMR_AL_ENABLE          (0x0001u)
N
N#define CSL_I2C_ICIMR_RESETVAL           (0x0000u)
N
N/* ICSTR */
N
N#define CSL_I2C_ICSTR_SDIR_MASK          (0x4000u)
N#define CSL_I2C_ICSTR_SDIR_SHIFT         (0x000Eu)
N#define CSL_I2C_ICSTR_SDIR_RESETVAL      (0x0000u)
N
N#define CSL_I2C_ICSTR_NACKSNT_MASK       (0x2000u)
N#define CSL_I2C_ICSTR_NACKSNT_SHIFT      (0x000Du)
N#define CSL_I2C_ICSTR_NACKSNT_RESETVAL   (0x0000u)
N
N#define CSL_I2C_ICSTR_BB_MASK            (0x1000u)
N#define CSL_I2C_ICSTR_BB_SHIFT           (0x000Cu)
N#define CSL_I2C_ICSTR_BB_RESETVAL        (0x0000u)
N
N#define CSL_I2C_ICSTR_RSFULL_MASK        (0x0800u)
N#define CSL_I2C_ICSTR_RSFULL_SHIFT       (0x000Bu)
N#define CSL_I2C_ICSTR_RSFULL_RESETVAL    (0x0000u)
N
N#define CSL_I2C_ICSTR_XSMT_MASK          (0x0400u)
N#define CSL_I2C_ICSTR_XSMT_SHIFT         (0x000Au)
N#define CSL_I2C_ICSTR_XSMT_RESETVAL      (0x0001u)
N
N#define CSL_I2C_ICSTR_AAS_MASK           (0x0200u)
N#define CSL_I2C_ICSTR_AAS_SHIFT          (0x0009u)
N#define CSL_I2C_ICSTR_AAS_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICSTR_AD0_MASK           (0x0100u)
N#define CSL_I2C_ICSTR_AD0_SHIFT          (0x0008u)
N#define CSL_I2C_ICSTR_AD0_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICSTR_SCD_MASK           (0x0020u)
N#define CSL_I2C_ICSTR_SCD_SHIFT          (0x0005u)
N#define CSL_I2C_ICSTR_SCD_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICSTR_ICXRDY_MASK        (0x0010u)
N#define CSL_I2C_ICSTR_ICXRDY_SHIFT       (0x0004u)
N#define CSL_I2C_ICSTR_ICXRDY_RESETVAL    (0x0001u)
N
N#define CSL_I2C_ICSTR_ICRRDY_MASK        (0x0008u)
N#define CSL_I2C_ICSTR_ICRRDY_SHIFT       (0x0003u)
N#define CSL_I2C_ICSTR_ICRRDY_RESETVAL    (0x0000u)
N
N#define CSL_I2C_ICSTR_ARDY_MASK          (0x0004u)
N#define CSL_I2C_ICSTR_ARDY_SHIFT         (0x0002u)
N#define CSL_I2C_ICSTR_ARDY_RESETVAL      (0x0000u)
N
N#define CSL_I2C_ICSTR_NACK_MASK          (0x0002u)
N#define CSL_I2C_ICSTR_NACK_SHIFT         (0x0001u)
N#define CSL_I2C_ICSTR_NACK_RESETVAL      (0x0000u)
N
N#define CSL_I2C_ICSTR_AL_MASK            (0x0001u)
N#define CSL_I2C_ICSTR_AL_SHIFT           (0x0000u)
N#define CSL_I2C_ICSTR_AL_RESETVAL        (0x0000u)
N
N#define CSL_I2C_ICSTR_RESETVAL           (0x0410u)
N
N/* ICCLKL */
N
N#define CSL_I2C_ICCLKL_ICCL_MASK         (0xFFFFu)
N#define CSL_I2C_ICCLKL_ICCL_SHIFT        (0x0000u)
N#define CSL_I2C_ICCLKL_ICCL_RESETVAL     (0x0000u)
N
N#define CSL_I2C_ICCLKL_RESETVAL          (0x0000u)
N
N/* ICCLKH */
N
N#define CSL_I2C_ICCLKH_ICCH_MASK         (0xFFFFu)
N#define CSL_I2C_ICCLKH_ICCH_SHIFT        (0x0000u)
N#define CSL_I2C_ICCLKH_ICCH_RESETVAL     (0x0000u)
N
N#define CSL_I2C_ICCLKH_RESETVAL          (0x0000u)
N
N/* ICCNT */
N
N#define CSL_I2C_ICCNT_ICDC_MASK          (0xFFFFu)
N#define CSL_I2C_ICCNT_ICDC_SHIFT         (0x0000u)
N#define CSL_I2C_ICCNT_ICDC_RESETVAL      (0x0000u)
N
N#define CSL_I2C_ICCNT_RESETVAL           (0x0000u)
N
N/* ICDRR */
N
N#define CSL_I2C_ICDRR_D_MASK             (0x00FFu)
N#define CSL_I2C_ICDRR_D_SHIFT            (0x0000u)
N#define CSL_I2C_ICDRR_D_RESETVAL         (0x0000u)
N
N#define CSL_I2C_ICDRR_RESETVAL           (0x0000u)
N
N/* ICSAR */
N
N#define CSL_I2C_ICSAR_A_MASK         (0x03FFu)
N#define CSL_I2C_ICSAR_A_SHIFT        (0x0000u)
N#define CSL_I2C_ICSAR_A_RESETVAL     (0x03FFu)
N
N#define CSL_I2C_ICSAR_RESETVAL           (0x03FFu)
N
N/* ICDXR */
N
N#define CSL_I2C_ICDXR_D_MASK             (0x00FFu)
N#define CSL_I2C_ICDXR_D_SHIFT            (0x0000u)
N#define CSL_I2C_ICDXR_D_RESETVAL         (0x0000u)
N
N#define CSL_I2C_ICDXR_RESETVAL           (0x0000u)
N
N/* ICMDR */
N
N#define CSL_I2C_ICMDR_NACKMOD_MASK       (0x8000u)
N#define CSL_I2C_ICMDR_NACKMOD_SHIFT      (0x000Fu)
N#define CSL_I2C_ICMDR_NACKMOD_RESETVAL   (0x0000u)
N
N#define CSL_I2C_ICMDR_FREE_MASK          (0x4000u)
N#define CSL_I2C_ICMDR_FREE_SHIFT         (0x000Eu)
N#define CSL_I2C_ICMDR_FREE_RESETVAL      (0x0000u)
N
N#define CSL_I2C_ICMDR_STT_MASK           (0x2000u)
N#define CSL_I2C_ICMDR_STT_SHIFT          (0x000Du)
N#define CSL_I2C_ICMDR_STT_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_STP_MASK           (0x0800u)
N#define CSL_I2C_ICMDR_STP_SHIFT          (0x000Bu)
N#define CSL_I2C_ICMDR_STP_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_MST_MASK           (0x0400u)
N#define CSL_I2C_ICMDR_MST_SHIFT          (0x000Au)
N#define CSL_I2C_ICMDR_MST_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_TRX_MASK           (0x0200u)
N#define CSL_I2C_ICMDR_TRX_SHIFT          (0x0009u)
N#define CSL_I2C_ICMDR_TRX_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_XA_MASK            (0x0100u)
N#define CSL_I2C_ICMDR_XA_SHIFT           (0x0008u)
N#define CSL_I2C_ICMDR_XA_RESETVAL        (0x0000u)
N
N#define CSL_I2C_ICMDR_RM_MASK            (0x0080u)
N#define CSL_I2C_ICMDR_RM_SHIFT           (0x0007u)
N#define CSL_I2C_ICMDR_RM_RESETVAL        (0x0000u)
N
N#define CSL_I2C_ICMDR_DLB_MASK           (0x0040u)
N#define CSL_I2C_ICMDR_DLB_SHIFT          (0x0006u)
N#define CSL_I2C_ICMDR_DLB_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_IRS_MASK           (0x0020u)
N#define CSL_I2C_ICMDR_IRS_SHIFT          (0x0005u)
N#define CSL_I2C_ICMDR_IRS_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_STB_MASK           (0x0010u)
N#define CSL_I2C_ICMDR_STB_SHIFT          (0x0004u)
N#define CSL_I2C_ICMDR_STB_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_FDF_MASK           (0x0008u)
N#define CSL_I2C_ICMDR_FDF_SHIFT          (0x0003u)
N#define CSL_I2C_ICMDR_FDF_RESETVAL       (0x0000u)
N
N#define CSL_I2C_ICMDR_BC_MASK            (0x0007u)
N#define CSL_I2C_ICMDR_BC_SHIFT           (0x0000u)
N#define CSL_I2C_ICMDR_BC_RESETVAL        (0x0000u)
N
N#define CSL_I2C_ICMDR_RESETVAL           (0x0000u)
N
N/* ICIVR */
N
N#define CSL_I2C_ICIVR_TESTMD_MASK        (0x0F00u)
N#define CSL_I2C_ICIVR_TESTMD_SHIFT       (0x0008u)
N#define CSL_I2C_ICIVR_TESTMD_RESETVAL    (0x0000u)
N
N#define CSL_I2C_ICIVR_INTCODE_MASK       (0x0007u)
N#define CSL_I2C_ICIVR_INTCODE_SHIFT      (0x0000u)
N#define CSL_I2C_ICIVR_INTCODE_RESETVAL   (0x0000u)
N
N/*----INTCODE Tokens----*/
N#define CSL_I2C_ICIVR_INTCODE_NONE       (0x0000u)
N#define CSL_I2C_ICIVR_INTCODE_AL         (0x0001u)
N#define CSL_I2C_ICIVR_INTCODE_NACK       (0x0002u)
N#define CSL_I2C_ICIVR_INTCODE_RAR        (0x0003u)
N#define CSL_I2C_ICIVR_INTCODE_RDR        (0x0004u)
N#define CSL_I2C_ICIVR_INTCODE_TDR        (0x0005u)
N#define CSL_I2C_ICIVR_INTCODE_SCD        (0x0006u)
N#define CSL_I2C_ICIVR_INTCODE_AAS        (0x0007u)
N
N#define CSL_I2C_ICIVR_RESETVAL           (0x0000u)
N
N/* ICEMDR */
N
N#define CSL_I2C_ICEMDR_BCM_MASK          (0x0001u)
N#define CSL_I2C_ICEMDR_BCM_SHIFT         (0x0000u)
N#define CSL_I2C_ICEMDR_BCM_RESETVAL      (0x0001u)
N
N#define CSL_I2C_ICEMDR_RESETVAL          (0x0000u)
N
N/* ICPSC */
N
N#define CSL_I2C_ICPSC_IPSC_MASK          (0x00FFu)
N#define CSL_I2C_ICPSC_IPSC_SHIFT         (0x0000u)
N#define CSL_I2C_ICPSC_IPSC_RESETVAL      (0x0000u)
N
N#define CSL_I2C_ICPSC_RESETVAL           (0x0000u)
N
N/* ICPID1 */
N
N#define CSL_I2C_ICPID1_CLASS_MASK        (0xFF00u)
N#define CSL_I2C_ICPID1_CLASS_SHIFT       (0x0008u)
N#define CSL_I2C_ICPID1_CLASS_RESETVAL    (0x0001u)
N
N#define CSL_I2C_ICPID1_REVISION_MASK     (0x00FFu)
N#define CSL_I2C_ICPID1_REVISION_SHIFT    (0x0000u)
N#define CSL_I2C_ICPID1_REVISION_RESETVAL (0x0025u)
N
N#define CSL_I2C_ICPID1_RESETVAL          (0x0125u)
N
N/* ICPID2 */
N
N#define CSL_I2C_ICPID2_TYPE_MASK         (0x00FFu)
N#define CSL_I2C_ICPID2_TYPE_SHIFT        (0x0000u)
N#define CSL_I2C_ICPID2_TYPE_RESETVAL     (0x0005u)
N
N#define CSL_I2C_ICPID2_RESETVAL          (0x0005u)
N
N/* ICPFUNC */
N
N#define CSL_I2C_ICPFUNC_PFUNC_MASK       (0x00000001u)
N#define CSL_I2C_ICPFUNC_PFUNC_SHIFT      (0x00000000u)
N#define CSL_I2C_ICPFUNC_PFUNC_RESETVAL   (0x00000000u)
N
N#define CSL_I2C_ICPFUNC_RESETVAL         (0x00000000u)
N
N/* ICPDIR */
N
N#define CSL_I2C_ICPDIR_PDIR1_MASK        (0x00000002u)
N#define CSL_I2C_ICPDIR_PDIR1_SHIFT       (0x00000001u)
N#define CSL_I2C_ICPDIR_PDIR1_RESETVAL    (0x00000000u)
N
N/*----PDIR1 Tokens----*/
N#define CSL_I2C_ICPDIR_PDIR1_IN          (0x00000000u)
N#define CSL_I2C_ICPDIR_PDIR1_OUT         (0x00000001u)
N
N#define CSL_I2C_ICPDIR_PDIR0_MASK        (0x00000001u)
N#define CSL_I2C_ICPDIR_PDIR0_SHIFT       (0x00000000u)
N#define CSL_I2C_ICPDIR_PDIR0_RESETVAL    (0x00000000u)
N
N/*----PDIR0 Tokens----*/
N#define CSL_I2C_ICPDIR_PDIR0_IN          (0x00000000u)
N#define CSL_I2C_ICPDIR_PDIR0_OUT         (0x00000001u)
N
N#define CSL_I2C_ICPDIR_RESETVAL          (0x00000000u)
N
N/* ICPDIN */
N
N#define CSL_I2C_ICPDIN_PDIN1_MASK        (0x00000002u)
N#define CSL_I2C_ICPDIN_PDIN1_SHIFT       (0x00000001u)
N#define CSL_I2C_ICPDIN_PDIN1_RESETVAL    (0x00000000u)
N
N/*----PDIN1 Tokens----*/
N#define CSL_I2C_ICPDIN_PDIN1_LOW         (0x00000000u)
N#define CSL_I2C_ICPDIN_PDIN1_HIGH        (0x00000001u)
N
N#define CSL_I2C_ICPDIN_PDIN0_MASK        (0x00000001u)
N#define CSL_I2C_ICPDIN_PDIN0_SHIFT       (0x00000000u)
N#define CSL_I2C_ICPDIN_PDIN0_RESETVAL    (0x00000000u)
N
N/*----PDIN0 Tokens----*/
N#define CSL_I2C_ICPDIN_PDIN0_LOW         (0x00000000u)
N#define CSL_I2C_ICPDIN_PDIN0_HIGH        (0x00000001u)
N
N#define CSL_I2C_ICPDIN_RESETVAL          (0x00000000u)
N
N/* ICPDOUT */
N
N#define CSL_I2C_ICPDOUT_PDOUT1_MASK      (0x00000002u)
N#define CSL_I2C_ICPDOUT_PDOUT1_SHIFT     (0x00000001u)
N#define CSL_I2C_ICPDOUT_PDOUT1_RESETVAL  (0x00000000u)
N
N/*----PDOUT1 Tokens----*/
N#define CSL_I2C_ICPDOUT_PDOUT1_LOW       (0x00000000u)
N#define CSL_I2C_ICPDOUT_PDOUT1_HIGH      (0x00000001u)
N
N#define CSL_I2C_ICPDOUT_PDOUT0_MASK      (0x00000001u)
N#define CSL_I2C_ICPDOUT_PDOUT0_SHIFT     (0x00000000u)
N#define CSL_I2C_ICPDOUT_PDOUT0_RESETVAL  (0x00000000u)
N
N/*----PDOUT0 Tokens----*/
N#define CSL_I2C_ICPDOUT_PDOUT0_LOW       (0x00000000u)
N#define CSL_I2C_ICPDOUT_PDOUT0_HIGH      (0x00000001u)
N
N#define CSL_I2C_ICPDOUT_RESETVAL         (0x00000000u)
N
N/* ICPDSET */
N
N#define CSL_I2C_ICPDSET_PDSET1_MASK      (0x00000002u)
N#define CSL_I2C_ICPDSET_PDSET1_SHIFT     (0x00000001u)
N#define CSL_I2C_ICPDSET_PDSET1_RESETVAL  (0x00000000u)
N
N/*----PDSET1 Tokens----*/
N#define CSL_I2C_ICPDSET_PDSET1_NONE      (0x00000000u)
N#define CSL_I2C_ICPDSET_PDSET1_SET       (0x00000001u)
N
N#define CSL_I2C_ICPDSET_PDSET0_MASK      (0x00000001u)
N#define CSL_I2C_ICPDSET_PDSET0_SHIFT     (0x00000000u)
N#define CSL_I2C_ICPDSET_PDSET0_RESETVAL  (0x00000000u)
N
N/*----PDSET0 Tokens----*/
N#define CSL_I2C_ICPDSET_PDSET0_NONE      (0x00000000u)
N#define CSL_I2C_ICPDSET_PDSET0_SET       (0x00000001u)
N
N#define CSL_I2C_ICPDSET_RESETVAL         (0x00000000u)
N
N/* ICPDCLR */
N
N#define CSL_I2C_ICPDCLR_PDCLR1_MASK      (0x00000002u)
N#define CSL_I2C_ICPDCLR_PDCLR1_SHIFT     (0x00000001u)
N#define CSL_I2C_ICPDCLR_PDCLR1_RESETVAL  (0x00000000u)
N
N/*----PDCLR1 Tokens----*/
N#define CSL_I2C_ICPDCLR_PDCLR1_NONE      (0x00000000u)
N#define CSL_I2C_ICPDCLR_PDCLR1_RESET     (0x00000001u)
N
N#define CSL_I2C_ICPDCLR_PDCLR0_MASK      (0x00000001u)
N#define CSL_I2C_ICPDCLR_PDCLR0_SHIFT     (0x00000000u)
N#define CSL_I2C_ICPDCLR_PDCLR0_RESETVAL  (0x00000000u)
N
N/*----PDCLR0 Tokens----*/
N#define CSL_I2C_ICPDCLR_PDCLR0_NONE      (0x00000000u)
N#define CSL_I2C_ICPDCLR_PDCLR0_RESET     (0x00000001u)
N
N#define CSL_I2C_ICPDCLR_RESETVAL         (0x00000000u)
N
N#endif
L 39 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_spi.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_spi.h" 1
N#ifndef _CSLR_SPI_H_
N#define _CSLR_SPI_H_
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_spi.h
N * 
N * \brief This file contains the Register Desciptions for SPI
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 SPIGCR0;
N    volatile Uint32 SPIGCR1;
N    volatile Uint32 SPIINT0;
N    volatile Uint32 SPILVL;
N    volatile Uint32 SPIFLG;
N    volatile Uint32 SPIPC0;
N    volatile Uint32 SPIPC1;
N    volatile Uint32 SPIPC2;
N    volatile Uint32 SPIPC3;
N    volatile Uint32 SPIPC4;
N    volatile Uint32 SPIPC5;
N    volatile Uint32 RSVD0[3];
N    volatile Uint32 SPIDAT0;
N    volatile Uint32 SPIDAT1;
N    volatile Uint32 SPIBUF;
N    volatile Uint32 SPIEMU;
N    volatile Uint32 SPIDELAY;
N    volatile Uint32 SPIDEF;
N    volatile Uint32 SPIFMT[4];
N    volatile Uint32 TGINTVECT[2];
N} CSL_SpiRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* SPIGCR0 */
N
N#define CSL_SPI_SPIGCR0_RESET_MASK       (0x00000001u)
N#define CSL_SPI_SPIGCR0_RESET_SHIFT      (0x00000000u)
N#define CSL_SPI_SPIGCR0_RESET_RESETVAL   (0x00000000u)
N
N/*----RESET Tokens----*/
N#define CSL_SPI_SPIGCR0_RESET_YES        (0x00000000u)
N#define CSL_SPI_SPIGCR0_RESET_NO         (0x00000001u)
N
N#define CSL_SPI_SPIGCR0_RESETVAL         (0x00000000u)
N
N/* SPIGCR1 */
N
N#define CSL_SPI_SPIGCR1_ENABLE_MASK      (0x01000000u)
N#define CSL_SPI_SPIGCR1_ENABLE_SHIFT     (0x00000018u)
N#define CSL_SPI_SPIGCR1_ENABLE_RESETVAL  (0x00000000u)
N
N/*----ENABLE Tokens----*/
N#define CSL_SPI_SPIGCR1_ENABLE_DISABLE   (0x00000000u)
N#define CSL_SPI_SPIGCR1_ENABLE_ENABLE    (0x00000001u)
N
N#define CSL_SPI_SPIGCR1_LOOPBACK_MASK    (0x00010000u)
N#define CSL_SPI_SPIGCR1_LOOPBACK_SHIFT   (0x00000010u)
N#define CSL_SPI_SPIGCR1_LOOPBACK_RESETVAL (0x00000000u)
N
N/*----LOOPBACK Tokens----*/
N#define CSL_SPI_SPIGCR1_LOOPBACK_DISABLE (0x00000000u)
N#define CSL_SPI_SPIGCR1_LOOPBACK_ENABLE  (0x00000001u)
N
N#define CSL_SPI_SPIGCR1_CLKMOD_MASK      (0x00000002u)
N#define CSL_SPI_SPIGCR1_CLKMOD_SHIFT     (0x00000001u)
N#define CSL_SPI_SPIGCR1_CLKMOD_RESETVAL  (0x00000000u)
N
N/*----CLKMOD Tokens----*/
N#define CSL_SPI_SPIGCR1_CLKMOD_SLAVEMODE (0x00000000u)
N#define CSL_SPI_SPIGCR1_CLKMOD_MASTERMODE (0x00000001u)
N
N#define CSL_SPI_SPIGCR1_MASTER_MASK      (0x00000001u)
N#define CSL_SPI_SPIGCR1_MASTER_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIGCR1_MASTER_RESETVAL  (0x00000000u)
N
N/*----MASTER Tokens----*/
N#define CSL_SPI_SPIGCR1_MASTER_NO        (0x00000000u)
N#define CSL_SPI_SPIGCR1_MASTER_YES       (0x00000001u)
N
N#define CSL_SPI_SPIGCR1_RESETVAL         (0x00000000u)
N
N/* SPIINT0 */
N
N#define CSL_SPI_SPIINT0_ENABLEHIGHZ_MASK (0x01000000u)
N#define CSL_SPI_SPIINT0_ENABLEHIGHZ_SHIFT (0x00000018u)
N#define CSL_SPI_SPIINT0_ENABLEHIGHZ_RESETVAL (0x00000000u)
N
N/*----ENABLEHIGHZ Tokens----*/
N#define CSL_SPI_SPIINT0_ENABLEHIGHZ_DISABLE (0x00000000u)
N#define CSL_SPI_SPIINT0_ENABLEHIGHZ_ENABLE (0x00000001u)
N
N#define CSL_SPI_SPIINT0_DMAREQEN_MASK    (0x00010000u)
N#define CSL_SPI_SPIINT0_DMAREQEN_SHIFT   (0x00000010u)
N#define CSL_SPI_SPIINT0_DMAREQEN_RESETVAL (0x00000000u)
N
N/*----DMAREQEN Tokens----*/
N#define CSL_SPI_SPIINT0_DMAREQEN_DISABLE (0x00000000u)
N#define CSL_SPI_SPIINT0_DMAREQEN_ENABLE  (0x00000001u)
N
N#define CSL_SPI_SPIINT0_RXINTEN_MASK     (0x00000100u)
N#define CSL_SPI_SPIINT0_RXINTEN_SHIFT    (0x00000008u)
N#define CSL_SPI_SPIINT0_RXINTEN_RESETVAL (0x00000000u)
N
N/*----RXINTEN Tokens----*/
N#define CSL_SPI_SPIINT0_RXINTEN_DISABLE  (0x00000000u)
N#define CSL_SPI_SPIINT0_RXINTEN_ENABLE   (0x00000001u)
N
N#define CSL_SPI_SPIINT0_OVRNINTEN_MASK   (0x00000040u)
N#define CSL_SPI_SPIINT0_OVRNINTEN_SHIFT  (0x00000006u)
N#define CSL_SPI_SPIINT0_OVRNINTEN_RESETVAL (0x00000000u)
N
N/*----OVRNINTEN Tokens----*/
N#define CSL_SPI_SPIINT0_OVRNINTEN_DISABLE (0x00000000u)
N#define CSL_SPI_SPIINT0_OVRNINTEN_ENABLE (0x00000001u)
N
N#define CSL_SPI_SPIINT0_BITERRENA_MASK   (0x00000010u)
N#define CSL_SPI_SPIINT0_BITERRENA_SHIFT  (0x00000004u)
N#define CSL_SPI_SPIINT0_BITERRENA_RESETVAL (0x00000000u)
N
N/*----BITERRENA Tokens----*/
N#define CSL_SPI_SPIINT0_BITERRENA_DISABLE (0x00000000u)
N#define CSL_SPI_SPIINT0_BITERRENA_ENABLE (0x00000001u)
N
N#define CSL_SPI_SPIINT0_DESYNCENA_MASK   (0x00000008u)
N#define CSL_SPI_SPIINT0_DESYNCENA_SHIFT  (0x00000003u)
N#define CSL_SPI_SPIINT0_DESYNCENA_RESETVAL (0x00000000u)
N
N/*----DESYNCENA Tokens----*/
N#define CSL_SPI_SPIINT0_DESYNCENA_DISABLE (0x00000000u)
N#define CSL_SPI_SPIINT0_DESYNCENA_ENABLE (0x00000001u)
N
N#define CSL_SPI_SPIINT0_TIMEOUTENA_MASK  (0x00000002u)
N#define CSL_SPI_SPIINT0_TIMEOUTENA_SHIFT (0x00000001u)
N#define CSL_SPI_SPIINT0_TIMEOUTENA_RESETVAL (0x00000000u)
N
N/*----TIMEOUTENA Tokens----*/
N#define CSL_SPI_SPIINT0_TIMEOUTENA_DISABLE (0x00000000u)
N#define CSL_SPI_SPIINT0_TIMEOUTENA_ENABLE (0x00000001u)
N
N#define CSL_SPI_SPIINT0_RESETVAL         (0x00000000u)
N
N/* SPILVL */
N
N#define CSL_SPI_SPILVL_RXINTLVL_MASK     (0x00000100u)
N#define CSL_SPI_SPILVL_RXINTLVL_SHIFT    (0x00000008u)
N#define CSL_SPI_SPILVL_RXINTLVL_RESETVAL (0x00000000u)
N
N/*----RXINTLVL Tokens----*/
N#define CSL_SPI_SPILVL_RXINTLVL_INT0     (0x00000000u)
N#define CSL_SPI_SPILVL_RXINTLVL_INT1     (0x00000001u)
N
N#define CSL_SPI_SPILVL_OVRNINTLVL_MASK   (0x00000040u)
N#define CSL_SPI_SPILVL_OVRNINTLVL_SHIFT  (0x00000006u)
N#define CSL_SPI_SPILVL_OVRNINTLVL_RESETVAL (0x00000000u)
N
N/*----OVRNINTLVL Tokens----*/
N#define CSL_SPI_SPILVL_OVRNINTLVL_INT0   (0x00000000u)
N#define CSL_SPI_SPILVL_OVRNINTLVL_INT1   (0x00000001u)
N
N#define CSL_SPI_SPILVL_BITERRLVL_MASK    (0x00000010u)
N#define CSL_SPI_SPILVL_BITERRLVL_SHIFT   (0x00000004u)
N#define CSL_SPI_SPILVL_BITERRLVL_RESETVAL (0x00000000u)
N
N/*----BITERRLVL Tokens----*/
N#define CSL_SPI_SPILVL_BITERRLVL_INT0    (0x00000000u)
N#define CSL_SPI_SPILVL_BITERRLVL_INT1    (0x00000001u)
N
N#define CSL_SPI_SPILVL_DESYNCLVL_MASK    (0x00000008u)
N#define CSL_SPI_SPILVL_DESYNCLVL_SHIFT   (0x00000003u)
N#define CSL_SPI_SPILVL_DESYNCLVL_RESETVAL (0x00000000u)
N
N/*----DESYNCLVL Tokens----*/
N#define CSL_SPI_SPILVL_DESYNCLVL_INT0    (0x00000000u)
N#define CSL_SPI_SPILVL_DESYNCLVL_INT1    (0x00000001u)
N
N#define CSL_SPI_SPILVL_TIMEOUTLVL_MASK   (0x00000002u)
N#define CSL_SPI_SPILVL_TIMEOUTLVL_SHIFT  (0x00000001u)
N#define CSL_SPI_SPILVL_TIMEOUTLVL_RESETVAL (0x00000000u)
N
N/*----TIMEOUTLVL Tokens----*/
N#define CSL_SPI_SPILVL_TIMEOUTLVL_INT0   (0x00000000u)
N#define CSL_SPI_SPILVL_TIMEOUTLVL_INT1   (0x00000001u)
N
N#define CSL_SPI_SPILVL_RESETVAL          (0x00000000u)
N
N/* SPIFLG */
N
N#define CSL_SPI_SPIFLG_RXINTFLAG_MASK    (0x00000100u)
N#define CSL_SPI_SPIFLG_RXINTFLAG_SHIFT   (0x00000008u)
N#define CSL_SPI_SPIFLG_RXINTFLAG_RESETVAL (0x00000000u)
N
N/*----RXINTFLAG Tokens----*/
N#define CSL_SPI_SPIFLG_RXINTFLAG_NO      (0x00000000u)
N#define CSL_SPI_SPIFLG_RXINTFLAG_YES     (0x00000001u)
N
N#define CSL_SPI_SPIFLG_OVRNINTFLG_MASK   (0x00000040u)
N#define CSL_SPI_SPIFLG_OVRNINTFLG_SHIFT  (0x00000006u)
N#define CSL_SPI_SPIFLG_OVRNINTFLG_RESETVAL (0x00000000u)
N
N/*----OVRNINTFLG Tokens----*/
N#define CSL_SPI_SPIFLG_OVRNINTFLG_NO     (0x00000000u)
N#define CSL_SPI_SPIFLG_OVRNINTFLG_YES    (0x00000001u)
N
N#define CSL_SPI_SPIFLG_BITERRFLG_MASK    (0x00000010u)
N#define CSL_SPI_SPIFLG_BITERRFLG_SHIFT   (0x00000004u)
N#define CSL_SPI_SPIFLG_BITERRFLG_RESETVAL (0x00000000u)
N
N/*----BITERRFLG Tokens----*/
N#define CSL_SPI_SPIFLG_BITERRFLG_NO      (0x00000000u)
N#define CSL_SPI_SPIFLG_BITERRFLG_YES     (0x00000001u)
N
N#define CSL_SPI_SPIFLG_DESYNCFLG_MASK    (0x00000008u)
N#define CSL_SPI_SPIFLG_DESYNCFLG_SHIFT   (0x00000003u)
N#define CSL_SPI_SPIFLG_DESYNCFLG_RESETVAL (0x00000000u)
N
N/*----DESYNCFLG Tokens----*/
N#define CSL_SPI_SPIFLG_DESYNCFLG_NO      (0x00000000u)
N#define CSL_SPI_SPIFLG_DESYNCFLG_YES     (0x00000001u)
N
N#define CSL_SPI_SPIFLG_TIMEOUTFLG_MASK   (0x00000002u)
N#define CSL_SPI_SPIFLG_TIMEOUTFLG_SHIFT  (0x00000001u)
N#define CSL_SPI_SPIFLG_TIMEOUTFLG_RESETVAL (0x00000000u)
N
N/*----TIMEOUTFLG Tokens----*/
N#define CSL_SPI_SPIFLG_TIMEOUTFLG_NO     (0x00000000u)
N#define CSL_SPI_SPIFLG_TIMEOUTFLG_YES    (0x00000001u)
N
N#define CSL_SPI_SPIFLG_RESETVAL          (0x00000000u)
N
N/* SPIPC0 */
N
N#define CSL_SPI_SPIPC0_SOMIFUN_MASK      (0x00000800u)
N#define CSL_SPI_SPIPC0_SOMIFUN_SHIFT     (0x0000000Bu)
N#define CSL_SPI_SPIPC0_SOMIFUN_RESETVAL  (0x00000000u)
N
N/*----SOMIFUN Tokens----*/
N#define CSL_SPI_SPIPC0_SOMIFUN_GPIO      (0x00000000u)
N#define CSL_SPI_SPIPC0_SOMIFUN_SPI       (0x00000001u)
N
N#define CSL_SPI_SPIPC0_SIMOFUN_MASK      (0x00000400u)
N#define CSL_SPI_SPIPC0_SIMOFUN_SHIFT     (0x0000000Au)
N#define CSL_SPI_SPIPC0_SIMOFUN_RESETVAL  (0x00000000u)
N
N/*----SIMOFUN Tokens----*/
N#define CSL_SPI_SPIPC0_SIMOFUN_GPIO      (0x00000000u)
N#define CSL_SPI_SPIPC0_SIMOFUN_SPI       (0x00000001u)
N
N#define CSL_SPI_SPIPC0_CLKFUN_MASK       (0x00000200u)
N#define CSL_SPI_SPIPC0_CLKFUN_SHIFT      (0x00000009u)
N#define CSL_SPI_SPIPC0_CLKFUN_RESETVAL   (0x00000000u)
N
N/*----CLKFUN Tokens----*/
N#define CSL_SPI_SPIPC0_CLKFUN_GPIO       (0x00000000u)
N#define CSL_SPI_SPIPC0_CLKFUN_SPI        (0x00000001u)
N
N#define CSL_SPI_SPIPC0_ENABLEFUN_MASK    (0x00000100u)
N#define CSL_SPI_SPIPC0_ENABLEFUN_SHIFT   (0x00000008u)
N#define CSL_SPI_SPIPC0_ENABLEFUN_RESETVAL (0x00000000u)
N
N/*----ENABLEFUN Tokens----*/
N#define CSL_SPI_SPIPC0_ENABLEFUN_GPIO    (0x00000000u)
N#define CSL_SPI_SPIPC0_ENABLEFUN_SPI     (0x00000001u)
N
N#define CSL_SPI_SPIPC0_SCSFUN0_MASK      (0x00000001u)
N#define CSL_SPI_SPIPC0_SCSFUN0_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIPC0_SCSFUN0_RESETVAL  (0x00000000u)
N
N/*----SCSFUN0 Tokens----*/
N#define CSL_SPI_SPIPC0_SCSFUN0_GPIO      (0x00000000u)
N#define CSL_SPI_SPIPC0_SCSFUN0_SPI       (0x00000001u)
N
N#define CSL_SPI_SPIPC0_RESETVAL          (0x00000000u)
N
N/* SPIPC1 */
N
N#define CSL_SPI_SPIPC1_SOMIDIR_MASK      (0x00000800u)
N#define CSL_SPI_SPIPC1_SOMIDIR_SHIFT     (0x0000000Bu)
N#define CSL_SPI_SPIPC1_SOMIDIR_RESETVAL  (0x00000000u)
N
N/*----SOMIDIR Tokens----*/
N#define CSL_SPI_SPIPC1_SOMIDIR_IN        (0x00000000u)
N#define CSL_SPI_SPIPC1_SOMIDIR_OUT       (0x00000001u)
N
N#define CSL_SPI_SPIPC1_SIMODIR_MASK      (0x00000400u)
N#define CSL_SPI_SPIPC1_SIMODIR_SHIFT     (0x0000000Au)
N#define CSL_SPI_SPIPC1_SIMODIR_RESETVAL  (0x00000000u)
N
N/*----SIMODIR Tokens----*/
N#define CSL_SPI_SPIPC1_SIMODIR_IN        (0x00000000u)
N#define CSL_SPI_SPIPC1_SIMODIR_OUT       (0x00000001u)
N
N#define CSL_SPI_SPIPC1_CLKDIR_MASK       (0x00000200u)
N#define CSL_SPI_SPIPC1_CLKDIR_SHIFT      (0x00000009u)
N#define CSL_SPI_SPIPC1_CLKDIR_RESETVAL   (0x00000000u)
N
N/*----CLKDIR Tokens----*/
N#define CSL_SPI_SPIPC1_CLKDIR_IN         (0x00000000u)
N#define CSL_SPI_SPIPC1_CLKDIR_OUT        (0x00000001u)
N
N#define CSL_SPI_SPIPC1_ENABLEDIR_MASK    (0x00000100u)
N#define CSL_SPI_SPIPC1_ENABLEDIR_SHIFT   (0x00000008u)
N#define CSL_SPI_SPIPC1_ENABLEDIR_RESETVAL (0x00000000u)
N
N/*----ENABLEDIR Tokens----*/
N#define CSL_SPI_SPIPC1_ENABLEDIR_IN      (0x00000000u)
N#define CSL_SPI_SPIPC1_ENABLEDIR_OUT     (0x00000001u)
N
N#define CSL_SPI_SPIPC1_SCSDIR0_MASK      (0x00000001u)
N#define CSL_SPI_SPIPC1_SCSDIR0_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIPC1_SCSDIR0_RESETVAL  (0x00000000u)
N
N/*----SCSDIR0 Tokens----*/
N#define CSL_SPI_SPIPC1_SCSDIR0_IN        (0x00000000u)
N#define CSL_SPI_SPIPC1_SCSDIR0_OUT       (0x00000001u)
N
N#define CSL_SPI_SPIPC1_RESETVAL          (0x00000000u)
N
N/* SPIPC2 */
N
N#define CSL_SPI_SPIPC2_SOMIDIN_MASK      (0x00000800u)
N#define CSL_SPI_SPIPC2_SOMIDIN_SHIFT     (0x0000000Bu)
N#define CSL_SPI_SPIPC2_SOMIDIN_RESETVAL  (0x00000000u)
N
N/*----SOMIDIN Tokens----*/
N#define CSL_SPI_SPIPC2_SOMIDIN_LO        (0x00000000u)
N#define CSL_SPI_SPIPC2_SOMIDIN_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC2_SIMODIN_MASK      (0x00000400u)
N#define CSL_SPI_SPIPC2_SIMODIN_SHIFT     (0x0000000Au)
N#define CSL_SPI_SPIPC2_SIMODIN_RESETVAL  (0x00000000u)
N
N/*----SIMODIN Tokens----*/
N#define CSL_SPI_SPIPC2_SIMODIN_LO        (0x00000000u)
N#define CSL_SPI_SPIPC2_SIMODIN_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC2_CLKDIN_MASK       (0x00000200u)
N#define CSL_SPI_SPIPC2_CLKDIN_SHIFT      (0x00000009u)
N#define CSL_SPI_SPIPC2_CLKDIN_RESETVAL   (0x00000000u)
N
N/*----CLKDIN Tokens----*/
N#define CSL_SPI_SPIPC2_CLKDIN_LO         (0x00000000u)
N#define CSL_SPI_SPIPC2_CLKDIN_HI         (0x00000001u)
N
N#define CSL_SPI_SPIPC2_ENABLEDIN_MASK    (0x00000100u)
N#define CSL_SPI_SPIPC2_ENABLEDIN_SHIFT   (0x00000008u)
N#define CSL_SPI_SPIPC2_ENABLEDIN_RESETVAL (0x00000000u)
N
N/*----ENABLEDIN Tokens----*/
N#define CSL_SPI_SPIPC2_ENABLEDIN_LO      (0x00000000u)
N#define CSL_SPI_SPIPC2_ENABLEDIN_HI      (0x00000001u)
N
N#define CSL_SPI_SPIPC2_SCSDIN0_MASK      (0x00000001u)
N#define CSL_SPI_SPIPC2_SCSDIN0_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIPC2_SCSDIN0_RESETVAL  (0x00000000u)
N
N/*----SCSDIN0 Tokens----*/
N#define CSL_SPI_SPIPC2_SCSDIN0_LO        (0x00000000u)
N#define CSL_SPI_SPIPC2_SCSDIN0_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC2_RESETVAL          (0x00000000u)
N
N/* SPIPC3 */
N
N#define CSL_SPI_SPIPC3_SOMIDOUT_MASK     (0x00000800u)
N#define CSL_SPI_SPIPC3_SOMIDOUT_SHIFT    (0x0000000Bu)
N#define CSL_SPI_SPIPC3_SOMIDOUT_RESETVAL (0x00000000u)
N
N/*----SOMIDOUT Tokens----*/
N#define CSL_SPI_SPIPC3_SOMIDOUT_LO       (0x00000000u)
N#define CSL_SPI_SPIPC3_SOMIDOUT_HI       (0x00000001u)
N
N#define CSL_SPI_SPIPC3_SIMODOUT_MASK     (0x00000400u)
N#define CSL_SPI_SPIPC3_SIMODOUT_SHIFT    (0x0000000Au)
N#define CSL_SPI_SPIPC3_SIMODOUT_RESETVAL (0x00000000u)
N
N/*----SIMODOUT Tokens----*/
N#define CSL_SPI_SPIPC3_SIMODOUT_LO       (0x00000000u)
N#define CSL_SPI_SPIPC3_SIMODOUT_HI       (0x00000001u)
N
N#define CSL_SPI_SPIPC3_CLKDOUT_MASK      (0x00000200u)
N#define CSL_SPI_SPIPC3_CLKDOUT_SHIFT     (0x00000009u)
N#define CSL_SPI_SPIPC3_CLKDOUT_RESETVAL  (0x00000000u)
N
N/*----CLKDOUT Tokens----*/
N#define CSL_SPI_SPIPC3_CLKDOUT_LO        (0x00000000u)
N#define CSL_SPI_SPIPC3_CLKDOUT_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC3_ENABLEDOUT_MASK   (0x00000100u)
N#define CSL_SPI_SPIPC3_ENABLEDOUT_SHIFT  (0x00000008u)
N#define CSL_SPI_SPIPC3_ENABLEDOUT_RESETVAL (0x00000000u)
N
N/*----ENABLEDOUT Tokens----*/
N#define CSL_SPI_SPIPC3_ENABLEDOUT_LO     (0x00000000u)
N#define CSL_SPI_SPIPC3_ENABLEDOUT_HI     (0x00000001u)
N
N#define CSL_SPI_SPIPC3_SCSDOUT0_MASK     (0x00000001u)
N#define CSL_SPI_SPIPC3_SCSDOUT0_SHIFT    (0x00000000u)
N#define CSL_SPI_SPIPC3_SCSDOUT0_RESETVAL (0x00000000u)
N
N/*----SCSDOUT0 Tokens----*/
N#define CSL_SPI_SPIPC3_SCSDOUT0_LO       (0x00000000u)
N#define CSL_SPI_SPIPC3_SCSDOUT0_HI       (0x00000001u)
N
N#define CSL_SPI_SPIPC3_RESETVAL          (0x00000000u)
N
N/* SPIPC4 */
N
N#define CSL_SPI_SPIPC4_SOMISET_MASK      (0x00000800u)
N#define CSL_SPI_SPIPC4_SOMISET_SHIFT     (0x0000000Bu)
N#define CSL_SPI_SPIPC4_SOMISET_RESETVAL  (0x00000000u)
N
N/*----SOMISET Tokens----*/
N#define CSL_SPI_SPIPC4_SOMISET_LO        (0x00000000u)
N#define CSL_SPI_SPIPC4_SOMISET_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC4_SIMOSET_MASK      (0x00000400u)
N#define CSL_SPI_SPIPC4_SIMOSET_SHIFT     (0x0000000Au)
N#define CSL_SPI_SPIPC4_SIMOSET_RESETVAL  (0x00000000u)
N
N/*----SIMOSET Tokens----*/
N#define CSL_SPI_SPIPC4_SIMOSET_LO        (0x00000000u)
N#define CSL_SPI_SPIPC4_SIMOSET_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC4_CLKSET_MASK       (0x00000200u)
N#define CSL_SPI_SPIPC4_CLKSET_SHIFT      (0x00000009u)
N#define CSL_SPI_SPIPC4_CLKSET_RESETVAL   (0x00000000u)
N
N/*----CLKSET Tokens----*/
N#define CSL_SPI_SPIPC4_CLKSET_LO         (0x00000000u)
N#define CSL_SPI_SPIPC4_CLKSET_HI         (0x00000001u)
N
N#define CSL_SPI_SPIPC4_ENABLESET_MASK    (0x00000100u)
N#define CSL_SPI_SPIPC4_ENABLESET_SHIFT   (0x00000008u)
N#define CSL_SPI_SPIPC4_ENABLESET_RESETVAL (0x00000000u)
N
N/*----ENABLESET Tokens----*/
N#define CSL_SPI_SPIPC4_ENABLESET_LO      (0x00000000u)
N#define CSL_SPI_SPIPC4_ENABLESET_HI      (0x00000001u)
N
N#define CSL_SPI_SPIPC4_SCSSET0_MASK      (0x00000001u)
N#define CSL_SPI_SPIPC4_SCSSET0_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIPC4_SCSSET0_RESETVAL  (0x00000000u)
N
N/*----SCSSET0 Tokens----*/
N#define CSL_SPI_SPIPC4_SCSSET0_LO        (0x00000000u)
N#define CSL_SPI_SPIPC4_SCSSET0_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC4_RESETVAL          (0x00000000u)
N
N/* SPIPC5 */
N
N#define CSL_SPI_SPIPC5_SOMICLR_MASK      (0x00000800u)
N#define CSL_SPI_SPIPC5_SOMICLR_SHIFT     (0x0000000Bu)
N#define CSL_SPI_SPIPC5_SOMICLR_RESETVAL  (0x00000000u)
N
N/*----SOMICLR Tokens----*/
N#define CSL_SPI_SPIPC5_SOMICLR_LO        (0x00000000u)
N#define CSL_SPI_SPIPC5_SOMICLR_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC5_SIMOCLR_MASK      (0x00000400u)
N#define CSL_SPI_SPIPC5_SIMOCLR_SHIFT     (0x0000000Au)
N#define CSL_SPI_SPIPC5_SIMOCLR_RESETVAL  (0x00000000u)
N
N/*----SIMOCLR Tokens----*/
N#define CSL_SPI_SPIPC5_SIMOCLR_LO        (0x00000000u)
N#define CSL_SPI_SPIPC5_SIMOCLR_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC5_CLKCLR_MASK       (0x00000200u)
N#define CSL_SPI_SPIPC5_CLKCLR_SHIFT      (0x00000009u)
N#define CSL_SPI_SPIPC5_CLKCLR_RESETVAL   (0x00000000u)
N
N/*----CLKCLR Tokens----*/
N#define CSL_SPI_SPIPC5_CLKCLR_LO         (0x00000000u)
N#define CSL_SPI_SPIPC5_CLKCLR_HI         (0x00000001u)
N
N#define CSL_SPI_SPIPC5_ENABLECLR_MASK    (0x00000100u)
N#define CSL_SPI_SPIPC5_ENABLECLR_SHIFT   (0x00000008u)
N#define CSL_SPI_SPIPC5_ENABLECLR_RESETVAL (0x00000000u)
N
N/*----ENABLECLR Tokens----*/
N#define CSL_SPI_SPIPC5_ENABLECLR_LO      (0x00000000u)
N#define CSL_SPI_SPIPC5_ENABLECLR_HI      (0x00000001u)
N
N#define CSL_SPI_SPIPC5_SCSCLR0_MASK      (0x00000001u)
N#define CSL_SPI_SPIPC5_SCSCLR0_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIPC5_SCSCLR0_RESETVAL  (0x00000000u)
N
N/*----SCSCLR0 Tokens----*/
N#define CSL_SPI_SPIPC5_SCSCLR0_LO        (0x00000000u)
N#define CSL_SPI_SPIPC5_SCSCLR0_HI        (0x00000001u)
N
N#define CSL_SPI_SPIPC5_RESETVAL          (0x00000000u)
N
N/* SPIDAT0 */
N
N#define CSL_SPI_SPIDAT0_SPIDAT0_MASK     (0x0000FFFFu)
N#define CSL_SPI_SPIDAT0_SPIDAT0_SHIFT    (0x00000000u)
N#define CSL_SPI_SPIDAT0_SPIDAT0_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIDAT0_RESETVAL         (0x00000000u)
N
N/* SPIDAT1 */
N
N#define CSL_SPI_SPIDAT1_CSHOLD_MASK      (0x10000000u)
N#define CSL_SPI_SPIDAT1_CSHOLD_SHIFT     (0x0000001Cu)
N#define CSL_SPI_SPIDAT1_CSHOLD_RESETVAL  (0x00000000u)
N
N/*----CSHOLD Tokens----*/
N#define CSL_SPI_SPIDAT1_CSHOLD_NO        (0x00000000u)
N#define CSL_SPI_SPIDAT1_CSHOLD_YES       (0x00000001u)
N
N#define CSL_SPI_SPIDAT1_WDEL_MASK        (0x04000000u)
N#define CSL_SPI_SPIDAT1_WDEL_SHIFT       (0x0000001Au)
N#define CSL_SPI_SPIDAT1_WDEL_RESETVAL    (0x00000000u)
N
N/*----WDEL Tokens----*/
N#define CSL_SPI_SPIDAT1_WDEL_NODELAY     (0x00000000u)
N#define CSL_SPI_SPIDAT1_WDEL_DELAY       (0x00000001u)
N
N#define CSL_SPI_SPIDAT1_DFSEL_MASK       (0x03000000u)
N#define CSL_SPI_SPIDAT1_DFSEL_SHIFT      (0x00000018u)
N#define CSL_SPI_SPIDAT1_DFSEL_RESETVAL   (0x00000000u)
N
N/*----DFSEL Tokens----*/
N#define CSL_SPI_SPIDAT1_DFSEL_FMT0       (0x00000000u)
N#define CSL_SPI_SPIDAT1_DFSEL_FMT1       (0x00000001u)
N#define CSL_SPI_SPIDAT1_DFSEL_FMT2       (0x00000002u)
N#define CSL_SPI_SPIDAT1_DFSEL_FMT3       (0x00000003u)
N
N#define CSL_SPI_SPIDAT1_CSNR_MASK        (0x00FF0000u)
N#define CSL_SPI_SPIDAT1_CSNR_SHIFT       (0x00000010u)
N#define CSL_SPI_SPIDAT1_CSNR_RESETVAL    (0x00000000u)
N
N#define CSL_SPI_SPIDAT1_SPIDAT1_MASK     (0x0000FFFFu)
N#define CSL_SPI_SPIDAT1_SPIDAT1_SHIFT    (0x00000000u)
N#define CSL_SPI_SPIDAT1_SPIDAT1_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIDAT1_RESETVAL         (0x00000000u)
N
N/* SPIBUF */
N
N#define CSL_SPI_SPIBUF_RXEMPTY_MASK      (0x80000000u)
N#define CSL_SPI_SPIBUF_RXEMPTY_SHIFT     (0x0000001Fu)
N#define CSL_SPI_SPIBUF_RXEMPTY_RESETVAL  (0x00000001u)
N
N/*----RXEMPTY Tokens----*/
N#define CSL_SPI_SPIBUF_RXEMPTY_YES       (0x00000000u)
N#define CSL_SPI_SPIBUF_RXEMPTY_NO        (0x00000001u)
N
N#define CSL_SPI_SPIBUF_OVRNINT_MASK      (0x40000000u)
N#define CSL_SPI_SPIBUF_OVRNINT_SHIFT     (0x0000001Eu)
N#define CSL_SPI_SPIBUF_OVRNINT_RESETVAL  (0x00000000u)
N
N/*----OVRNINT Tokens----*/
N#define CSL_SPI_SPIBUF_OVRNINT_NO        (0x00000000u)
N#define CSL_SPI_SPIBUF_OVRNINT_YES       (0x00000001u)
N
N#define CSL_SPI_SPIBUF_TXFULL_MASK       (0x20000000u)
N#define CSL_SPI_SPIBUF_TXFULL_SHIFT      (0x0000001Du)
N#define CSL_SPI_SPIBUF_TXFULL_RESETVAL   (0x00000000u)
N
N/*----TXFULL Tokens----*/
N#define CSL_SPI_SPIBUF_TXFULL_NO         (0x00000000u)
N#define CSL_SPI_SPIBUF_TXFULL_YES        (0x00000001u)
N
N#define CSL_SPI_SPIBUF_BITERR_MASK       (0x10000000u)
N#define CSL_SPI_SPIBUF_BITERR_SHIFT      (0x0000001Cu)
N#define CSL_SPI_SPIBUF_BITERR_RESETVAL   (0x00000000u)
N
N/*----BITERR Tokens----*/
N#define CSL_SPI_SPIBUF_BITERR_NO         (0x00000000u)
N#define CSL_SPI_SPIBUF_BITERR_YES        (0x00000001u)
N
N#define CSL_SPI_SPIBUF_DESYNC_MASK       (0x08000000u)
N#define CSL_SPI_SPIBUF_DESYNC_SHIFT      (0x0000001Bu)
N#define CSL_SPI_SPIBUF_DESYNC_RESETVAL   (0x00000000u)
N
N/*----DESYNC Tokens----*/
N#define CSL_SPI_SPIBUF_DESYNC_NO         (0x00000000u)
N#define CSL_SPI_SPIBUF_DESYNC_YES        (0x00000001u)
N
N#define CSL_SPI_SPIBUF_TIMEOUT_MASK      (0x02000000u)
N#define CSL_SPI_SPIBUF_TIMEOUT_SHIFT     (0x00000019u)
N#define CSL_SPI_SPIBUF_TIMEOUT_RESETVAL  (0x00000000u)
N
N/*----TIMEOUT Tokens----*/
N#define CSL_SPI_SPIBUF_TIMEOUT_NO        (0x00000000u)
N#define CSL_SPI_SPIBUF_TIMEOUT_YES       (0x00000001u)
N
N#define CSL_SPI_SPIBUF_SPIBUF_MASK       (0x0000FFFFu)
N#define CSL_SPI_SPIBUF_SPIBUF_SHIFT      (0x00000000u)
N#define CSL_SPI_SPIBUF_SPIBUF_RESETVAL   (0x00000000u)
N
N#define CSL_SPI_SPIBUF_RESETVAL          (0x80000000u)
N
N/* SPIEMU */
N
N#define CSL_SPI_SPIEMU_SPIEMU_MASK       (0x0000FFFFu)
N#define CSL_SPI_SPIEMU_SPIEMU_SHIFT      (0x00000000u)
N#define CSL_SPI_SPIEMU_SPIEMU_RESETVAL   (0x00000000u)
N
N#define CSL_SPI_SPIEMU_RESETVAL          (0x00000000u)
N
N/* SPIDELAY */
N
N#define CSL_SPI_SPIDELAY_C2TDELAY_MASK   (0x1F000000u)
N#define CSL_SPI_SPIDELAY_C2TDELAY_SHIFT  (0x00000018u)
N#define CSL_SPI_SPIDELAY_C2TDELAY_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIDELAY_T2CDELAY_MASK   (0x001F0000u)
N#define CSL_SPI_SPIDELAY_T2CDELAY_SHIFT  (0x00000010u)
N#define CSL_SPI_SPIDELAY_T2CDELAY_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIDELAY_T2EDELAY_MASK   (0x0000FF00u)
N#define CSL_SPI_SPIDELAY_T2EDELAY_SHIFT  (0x00000008u)
N#define CSL_SPI_SPIDELAY_T2EDELAY_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIDELAY_C2EDELAY_MASK   (0x000000FFu)
N#define CSL_SPI_SPIDELAY_C2EDELAY_SHIFT  (0x00000000u)
N#define CSL_SPI_SPIDELAY_C2EDELAY_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIDELAY_RESETVAL        (0x00000000u)
N
N/* SPIDEF */
N
N#define CSL_SPI_SPIDEF_CSDEF0_MASK       (0x00000001u)
N#define CSL_SPI_SPIDEF_CSDEF0_SHIFT      (0x00000000u)
N#define CSL_SPI_SPIDEF_CSDEF0_RESETVAL   (0x00000001u)
N
N#define CSL_SPI_SPIDEF_RESETVAL          (0x00000001u)
N
N/* SPIFMT */
N
N#define CSL_SPI_SPIFMT_WDELAY_MASK       (0x3F000000u)
N#define CSL_SPI_SPIFMT_WDELAY_SHIFT      (0x00000018u)
N#define CSL_SPI_SPIFMT_WDELAY_RESETVAL   (0x00000000u)
N
N#define CSL_SPI_SPIFMT_WAITENA_MASK      (0x00200000u)
N#define CSL_SPI_SPIFMT_WAITENA_SHIFT     (0x00000015u)
N#define CSL_SPI_SPIFMT_WAITENA_RESETVAL  (0x00000000u)
N
N/*----WAITENA Tokens----*/
N#define CSL_SPI_SPIFMT_WAITENA_NO        (0x00000000u)
N#define CSL_SPI_SPIFMT_WAITENA_YES       (0x00000001u)
N
N#define CSL_SPI_SPIFMT_SHIFTDIR_MASK     (0x00100000u)
N#define CSL_SPI_SPIFMT_SHIFTDIR_SHIFT    (0x00000014u)
N#define CSL_SPI_SPIFMT_SHIFTDIR_RESETVAL (0x00000000u)
N
N/*----SHIFTDIR Tokens----*/
N#define CSL_SPI_SPIFMT_SHIFTDIR_MSBFIRST (0x00000000u)
N#define CSL_SPI_SPIFMT_SHIFTDIR_LSBFIRST (0x00000001u)
N
N#define CSL_SPI_SPIFMT_POLARITY_MASK     (0x00020000u)
N#define CSL_SPI_SPIFMT_POLARITY_SHIFT    (0x00000011u)
N#define CSL_SPI_SPIFMT_POLARITY_RESETVAL (0x00000000u)
N
N/*----POLARITY Tokens----*/
N#define CSL_SPI_SPIFMT_POLARITY_INACTIVELO (0x00000000u)
N#define CSL_SPI_SPIFMT_POLARITY_INACTIVEHI (0x00000001u)
N
N#define CSL_SPI_SPIFMT_PHASE_MASK        (0x00010000u)
N#define CSL_SPI_SPIFMT_PHASE_SHIFT       (0x00000010u)
N#define CSL_SPI_SPIFMT_PHASE_RESETVAL    (0x00000000u)
N
N/*----PHASE Tokens----*/
N#define CSL_SPI_SPIFMT_PHASE_IN          (0x00000000u)
N#define CSL_SPI_SPIFMT_PHASE_OUT         (0x00000001u)
N
N#define CSL_SPI_SPIFMT_PRESCALE_MASK     (0x0000FF00u)
N#define CSL_SPI_SPIFMT_PRESCALE_SHIFT    (0x00000008u)
N#define CSL_SPI_SPIFMT_PRESCALE_RESETVAL (0x00000000u)
N
N#define CSL_SPI_SPIFMT_CHARLEN_MASK      (0x0000001Fu)
N#define CSL_SPI_SPIFMT_CHARLEN_SHIFT     (0x00000000u)
N#define CSL_SPI_SPIFMT_CHARLEN_RESETVAL  (0x00000000u)
N
N#define CSL_SPI_SPIFMT_RESETVAL          (0x00000000u)
N
N/* TGINTVECT */
N
N#define CSL_SPI_TGINTVECT_INTVECT_MASK   (0x0000003Eu)
N#define CSL_SPI_TGINTVECT_INTVECT_SHIFT  (0x00000001u)
N#define CSL_SPI_TGINTVECT_INTVECT_RESETVAL (0x00000000u)
N
N#define CSL_SPI_TGINTVECT_RESETVAL       (0x00000000u)
N
N#endif
L 40 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_mcasp.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_mcasp.h" 1
N#ifndef _CSLR_MCASP_H_
N#define _CSLR_MCASP_H_
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_mcasp.h
N * 
N * \brief This file contains the Register Desciptions for McASP
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 PID;
N    volatile Uint32 PWRDEMU;
N    volatile Uint32 RSVD0[2];
N    volatile Uint32 PFUNC;
N    volatile Uint32 PDIR;
N    volatile Uint32 PDOUT;
N    volatile Uint32 PDIN_PDSET;
N    volatile Uint32 PDCLR;
N    volatile Uint32 RSVD1[8];
N    volatile Uint32 GBLCTL;
N    volatile Uint32 AMUTE;
N    volatile Uint32 DLBCTL;
N    volatile Uint32 DITCTL;
N    volatile Uint32 RSVD2[3];
N    volatile Uint32 RGBLCTL;
N    volatile Uint32 RMASK;
N    volatile Uint32 RFMT;
N    volatile Uint32 AFSRCTL;
N    volatile Uint32 ACLKRCTL;
N    volatile Uint32 AHCLKRCTL;
N    volatile Uint32 RTDM;
N    volatile Uint32 RINTCTL;
N    volatile Uint32 RSTAT;
N    volatile Uint32 RSLOT;
N    volatile Uint32 RCLKCHK;
N    volatile Uint32 REVTCTL;
N    volatile Uint32 RSVD3[4];
N    volatile Uint32 XGBLCTL;
N    volatile Uint32 XMASK;
N    volatile Uint32 XFMT;
N    volatile Uint32 AFSXCTL;
N    volatile Uint32 ACLKXCTL;
N    volatile Uint32 AHCLKXCTL;
N    volatile Uint32 XTDM;
N    volatile Uint32 XINTCTL;
N    volatile Uint32 XSTAT;
N    volatile Uint32 XSLOT;
N    volatile Uint32 XCLKCHK;
N    volatile Uint32 XEVTCTL;
N    volatile Uint32 RSVD4[12];
N    volatile Uint32 DITCSRA0;
N    volatile Uint32 DITCSRA1;
N    volatile Uint32 DITCSRA2;
N    volatile Uint32 DITCSRA3;
N    volatile Uint32 DITCSRA4;
N    volatile Uint32 DITCSRA5;
N    volatile Uint32 DITCSRB0;
N    volatile Uint32 DITCSRB1;
N    volatile Uint32 DITCSRB2;
N    volatile Uint32 DITCSRB3;
N    volatile Uint32 DITCSRB4;
N    volatile Uint32 DITCSRB5;
N    volatile Uint32 DITUDRA0;
N    volatile Uint32 DITUDRA1;
N    volatile Uint32 DITUDRA2;
N    volatile Uint32 DITUDRA3;
N    volatile Uint32 DITUDRA4;
N    volatile Uint32 DITUDRA5;
N    volatile Uint32 DITUDRB0;
N    volatile Uint32 DITUDRB1;
N    volatile Uint32 DITUDRB2;
N    volatile Uint32 DITUDRB3;
N    volatile Uint32 DITUDRB4;
N    volatile Uint32 DITUDRB5;
N    volatile Uint32 RSVD5[8];
N    volatile Uint32 SRCTL0;
N    volatile Uint32 SRCTL1;
N    volatile Uint32 SRCTL2;
N    volatile Uint32 SRCTL3;
N    volatile Uint32 SRCTL4;
N    volatile Uint32 SRCTL5;
N    volatile Uint32 SRCTL6;
N    volatile Uint32 SRCTL7;
N    volatile Uint32 SRCTL8;
N    volatile Uint32 SRCTL9;
N    volatile Uint32 SRCTL10;
N    volatile Uint32 SRCTL11;
N    volatile Uint32 SRCTL12;
N    volatile Uint32 SRCTL13;
N    volatile Uint32 SRCTL14;
N    volatile Uint32 SRCTL15;
N    volatile Uint32 RSVD6[16];
N    volatile Uint32 XBUF0;
N    volatile Uint32 XBUF1;
N    volatile Uint32 XBUF2;
N    volatile Uint32 XBUF3;
N    volatile Uint32 XBUF4;
N    volatile Uint32 XBUF5;
N    volatile Uint32 XBUF6;
N    volatile Uint32 XBUF7;
N    volatile Uint32 XBUF8;
N    volatile Uint32 XBUF9;
N    volatile Uint32 XBUF10;
N    volatile Uint32 XBUF11;
N    volatile Uint32 XBUF12;
N    volatile Uint32 XBUF13;
N    volatile Uint32 XBUF14;
N    volatile Uint32 XBUF15;
N    volatile Uint32 RSVD7[16];
N    volatile Uint32 RBUF0;
N    volatile Uint32 RBUF1;
N    volatile Uint32 RBUF2;
N    volatile Uint32 RBUF3;
N    volatile Uint32 RBUF4;
N    volatile Uint32 RBUF5;
N    volatile Uint32 RBUF6;
N    volatile Uint32 RBUF7;
N    volatile Uint32 RBUF8;
N    volatile Uint32 RBUF9;
N    volatile Uint32 RBUF10;
N    volatile Uint32 RBUF11;
N    volatile Uint32 RBUF12;
N    volatile Uint32 RBUF13;
N    volatile Uint32 RBUF14;
N    volatile Uint32 RBUF15;
N} CSL_McaspRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* PID */
N
N#define CSL_MCASP_PID_TYPE_MASK          (0x00FF0000u)
N#define CSL_MCASP_PID_TYPE_SHIFT         (0x00000010u)
N#define CSL_MCASP_PID_TYPE_RESETVAL      (0x00000010u)
N
N#define CSL_MCASP_PID_CLASS_MASK         (0x0000FF00u)
N#define CSL_MCASP_PID_CLASS_SHIFT        (0x00000008u)
N#define CSL_MCASP_PID_CLASS_RESETVAL     (0x00000001u)
N
N#define CSL_MCASP_PID_REV_MASK           (0x000000FFu)
N#define CSL_MCASP_PID_REV_SHIFT          (0x00000000u)
N#define CSL_MCASP_PID_REV_RESETVAL       (0x00000001u)
N
N#define CSL_MCASP_PID_RESETVAL           (0x00100101u)
N
N/* PWRDEMU */
N
N#define CSL_MCASP_PWRDEMU_FREE_MASK      (0x00000001u)
N#define CSL_MCASP_PWRDEMU_FREE_SHIFT     (0x00000000u)
N#define CSL_MCASP_PWRDEMU_FREE_RESETVAL  (0x00000000u)
N
N/*----FREE Tokens----*/
N#define CSL_MCASP_PWRDEMU_FREE_OFF       (0x00000000u)
N#define CSL_MCASP_PWRDEMU_FREE_ON        (0x00000001u)
N
N#define CSL_MCASP_PWRDEMU_RESETVAL       (0x00000000u)
N
N/* PFUNC */
N
N#define CSL_MCASP_PFUNC_AFSR_MASK        (0x80000000u)
N#define CSL_MCASP_PFUNC_AFSR_SHIFT       (0x0000001Fu)
N#define CSL_MCASP_PFUNC_AFSR_RESETVAL    (0x00000000u)
N
N/*----AFSR Tokens----*/
N#define CSL_MCASP_PFUNC_AFSR_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AFSR_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AHCLKR_MASK      (0x40000000u)
N#define CSL_MCASP_PFUNC_AHCLKR_SHIFT     (0x0000001Eu)
N#define CSL_MCASP_PFUNC_AHCLKR_RESETVAL  (0x00000000u)
N
N/*----AHCLKR Tokens----*/
N#define CSL_MCASP_PFUNC_AHCLKR_MCASP     (0x00000000u)
N#define CSL_MCASP_PFUNC_AHCLKR_GPIO      (0x00000001u)
N
N#define CSL_MCASP_PFUNC_ACLKR_MASK       (0x20000000u)
N#define CSL_MCASP_PFUNC_ACLKR_SHIFT      (0x0000001Du)
N#define CSL_MCASP_PFUNC_ACLKR_RESETVAL   (0x00000000u)
N
N/*----ACLKR Tokens----*/
N#define CSL_MCASP_PFUNC_ACLKR_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_ACLKR_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AFSX_MASK        (0x10000000u)
N#define CSL_MCASP_PFUNC_AFSX_SHIFT       (0x0000001Cu)
N#define CSL_MCASP_PFUNC_AFSX_RESETVAL    (0x00000000u)
N
N/*----AFSX Tokens----*/
N#define CSL_MCASP_PFUNC_AFSX_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AFSX_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AHCLKX_MASK      (0x08000000u)
N#define CSL_MCASP_PFUNC_AHCLKX_SHIFT     (0x0000001Bu)
N#define CSL_MCASP_PFUNC_AHCLKX_RESETVAL  (0x00000000u)
N
N/*----AHCLKX Tokens----*/
N#define CSL_MCASP_PFUNC_AHCLKX_MCASP     (0x00000000u)
N#define CSL_MCASP_PFUNC_AHCLKX_GPIO      (0x00000001u)
N
N#define CSL_MCASP_PFUNC_ACLKX_MASK       (0x04000000u)
N#define CSL_MCASP_PFUNC_ACLKX_SHIFT      (0x0000001Au)
N#define CSL_MCASP_PFUNC_ACLKX_RESETVAL   (0x00000000u)
N
N/*----ACLKX Tokens----*/
N#define CSL_MCASP_PFUNC_ACLKX_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_ACLKX_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AMUTE_MASK       (0x02000000u)
N#define CSL_MCASP_PFUNC_AMUTE_SHIFT      (0x00000019u)
N#define CSL_MCASP_PFUNC_AMUTE_RESETVAL   (0x00000000u)
N
N/*----AMUTE Tokens----*/
N#define CSL_MCASP_PFUNC_AMUTE_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AMUTE_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR15_MASK       (0x00008000u)
N#define CSL_MCASP_PFUNC_AXR15_SHIFT      (0x0000000Fu)
N#define CSL_MCASP_PFUNC_AXR15_RESETVAL   (0x00000000u)
N
N/*----AXR15 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR15_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR15_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR14_MASK       (0x00004000u)
N#define CSL_MCASP_PFUNC_AXR14_SHIFT      (0x0000000Eu)
N#define CSL_MCASP_PFUNC_AXR14_RESETVAL   (0x00000000u)
N
N/*----AXR14 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR14_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR14_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR13_MASK       (0x00002000u)
N#define CSL_MCASP_PFUNC_AXR13_SHIFT      (0x0000000Du)
N#define CSL_MCASP_PFUNC_AXR13_RESETVAL   (0x00000000u)
N
N/*----AXR13 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR13_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR13_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR12_MASK       (0x00001000u)
N#define CSL_MCASP_PFUNC_AXR12_SHIFT      (0x0000000Cu)
N#define CSL_MCASP_PFUNC_AXR12_RESETVAL   (0x00000000u)
N
N/*----AXR12 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR12_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR12_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR11_MASK       (0x00000800u)
N#define CSL_MCASP_PFUNC_AXR11_SHIFT      (0x0000000Bu)
N#define CSL_MCASP_PFUNC_AXR11_RESETVAL   (0x00000000u)
N
N/*----AXR11 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR11_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR11_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR10_MASK       (0x00000400u)
N#define CSL_MCASP_PFUNC_AXR10_SHIFT      (0x0000000Au)
N#define CSL_MCASP_PFUNC_AXR10_RESETVAL   (0x00000000u)
N
N/*----AXR10 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR10_MCASP      (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR10_GPIO       (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR9_MASK        (0x00000200u)
N#define CSL_MCASP_PFUNC_AXR9_SHIFT       (0x00000009u)
N#define CSL_MCASP_PFUNC_AXR9_RESETVAL    (0x00000000u)
N
N/*----AXR9 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR9_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR9_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR8_MASK        (0x00000100u)
N#define CSL_MCASP_PFUNC_AXR8_SHIFT       (0x00000008u)
N#define CSL_MCASP_PFUNC_AXR8_RESETVAL    (0x00000000u)
N
N/*----AXR8 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR8_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR8_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR7_MASK        (0x00000080u)
N#define CSL_MCASP_PFUNC_AXR7_SHIFT       (0x00000007u)
N#define CSL_MCASP_PFUNC_AXR7_RESETVAL    (0x00000000u)
N
N/*----AXR7 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR7_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR7_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR6_MASK        (0x00000040u)
N#define CSL_MCASP_PFUNC_AXR6_SHIFT       (0x00000006u)
N#define CSL_MCASP_PFUNC_AXR6_RESETVAL    (0x00000000u)
N
N/*----AXR6 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR6_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR6_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR5_MASK        (0x00000020u)
N#define CSL_MCASP_PFUNC_AXR5_SHIFT       (0x00000005u)
N#define CSL_MCASP_PFUNC_AXR5_RESETVAL    (0x00000000u)
N
N/*----AXR5 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR5_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR5_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR4_MASK        (0x00000010u)
N#define CSL_MCASP_PFUNC_AXR4_SHIFT       (0x00000004u)
N#define CSL_MCASP_PFUNC_AXR4_RESETVAL    (0x00000000u)
N
N/*----AXR4 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR4_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR4_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR3_MASK        (0x00000008u)
N#define CSL_MCASP_PFUNC_AXR3_SHIFT       (0x00000003u)
N#define CSL_MCASP_PFUNC_AXR3_RESETVAL    (0x00000000u)
N
N/*----AXR3 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR3_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR3_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR2_MASK        (0x00000004u)
N#define CSL_MCASP_PFUNC_AXR2_SHIFT       (0x00000002u)
N#define CSL_MCASP_PFUNC_AXR2_RESETVAL    (0x00000000u)
N
N/*----AXR2 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR2_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR2_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR1_MASK        (0x00000002u)
N#define CSL_MCASP_PFUNC_AXR1_SHIFT       (0x00000001u)
N#define CSL_MCASP_PFUNC_AXR1_RESETVAL    (0x00000000u)
N
N/*----AXR1 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR1_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR1_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_AXR0_MASK        (0x00000001u)
N#define CSL_MCASP_PFUNC_AXR0_SHIFT       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR0_RESETVAL    (0x00000000u)
N
N/*----AXR0 Tokens----*/
N#define CSL_MCASP_PFUNC_AXR0_MCASP       (0x00000000u)
N#define CSL_MCASP_PFUNC_AXR0_GPIO        (0x00000001u)
N
N#define CSL_MCASP_PFUNC_RESETVAL         (0x00000000u)
N
N/* PDIR */
N
N#define CSL_MCASP_PDIR_AFSR_MASK         (0x80000000u)
N#define CSL_MCASP_PDIR_AFSR_SHIFT        (0x0000001Fu)
N#define CSL_MCASP_PDIR_AFSR_RESETVAL     (0x00000000u)
N
N/*----AFSR Tokens----*/
N#define CSL_MCASP_PDIR_AFSR_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AFSR_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AHCLKR_MASK       (0x40000000u)
N#define CSL_MCASP_PDIR_AHCLKR_SHIFT      (0x0000001Eu)
N#define CSL_MCASP_PDIR_AHCLKR_RESETVAL   (0x00000000u)
N
N/*----AHCLKR Tokens----*/
N#define CSL_MCASP_PDIR_AHCLKR_INPUT      (0x00000000u)
N#define CSL_MCASP_PDIR_AHCLKR_OUTPUT     (0x00000001u)
N
N#define CSL_MCASP_PDIR_ACLKR_MASK        (0x20000000u)
N#define CSL_MCASP_PDIR_ACLKR_SHIFT       (0x0000001Du)
N#define CSL_MCASP_PDIR_ACLKR_RESETVAL    (0x00000000u)
N
N/*----ACLKR Tokens----*/
N#define CSL_MCASP_PDIR_ACLKR_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_ACLKR_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AFSX_MASK         (0x10000000u)
N#define CSL_MCASP_PDIR_AFSX_SHIFT        (0x0000001Cu)
N#define CSL_MCASP_PDIR_AFSX_RESETVAL     (0x00000000u)
N
N/*----AFSX Tokens----*/
N#define CSL_MCASP_PDIR_AFSX_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AFSX_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AHCLKX_MASK       (0x08000000u)
N#define CSL_MCASP_PDIR_AHCLKX_SHIFT      (0x0000001Bu)
N#define CSL_MCASP_PDIR_AHCLKX_RESETVAL   (0x00000000u)
N
N/*----AHCLKX Tokens----*/
N#define CSL_MCASP_PDIR_AHCLKX_INPUT      (0x00000000u)
N#define CSL_MCASP_PDIR_AHCLKX_OUTPUT     (0x00000001u)
N
N#define CSL_MCASP_PDIR_ACLKX_MASK        (0x04000000u)
N#define CSL_MCASP_PDIR_ACLKX_SHIFT       (0x0000001Au)
N#define CSL_MCASP_PDIR_ACLKX_RESETVAL    (0x00000000u)
N
N/*----ACLKX Tokens----*/
N#define CSL_MCASP_PDIR_ACLKX_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_ACLKX_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AMUTE_MASK        (0x02000000u)
N#define CSL_MCASP_PDIR_AMUTE_SHIFT       (0x00000019u)
N#define CSL_MCASP_PDIR_AMUTE_RESETVAL    (0x00000000u)
N
N/*----AMUTE Tokens----*/
N#define CSL_MCASP_PDIR_AMUTE_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AMUTE_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR15_MASK        (0x00008000u)
N#define CSL_MCASP_PDIR_AXR15_SHIFT       (0x0000000Fu)
N#define CSL_MCASP_PDIR_AXR15_RESETVAL    (0x00000000u)
N
N/*----AXR15 Tokens----*/
N#define CSL_MCASP_PDIR_AXR15_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AXR15_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR14_MASK        (0x00004000u)
N#define CSL_MCASP_PDIR_AXR14_SHIFT       (0x0000000Eu)
N#define CSL_MCASP_PDIR_AXR14_RESETVAL    (0x00000000u)
N
N/*----AXR14 Tokens----*/
N#define CSL_MCASP_PDIR_AXR14_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AXR14_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR13_MASK        (0x00002000u)
N#define CSL_MCASP_PDIR_AXR13_SHIFT       (0x0000000Du)
N#define CSL_MCASP_PDIR_AXR13_RESETVAL    (0x00000000u)
N
N/*----AXR13 Tokens----*/
N#define CSL_MCASP_PDIR_AXR13_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AXR13_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR12_MASK        (0x00001000u)
N#define CSL_MCASP_PDIR_AXR12_SHIFT       (0x0000000Cu)
N#define CSL_MCASP_PDIR_AXR12_RESETVAL    (0x00000000u)
N
N/*----AXR12 Tokens----*/
N#define CSL_MCASP_PDIR_AXR12_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AXR12_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR11_MASK        (0x00000800u)
N#define CSL_MCASP_PDIR_AXR11_SHIFT       (0x0000000Bu)
N#define CSL_MCASP_PDIR_AXR11_RESETVAL    (0x00000000u)
N
N/*----AXR11 Tokens----*/
N#define CSL_MCASP_PDIR_AXR11_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AXR11_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR10_MASK        (0x00000400u)
N#define CSL_MCASP_PDIR_AXR10_SHIFT       (0x0000000Au)
N#define CSL_MCASP_PDIR_AXR10_RESETVAL    (0x00000000u)
N
N/*----AXR10 Tokens----*/
N#define CSL_MCASP_PDIR_AXR10_INPUT       (0x00000000u)
N#define CSL_MCASP_PDIR_AXR10_OUTPUT      (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR9_MASK         (0x00000200u)
N#define CSL_MCASP_PDIR_AXR9_SHIFT        (0x00000009u)
N#define CSL_MCASP_PDIR_AXR9_RESETVAL     (0x00000000u)
N
N/*----AXR9 Tokens----*/
N#define CSL_MCASP_PDIR_AXR9_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR9_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR8_MASK         (0x00000100u)
N#define CSL_MCASP_PDIR_AXR8_SHIFT        (0x00000008u)
N#define CSL_MCASP_PDIR_AXR8_RESETVAL     (0x00000000u)
N
N/*----AXR8 Tokens----*/
N#define CSL_MCASP_PDIR_AXR8_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR8_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR7_MASK         (0x00000080u)
N#define CSL_MCASP_PDIR_AXR7_SHIFT        (0x00000007u)
N#define CSL_MCASP_PDIR_AXR7_RESETVAL     (0x00000000u)
N
N/*----AXR7 Tokens----*/
N#define CSL_MCASP_PDIR_AXR7_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR7_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR6_MASK         (0x00000040u)
N#define CSL_MCASP_PDIR_AXR6_SHIFT        (0x00000006u)
N#define CSL_MCASP_PDIR_AXR6_RESETVAL     (0x00000000u)
N
N/*----AXR6 Tokens----*/
N#define CSL_MCASP_PDIR_AXR6_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR6_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR5_MASK         (0x00000020u)
N#define CSL_MCASP_PDIR_AXR5_SHIFT        (0x00000005u)
N#define CSL_MCASP_PDIR_AXR5_RESETVAL     (0x00000000u)
N
N/*----AXR5 Tokens----*/
N#define CSL_MCASP_PDIR_AXR5_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR5_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR4_MASK         (0x00000010u)
N#define CSL_MCASP_PDIR_AXR4_SHIFT        (0x00000004u)
N#define CSL_MCASP_PDIR_AXR4_RESETVAL     (0x00000000u)
N
N/*----AXR4 Tokens----*/
N#define CSL_MCASP_PDIR_AXR4_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR4_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR3_MASK         (0x00000008u)
N#define CSL_MCASP_PDIR_AXR3_SHIFT        (0x00000003u)
N#define CSL_MCASP_PDIR_AXR3_RESETVAL     (0x00000000u)
N
N/*----AXR3 Tokens----*/
N#define CSL_MCASP_PDIR_AXR3_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR3_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR2_MASK         (0x00000004u)
N#define CSL_MCASP_PDIR_AXR2_SHIFT        (0x00000002u)
N#define CSL_MCASP_PDIR_AXR2_RESETVAL     (0x00000000u)
N
N/*----AXR2 Tokens----*/
N#define CSL_MCASP_PDIR_AXR2_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR2_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR1_MASK         (0x00000002u)
N#define CSL_MCASP_PDIR_AXR1_SHIFT        (0x00000001u)
N#define CSL_MCASP_PDIR_AXR1_RESETVAL     (0x00000000u)
N
N/*----AXR1 Tokens----*/
N#define CSL_MCASP_PDIR_AXR1_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR1_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_AXR0_MASK         (0x00000001u)
N#define CSL_MCASP_PDIR_AXR0_SHIFT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR0_RESETVAL     (0x00000000u)
N
N/*----AXR0 Tokens----*/
N#define CSL_MCASP_PDIR_AXR0_INPUT        (0x00000000u)
N#define CSL_MCASP_PDIR_AXR0_OUTPUT       (0x00000001u)
N
N#define CSL_MCASP_PDIR_RESETVAL          (0x00000000u)
N
N/* PDOUT */
N
N#define CSL_MCASP_PDOUT_AFSR_MASK        (0x80000000u)
N#define CSL_MCASP_PDOUT_AFSR_SHIFT       (0x0000001Fu)
N#define CSL_MCASP_PDOUT_AFSR_RESETVAL    (0x00000000u)
N
N/*----AFSR Tokens----*/
N#define CSL_MCASP_PDOUT_AFSR_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AFSR_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AHCLKR_MASK      (0x40000000u)
N#define CSL_MCASP_PDOUT_AHCLKR_SHIFT     (0x0000001Eu)
N#define CSL_MCASP_PDOUT_AHCLKR_RESETVAL  (0x00000000u)
N
N/*----AHCLKR Tokens----*/
N#define CSL_MCASP_PDOUT_AHCLKR_DRIVE_LOW (0x00000000u)
N#define CSL_MCASP_PDOUT_AHCLKR_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_ACLKR_MASK       (0x20000000u)
N#define CSL_MCASP_PDOUT_ACLKR_SHIFT      (0x0000001Du)
N#define CSL_MCASP_PDOUT_ACLKR_RESETVAL   (0x00000000u)
N
N/*----ACLKR Tokens----*/
N#define CSL_MCASP_PDOUT_ACLKR_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_ACLKR_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AFSX_MASK        (0x10000000u)
N#define CSL_MCASP_PDOUT_AFSX_SHIFT       (0x0000001Cu)
N#define CSL_MCASP_PDOUT_AFSX_RESETVAL    (0x00000000u)
N
N/*----AFSX Tokens----*/
N#define CSL_MCASP_PDOUT_AFSX_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AFSX_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AHCLKX_MASK      (0x08000000u)
N#define CSL_MCASP_PDOUT_AHCLKX_SHIFT     (0x0000001Bu)
N#define CSL_MCASP_PDOUT_AHCLKX_RESETVAL  (0x00000000u)
N
N/*----AHCLKX Tokens----*/
N#define CSL_MCASP_PDOUT_AHCLKX_DRIVE_LOW (0x00000000u)
N#define CSL_MCASP_PDOUT_AHCLKX_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_ACLKX_MASK       (0x04000000u)
N#define CSL_MCASP_PDOUT_ACLKX_SHIFT      (0x0000001Au)
N#define CSL_MCASP_PDOUT_ACLKX_RESETVAL   (0x00000000u)
N
N/*----ACLKX Tokens----*/
N#define CSL_MCASP_PDOUT_ACLKX_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_ACLKX_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AMUTE_MASK       (0x02000000u)
N#define CSL_MCASP_PDOUT_AMUTE_SHIFT      (0x00000019u)
N#define CSL_MCASP_PDOUT_AMUTE_RESETVAL   (0x00000000u)
N
N/*----AMUTE Tokens----*/
N#define CSL_MCASP_PDOUT_AMUTE_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AMUTE_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR15_MASK       (0x00008000u)
N#define CSL_MCASP_PDOUT_AXR15_SHIFT      (0x0000000Fu)
N#define CSL_MCASP_PDOUT_AXR15_RESETVAL   (0x00000000u)
N
N/*----AXR15 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR15_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR15_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR14_MASK       (0x00004000u)
N#define CSL_MCASP_PDOUT_AXR14_SHIFT      (0x0000000Eu)
N#define CSL_MCASP_PDOUT_AXR14_RESETVAL   (0x00000000u)
N
N/*----AXR14 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR14_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR14_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR13_MASK       (0x00002000u)
N#define CSL_MCASP_PDOUT_AXR13_SHIFT      (0x0000000Du)
N#define CSL_MCASP_PDOUT_AXR13_RESETVAL   (0x00000000u)
N
N/*----AXR13 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR13_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR13_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR12_MASK       (0x00001000u)
N#define CSL_MCASP_PDOUT_AXR12_SHIFT      (0x0000000Cu)
N#define CSL_MCASP_PDOUT_AXR12_RESETVAL   (0x00000000u)
N
N/*----AXR12 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR12_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR12_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR11_MASK       (0x00000800u)
N#define CSL_MCASP_PDOUT_AXR11_SHIFT      (0x0000000Bu)
N#define CSL_MCASP_PDOUT_AXR11_RESETVAL   (0x00000000u)
N
N/*----AXR11 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR11_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR11_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR10_MASK       (0x00000400u)
N#define CSL_MCASP_PDOUT_AXR10_SHIFT      (0x0000000Au)
N#define CSL_MCASP_PDOUT_AXR10_RESETVAL   (0x00000000u)
N
N/*----AXR10 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR10_DRIVE_LOW  (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR10_DRIVE_HIGH (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR9_MASK        (0x00000200u)
N#define CSL_MCASP_PDOUT_AXR9_SHIFT       (0x00000009u)
N#define CSL_MCASP_PDOUT_AXR9_RESETVAL    (0x00000000u)
N
N/*----AXR9 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR9_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR9_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR8_MASK        (0x00000100u)
N#define CSL_MCASP_PDOUT_AXR8_SHIFT       (0x00000008u)
N#define CSL_MCASP_PDOUT_AXR8_RESETVAL    (0x00000000u)
N
N/*----AXR8 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR8_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR8_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR7_MASK        (0x00000080u)
N#define CSL_MCASP_PDOUT_AXR7_SHIFT       (0x00000007u)
N#define CSL_MCASP_PDOUT_AXR7_RESETVAL    (0x00000000u)
N
N/*----AXR7 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR7_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR7_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR6_MASK        (0x00000040u)
N#define CSL_MCASP_PDOUT_AXR6_SHIFT       (0x00000006u)
N#define CSL_MCASP_PDOUT_AXR6_RESETVAL    (0x00000000u)
N
N/*----AXR6 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR6_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR6_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR5_MASK        (0x00000020u)
N#define CSL_MCASP_PDOUT_AXR5_SHIFT       (0x00000005u)
N#define CSL_MCASP_PDOUT_AXR5_RESETVAL    (0x00000000u)
N
N/*----AXR5 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR5_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR5_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR4_MASK        (0x00000010u)
N#define CSL_MCASP_PDOUT_AXR4_SHIFT       (0x00000004u)
N#define CSL_MCASP_PDOUT_AXR4_RESETVAL    (0x00000000u)
N
N/*----AXR4 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR4_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR4_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR3_MASK        (0x00000008u)
N#define CSL_MCASP_PDOUT_AXR3_SHIFT       (0x00000003u)
N#define CSL_MCASP_PDOUT_AXR3_RESETVAL    (0x00000000u)
N
N/*----AXR3 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR3_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR3_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR2_MASK        (0x00000004u)
N#define CSL_MCASP_PDOUT_AXR2_SHIFT       (0x00000002u)
N#define CSL_MCASP_PDOUT_AXR2_RESETVAL    (0x00000000u)
N
N/*----AXR2 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR2_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR2_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR1_MASK        (0x00000002u)
N#define CSL_MCASP_PDOUT_AXR1_SHIFT       (0x00000001u)
N#define CSL_MCASP_PDOUT_AXR1_RESETVAL    (0x00000000u)
N
N/*----AXR1 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR1_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR1_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_AXR0_MASK        (0x00000001u)
N#define CSL_MCASP_PDOUT_AXR0_SHIFT       (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR0_RESETVAL    (0x00000000u)
N
N/*----AXR0 Tokens----*/
N#define CSL_MCASP_PDOUT_AXR0_DRIVE_LOW   (0x00000000u)
N#define CSL_MCASP_PDOUT_AXR0_DRIVE_HIGH  (0x00000001u)
N
N#define CSL_MCASP_PDOUT_RESETVAL         (0x00000000u)
N
N/* PDIN_PDSET */
N
N#define CSL_MCASP_PDIN_PDSET_AFSR_MASK   (0x80000000u)
N#define CSL_MCASP_PDIN_PDSET_AFSR_SHIFT  (0x0000001Fu)
N#define CSL_MCASP_PDIN_PDSET_AFSR_RESETVAL (0x00000000u)
N
N/*----AFSR Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AFSR_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AFSR_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AHCLKR_MASK (0x40000000u)
N#define CSL_MCASP_PDIN_PDSET_AHCLKR_SHIFT (0x0000001Eu)
N#define CSL_MCASP_PDIN_PDSET_AHCLKR_RESETVAL (0x00000000u)
N
N/*----AHCLKR Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AHCLKR_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AHCLKR_SET  (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_ACLKR_MASK  (0x20000000u)
N#define CSL_MCASP_PDIN_PDSET_ACLKR_SHIFT (0x0000001Du)
N#define CSL_MCASP_PDIN_PDSET_ACLKR_RESETVAL (0x00000000u)
N
N/*----ACLKR Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_ACLKR_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_ACLKR_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AFSX_MASK   (0x10000000u)
N#define CSL_MCASP_PDIN_PDSET_AFSX_SHIFT  (0x0000001Cu)
N#define CSL_MCASP_PDIN_PDSET_AFSX_RESETVAL (0x00000000u)
N
N/*----AFSX Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AFSX_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AFSX_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AHCLKX_MASK (0x08000000u)
N#define CSL_MCASP_PDIN_PDSET_AHCLKX_SHIFT (0x0000001Bu)
N#define CSL_MCASP_PDIN_PDSET_AHCLKX_RESETVAL (0x00000000u)
N
N/*----AHCLKX Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AHCLKX_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AHCLKX_SET  (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_ACLKX_MASK  (0x04000000u)
N#define CSL_MCASP_PDIN_PDSET_ACLKX_SHIFT (0x0000001Au)
N#define CSL_MCASP_PDIN_PDSET_ACLKX_RESETVAL (0x00000000u)
N
N/*----ACLKX Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_ACLKX_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_ACLKX_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AMUTE_MASK  (0x02000000u)
N#define CSL_MCASP_PDIN_PDSET_AMUTE_SHIFT (0x00000019u)
N#define CSL_MCASP_PDIN_PDSET_AMUTE_RESETVAL (0x00000000u)
N
N/*----AMUTE Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AMUTE_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AMUTE_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR15_MASK  (0x00008000u)
N#define CSL_MCASP_PDIN_PDSET_AXR15_SHIFT (0x0000000Fu)
N#define CSL_MCASP_PDIN_PDSET_AXR15_RESETVAL (0x00000000u)
N
N/*----AXR15 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR15_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR15_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR14_MASK  (0x00004000u)
N#define CSL_MCASP_PDIN_PDSET_AXR14_SHIFT (0x0000000Eu)
N#define CSL_MCASP_PDIN_PDSET_AXR14_RESETVAL (0x00000000u)
N
N/*----AXR14 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR14_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR14_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR13_MASK  (0x00002000u)
N#define CSL_MCASP_PDIN_PDSET_AXR13_SHIFT (0x0000000Du)
N#define CSL_MCASP_PDIN_PDSET_AXR13_RESETVAL (0x00000000u)
N
N/*----AXR13 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR13_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR13_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR12_MASK  (0x00001000u)
N#define CSL_MCASP_PDIN_PDSET_AXR12_SHIFT (0x0000000Cu)
N#define CSL_MCASP_PDIN_PDSET_AXR12_RESETVAL (0x00000000u)
N
N/*----AXR12 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR12_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR12_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR11_MASK  (0x00000800u)
N#define CSL_MCASP_PDIN_PDSET_AXR11_SHIFT (0x0000000Bu)
N#define CSL_MCASP_PDIN_PDSET_AXR11_RESETVAL (0x00000000u)
N
N/*----AXR11 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR11_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR11_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR10_MASK  (0x00000400u)
N#define CSL_MCASP_PDIN_PDSET_AXR10_SHIFT (0x0000000Au)
N#define CSL_MCASP_PDIN_PDSET_AXR10_RESETVAL (0x00000000u)
N
N/*----AXR10 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR10_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR10_SET   (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR9_MASK   (0x00000200u)
N#define CSL_MCASP_PDIN_PDSET_AXR9_SHIFT  (0x00000009u)
N#define CSL_MCASP_PDIN_PDSET_AXR9_RESETVAL (0x00000000u)
N
N/*----AXR9 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR9_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR9_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR8_MASK   (0x00000100u)
N#define CSL_MCASP_PDIN_PDSET_AXR8_SHIFT  (0x00000008u)
N#define CSL_MCASP_PDIN_PDSET_AXR8_RESETVAL (0x00000000u)
N
N/*----AXR8 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR8_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR8_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR7_MASK   (0x00000080u)
N#define CSL_MCASP_PDIN_PDSET_AXR7_SHIFT  (0x00000007u)
N#define CSL_MCASP_PDIN_PDSET_AXR7_RESETVAL (0x00000000u)
N
N/*----AXR7 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR7_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR7_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR6_MASK   (0x00000040u)
N#define CSL_MCASP_PDIN_PDSET_AXR6_SHIFT  (0x00000006u)
N#define CSL_MCASP_PDIN_PDSET_AXR6_RESETVAL (0x00000000u)
N
N/*----AXR6 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR6_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR6_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR5_MASK   (0x00000020u)
N#define CSL_MCASP_PDIN_PDSET_AXR5_SHIFT  (0x00000005u)
N#define CSL_MCASP_PDIN_PDSET_AXR5_RESETVAL (0x00000000u)
N
N/*----AXR5 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR5_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR5_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR4_MASK   (0x00000010u)
N#define CSL_MCASP_PDIN_PDSET_AXR4_SHIFT  (0x00000004u)
N#define CSL_MCASP_PDIN_PDSET_AXR4_RESETVAL (0x00000000u)
N
N/*----AXR4 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR4_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR4_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR3_MASK   (0x00000008u)
N#define CSL_MCASP_PDIN_PDSET_AXR3_SHIFT  (0x00000003u)
N#define CSL_MCASP_PDIN_PDSET_AXR3_RESETVAL (0x00000000u)
N
N/*----AXR3 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR3_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR3_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR2_MASK   (0x00000004u)
N#define CSL_MCASP_PDIN_PDSET_AXR2_SHIFT  (0x00000002u)
N#define CSL_MCASP_PDIN_PDSET_AXR2_RESETVAL (0x00000000u)
N
N/*----AXR2 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR2_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR2_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR1_MASK   (0x00000002u)
N#define CSL_MCASP_PDIN_PDSET_AXR1_SHIFT  (0x00000001u)
N#define CSL_MCASP_PDIN_PDSET_AXR1_RESETVAL (0x00000000u)
N
N/*----AXR1 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR1_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR1_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_AXR0_MASK   (0x00000001u)
N#define CSL_MCASP_PDIN_PDSET_AXR0_SHIFT  (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR0_RESETVAL (0x00000000u)
N
N/*----AXR0 Tokens----*/
N#define CSL_MCASP_PDIN_PDSET_AXR0_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDIN_PDSET_AXR0_SET    (0x00000001u)
N
N#define CSL_MCASP_PDIN_PDSET_RESETVAL    (0x00000000u)
N
N/* PDCLR */
N
N#define CSL_MCASP_PDCLR_AFSR_MASK        (0x80000000u)
N#define CSL_MCASP_PDCLR_AFSR_SHIFT       (0x0000001Fu)
N#define CSL_MCASP_PDCLR_AFSR_RESETVAL    (0x00000000u)
N
N/*----AFSR Tokens----*/
N#define CSL_MCASP_PDCLR_AFSR_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AFSR_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AHCLKR_MASK      (0x40000000u)
N#define CSL_MCASP_PDCLR_AHCLKR_SHIFT     (0x0000001Eu)
N#define CSL_MCASP_PDCLR_AHCLKR_RESETVAL  (0x00000000u)
N
N/*----AHCLKR Tokens----*/
N#define CSL_MCASP_PDCLR_AHCLKR_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDCLR_AHCLKR_CLR       (0x00000001u)
N
N#define CSL_MCASP_PDCLR_ACLKR_MASK       (0x20000000u)
N#define CSL_MCASP_PDCLR_ACLKR_SHIFT      (0x0000001Du)
N#define CSL_MCASP_PDCLR_ACLKR_RESETVAL   (0x00000000u)
N
N/*----ACLKR Tokens----*/
N#define CSL_MCASP_PDCLR_ACLKR_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_ACLKR_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AFSX_MASK        (0x10000000u)
N#define CSL_MCASP_PDCLR_AFSX_SHIFT       (0x0000001Cu)
N#define CSL_MCASP_PDCLR_AFSX_RESETVAL    (0x00000000u)
N
N/*----AFSX Tokens----*/
N#define CSL_MCASP_PDCLR_AFSX_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AFSX_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AHCLKX_MASK      (0x08000000u)
N#define CSL_MCASP_PDCLR_AHCLKX_SHIFT     (0x0000001Bu)
N#define CSL_MCASP_PDCLR_AHCLKX_RESETVAL  (0x00000000u)
N
N/*----AHCLKX Tokens----*/
N#define CSL_MCASP_PDCLR_AHCLKX_NO_EFFECT (0x00000000u)
N#define CSL_MCASP_PDCLR_AHCLKX_CLR       (0x00000001u)
N
N#define CSL_MCASP_PDCLR_ACLKX_MASK       (0x04000000u)
N#define CSL_MCASP_PDCLR_ACLKX_SHIFT      (0x0000001Au)
N#define CSL_MCASP_PDCLR_ACLKX_RESETVAL   (0x00000000u)
N
N/*----ACLKX Tokens----*/
N#define CSL_MCASP_PDCLR_ACLKX_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_ACLKX_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AMUTE_MASK       (0x02000000u)
N#define CSL_MCASP_PDCLR_AMUTE_SHIFT      (0x00000019u)
N#define CSL_MCASP_PDCLR_AMUTE_RESETVAL   (0x00000000u)
N
N/*----AMUTE Tokens----*/
N#define CSL_MCASP_PDCLR_AMUTE_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AMUTE_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR15_MASK       (0x00008000u)
N#define CSL_MCASP_PDCLR_AXR15_SHIFT      (0x0000000Fu)
N#define CSL_MCASP_PDCLR_AXR15_RESETVAL   (0x00000000u)
N
N/*----AXR15 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR15_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR15_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR14_MASK       (0x00004000u)
N#define CSL_MCASP_PDCLR_AXR14_SHIFT      (0x0000000Eu)
N#define CSL_MCASP_PDCLR_AXR14_RESETVAL   (0x00000000u)
N
N/*----AXR14 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR14_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR14_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR13_MASK       (0x00002000u)
N#define CSL_MCASP_PDCLR_AXR13_SHIFT      (0x0000000Du)
N#define CSL_MCASP_PDCLR_AXR13_RESETVAL   (0x00000000u)
N
N/*----AXR13 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR13_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR13_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR12_MASK       (0x00001000u)
N#define CSL_MCASP_PDCLR_AXR12_SHIFT      (0x0000000Cu)
N#define CSL_MCASP_PDCLR_AXR12_RESETVAL   (0x00000000u)
N
N/*----AXR12 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR12_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR12_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR11_MASK       (0x00000800u)
N#define CSL_MCASP_PDCLR_AXR11_SHIFT      (0x0000000Bu)
N#define CSL_MCASP_PDCLR_AXR11_RESETVAL   (0x00000000u)
N
N/*----AXR11 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR11_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR11_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR10_MASK       (0x00000400u)
N#define CSL_MCASP_PDCLR_AXR10_SHIFT      (0x0000000Au)
N#define CSL_MCASP_PDCLR_AXR10_RESETVAL   (0x00000000u)
N
N/*----AXR10 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR10_NO_EFFECT  (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR10_CLR        (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR9_MASK        (0x00000200u)
N#define CSL_MCASP_PDCLR_AXR9_SHIFT       (0x00000009u)
N#define CSL_MCASP_PDCLR_AXR9_RESETVAL    (0x00000000u)
N
N/*----AXR9 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR9_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR9_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR8_MASK        (0x00000100u)
N#define CSL_MCASP_PDCLR_AXR8_SHIFT       (0x00000008u)
N#define CSL_MCASP_PDCLR_AXR8_RESETVAL    (0x00000000u)
N
N/*----AXR8 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR8_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR8_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR7_MASK        (0x00000080u)
N#define CSL_MCASP_PDCLR_AXR7_SHIFT       (0x00000007u)
N#define CSL_MCASP_PDCLR_AXR7_RESETVAL    (0x00000000u)
N
N/*----AXR7 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR7_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR7_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR6_MASK        (0x00000040u)
N#define CSL_MCASP_PDCLR_AXR6_SHIFT       (0x00000006u)
N#define CSL_MCASP_PDCLR_AXR6_RESETVAL    (0x00000000u)
N
N/*----AXR6 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR6_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR6_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR5_MASK        (0x00000020u)
N#define CSL_MCASP_PDCLR_AXR5_SHIFT       (0x00000005u)
N#define CSL_MCASP_PDCLR_AXR5_RESETVAL    (0x00000000u)
N
N/*----AXR5 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR5_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR5_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR4_MASK        (0x00000010u)
N#define CSL_MCASP_PDCLR_AXR4_SHIFT       (0x00000004u)
N#define CSL_MCASP_PDCLR_AXR4_RESETVAL    (0x00000000u)
N
N/*----AXR4 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR4_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR4_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR3_MASK        (0x00000008u)
N#define CSL_MCASP_PDCLR_AXR3_SHIFT       (0x00000003u)
N#define CSL_MCASP_PDCLR_AXR3_RESETVAL    (0x00000000u)
N
N/*----AXR3 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR3_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR3_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR2_MASK        (0x00000004u)
N#define CSL_MCASP_PDCLR_AXR2_SHIFT       (0x00000002u)
N#define CSL_MCASP_PDCLR_AXR2_RESETVAL    (0x00000000u)
N
N/*----AXR2 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR2_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR2_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR1_MASK        (0x00000002u)
N#define CSL_MCASP_PDCLR_AXR1_SHIFT       (0x00000001u)
N#define CSL_MCASP_PDCLR_AXR1_RESETVAL    (0x00000000u)
N
N/*----AXR1 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR1_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR1_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_AXR0_MASK        (0x00000001u)
N#define CSL_MCASP_PDCLR_AXR0_SHIFT       (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR0_RESETVAL    (0x00000000u)
N
N/*----AXR0 Tokens----*/
N#define CSL_MCASP_PDCLR_AXR0_NO_EFFECT   (0x00000000u)
N#define CSL_MCASP_PDCLR_AXR0_CLR         (0x00000001u)
N
N#define CSL_MCASP_PDCLR_RESETVAL         (0x00000000u)
N
N/* GBLCTL */
N
N#define CSL_MCASP_GBLCTL_XFRST_MASK      (0x00001000u)
N#define CSL_MCASP_GBLCTL_XFRST_SHIFT     (0x0000000Cu)
N#define CSL_MCASP_GBLCTL_XFRST_RESETVAL  (0x00000000u)
N
N/*----XFRST Tokens----*/
N#define CSL_MCASP_GBLCTL_XFRST_RESET     (0x00000000u)
N#define CSL_MCASP_GBLCTL_XFRST_ACTIVE    (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_XSMRST_MASK     (0x00000800u)
N#define CSL_MCASP_GBLCTL_XSMRST_SHIFT    (0x0000000Bu)
N#define CSL_MCASP_GBLCTL_XSMRST_RESETVAL (0x00000000u)
N
N/*----XSMRST Tokens----*/
N#define CSL_MCASP_GBLCTL_XSMRST_RESET    (0x00000000u)
N#define CSL_MCASP_GBLCTL_XSMRST_ACTIVE   (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_XSRCLR_MASK     (0x00000400u)
N#define CSL_MCASP_GBLCTL_XSRCLR_SHIFT    (0x0000000Au)
N#define CSL_MCASP_GBLCTL_XSRCLR_RESETVAL (0x00000000u)
N
N/*----XSRCLR Tokens----*/
N#define CSL_MCASP_GBLCTL_XSRCLR_CLEAR    (0x00000000u)
N#define CSL_MCASP_GBLCTL_XSRCLR_ACTIVE   (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_XHCLKRST_MASK   (0x00000200u)
N#define CSL_MCASP_GBLCTL_XHCLKRST_SHIFT  (0x00000009u)
N#define CSL_MCASP_GBLCTL_XHCLKRST_RESETVAL (0x00000000u)
N
N/*----XHCLKRST Tokens----*/
N#define CSL_MCASP_GBLCTL_XHCLKRST_RESET  (0x00000000u)
N#define CSL_MCASP_GBLCTL_XHCLKRST_ACTIVE (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_XCLKRST_MASK    (0x00000100u)
N#define CSL_MCASP_GBLCTL_XCLKRST_SHIFT   (0x00000008u)
N#define CSL_MCASP_GBLCTL_XCLKRST_RESETVAL (0x00000000u)
N
N/*----XCLKRST Tokens----*/
N#define CSL_MCASP_GBLCTL_XCLKRST_RESET   (0x00000000u)
N#define CSL_MCASP_GBLCTL_XCLKRST_ACTIVE  (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_RFRST_MASK      (0x00000010u)
N#define CSL_MCASP_GBLCTL_RFRST_SHIFT     (0x00000004u)
N#define CSL_MCASP_GBLCTL_RFRST_RESETVAL  (0x00000000u)
N
N/*----RFRST Tokens----*/
N#define CSL_MCASP_GBLCTL_RFRST_RESET     (0x00000000u)
N#define CSL_MCASP_GBLCTL_RFRST_ACTIVE    (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_RSMRST_MASK     (0x00000008u)
N#define CSL_MCASP_GBLCTL_RSMRST_SHIFT    (0x00000003u)
N#define CSL_MCASP_GBLCTL_RSMRST_RESETVAL (0x00000000u)
N
N/*----RSMRST Tokens----*/
N#define CSL_MCASP_GBLCTL_RSMRST_RESET    (0x00000000u)
N#define CSL_MCASP_GBLCTL_RSMRST_ACTIVE   (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_RSRCLR_MASK     (0x00000004u)
N#define CSL_MCASP_GBLCTL_RSRCLR_SHIFT    (0x00000002u)
N#define CSL_MCASP_GBLCTL_RSRCLR_RESETVAL (0x00000000u)
N
N/*----RSRCLR Tokens----*/
N#define CSL_MCASP_GBLCTL_RSRCLR_CLEAR    (0x00000000u)
N#define CSL_MCASP_GBLCTL_RSRCLR_ACTIVE   (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_RHCLKRST_MASK   (0x00000002u)
N#define CSL_MCASP_GBLCTL_RHCLKRST_SHIFT  (0x00000001u)
N#define CSL_MCASP_GBLCTL_RHCLKRST_RESETVAL (0x00000000u)
N
N/*----RHCLKRST Tokens----*/
N#define CSL_MCASP_GBLCTL_RHCLKRST_RESET  (0x00000000u)
N#define CSL_MCASP_GBLCTL_RHCLKRST_ACTIVE (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_RCLKRST_MASK    (0x00000001u)
N#define CSL_MCASP_GBLCTL_RCLKRST_SHIFT   (0x00000000u)
N#define CSL_MCASP_GBLCTL_RCLKRST_RESETVAL (0x00000000u)
N
N/*----RCLKRST Tokens----*/
N#define CSL_MCASP_GBLCTL_RCLKRST_RESET   (0x00000000u)
N#define CSL_MCASP_GBLCTL_RCLKRST_ACTIVE  (0x00000001u)
N
N#define CSL_MCASP_GBLCTL_RESETVAL        (0x00000000u)
N
N/* AMUTE */
N
N#define CSL_MCASP_AMUTE_XDMAERR_MASK     (0x00001000u)
N#define CSL_MCASP_AMUTE_XDMAERR_SHIFT    (0x0000000Cu)
N#define CSL_MCASP_AMUTE_XDMAERR_RESETVAL (0x00000000u)
N
N/*----XDMAERR Tokens----*/
N#define CSL_MCASP_AMUTE_XDMAERR_DISABLE  (0x00000000u)
N#define CSL_MCASP_AMUTE_XDMAERR_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_AMUTE_RDMAERR_MASK     (0x00000800u)
N#define CSL_MCASP_AMUTE_RDMAERR_SHIFT    (0x0000000Bu)
N#define CSL_MCASP_AMUTE_RDMAERR_RESETVAL (0x00000000u)
N
N/*----RDMAERR Tokens----*/
N#define CSL_MCASP_AMUTE_RDMAERR_DISABLE  (0x00000000u)
N#define CSL_MCASP_AMUTE_RDMAERR_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_AMUTE_XCKFAIL_MASK     (0x00000400u)
N#define CSL_MCASP_AMUTE_XCKFAIL_SHIFT    (0x0000000Au)
N#define CSL_MCASP_AMUTE_XCKFAIL_RESETVAL (0x00000000u)
N
N/*----XCKFAIL Tokens----*/
N#define CSL_MCASP_AMUTE_XCKFAIL_DISABLE  (0x00000000u)
N#define CSL_MCASP_AMUTE_XCKFAIL_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_AMUTE_RCKFAIL_MASK     (0x00000200u)
N#define CSL_MCASP_AMUTE_RCKFAIL_SHIFT    (0x00000009u)
N#define CSL_MCASP_AMUTE_RCKFAIL_RESETVAL (0x00000000u)
N
N/*----RCKFAIL Tokens----*/
N#define CSL_MCASP_AMUTE_RCKFAIL_DISABLE  (0x00000000u)
N#define CSL_MCASP_AMUTE_RCKFAIL_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_AMUTE_XSYNCERR_MASK    (0x00000100u)
N#define CSL_MCASP_AMUTE_XSYNCERR_SHIFT   (0x00000008u)
N#define CSL_MCASP_AMUTE_XSYNCERR_RESETVAL (0x00000000u)
N
N/*----XSYNCERR Tokens----*/
N#define CSL_MCASP_AMUTE_XSYNCERR_DISABLE (0x00000000u)
N#define CSL_MCASP_AMUTE_XSYNCERR_ENABLE  (0x00000001u)
N
N#define CSL_MCASP_AMUTE_RSYNCERR_MASK    (0x00000080u)
N#define CSL_MCASP_AMUTE_RSYNCERR_SHIFT   (0x00000007u)
N#define CSL_MCASP_AMUTE_RSYNCERR_RESETVAL (0x00000000u)
N
N/*----RSYNCERR Tokens----*/
N#define CSL_MCASP_AMUTE_RSYNCERR_DISABLE (0x00000000u)
N#define CSL_MCASP_AMUTE_RSYNCERR_ENABLE  (0x00000001u)
N
N#define CSL_MCASP_AMUTE_XUNDRN_MASK      (0x00000040u)
N#define CSL_MCASP_AMUTE_XUNDRN_SHIFT     (0x00000006u)
N#define CSL_MCASP_AMUTE_XUNDRN_RESETVAL  (0x00000000u)
N
N/*----XUNDRN Tokens----*/
N#define CSL_MCASP_AMUTE_XUNDRN_DISABLE   (0x00000000u)
N#define CSL_MCASP_AMUTE_XUNDRN_ENABLE    (0x00000001u)
N
N#define CSL_MCASP_AMUTE_ROVRN_MASK       (0x00000020u)
N#define CSL_MCASP_AMUTE_ROVRN_SHIFT      (0x00000005u)
N#define CSL_MCASP_AMUTE_ROVRN_RESETVAL   (0x00000000u)
N
N/*----ROVRN Tokens----*/
N#define CSL_MCASP_AMUTE_ROVRN_DISABLE    (0x00000000u)
N#define CSL_MCASP_AMUTE_ROVRN_ENABLE     (0x00000001u)
N
N#define CSL_MCASP_AMUTE_INSTAT_MASK      (0x00000010u)
N#define CSL_MCASP_AMUTE_INSTAT_SHIFT     (0x00000004u)
N#define CSL_MCASP_AMUTE_INSTAT_RESETVAL  (0x00000000u)
N
N/*----INSTAT Tokens----*/
N#define CSL_MCASP_AMUTE_INSTAT_INACTIVE  (0x00000000u)
N#define CSL_MCASP_AMUTE_INSTAT_ACTIVE    (0x00000001u)
N
N#define CSL_MCASP_AMUTE_INEN_MASK        (0x00000008u)
N#define CSL_MCASP_AMUTE_INEN_SHIFT       (0x00000003u)
N#define CSL_MCASP_AMUTE_INEN_RESETVAL    (0x00000000u)
N
N/*----INEN Tokens----*/
N#define CSL_MCASP_AMUTE_INEN_DISABLE     (0x00000000u)
N#define CSL_MCASP_AMUTE_INEN_ENABLE      (0x00000001u)
N
N#define CSL_MCASP_AMUTE_INPOL_MASK       (0x00000004u)
N#define CSL_MCASP_AMUTE_INPOL_SHIFT      (0x00000002u)
N#define CSL_MCASP_AMUTE_INPOL_RESETVAL   (0x00000000u)
N
N/*----INPOL Tokens----*/
N#define CSL_MCASP_AMUTE_INPOL_ACTHIGH    (0x00000000u)
N#define CSL_MCASP_AMUTE_INPOL_ACTLOW     (0x00000001u)
N
N#define CSL_MCASP_AMUTE_MUTEN_MASK       (0x00000003u)
N#define CSL_MCASP_AMUTE_MUTEN_SHIFT      (0x00000000u)
N#define CSL_MCASP_AMUTE_MUTEN_RESETVAL   (0x00000000u)
N
N/*----MUTEN Tokens----*/
N#define CSL_MCASP_AMUTE_MUTEN_DISABLE    (0x00000000u)
N#define CSL_MCASP_AMUTE_MUTEN_ERRHIGH    (0x00000001u)
N#define CSL_MCASP_AMUTE_MUTEN_ERRLOW     (0x00000002u)
N#define CSL_MCASP_AMUTE_MUTEN_RESV       (0x00000003u)
N
N#define CSL_MCASP_AMUTE_RESETVAL         (0x00000000u)
N
N/* DLBCTL */
N
N#define CSL_MCASP_DLBCTL_MODE_MASK       (0x0000000Cu)
N#define CSL_MCASP_DLBCTL_MODE_SHIFT      (0x00000002u)
N#define CSL_MCASP_DLBCTL_MODE_RESETVAL   (0x00000000u)
N
N/*----MODE Tokens----*/
N#define CSL_MCASP_DLBCTL_MODE_INDPT      (0x00000000u)
N#define CSL_MCASP_DLBCTL_MODE_XMTCLK     (0x00000001u)
N#define CSL_MCASP_DLBCTL_MODE_RMTCLK     (0x00000002u)
N#define CSL_MCASP_DLBCTL_MODE_RESV       (0x00000003u)
N
N#define CSL_MCASP_DLBCTL_ORD_MASK        (0x00000002u)
N#define CSL_MCASP_DLBCTL_ORD_SHIFT       (0x00000001u)
N#define CSL_MCASP_DLBCTL_ORD_RESETVAL    (0x00000000u)
N
N/*----ORD Tokens----*/
N#define CSL_MCASP_DLBCTL_ORD_XMTODD      (0x00000000u)
N#define CSL_MCASP_DLBCTL_ORD_XMTEVEN     (0x00000001u)
N
N#define CSL_MCASP_DLBCTL_DLBEN_MASK      (0x00000001u)
N#define CSL_MCASP_DLBCTL_DLBEN_SHIFT     (0x00000000u)
N#define CSL_MCASP_DLBCTL_DLBEN_RESETVAL  (0x00000000u)
N
N/*----DLBEN Tokens----*/
N#define CSL_MCASP_DLBCTL_DLBEN_DISABLE   (0x00000000u)
N#define CSL_MCASP_DLBCTL_DLBEN_ENABLE    (0x00000001u)
N
N#define CSL_MCASP_DLBCTL_RESETVAL        (0x00000000u)
N
N/* DITCTL */
N
N#define CSL_MCASP_DITCTL_VB_MASK         (0x00000008u)
N#define CSL_MCASP_DITCTL_VB_SHIFT        (0x00000003u)
N#define CSL_MCASP_DITCTL_VB_RESETVAL     (0x00000000u)
N
N/*----VB Tokens----*/
N#define CSL_MCASP_DITCTL_VB_ZERO         (0x00000000u)
N#define CSL_MCASP_DITCTL_VB_ONE          (0x00000001u)
N
N#define CSL_MCASP_DITCTL_VA_MASK         (0x00000004u)
N#define CSL_MCASP_DITCTL_VA_SHIFT        (0x00000002u)
N#define CSL_MCASP_DITCTL_VA_RESETVAL     (0x00000000u)
N
N/*----VA Tokens----*/
N#define CSL_MCASP_DITCTL_VA_ZERO         (0x00000000u)
N#define CSL_MCASP_DITCTL_VA_ONE          (0x00000001u)
N
N#define CSL_MCASP_DITCTL_DITEN_MASK      (0x00000001u)
N#define CSL_MCASP_DITCTL_DITEN_SHIFT     (0x00000000u)
N#define CSL_MCASP_DITCTL_DITEN_RESETVAL  (0x00000000u)
N
N/*----DITEN Tokens----*/
N#define CSL_MCASP_DITCTL_DITEN_TDM       (0x00000000u)
N#define CSL_MCASP_DITCTL_DITEN_DIT       (0x00000001u)
N
N#define CSL_MCASP_DITCTL_RESETVAL        (0x00000000u)
N
N/* RGBLCTL */
N
N#define CSL_MCASP_RGBLCTL_XFRST_MASK     (0x00001000u)
N#define CSL_MCASP_RGBLCTL_XFRST_SHIFT    (0x0000000Cu)
N#define CSL_MCASP_RGBLCTL_XFRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RGBLCTL_XSMRST_MASK    (0x00000800u)
N#define CSL_MCASP_RGBLCTL_XSMRST_SHIFT   (0x0000000Bu)
N#define CSL_MCASP_RGBLCTL_XSMRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RGBLCTL_XSRCLR_MASK    (0x00000400u)
N#define CSL_MCASP_RGBLCTL_XSRCLR_SHIFT   (0x0000000Au)
N#define CSL_MCASP_RGBLCTL_XSRCLR_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RGBLCTL_XHCLKRST_MASK  (0x00000200u)
N#define CSL_MCASP_RGBLCTL_XHCLKRST_SHIFT (0x00000009u)
N#define CSL_MCASP_RGBLCTL_XHCLKRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RGBLCTL_XCLKRST_MASK   (0x00000100u)
N#define CSL_MCASP_RGBLCTL_XCLKRST_SHIFT  (0x00000008u)
N#define CSL_MCASP_RGBLCTL_XCLKRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RGBLCTL_RFRST_MASK     (0x00000010u)
N#define CSL_MCASP_RGBLCTL_RFRST_SHIFT    (0x00000004u)
N#define CSL_MCASP_RGBLCTL_RFRST_RESETVAL (0x00000000u)
N
N/*----RFRST Tokens----*/
N#define CSL_MCASP_RGBLCTL_RFRST_RESET    (0x00000000u)
N#define CSL_MCASP_RGBLCTL_RFRST_ACTIVE   (0x00000001u)
N
N#define CSL_MCASP_RGBLCTL_RSMRST_MASK    (0x00000008u)
N#define CSL_MCASP_RGBLCTL_RSMRST_SHIFT   (0x00000003u)
N#define CSL_MCASP_RGBLCTL_RSMRST_RESETVAL (0x00000000u)
N
N/*----RSMRST Tokens----*/
N#define CSL_MCASP_RGBLCTL_RSMRST_RESET   (0x00000000u)
N#define CSL_MCASP_RGBLCTL_RSMRST_ACTIVE  (0x00000001u)
N
N#define CSL_MCASP_RGBLCTL_RSRCLR_MASK    (0x00000004u)
N#define CSL_MCASP_RGBLCTL_RSRCLR_SHIFT   (0x00000002u)
N#define CSL_MCASP_RGBLCTL_RSRCLR_RESETVAL (0x00000000u)
N
N/*----RSRCLR Tokens----*/
N#define CSL_MCASP_RGBLCTL_RSRCLR_CLEAR   (0x00000000u)
N#define CSL_MCASP_RGBLCTL_RSRCLR_ACTIVE  (0x00000001u)
N
N#define CSL_MCASP_RGBLCTL_RHCLKRST_MASK  (0x00000002u)
N#define CSL_MCASP_RGBLCTL_RHCLKRST_SHIFT (0x00000001u)
N#define CSL_MCASP_RGBLCTL_RHCLKRST_RESETVAL (0x00000000u)
N
N/*----RHCLKRST Tokens----*/
N#define CSL_MCASP_RGBLCTL_RHCLKRST_RESET (0x00000000u)
N#define CSL_MCASP_RGBLCTL_RHCLKRST_ACTIVE (0x00000001u)
N
N#define CSL_MCASP_RGBLCTL_RCLKRST_MASK   (0x00000001u)
N#define CSL_MCASP_RGBLCTL_RCLKRST_SHIFT  (0x00000000u)
N#define CSL_MCASP_RGBLCTL_RCLKRST_RESETVAL (0x00000000u)
N
N/*----RCLKRST Tokens----*/
N#define CSL_MCASP_RGBLCTL_RCLKRST_RESET  (0x00000000u)
N#define CSL_MCASP_RGBLCTL_RCLKRST_ACTIVE (0x00000001u)
N
N#define CSL_MCASP_RGBLCTL_RESETVAL       (0x00000000u)
N
N/* RMASK */
N
N#define CSL_MCASP_RMASK_RMASK_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RMASK_RMASK_SHIFT      (0x00000000u)
N#define CSL_MCASP_RMASK_RMASK_RESETVAL   (0x00000000u)
N
N/*----RMASK Tokens----*/
N#define CSL_MCASP_RMASK_RMASK_USEMASK    (0x00000000u)
N#define CSL_MCASP_RMASK_RMASK_NOMASK     (0x00000001u)
N
N#define CSL_MCASP_RMASK_RESETVAL         (0x00000000u)
N
N/* RFMT */
N
N#define CSL_MCASP_RFMT_RDATDLY_MASK      (0x00030000u)
N#define CSL_MCASP_RFMT_RDATDLY_SHIFT     (0x00000010u)
N#define CSL_MCASP_RFMT_RDATDLY_RESETVAL  (0x00000000u)
N
N/*----RDATDLY Tokens----*/
N#define CSL_MCASP_RFMT_RDATDLY_0BIT      (0x00000000u)
N#define CSL_MCASP_RFMT_RDATDLY_1BIT      (0x00000001u)
N#define CSL_MCASP_RFMT_RDATDLY_2BIT      (0x00000002u)
N#define CSL_MCASP_RFMT_RDATDLY_RESV      (0x00000003u)
N
N#define CSL_MCASP_RFMT_RRVRS_MASK        (0x00008000u)
N#define CSL_MCASP_RFMT_RRVRS_SHIFT       (0x0000000Fu)
N#define CSL_MCASP_RFMT_RRVRS_RESETVAL    (0x00000000u)
N
N/*----RRVRS Tokens----*/
N#define CSL_MCASP_RFMT_RRVRS_LSBFIRST    (0x00000000u)
N#define CSL_MCASP_RFMT_RRVRS_MSBFIRST    (0x00000001u)
N
N#define CSL_MCASP_RFMT_RPAD_MASK         (0x00006000u)
N#define CSL_MCASP_RFMT_RPAD_SHIFT        (0x0000000Du)
N#define CSL_MCASP_RFMT_RPAD_RESETVAL     (0x00000000u)
N
N/*----RPAD Tokens----*/
N#define CSL_MCASP_RFMT_RPAD_ZERO         (0x00000000u)
N#define CSL_MCASP_RFMT_RPAD_ONE          (0x00000001u)
N#define CSL_MCASP_RFMT_RPAD_RPBIT        (0x00000002u)
N#define CSL_MCASP_RFMT_RPAD_RESV         (0x00000003u)
N
N#define CSL_MCASP_RFMT_RPBIT_MASK        (0x00001F00u)
N#define CSL_MCASP_RFMT_RPBIT_SHIFT       (0x00000008u)
N#define CSL_MCASP_RFMT_RPBIT_RESETVAL    (0x00000000u)
N
N#define CSL_MCASP_RFMT_RSSZ_MASK         (0x000000F0u)
N#define CSL_MCASP_RFMT_RSSZ_SHIFT        (0x00000004u)
N#define CSL_MCASP_RFMT_RSSZ_RESETVAL     (0x00000000u)
N
N#define CSL_MCASP_RFMT_RBUSEL_MASK       (0x00000008u)
N#define CSL_MCASP_RFMT_RBUSEL_SHIFT      (0x00000003u)
N#define CSL_MCASP_RFMT_RBUSEL_RESETVAL   (0x00000000u)
N
N/*----RBUSEL Tokens----*/
N#define CSL_MCASP_RFMT_RBUSEL_VBUSP      (0x00000000u)
N#define CSL_MCASP_RFMT_RBUSEL_VBUS       (0x00000001u)
N
N#define CSL_MCASP_RFMT_RROT_MASK         (0x00000007u)
N#define CSL_MCASP_RFMT_RROT_SHIFT        (0x00000000u)
N#define CSL_MCASP_RFMT_RROT_RESETVAL     (0x00000000u)
N
N/*----RROT Tokens----*/
N#define CSL_MCASP_RFMT_RROT_NONE         (0x00000000u)
N#define CSL_MCASP_RFMT_RROT_4BITS        (0x00000001u)
N#define CSL_MCASP_RFMT_RROT_8BITS        (0x00000002u)
N#define CSL_MCASP_RFMT_RROT_12BITS       (0x00000003u)
N#define CSL_MCASP_RFMT_RROT_16BITS       (0x00000004u)
N#define CSL_MCASP_RFMT_RROT_20BITS       (0x00000005u)
N#define CSL_MCASP_RFMT_RROT_24BITS       (0x00000006u)
N#define CSL_MCASP_RFMT_RROT_28BITS       (0x00000007u)
N
N#define CSL_MCASP_RFMT_RESETVAL          (0x00000000u)
N
N/* AFSRCTL */
N
N#define CSL_MCASP_AFSRCTL_RMOD_MASK      (0x0000FF80u)
N#define CSL_MCASP_AFSRCTL_RMOD_SHIFT     (0x00000007u)
N#define CSL_MCASP_AFSRCTL_RMOD_RESETVAL  (0x00000000u)
N
N/*----RMOD Tokens----*/
N#define CSL_MCASP_AFSRCTL_RMOD_BURST     (0x00000000u)
N
N#define CSL_MCASP_AFSRCTL_FRWID_MASK     (0x00000010u)
N#define CSL_MCASP_AFSRCTL_FRWID_SHIFT    (0x00000004u)
N#define CSL_MCASP_AFSRCTL_FRWID_RESETVAL (0x00000000u)
N
N/*----FRWID Tokens----*/
N#define CSL_MCASP_AFSRCTL_FRWID_BIT      (0x00000000u)
N#define CSL_MCASP_AFSRCTL_FRWID_WORD     (0x00000001u)
N
N#define CSL_MCASP_AFSRCTL_FSRM_MASK      (0x00000002u)
N#define CSL_MCASP_AFSRCTL_FSRM_SHIFT     (0x00000001u)
N#define CSL_MCASP_AFSRCTL_FSRM_RESETVAL  (0x00000000u)
N
N/*----FSRM Tokens----*/
N#define CSL_MCASP_AFSRCTL_FSRM_EXTERNAL  (0x00000000u)
N#define CSL_MCASP_AFSRCTL_FSRM_INTERNAL  (0x00000001u)
N
N#define CSL_MCASP_AFSRCTL_FSRP_MASK      (0x00000001u)
N#define CSL_MCASP_AFSRCTL_FSRP_SHIFT     (0x00000000u)
N#define CSL_MCASP_AFSRCTL_FSRP_RESETVAL  (0x00000000u)
N
N/*----FSRP Tokens----*/
N#define CSL_MCASP_AFSRCTL_FSRP_ACTIVEHIGH (0x00000000u)
N#define CSL_MCASP_AFSRCTL_FSRP_ACTIVELOW (0x00000001u)
N
N#define CSL_MCASP_AFSRCTL_RESETVAL       (0x00000000u)
N
N/* ACLKRCTL */
N
N#define CSL_MCASP_ACLKRCTL_CLKRP_MASK    (0x00000080u)
N#define CSL_MCASP_ACLKRCTL_CLKRP_SHIFT   (0x00000007u)
N#define CSL_MCASP_ACLKRCTL_CLKRP_RESETVAL (0x00000000u)
N
N/*----CLKRP Tokens----*/
N#define CSL_MCASP_ACLKRCTL_CLKRP_FALLING (0x00000000u)
N#define CSL_MCASP_ACLKRCTL_CLKRP_RISING  (0x00000001u)
N
N#define CSL_MCASP_ACLKRCTL_CLKRM_MASK    (0x00000020u)
N#define CSL_MCASP_ACLKRCTL_CLKRM_SHIFT   (0x00000005u)
N#define CSL_MCASP_ACLKRCTL_CLKRM_RESETVAL (0x00000001u)
N
N/*----CLKRM Tokens----*/
N#define CSL_MCASP_ACLKRCTL_CLKRM_EXTERNAL (0x00000000u)
N#define CSL_MCASP_ACLKRCTL_CLKRM_INTERNAL (0x00000001u)
N
N#define CSL_MCASP_ACLKRCTL_CLKRDIV_MASK  (0x0000001Fu)
N#define CSL_MCASP_ACLKRCTL_CLKRDIV_SHIFT (0x00000000u)
N#define CSL_MCASP_ACLKRCTL_CLKRDIV_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_ACLKRCTL_RESETVAL      (0x00000020u)
N
N/* AHCLKRCTL */
N
N#define CSL_MCASP_AHCLKRCTL_HCLKRM_MASK  (0x00008000u)
N#define CSL_MCASP_AHCLKRCTL_HCLKRM_SHIFT (0x0000000Fu)
N#define CSL_MCASP_AHCLKRCTL_HCLKRM_RESETVAL (0x00000001u)
N
N/*----HCLKRM Tokens----*/
N#define CSL_MCASP_AHCLKRCTL_HCLKRM_EXTERNAL (0x00000000u)
N#define CSL_MCASP_AHCLKRCTL_HCLKRM_INTERNAL (0x00000001u)
N
N#define CSL_MCASP_AHCLKRCTL_HCLKRP_MASK  (0x00004000u)
N#define CSL_MCASP_AHCLKRCTL_HCLKRP_SHIFT (0x0000000Eu)
N#define CSL_MCASP_AHCLKRCTL_HCLKRP_RESETVAL (0x00000000u)
N
N/*----HCLKRP Tokens----*/
N#define CSL_MCASP_AHCLKRCTL_HCLKRP_RISING (0x00000000u)
N#define CSL_MCASP_AHCLKRCTL_HCLKRP_FALLING (0x00000001u)
N
N#define CSL_MCASP_AHCLKRCTL_HCLKRDIV_MASK (0x00000FFFu)
N#define CSL_MCASP_AHCLKRCTL_HCLKRDIV_SHIFT (0x00000000u)
N#define CSL_MCASP_AHCLKRCTL_HCLKRDIV_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_AHCLKRCTL_RESETVAL     (0x00008000u)
N
N/* RTDM */
N
N#define CSL_MCASP_RTDM_RTDMS_MASK        (0xFFFFFFFFu)
N#define CSL_MCASP_RTDM_RTDMS_SHIFT       (0x00000000u)
N#define CSL_MCASP_RTDM_RTDMS_RESETVAL    (0x00000000u)
N
N/*----RTDMS Tokens----*/
N#define CSL_MCASP_RTDM_RTDMS_INACTIVE    (0x00000000u)
N#define CSL_MCASP_RTDM_RTDMS_ACTIVE      (0x00000001u)
N
N#define CSL_MCASP_RTDM_RESETVAL          (0x00000000u)
N
N/* RINTCTL */
N
N#define CSL_MCASP_RINTCTL_RSTAFRM_MASK   (0x00000080u)
N#define CSL_MCASP_RINTCTL_RSTAFRM_SHIFT  (0x00000007u)
N#define CSL_MCASP_RINTCTL_RSTAFRM_RESETVAL (0x00000000u)
N
N/*----RSTAFRM Tokens----*/
N#define CSL_MCASP_RINTCTL_RSTAFRM_DISABLE (0x00000000u)
N#define CSL_MCASP_RINTCTL_RSTAFRM_ENABLE (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_RDATA_MASK     (0x00000020u)
N#define CSL_MCASP_RINTCTL_RDATA_SHIFT    (0x00000005u)
N#define CSL_MCASP_RINTCTL_RDATA_RESETVAL (0x00000000u)
N
N/*----RDATA Tokens----*/
N#define CSL_MCASP_RINTCTL_RDATA_DISABLE  (0x00000000u)
N#define CSL_MCASP_RINTCTL_RDATA_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_RLAST_MASK     (0x00000010u)
N#define CSL_MCASP_RINTCTL_RLAST_SHIFT    (0x00000004u)
N#define CSL_MCASP_RINTCTL_RLAST_RESETVAL (0x00000000u)
N
N/*----RLAST Tokens----*/
N#define CSL_MCASP_RINTCTL_RLAST_DISABLE  (0x00000000u)
N#define CSL_MCASP_RINTCTL_RLAST_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_RDMAERR_MASK   (0x00000008u)
N#define CSL_MCASP_RINTCTL_RDMAERR_SHIFT  (0x00000003u)
N#define CSL_MCASP_RINTCTL_RDMAERR_RESETVAL (0x00000000u)
N
N/*----RDMAERR Tokens----*/
N#define CSL_MCASP_RINTCTL_RDMAERR_DISABLE (0x00000000u)
N#define CSL_MCASP_RINTCTL_RDMAERR_ENABLE (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_RCKFAIL_MASK   (0x00000004u)
N#define CSL_MCASP_RINTCTL_RCKFAIL_SHIFT  (0x00000002u)
N#define CSL_MCASP_RINTCTL_RCKFAIL_RESETVAL (0x00000000u)
N
N/*----RCKFAIL Tokens----*/
N#define CSL_MCASP_RINTCTL_RCKFAIL_DISABLE (0x00000000u)
N#define CSL_MCASP_RINTCTL_RCKFAIL_ENABLE (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_RSYNCERR_MASK  (0x00000002u)
N#define CSL_MCASP_RINTCTL_RSYNCERR_SHIFT (0x00000001u)
N#define CSL_MCASP_RINTCTL_RSYNCERR_RESETVAL (0x00000000u)
N
N/*----RSYNCERR Tokens----*/
N#define CSL_MCASP_RINTCTL_RSYNCERR_DISABLE (0x00000000u)
N#define CSL_MCASP_RINTCTL_RSYNCERR_ENABLE (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_ROVRN_MASK     (0x00000001u)
N#define CSL_MCASP_RINTCTL_ROVRN_SHIFT    (0x00000000u)
N#define CSL_MCASP_RINTCTL_ROVRN_RESETVAL (0x00000000u)
N
N/*----ROVRN Tokens----*/
N#define CSL_MCASP_RINTCTL_ROVRN_DISABLE  (0x00000000u)
N#define CSL_MCASP_RINTCTL_ROVRN_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_RINTCTL_RESETVAL       (0x00000000u)
N
N/* RSTAT */
N
N#define CSL_MCASP_RSTAT_RERR_MASK        (0x00000100u)
N#define CSL_MCASP_RSTAT_RERR_SHIFT       (0x00000008u)
N#define CSL_MCASP_RSTAT_RERR_RESETVAL    (0x00000000u)
N
N/*----RERR Tokens----*/
N#define CSL_MCASP_RSTAT_RERR_NO_ERROR    (0x00000000u)
N#define CSL_MCASP_RSTAT_RERR_ERROR       (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RDMAERR_MASK     (0x00000080u)
N#define CSL_MCASP_RSTAT_RDMAERR_SHIFT    (0x00000007u)
N#define CSL_MCASP_RSTAT_RDMAERR_RESETVAL (0x00000000u)
N
N/*----RDMAERR Tokens----*/
N#define CSL_MCASP_RSTAT_RDMAERR_NO_ERROR (0x00000000u)
N#define CSL_MCASP_RSTAT_RDMAERR_ERROR    (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RSTAFRM_MASK     (0x00000040u)
N#define CSL_MCASP_RSTAT_RSTAFRM_SHIFT    (0x00000006u)
N#define CSL_MCASP_RSTAT_RSTAFRM_RESETVAL (0x00000000u)
N
N/*----RSTAFRM Tokens----*/
N#define CSL_MCASP_RSTAT_RSTAFRM_NO       (0x00000000u)
N#define CSL_MCASP_RSTAT_RSTAFRM_YES      (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RDATA_MASK       (0x00000020u)
N#define CSL_MCASP_RSTAT_RDATA_SHIFT      (0x00000005u)
N#define CSL_MCASP_RSTAT_RDATA_RESETVAL   (0x00000000u)
N
N/*----RDATA Tokens----*/
N#define CSL_MCASP_RSTAT_RDATA_NO         (0x00000000u)
N#define CSL_MCASP_RSTAT_RDATA_YES        (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RLAST_MASK       (0x00000010u)
N#define CSL_MCASP_RSTAT_RLAST_SHIFT      (0x00000004u)
N#define CSL_MCASP_RSTAT_RLAST_RESETVAL   (0x00000000u)
N
N/*----RLAST Tokens----*/
N#define CSL_MCASP_RSTAT_RLAST_NO         (0x00000000u)
N#define CSL_MCASP_RSTAT_RLAST_YES        (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RTDMSLOT_MASK    (0x00000008u)
N#define CSL_MCASP_RSTAT_RTDMSLOT_SHIFT   (0x00000003u)
N#define CSL_MCASP_RSTAT_RTDMSLOT_RESETVAL (0x00000000u)
N
N/*----RTDMSLOT Tokens----*/
N#define CSL_MCASP_RSTAT_RTDMSLOT_ODD     (0x00000000u)
N#define CSL_MCASP_RSTAT_RTDMSLOT_EVEN    (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RCKFAIL_MASK     (0x00000004u)
N#define CSL_MCASP_RSTAT_RCKFAIL_SHIFT    (0x00000002u)
N#define CSL_MCASP_RSTAT_RCKFAIL_RESETVAL (0x00000000u)
N
N/*----RCKFAIL Tokens----*/
N#define CSL_MCASP_RSTAT_RCKFAIL_NO       (0x00000000u)
N#define CSL_MCASP_RSTAT_RCKFAIL_YES      (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RSYNCERR_MASK    (0x00000002u)
N#define CSL_MCASP_RSTAT_RSYNCERR_SHIFT   (0x00000001u)
N#define CSL_MCASP_RSTAT_RSYNCERR_RESETVAL (0x00000000u)
N
N/*----RSYNCERR Tokens----*/
N#define CSL_MCASP_RSTAT_RSYNCERR_NO      (0x00000000u)
N#define CSL_MCASP_RSTAT_RSYNCERR_YES     (0x00000001u)
N
N#define CSL_MCASP_RSTAT_ROVRN_MASK       (0x00000001u)
N#define CSL_MCASP_RSTAT_ROVRN_SHIFT      (0x00000000u)
N#define CSL_MCASP_RSTAT_ROVRN_RESETVAL   (0x00000000u)
N
N/*----ROVRN Tokens----*/
N#define CSL_MCASP_RSTAT_ROVRN_NO         (0x00000000u)
N#define CSL_MCASP_RSTAT_ROVRN_YES        (0x00000001u)
N
N#define CSL_MCASP_RSTAT_RESETVAL         (0x00000000u)
N
N/* RSLOT */
N
N#define CSL_MCASP_RSLOT_RSLOTCNT_MASK    (0x000003FFu)
N#define CSL_MCASP_RSLOT_RSLOTCNT_SHIFT   (0x00000000u)
N#define CSL_MCASP_RSLOT_RSLOTCNT_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RSLOT_RESETVAL         (0x00000000u)
N
N/* RCLKCHK */
N
N#define CSL_MCASP_RCLKCHK_RCNT_MASK      (0xFF000000u)
N#define CSL_MCASP_RCLKCHK_RCNT_SHIFT     (0x00000018u)
N#define CSL_MCASP_RCLKCHK_RCNT_RESETVAL  (0x00000000u)
N
N#define CSL_MCASP_RCLKCHK_RMAX_MASK      (0x00FF0000u)
N#define CSL_MCASP_RCLKCHK_RMAX_SHIFT     (0x00000010u)
N#define CSL_MCASP_RCLKCHK_RMAX_RESETVAL  (0x00000000u)
N
N#define CSL_MCASP_RCLKCHK_RMIN_MASK      (0x0000FF00u)
N#define CSL_MCASP_RCLKCHK_RMIN_SHIFT     (0x00000008u)
N#define CSL_MCASP_RCLKCHK_RMIN_RESETVAL  (0x00000000u)
N
N#define CSL_MCASP_RCLKCHK_RPS_MASK       (0x0000000Fu)
N#define CSL_MCASP_RCLKCHK_RPS_SHIFT      (0x00000000u)
N#define CSL_MCASP_RCLKCHK_RPS_RESETVAL   (0x00000000u)
N
N/*----RPS Tokens----*/
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY1     (0x00000000u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY2     (0x00000001u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY4     (0x00000002u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY8     (0x00000003u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY16    (0x00000004u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY32    (0x00000005u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY64    (0x00000006u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY128   (0x00000007u)
N#define CSL_MCASP_RCLKCHK_RPS_DIVBY256   (0x00000008u)
N
N#define CSL_MCASP_RCLKCHK_RESETVAL       (0x00000000u)
N
N/* REVTCTL */
N
N#define CSL_MCASP_REVTCTL_RDATDMA_MASK   (0x00000001u)
N#define CSL_MCASP_REVTCTL_RDATDMA_SHIFT  (0x00000000u)
N#define CSL_MCASP_REVTCTL_RDATDMA_RESETVAL (0x00000000u)
N
N/*----RDATDMA Tokens----*/
N#define CSL_MCASP_REVTCTL_RDATDMA_ENABLE (0x00000000u)
N#define CSL_MCASP_REVTCTL_RDATDMA_DISABLE (0x00000001u)
N
N#define CSL_MCASP_REVTCTL_RESETVAL       (0x00000000u)
N
N/* XGBLCTL */
N
N#define CSL_MCASP_XGBLCTL_XFRST_MASK     (0x00001000u)
N#define CSL_MCASP_XGBLCTL_XFRST_SHIFT    (0x0000000Cu)
N#define CSL_MCASP_XGBLCTL_XFRST_RESETVAL (0x00000000u)
N
N/*----XFRST Tokens----*/
N#define CSL_MCASP_XGBLCTL_XFRST_RESET    (0x00000000u)
N#define CSL_MCASP_XGBLCTL_XFRST_ACTIVE   (0x00000001u)
N
N#define CSL_MCASP_XGBLCTL_XSMRST_MASK    (0x00000800u)
N#define CSL_MCASP_XGBLCTL_XSMRST_SHIFT   (0x0000000Bu)
N#define CSL_MCASP_XGBLCTL_XSMRST_RESETVAL (0x00000000u)
N
N/*----XSMRST Tokens----*/
N#define CSL_MCASP_XGBLCTL_XSMRST_RESET   (0x00000000u)
N#define CSL_MCASP_XGBLCTL_XSMRST_ACTIVE  (0x00000001u)
N
N#define CSL_MCASP_XGBLCTL_XSRCLR_MASK    (0x00000400u)
N#define CSL_MCASP_XGBLCTL_XSRCLR_SHIFT   (0x0000000Au)
N#define CSL_MCASP_XGBLCTL_XSRCLR_RESETVAL (0x00000000u)
N
N/*----XSRCLR Tokens----*/
N#define CSL_MCASP_XGBLCTL_XSRCLR_CLEAR   (0x00000000u)
N#define CSL_MCASP_XGBLCTL_XSRCLR_ACTIVE  (0x00000001u)
N
N#define CSL_MCASP_XGBLCTL_XHCLKRST_MASK  (0x00000200u)
N#define CSL_MCASP_XGBLCTL_XHCLKRST_SHIFT (0x00000009u)
N#define CSL_MCASP_XGBLCTL_XHCLKRST_RESETVAL (0x00000000u)
N
N/*----XHCLKRST Tokens----*/
N#define CSL_MCASP_XGBLCTL_XHCLKRST_RESET (0x00000000u)
N#define CSL_MCASP_XGBLCTL_XHCLKRST_ACTIVE (0x00000001u)
N
N#define CSL_MCASP_XGBLCTL_XCLKRST_MASK   (0x00000100u)
N#define CSL_MCASP_XGBLCTL_XCLKRST_SHIFT  (0x00000008u)
N#define CSL_MCASP_XGBLCTL_XCLKRST_RESETVAL (0x00000000u)
N
N/*----XCLKRST Tokens----*/
N#define CSL_MCASP_XGBLCTL_XCLKRST_RESET  (0x00000000u)
N#define CSL_MCASP_XGBLCTL_XCLKRST_ACTIVE (0x00000001u)
N
N#define CSL_MCASP_XGBLCTL_RFRST_MASK     (0x00000010u)
N#define CSL_MCASP_XGBLCTL_RFRST_SHIFT    (0x00000004u)
N#define CSL_MCASP_XGBLCTL_RFRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XGBLCTL_RSMRST_MASK    (0x00000008u)
N#define CSL_MCASP_XGBLCTL_RSMRST_SHIFT   (0x00000003u)
N#define CSL_MCASP_XGBLCTL_RSMRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XGBLCTL_RSRCLR_MASK    (0x00000004u)
N#define CSL_MCASP_XGBLCTL_RSRCLR_SHIFT   (0x00000002u)
N#define CSL_MCASP_XGBLCTL_RSRCLR_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XGBLCTL_RHCLKRST_MASK  (0x00000002u)
N#define CSL_MCASP_XGBLCTL_RHCLKRST_SHIFT (0x00000001u)
N#define CSL_MCASP_XGBLCTL_RHCLKRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XGBLCTL_RCLKRST_MASK   (0x00000001u)
N#define CSL_MCASP_XGBLCTL_RCLKRST_SHIFT  (0x00000000u)
N#define CSL_MCASP_XGBLCTL_RCLKRST_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XGBLCTL_RESETVAL       (0x00000000u)
N
N/* XMASK */
N
N#define CSL_MCASP_XMASK_XMASK_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XMASK_XMASK_SHIFT      (0x00000000u)
N#define CSL_MCASP_XMASK_XMASK_RESETVAL   (0x00000000u)
N
N/*----XMASK Tokens----*/
N#define CSL_MCASP_XMASK_XMASK_USEMASK    (0x00000000u)
N#define CSL_MCASP_XMASK_XMASK_NOMASK     (0x00000001u)
N
N#define CSL_MCASP_XMASK_RESETVAL         (0x00000000u)
N
N/* XFMT */
N
N#define CSL_MCASP_XFMT_XDATDLY_MASK      (0x00030000u)
N#define CSL_MCASP_XFMT_XDATDLY_SHIFT     (0x00000010u)
N#define CSL_MCASP_XFMT_XDATDLY_RESETVAL  (0x00000000u)
N
N/*----XDATDLY Tokens----*/
N#define CSL_MCASP_XFMT_XDATDLY_0BIT      (0x00000000u)
N#define CSL_MCASP_XFMT_XDATDLY_1BIT      (0x00000001u)
N#define CSL_MCASP_XFMT_XDATDLY_2BIT      (0x00000002u)
N
N#define CSL_MCASP_XFMT_XRVRS_MASK        (0x00008000u)
N#define CSL_MCASP_XFMT_XRVRS_SHIFT       (0x0000000Fu)
N#define CSL_MCASP_XFMT_XRVRS_RESETVAL    (0x00000000u)
N
N/*----XRVRS Tokens----*/
N#define CSL_MCASP_XFMT_XRVRS_LSBFIRST    (0x00000000u)
N#define CSL_MCASP_XFMT_XRVRS_MSBFIRST    (0x00000001u)
N
N#define CSL_MCASP_XFMT_XPAD_MASK         (0x00006000u)
N#define CSL_MCASP_XFMT_XPAD_SHIFT        (0x0000000Du)
N#define CSL_MCASP_XFMT_XPAD_RESETVAL     (0x00000000u)
N
N/*----XPAD Tokens----*/
N#define CSL_MCASP_XFMT_XPAD_ZERO         (0x00000000u)
N#define CSL_MCASP_XFMT_XPAD_ONE          (0x00000001u)
N#define CSL_MCASP_XFMT_XPAD_XPBIT        (0x00000002u)
N
N#define CSL_MCASP_XFMT_XPBIT_MASK        (0x00001F00u)
N#define CSL_MCASP_XFMT_XPBIT_SHIFT       (0x00000008u)
N#define CSL_MCASP_XFMT_XPBIT_RESETVAL    (0x00000000u)
N
N#define CSL_MCASP_XFMT_XSSZ_MASK         (0x000000F0u)
N#define CSL_MCASP_XFMT_XSSZ_SHIFT        (0x00000004u)
N#define CSL_MCASP_XFMT_XSSZ_RESETVAL     (0x00000000u)
N
N/*----XSSZ Tokens----*/
N#define CSL_MCASP_XFMT_XSSZ_             (0xFFFFFFFEu)
N#define CSL_MCASP_XFMT_XSSZ_8BITS        (0x00000003u)
N#define CSL_MCASP_XFMT_XSSZ_12BITS       (0x00000005u)
N#define CSL_MCASP_XFMT_XSSZ_16BITS       (0x00000007u)
N#define CSL_MCASP_XFMT_XSSZ_20BITS       (0x00000009u)
N#define CSL_MCASP_XFMT_XSSZ_24BITS       (0x0000000Bu)
N#define CSL_MCASP_XFMT_XSSZ_28BITS       (0x0000000Du)
N#define CSL_MCASP_XFMT_XSSZ_32BITS       (0x0000000Fu)
N
N#define CSL_MCASP_XFMT_XBUSEL_MASK       (0x00000008u)
N#define CSL_MCASP_XFMT_XBUSEL_SHIFT      (0x00000003u)
N#define CSL_MCASP_XFMT_XBUSEL_RESETVAL   (0x00000000u)
N
N/*----XBUSEL Tokens----*/
N#define CSL_MCASP_XFMT_XBUSEL_VBUSP      (0x00000000u)
N#define CSL_MCASP_XFMT_XBUSEL_VBUS       (0x00000001u)
N
N#define CSL_MCASP_XFMT_XROT_MASK         (0x00000007u)
N#define CSL_MCASP_XFMT_XROT_SHIFT        (0x00000000u)
N#define CSL_MCASP_XFMT_XROT_RESETVAL     (0x00000000u)
N
N/*----XROT Tokens----*/
N#define CSL_MCASP_XFMT_XROT_NONE         (0x00000000u)
N#define CSL_MCASP_XFMT_XROT_4BITS        (0x00000001u)
N#define CSL_MCASP_XFMT_XROT_8BITS        (0x00000002u)
N#define CSL_MCASP_XFMT_XROT_12BITS       (0x00000003u)
N#define CSL_MCASP_XFMT_XROT_16BITS       (0x00000004u)
N#define CSL_MCASP_XFMT_XROT_20BITS       (0x00000005u)
N#define CSL_MCASP_XFMT_XROT_24BITS       (0x00000006u)
N#define CSL_MCASP_XFMT_XROT_28BITS       (0x00000007u)
N
N#define CSL_MCASP_XFMT_RESETVAL          (0x00000000u)
N
N/* AFSXCTL */
N
N#define CSL_MCASP_AFSXCTL_XMOD_MASK      (0x0000FF80u)
N#define CSL_MCASP_AFSXCTL_XMOD_SHIFT     (0x00000007u)
N#define CSL_MCASP_AFSXCTL_XMOD_RESETVAL  (0x00000000u)
N
N/*----XMOD Tokens----*/
N#define CSL_MCASP_AFSXCTL_XMOD_BURST     (0x00000000u)
N
N#define CSL_MCASP_AFSXCTL_FXWID_MASK     (0x00000010u)
N#define CSL_MCASP_AFSXCTL_FXWID_SHIFT    (0x00000004u)
N#define CSL_MCASP_AFSXCTL_FXWID_RESETVAL (0x00000000u)
N
N/*----FXWID Tokens----*/
N#define CSL_MCASP_AFSXCTL_FXWID_BIT      (0x00000000u)
N#define CSL_MCASP_AFSXCTL_FXWID_WORD     (0x00000001u)
N
N#define CSL_MCASP_AFSXCTL_FSXM_MASK      (0x00000002u)
N#define CSL_MCASP_AFSXCTL_FSXM_SHIFT     (0x00000001u)
N#define CSL_MCASP_AFSXCTL_FSXM_RESETVAL  (0x00000000u)
N
N/*----FSXM Tokens----*/
N#define CSL_MCASP_AFSXCTL_FSXM_EXTERNAL  (0x00000000u)
N#define CSL_MCASP_AFSXCTL_FSXM_INTERNAL  (0x00000001u)
N
N#define CSL_MCASP_AFSXCTL_FSXP_MASK      (0x00000001u)
N#define CSL_MCASP_AFSXCTL_FSXP_SHIFT     (0x00000000u)
N#define CSL_MCASP_AFSXCTL_FSXP_RESETVAL  (0x00000000u)
N
N/*----FSXP Tokens----*/
N#define CSL_MCASP_AFSXCTL_FSXP_ACTIVEHIGH (0x00000000u)
N#define CSL_MCASP_AFSXCTL_FSXP_ACTIVELOW (0x00000001u)
N
N#define CSL_MCASP_AFSXCTL_RESETVAL       (0x00000000u)
N
N/* ACLKXCTL */
N
N#define CSL_MCASP_ACLKXCTL_CLKXP_MASK    (0x00000080u)
N#define CSL_MCASP_ACLKXCTL_CLKXP_SHIFT   (0x00000007u)
N#define CSL_MCASP_ACLKXCTL_CLKXP_RESETVAL (0x00000000u)
N
N/*----CLKXP Tokens----*/
N#define CSL_MCASP_ACLKXCTL_CLKXP_RISING  (0x00000000u)
N#define CSL_MCASP_ACLKXCTL_CLKXP_FALLING (0x00000001u)
N
N#define CSL_MCASP_ACLKXCTL_ASYNC_MASK    (0x00000040u)
N#define CSL_MCASP_ACLKXCTL_ASYNC_SHIFT   (0x00000006u)
N#define CSL_MCASP_ACLKXCTL_ASYNC_RESETVAL (0x00000001u)
N
N/*----ASYNC Tokens----*/
N#define CSL_MCASP_ACLKXCTL_ASYNC_SYNC    (0x00000000u)
N#define CSL_MCASP_ACLKXCTL_ASYNC_ASYNC   (0x00000001u)
N
N#define CSL_MCASP_ACLKXCTL_CLKXM_MASK    (0x00000020u)
N#define CSL_MCASP_ACLKXCTL_CLKXM_SHIFT   (0x00000005u)
N#define CSL_MCASP_ACLKXCTL_CLKXM_RESETVAL (0x00000001u)
N
N/*----CLKXM Tokens----*/
N#define CSL_MCASP_ACLKXCTL_CLKXM_EXTERNAL (0x00000000u)
N#define CSL_MCASP_ACLKXCTL_CLKXM_INTERNAL (0x00000001u)
N
N#define CSL_MCASP_ACLKXCTL_CLKXDIV_MASK  (0x0000001Fu)
N#define CSL_MCASP_ACLKXCTL_CLKXDIV_SHIFT (0x00000000u)
N#define CSL_MCASP_ACLKXCTL_CLKXDIV_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_ACLKXCTL_RESETVAL      (0x00000060u)
N
N/* AHCLKXCTL */
N
N#define CSL_MCASP_AHCLKXCTL_HCLKXM_MASK  (0x00008000u)
N#define CSL_MCASP_AHCLKXCTL_HCLKXM_SHIFT (0x0000000Fu)
N#define CSL_MCASP_AHCLKXCTL_HCLKXM_RESETVAL (0x00000001u)
N
N/*----HCLKXM Tokens----*/
N#define CSL_MCASP_AHCLKXCTL_HCLKXM_EXTERNAL (0x00000000u)
N#define CSL_MCASP_AHCLKXCTL_HCLKXM_INTERNAL (0x00000001u)
N
N#define CSL_MCASP_AHCLKXCTL_HCLKXP_MASK  (0x00004000u)
N#define CSL_MCASP_AHCLKXCTL_HCLKXP_SHIFT (0x0000000Eu)
N#define CSL_MCASP_AHCLKXCTL_HCLKXP_RESETVAL (0x00000000u)
N
N/*----HCLKXP Tokens----*/
N#define CSL_MCASP_AHCLKXCTL_HCLKXP_RISING (0x00000000u)
N#define CSL_MCASP_AHCLKXCTL_HCLKXP_FALLING (0x00000001u)
N
N#define CSL_MCASP_AHCLKXCTL_HCLKXDIV_MASK (0x00000FFFu)
N#define CSL_MCASP_AHCLKXCTL_HCLKXDIV_SHIFT (0x00000000u)
N#define CSL_MCASP_AHCLKXCTL_HCLKXDIV_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_AHCLKXCTL_RESETVAL     (0x00008000u)
N
N/* XTDM */
N
N#define CSL_MCASP_XTDM_XTDMS_MASK        (0xFFFFFFFFu)
N#define CSL_MCASP_XTDM_XTDMS_SHIFT       (0x00000000u)
N#define CSL_MCASP_XTDM_XTDMS_RESETVAL    (0x00000000u)
N
N/*----XTDMS Tokens----*/
N#define CSL_MCASP_XTDM_XTDMS_INACTIVE    (0x00000000u)
N#define CSL_MCASP_XTDM_XTDMS_ACTIVE      (0x00000001u)
N
N#define CSL_MCASP_XTDM_RESETVAL          (0x00000000u)
N
N/* XINTCTL */
N
N#define CSL_MCASP_XINTCTL_XSTAFRM_MASK   (0x00000080u)
N#define CSL_MCASP_XINTCTL_XSTAFRM_SHIFT  (0x00000007u)
N#define CSL_MCASP_XINTCTL_XSTAFRM_RESETVAL (0x00000000u)
N
N/*----XSTAFRM Tokens----*/
N#define CSL_MCASP_XINTCTL_XSTAFRM_DISABLE (0x00000000u)
N#define CSL_MCASP_XINTCTL_XSTAFRM_ENABLE (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_XDATA_MASK     (0x00000020u)
N#define CSL_MCASP_XINTCTL_XDATA_SHIFT    (0x00000005u)
N#define CSL_MCASP_XINTCTL_XDATA_RESETVAL (0x00000000u)
N
N/*----XDATA Tokens----*/
N#define CSL_MCASP_XINTCTL_XDATA_DISABLE  (0x00000000u)
N#define CSL_MCASP_XINTCTL_XDATA_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_XLAST_MASK     (0x00000010u)
N#define CSL_MCASP_XINTCTL_XLAST_SHIFT    (0x00000004u)
N#define CSL_MCASP_XINTCTL_XLAST_RESETVAL (0x00000000u)
N
N/*----XLAST Tokens----*/
N#define CSL_MCASP_XINTCTL_XLAST_DISABLE  (0x00000000u)
N#define CSL_MCASP_XINTCTL_XLAST_ENABLE   (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_XDMAERR_MASK   (0x00000008u)
N#define CSL_MCASP_XINTCTL_XDMAERR_SHIFT  (0x00000003u)
N#define CSL_MCASP_XINTCTL_XDMAERR_RESETVAL (0x00000000u)
N
N/*----XDMAERR Tokens----*/
N#define CSL_MCASP_XINTCTL_XDMAERR_DISABLE (0x00000000u)
N#define CSL_MCASP_XINTCTL_XDMAERR_ENABLE (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_XCKFAIL_MASK   (0x00000004u)
N#define CSL_MCASP_XINTCTL_XCKFAIL_SHIFT  (0x00000002u)
N#define CSL_MCASP_XINTCTL_XCKFAIL_RESETVAL (0x00000000u)
N
N/*----XCKFAIL Tokens----*/
N#define CSL_MCASP_XINTCTL_XCKFAIL_DISABLE (0x00000000u)
N#define CSL_MCASP_XINTCTL_XCKFAIL_ENABLE (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_XSYNCERR_MASK  (0x00000002u)
N#define CSL_MCASP_XINTCTL_XSYNCERR_SHIFT (0x00000001u)
N#define CSL_MCASP_XINTCTL_XSYNCERR_RESETVAL (0x00000000u)
N
N/*----XSYNCERR Tokens----*/
N#define CSL_MCASP_XINTCTL_XSYNCERR_DISABLE (0x00000000u)
N#define CSL_MCASP_XINTCTL_XSYNCERR_ENABLE (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_XUNDRN_MASK    (0x00000001u)
N#define CSL_MCASP_XINTCTL_XUNDRN_SHIFT   (0x00000000u)
N#define CSL_MCASP_XINTCTL_XUNDRN_RESETVAL (0x00000000u)
N
N/*----XUNDRN Tokens----*/
N#define CSL_MCASP_XINTCTL_XUNDRN_DISABLE (0x00000000u)
N#define CSL_MCASP_XINTCTL_XUNDRN_ENABLE  (0x00000001u)
N
N#define CSL_MCASP_XINTCTL_RESETVAL       (0x00000000u)
N
N/* XSTAT */
N
N#define CSL_MCASP_XSTAT_XERR_MASK        (0x00000100u)
N#define CSL_MCASP_XSTAT_XERR_SHIFT       (0x00000008u)
N#define CSL_MCASP_XSTAT_XERR_RESETVAL    (0x00000000u)
N
N/*----XERR Tokens----*/
N#define CSL_MCASP_XSTAT_XERR_NO_ERROR    (0x00000000u)
N#define CSL_MCASP_XSTAT_XERR_ERROR       (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XDMAERR_MASK     (0x00000080u)
N#define CSL_MCASP_XSTAT_XDMAERR_SHIFT    (0x00000007u)
N#define CSL_MCASP_XSTAT_XDMAERR_RESETVAL (0x00000000u)
N
N/*----XDMAERR Tokens----*/
N#define CSL_MCASP_XSTAT_XDMAERR_NO_ERROR (0x00000000u)
N#define CSL_MCASP_XSTAT_XDMAERR_ERROR    (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XSTAFRM_MASK     (0x00000040u)
N#define CSL_MCASP_XSTAT_XSTAFRM_SHIFT    (0x00000006u)
N#define CSL_MCASP_XSTAT_XSTAFRM_RESETVAL (0x00000000u)
N
N/*----XSTAFRM Tokens----*/
N#define CSL_MCASP_XSTAT_XSTAFRM_NO       (0x00000000u)
N#define CSL_MCASP_XSTAT_XSTAFRM_YES      (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XDATA_MASK       (0x00000020u)
N#define CSL_MCASP_XSTAT_XDATA_SHIFT      (0x00000005u)
N#define CSL_MCASP_XSTAT_XDATA_RESETVAL   (0x00000000u)
N
N/*----XDATA Tokens----*/
N#define CSL_MCASP_XSTAT_XDATA_NO         (0x00000000u)
N#define CSL_MCASP_XSTAT_XDATA_YES        (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XLAST_MASK       (0x00000010u)
N#define CSL_MCASP_XSTAT_XLAST_SHIFT      (0x00000004u)
N#define CSL_MCASP_XSTAT_XLAST_RESETVAL   (0x00000000u)
N
N/*----XLAST Tokens----*/
N#define CSL_MCASP_XSTAT_XLAST_NO         (0x00000000u)
N#define CSL_MCASP_XSTAT_XLAST_YES        (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XTDMSLOT_MASK    (0x00000008u)
N#define CSL_MCASP_XSTAT_XTDMSLOT_SHIFT   (0x00000003u)
N#define CSL_MCASP_XSTAT_XTDMSLOT_RESETVAL (0x00000000u)
N
N/*----XTDMSLOT Tokens----*/
N#define CSL_MCASP_XSTAT_XTDMSLOT_ODD     (0x00000000u)
N#define CSL_MCASP_XSTAT_XTDMSLOT_EVEN    (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XCKFAIL_MASK     (0x00000004u)
N#define CSL_MCASP_XSTAT_XCKFAIL_SHIFT    (0x00000002u)
N#define CSL_MCASP_XSTAT_XCKFAIL_RESETVAL (0x00000000u)
N
N/*----XCKFAIL Tokens----*/
N#define CSL_MCASP_XSTAT_XCKFAIL_NO       (0x00000000u)
N#define CSL_MCASP_XSTAT_XCKFAIL_YES      (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XSYNCERR_MASK    (0x00000002u)
N#define CSL_MCASP_XSTAT_XSYNCERR_SHIFT   (0x00000001u)
N#define CSL_MCASP_XSTAT_XSYNCERR_RESETVAL (0x00000000u)
N
N/*----XSYNCERR Tokens----*/
N#define CSL_MCASP_XSTAT_XSYNCERR_NO      (0x00000000u)
N#define CSL_MCASP_XSTAT_XSYNCERR_YES     (0x00000001u)
N
N#define CSL_MCASP_XSTAT_XUNDRN_MASK      (0x00000001u)
N#define CSL_MCASP_XSTAT_XUNDRN_SHIFT     (0x00000000u)
N#define CSL_MCASP_XSTAT_XUNDRN_RESETVAL  (0x00000000u)
N
N/*----XUNDRN Tokens----*/
N#define CSL_MCASP_XSTAT_XUNDRN_NO        (0x00000000u)
N#define CSL_MCASP_XSTAT_XUNDRN_YES       (0x00000001u)
N
N#define CSL_MCASP_XSTAT_RESETVAL         (0x00000000u)
N
N/* XSLOT */
N
N#define CSL_MCASP_XSLOT_XSLOTCNT_MASK    (0x000003FFu)
N#define CSL_MCASP_XSLOT_XSLOTCNT_SHIFT   (0x00000000u)
N#define CSL_MCASP_XSLOT_XSLOTCNT_RESETVAL (0x0000017Fu)
N
N#define CSL_MCASP_XSLOT_RESETVAL         (0x0000017Fu)
N
N/* XCLKCHK */
N
N#define CSL_MCASP_XCLKCHK_XCNT_MASK      (0xFF000000u)
N#define CSL_MCASP_XCLKCHK_XCNT_SHIFT     (0x00000018u)
N#define CSL_MCASP_XCLKCHK_XCNT_RESETVAL  (0x00000000u)
N
N#define CSL_MCASP_XCLKCHK_XMAX_MASK      (0x00FF0000u)
N#define CSL_MCASP_XCLKCHK_XMAX_SHIFT     (0x00000010u)
N#define CSL_MCASP_XCLKCHK_XMAX_RESETVAL  (0x00000000u)
N
N#define CSL_MCASP_XCLKCHK_XMIN_MASK      (0x0000FF00u)
N#define CSL_MCASP_XCLKCHK_XMIN_SHIFT     (0x00000008u)
N#define CSL_MCASP_XCLKCHK_XMIN_RESETVAL  (0x00000000u)
N
N#define CSL_MCASP_XCLKCHK_XCKFAILSW_MASK (0x00000080u)
N#define CSL_MCASP_XCLKCHK_XCKFAILSW_SHIFT (0x00000007u)
N#define CSL_MCASP_XCLKCHK_XCKFAILSW_RESETVAL (0x00000000u)
N
N/*----XCKFAILSW Tokens----*/
N#define CSL_MCASP_XCLKCHK_XCKFAILSW_DISABLE (0x00000000u)
N#define CSL_MCASP_XCLKCHK_XCKFAILSW_ENABLE (0x00000001u)
N
N#define CSL_MCASP_XCLKCHK_XPS_MASK       (0x0000000Fu)
N#define CSL_MCASP_XCLKCHK_XPS_SHIFT      (0x00000000u)
N#define CSL_MCASP_XCLKCHK_XPS_RESETVAL   (0x00000000u)
N
N/*----XPS Tokens----*/
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY1     (0x00000000u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY2     (0x00000001u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY4     (0x00000002u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY8     (0x00000003u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY16    (0x00000004u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY32    (0x00000005u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY64    (0x00000006u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY128   (0x00000007u)
N#define CSL_MCASP_XCLKCHK_XPS_DIVBY256   (0x00000008u)
N
N#define CSL_MCASP_XCLKCHK_RESETVAL       (0x00000000u)
N
N/* XEVTCTL */
N
N#define CSL_MCASP_XEVTCTL_XDATDMA_MASK   (0x00000001u)
N#define CSL_MCASP_XEVTCTL_XDATDMA_SHIFT  (0x00000000u)
N#define CSL_MCASP_XEVTCTL_XDATDMA_RESETVAL (0x00000000u)
N
N/*----XDATDMA Tokens----*/
N#define CSL_MCASP_XEVTCTL_XDATDMA_ENABLE (0x00000000u)
N#define CSL_MCASP_XEVTCTL_XDATDMA_DISABLE (0x00000001u)
N
N#define CSL_MCASP_XEVTCTL_RESETVAL       (0x00000000u)
N
N/* DITCSRA0 */
N
N#define CSL_MCASP_DITCSRA0_DITCSRA0_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRA0_DITCSRA0_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRA0_DITCSRA0_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRA0_RESETVAL      (0x00000000u)
N
N/* DITCSRA1 */
N
N#define CSL_MCASP_DITCSRA1_DITCSRA1_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRA1_DITCSRA1_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRA1_DITCSRA1_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRA1_RESETVAL      (0x00000000u)
N
N/* DITCSRA2 */
N
N#define CSL_MCASP_DITCSRA2_DITCSRA2_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRA2_DITCSRA2_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRA2_DITCSRA2_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRA2_RESETVAL      (0x00000000u)
N
N/* DITCSRA3 */
N
N#define CSL_MCASP_DITCSRA3_DITCSRA3_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRA3_DITCSRA3_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRA3_DITCSRA3_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRA3_RESETVAL      (0x00000000u)
N
N/* DITCSRA4 */
N
N#define CSL_MCASP_DITCSRA4_DITCSRA3_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRA4_DITCSRA3_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRA4_DITCSRA3_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRA4_RESETVAL      (0x00000000u)
N
N/* DITCSRA5 */
N
N#define CSL_MCASP_DITCSRA5_DITCSRA5_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRA5_DITCSRA5_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRA5_DITCSRA5_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRA5_RESETVAL      (0x00000000u)
N
N/* DITCSRB0 */
N
N#define CSL_MCASP_DITCSRB0_DITCSRB0_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRB0_DITCSRB0_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRB0_DITCSRB0_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRB0_RESETVAL      (0x00000000u)
N
N/* DITCSRB1 */
N
N#define CSL_MCASP_DITCSRB1_DITCSRB1_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRB1_DITCSRB1_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRB1_DITCSRB1_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRB1_RESETVAL      (0x00000000u)
N
N/* DITCSRB2 */
N
N#define CSL_MCASP_DITCSRB2_DITCSRB2_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRB2_DITCSRB2_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRB2_DITCSRB2_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRB2_RESETVAL      (0x00000000u)
N
N/* DITCSRB3 */
N
N#define CSL_MCASP_DITCSRB3_DITCSRB3_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRB3_DITCSRB3_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRB3_DITCSRB3_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRB3_RESETVAL      (0x00000000u)
N
N/* DITCSRB4 */
N
N#define CSL_MCASP_DITCSRB4_DITCSRB4_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRB4_DITCSRB4_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRB4_DITCSRB4_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRB4_RESETVAL      (0x00000000u)
N
N/* DITCSRB5 */
N
N#define CSL_MCASP_DITCSRB5_DITCSRB5_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITCSRB5_DITCSRB5_SHIFT (0x00000000u)
N#define CSL_MCASP_DITCSRB5_DITCSRB5_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITCSRB5_RESETVAL      (0x00000000u)
N
N/* DITUDRA0 */
N
N#define CSL_MCASP_DITUDRA0_DITUDRA0_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRA0_DITUDRA0_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRA0_DITUDRA0_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRA0_RESETVAL      (0x00000000u)
N
N/* DITUDRA1 */
N
N#define CSL_MCASP_DITUDRA1_DITUDRA1_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRA1_DITUDRA1_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRA1_DITUDRA1_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRA1_RESETVAL      (0x00000000u)
N
N/* DITUDRA2 */
N
N#define CSL_MCASP_DITUDRA2_DITUDRA2_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRA2_DITUDRA2_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRA2_DITUDRA2_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRA2_RESETVAL      (0x00000000u)
N
N/* DITUDRA3 */
N
N#define CSL_MCASP_DITUDRA3_DITUDRA3_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRA3_DITUDRA3_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRA3_DITUDRA3_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRA3_RESETVAL      (0x00000000u)
N
N/* DITUDRA4 */
N
N#define CSL_MCASP_DITUDRA4_DITUDRA4_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRA4_DITUDRA4_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRA4_DITUDRA4_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRA4_RESETVAL      (0x00000000u)
N
N/* DITUDRA5 */
N
N#define CSL_MCASP_DITUDRA5_DITUDRA5_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRA5_DITUDRA5_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRA5_DITUDRA5_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRA5_RESETVAL      (0x00000000u)
N
N/* DITUDRB0 */
N
N#define CSL_MCASP_DITUDRB0_DITUDRB0_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRB0_DITUDRB0_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRB0_DITUDRB0_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRB0_RESETVAL      (0x00000000u)
N
N/* DITUDRB1 */
N
N#define CSL_MCASP_DITUDRB1_DITUDRB1_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRB1_DITUDRB1_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRB1_DITUDRB1_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRB1_RESETVAL      (0x00000000u)
N
N/* DITUDRB2 */
N
N#define CSL_MCASP_DITUDRB2_DITUDRB2_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRB2_DITUDRB2_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRB2_DITUDRB2_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRB2_RESETVAL      (0x00000000u)
N
N/* DITUDRB3 */
N
N#define CSL_MCASP_DITUDRB3_DITUDRB3_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRB3_DITUDRB3_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRB3_DITUDRB3_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRB3_RESETVAL      (0x00000000u)
N
N/* DITUDRB4 */
N
N#define CSL_MCASP_DITUDRB4_DITUDRB4_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRB4_DITUDRB4_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRB4_DITUDRB4_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRB4_RESETVAL      (0x00000000u)
N
N/* DITUDRB5 */
N
N#define CSL_MCASP_DITUDRB5_DITUDRB5_MASK (0xFFFFFFFFu)
N#define CSL_MCASP_DITUDRB5_DITUDRB5_SHIFT (0x00000000u)
N#define CSL_MCASP_DITUDRB5_DITUDRB5_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_DITUDRB5_RESETVAL      (0x00000000u)
N
N/* SRCTL0 */
N
N#define CSL_MCASP_SRCTL0_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL0_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL0_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL0_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL0_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL0_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL0_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL0_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL0_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL0_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL0_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL0_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL0_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL0_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL0_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL0_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL0_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL0_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL0_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL0_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL0_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL0_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL0_RESETVAL        (0x00000000u)
N
N/* SRCTL1 */
N
N#define CSL_MCASP_SRCTL1_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL1_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL1_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL1_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL1_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL1_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL1_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL1_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL1_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL1_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL1_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL1_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL1_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL1_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL1_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL1_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL1_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL1_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL1_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL1_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL1_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL1_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL1_RESETVAL        (0x00000000u)
N
N/* SRCTL2 */
N
N#define CSL_MCASP_SRCTL2_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL2_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL2_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL2_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL2_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL2_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL2_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL2_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL2_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL2_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL2_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL2_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL2_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL2_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL2_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL2_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL2_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL2_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL2_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL2_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL2_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL2_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL2_RESETVAL        (0x00000000u)
N
N/* SRCTL3 */
N
N#define CSL_MCASP_SRCTL3_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL3_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL3_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL3_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL3_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL3_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL3_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL3_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL3_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL3_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL3_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL3_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL3_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL3_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL3_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL3_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL3_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL3_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL3_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL3_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL3_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL3_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL3_RESETVAL        (0x00000000u)
N
N/* SRCTL4 */
N
N#define CSL_MCASP_SRCTL4_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL4_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL4_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL4_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL4_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL4_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL4_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL4_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL4_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL4_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL4_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL4_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL4_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL4_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL4_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL4_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL4_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL4_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL4_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL4_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL4_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL4_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL4_RESETVAL        (0x00000000u)
N
N/* SRCTL5 */
N
N#define CSL_MCASP_SRCTL5_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL5_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL5_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL5_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL5_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL5_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL5_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL5_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL5_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL5_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL5_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL5_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL5_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL5_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL5_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL5_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL5_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL5_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL5_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL5_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL5_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL5_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL5_RESETVAL        (0x00000000u)
N
N/* SRCTL6 */
N
N#define CSL_MCASP_SRCTL6_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL6_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL6_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL6_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL6_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL6_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL6_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL6_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL6_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL6_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL6_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL6_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL6_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL6_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL6_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL6_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL6_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL6_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL6_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL6_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL6_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL6_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL6_RESETVAL        (0x00000000u)
N
N/* SRCTL7 */
N
N#define CSL_MCASP_SRCTL7_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL7_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL7_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL7_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL7_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL7_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL7_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL7_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL7_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL7_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL7_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL7_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL7_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL7_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL7_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL7_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL7_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL7_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL7_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL7_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL7_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL7_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL7_RESETVAL        (0x00000000u)
N
N/* SRCTL8 */
N
N#define CSL_MCASP_SRCTL8_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL8_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL8_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL8_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL8_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL8_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL8_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL8_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL8_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL8_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL8_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL8_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL8_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL8_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL8_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL8_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL8_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL8_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL8_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL8_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL8_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL8_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL8_RESETVAL        (0x00000000u)
N
N/* SRCTL9 */
N
N#define CSL_MCASP_SRCTL9_RRDY_MASK       (0x00000020u)
N#define CSL_MCASP_SRCTL9_RRDY_SHIFT      (0x00000005u)
N#define CSL_MCASP_SRCTL9_RRDY_RESETVAL   (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL9_RRDY_EMPTY      (0x00000000u)
N#define CSL_MCASP_SRCTL9_RRDY_DATA       (0x00000001u)
N
N#define CSL_MCASP_SRCTL9_XRDY_MASK       (0x00000010u)
N#define CSL_MCASP_SRCTL9_XRDY_SHIFT      (0x00000004u)
N#define CSL_MCASP_SRCTL9_XRDY_RESETVAL   (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL9_XRDY_DATA       (0x00000000u)
N#define CSL_MCASP_SRCTL9_XRDY_EMPTY      (0x00000001u)
N
N#define CSL_MCASP_SRCTL9_DISMOD_MASK     (0x0000000Cu)
N#define CSL_MCASP_SRCTL9_DISMOD_SHIFT    (0x00000002u)
N#define CSL_MCASP_SRCTL9_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL9_DISMOD_3STATE   (0x00000000u)
N#define CSL_MCASP_SRCTL9_DISMOD_LOW      (0x00000002u)
N#define CSL_MCASP_SRCTL9_DISMOD_HIGH     (0x00000003u)
N
N#define CSL_MCASP_SRCTL9_SRMOD_MASK      (0x00000003u)
N#define CSL_MCASP_SRCTL9_SRMOD_SHIFT     (0x00000000u)
N#define CSL_MCASP_SRCTL9_SRMOD_RESETVAL  (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL9_SRMOD_INACTIVE  (0x00000000u)
N#define CSL_MCASP_SRCTL9_SRMOD_XMT       (0x00000001u)
N#define CSL_MCASP_SRCTL9_SRMOD_RCV       (0x00000002u)
N
N#define CSL_MCASP_SRCTL9_RESETVAL        (0x00000000u)
N
N/* SRCTL10 */
N
N#define CSL_MCASP_SRCTL10_RRDY_MASK      (0x00000020u)
N#define CSL_MCASP_SRCTL10_RRDY_SHIFT     (0x00000005u)
N#define CSL_MCASP_SRCTL10_RRDY_RESETVAL  (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL10_RRDY_EMPTY     (0x00000000u)
N#define CSL_MCASP_SRCTL10_RRDY_DATA      (0x00000001u)
N
N#define CSL_MCASP_SRCTL10_XRDY_MASK      (0x00000010u)
N#define CSL_MCASP_SRCTL10_XRDY_SHIFT     (0x00000004u)
N#define CSL_MCASP_SRCTL10_XRDY_RESETVAL  (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL10_XRDY_DATA      (0x00000000u)
N#define CSL_MCASP_SRCTL10_XRDY_EMPTY     (0x00000001u)
N
N#define CSL_MCASP_SRCTL10_DISMOD_MASK    (0x0000000Cu)
N#define CSL_MCASP_SRCTL10_DISMOD_SHIFT   (0x00000002u)
N#define CSL_MCASP_SRCTL10_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL10_DISMOD_3STATE  (0x00000000u)
N#define CSL_MCASP_SRCTL10_DISMOD_LOW     (0x00000002u)
N#define CSL_MCASP_SRCTL10_DISMOD_HIGH    (0x00000003u)
N
N#define CSL_MCASP_SRCTL10_SRMOD_MASK     (0x00000003u)
N#define CSL_MCASP_SRCTL10_SRMOD_SHIFT    (0x00000000u)
N#define CSL_MCASP_SRCTL10_SRMOD_RESETVAL (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL10_SRMOD_INACTIVE (0x00000000u)
N#define CSL_MCASP_SRCTL10_SRMOD_XMT      (0x00000001u)
N#define CSL_MCASP_SRCTL10_SRMOD_RCV      (0x00000002u)
N
N#define CSL_MCASP_SRCTL10_RESETVAL       (0x00000000u)
N
N/* SRCTL11 */
N
N#define CSL_MCASP_SRCTL11_RRDY_MASK      (0x00000020u)
N#define CSL_MCASP_SRCTL11_RRDY_SHIFT     (0x00000005u)
N#define CSL_MCASP_SRCTL11_RRDY_RESETVAL  (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL11_RRDY_EMPTY     (0x00000000u)
N#define CSL_MCASP_SRCTL11_RRDY_DATA      (0x00000001u)
N
N#define CSL_MCASP_SRCTL11_XRDY_MASK      (0x00000010u)
N#define CSL_MCASP_SRCTL11_XRDY_SHIFT     (0x00000004u)
N#define CSL_MCASP_SRCTL11_XRDY_RESETVAL  (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL11_XRDY_DATA      (0x00000000u)
N#define CSL_MCASP_SRCTL11_XRDY_EMPTY     (0x00000001u)
N
N#define CSL_MCASP_SRCTL11_DISMOD_MASK    (0x0000000Cu)
N#define CSL_MCASP_SRCTL11_DISMOD_SHIFT   (0x00000002u)
N#define CSL_MCASP_SRCTL11_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL11_DISMOD_3STATE  (0x00000000u)
N#define CSL_MCASP_SRCTL11_DISMOD_LOW     (0x00000002u)
N#define CSL_MCASP_SRCTL11_DISMOD_HIGH    (0x00000003u)
N
N#define CSL_MCASP_SRCTL11_SRMOD_MASK     (0x00000003u)
N#define CSL_MCASP_SRCTL11_SRMOD_SHIFT    (0x00000000u)
N#define CSL_MCASP_SRCTL11_SRMOD_RESETVAL (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL11_SRMOD_INACTIVE (0x00000000u)
N#define CSL_MCASP_SRCTL11_SRMOD_XMT      (0x00000001u)
N#define CSL_MCASP_SRCTL11_SRMOD_RCV      (0x00000002u)
N
N#define CSL_MCASP_SRCTL11_RESETVAL       (0x00000000u)
N
N/* SRCTL12 */
N
N#define CSL_MCASP_SRCTL12_RRDY_MASK      (0x00000020u)
N#define CSL_MCASP_SRCTL12_RRDY_SHIFT     (0x00000005u)
N#define CSL_MCASP_SRCTL12_RRDY_RESETVAL  (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL12_RRDY_EMPTY     (0x00000000u)
N#define CSL_MCASP_SRCTL12_RRDY_DATA      (0x00000001u)
N
N#define CSL_MCASP_SRCTL12_XRDY_MASK      (0x00000010u)
N#define CSL_MCASP_SRCTL12_XRDY_SHIFT     (0x00000004u)
N#define CSL_MCASP_SRCTL12_XRDY_RESETVAL  (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL12_XRDY_DATA      (0x00000000u)
N#define CSL_MCASP_SRCTL12_XRDY_EMPTY     (0x00000001u)
N
N#define CSL_MCASP_SRCTL12_DISMOD_MASK    (0x0000000Cu)
N#define CSL_MCASP_SRCTL12_DISMOD_SHIFT   (0x00000002u)
N#define CSL_MCASP_SRCTL12_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL12_DISMOD_3STATE  (0x00000000u)
N#define CSL_MCASP_SRCTL12_DISMOD_LOW     (0x00000002u)
N#define CSL_MCASP_SRCTL12_DISMOD_HIGH    (0x00000003u)
N
N#define CSL_MCASP_SRCTL12_SRMOD_MASK     (0x00000003u)
N#define CSL_MCASP_SRCTL12_SRMOD_SHIFT    (0x00000000u)
N#define CSL_MCASP_SRCTL12_SRMOD_RESETVAL (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL12_SRMOD_INACTIVE (0x00000000u)
N#define CSL_MCASP_SRCTL12_SRMOD_XMT      (0x00000001u)
N#define CSL_MCASP_SRCTL12_SRMOD_RCV      (0x00000002u)
N
N#define CSL_MCASP_SRCTL12_RESETVAL       (0x00000000u)
N
N/* SRCTL13 */
N
N#define CSL_MCASP_SRCTL13_RRDY_MASK      (0x00000020u)
N#define CSL_MCASP_SRCTL13_RRDY_SHIFT     (0x00000005u)
N#define CSL_MCASP_SRCTL13_RRDY_RESETVAL  (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL13_RRDY_EMPTY     (0x00000000u)
N#define CSL_MCASP_SRCTL13_RRDY_DATA      (0x00000001u)
N
N#define CSL_MCASP_SRCTL13_XRDY_MASK      (0x00000010u)
N#define CSL_MCASP_SRCTL13_XRDY_SHIFT     (0x00000004u)
N#define CSL_MCASP_SRCTL13_XRDY_RESETVAL  (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL13_XRDY_DATA      (0x00000000u)
N#define CSL_MCASP_SRCTL13_XRDY_EMPTY     (0x00000001u)
N
N#define CSL_MCASP_SRCTL13_DISMOD_MASK    (0x0000000Cu)
N#define CSL_MCASP_SRCTL13_DISMOD_SHIFT   (0x00000002u)
N#define CSL_MCASP_SRCTL13_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL13_DISMOD_3STATE  (0x00000000u)
N#define CSL_MCASP_SRCTL13_DISMOD_LOW     (0x00000002u)
N#define CSL_MCASP_SRCTL13_DISMOD_HIGH    (0x00000003u)
N
N#define CSL_MCASP_SRCTL13_SRMOD_MASK     (0x00000003u)
N#define CSL_MCASP_SRCTL13_SRMOD_SHIFT    (0x00000000u)
N#define CSL_MCASP_SRCTL13_SRMOD_RESETVAL (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL13_SRMOD_INACTIVE (0x00000000u)
N#define CSL_MCASP_SRCTL13_SRMOD_XMT      (0x00000001u)
N#define CSL_MCASP_SRCTL13_SRMOD_RCV      (0x00000002u)
N
N#define CSL_MCASP_SRCTL13_RESETVAL       (0x00000000u)
N
N/* SRCTL14 */
N
N#define CSL_MCASP_SRCTL14_RRDY_MASK      (0x00000020u)
N#define CSL_MCASP_SRCTL14_RRDY_SHIFT     (0x00000005u)
N#define CSL_MCASP_SRCTL14_RRDY_RESETVAL  (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL14_RRDY_EMPTY     (0x00000000u)
N#define CSL_MCASP_SRCTL14_RRDY_DATA      (0x00000001u)
N
N#define CSL_MCASP_SRCTL14_XRDY_MASK      (0x00000010u)
N#define CSL_MCASP_SRCTL14_XRDY_SHIFT     (0x00000004u)
N#define CSL_MCASP_SRCTL14_XRDY_RESETVAL  (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL14_XRDY_DATA      (0x00000000u)
N#define CSL_MCASP_SRCTL14_XRDY_EMPTY     (0x00000001u)
N
N#define CSL_MCASP_SRCTL14_DISMOD_MASK    (0x0000000Cu)
N#define CSL_MCASP_SRCTL14_DISMOD_SHIFT   (0x00000002u)
N#define CSL_MCASP_SRCTL14_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL14_DISMOD_3STATE  (0x00000000u)
N#define CSL_MCASP_SRCTL14_DISMOD_LOW     (0x00000002u)
N#define CSL_MCASP_SRCTL14_DISMOD_HIGH    (0x00000003u)
N
N#define CSL_MCASP_SRCTL14_SRMOD_MASK     (0x00000003u)
N#define CSL_MCASP_SRCTL14_SRMOD_SHIFT    (0x00000000u)
N#define CSL_MCASP_SRCTL14_SRMOD_RESETVAL (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL14_SRMOD_INACTIVE (0x00000000u)
N#define CSL_MCASP_SRCTL14_SRMOD_XMT      (0x00000001u)
N#define CSL_MCASP_SRCTL14_SRMOD_RCV      (0x00000002u)
N
N#define CSL_MCASP_SRCTL14_RESETVAL       (0x00000000u)
N
N/* SRCTL15 */
N
N#define CSL_MCASP_SRCTL15_RRDY_MASK      (0x00000020u)
N#define CSL_MCASP_SRCTL15_RRDY_SHIFT     (0x00000005u)
N#define CSL_MCASP_SRCTL15_RRDY_RESETVAL  (0x00000000u)
N
N/*----RRDY Tokens----*/
N#define CSL_MCASP_SRCTL15_RRDY_EMPTY     (0x00000000u)
N#define CSL_MCASP_SRCTL15_RRDY_DATA      (0x00000001u)
N
N#define CSL_MCASP_SRCTL15_XRDY_MASK      (0x00000010u)
N#define CSL_MCASP_SRCTL15_XRDY_SHIFT     (0x00000004u)
N#define CSL_MCASP_SRCTL15_XRDY_RESETVAL  (0x00000000u)
N
N/*----XRDY Tokens----*/
N#define CSL_MCASP_SRCTL15_XRDY_DATA      (0x00000000u)
N#define CSL_MCASP_SRCTL15_XRDY_EMPTY     (0x00000001u)
N
N#define CSL_MCASP_SRCTL15_DISMOD_MASK    (0x0000000Cu)
N#define CSL_MCASP_SRCTL15_DISMOD_SHIFT   (0x00000002u)
N#define CSL_MCASP_SRCTL15_DISMOD_RESETVAL (0x00000000u)
N
N/*----DISMOD Tokens----*/
N#define CSL_MCASP_SRCTL15_DISMOD_3STATE  (0x00000000u)
N#define CSL_MCASP_SRCTL15_DISMOD_LOW     (0x00000002u)
N#define CSL_MCASP_SRCTL15_DISMOD_HIGH    (0x00000003u)
N
N#define CSL_MCASP_SRCTL15_SRMOD_MASK     (0x00000003u)
N#define CSL_MCASP_SRCTL15_SRMOD_SHIFT    (0x00000000u)
N#define CSL_MCASP_SRCTL15_SRMOD_RESETVAL (0x00000000u)
N
N/*----SRMOD Tokens----*/
N#define CSL_MCASP_SRCTL15_SRMOD_INACTIVE (0x00000000u)
N#define CSL_MCASP_SRCTL15_SRMOD_XMT      (0x00000001u)
N#define CSL_MCASP_SRCTL15_SRMOD_RCV      (0x00000002u)
N
N#define CSL_MCASP_SRCTL15_RESETVAL       (0x00000000u)
N
N/* XBUF0 */
N
N#define CSL_MCASP_XBUF0_XBUF0_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF0_XBUF0_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF0_XBUF0_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF0_RESETVAL         (0x00000000u)
N
N/* XBUF1 */
N
N#define CSL_MCASP_XBUF1_XBUF1_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF1_XBUF1_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF1_XBUF1_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF1_RESETVAL         (0x00000000u)
N
N/* XBUF2 */
N
N#define CSL_MCASP_XBUF2_XBUF2_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF2_XBUF2_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF2_XBUF2_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF2_RESETVAL         (0x00000000u)
N
N/* XBUF3 */
N
N#define CSL_MCASP_XBUF3_XBUF3_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF3_XBUF3_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF3_XBUF3_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF3_RESETVAL         (0x00000000u)
N
N/* XBUF4 */
N
N#define CSL_MCASP_XBUF4_XBUF4_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF4_XBUF4_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF4_XBUF4_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF4_RESETVAL         (0x00000000u)
N
N/* XBUF5 */
N
N#define CSL_MCASP_XBUF5_XBUF5_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF5_XBUF5_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF5_XBUF5_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF5_RESETVAL         (0x00000000u)
N
N/* XBUF6 */
N
N#define CSL_MCASP_XBUF6_XBUF6_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF6_XBUF6_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF6_XBUF6_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF6_RESETVAL         (0x00000000u)
N
N/* XBUF7 */
N
N#define CSL_MCASP_XBUF7_XBUF7_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF7_XBUF7_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF7_XBUF7_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF7_RESETVAL         (0x00000000u)
N
N/* XBUF8 */
N
N#define CSL_MCASP_XBUF8_XBUF8_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF8_XBUF8_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF8_XBUF8_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF8_RESETVAL         (0x00000000u)
N
N/* XBUF9 */
N
N#define CSL_MCASP_XBUF9_XBUF9_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF9_XBUF9_SHIFT      (0x00000000u)
N#define CSL_MCASP_XBUF9_XBUF9_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_XBUF9_RESETVAL         (0x00000000u)
N
N/* XBUF10 */
N
N#define CSL_MCASP_XBUF10_XBUF10_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF10_XBUF10_SHIFT    (0x00000000u)
N#define CSL_MCASP_XBUF10_XBUF10_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XBUF10_RESETVAL        (0x00000000u)
N
N/* XBUF11 */
N
N#define CSL_MCASP_XBUF11_XBUF11_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF11_XBUF11_SHIFT    (0x00000000u)
N#define CSL_MCASP_XBUF11_XBUF11_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XBUF11_RESETVAL        (0x00000000u)
N
N/* XBUF12 */
N
N#define CSL_MCASP_XBUF12_XBUF12_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF12_XBUF12_SHIFT    (0x00000000u)
N#define CSL_MCASP_XBUF12_XBUF12_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XBUF12_RESETVAL        (0x00000000u)
N
N/* XBUF13 */
N
N#define CSL_MCASP_XBUF13_XBUF13_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF13_XBUF13_SHIFT    (0x00000000u)
N#define CSL_MCASP_XBUF13_XBUF13_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XBUF13_RESETVAL        (0x00000000u)
N
N/* XBUF14 */
N
N#define CSL_MCASP_XBUF14_XBUF14_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF14_XBUF14_SHIFT    (0x00000000u)
N#define CSL_MCASP_XBUF14_XBUF14_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XBUF14_RESETVAL        (0x00000000u)
N
N/* XBUF15 */
N
N#define CSL_MCASP_XBUF15_XBUF15_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_XBUF15_XBUF15_SHIFT    (0x00000000u)
N#define CSL_MCASP_XBUF15_XBUF15_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_XBUF15_RESETVAL        (0x00000000u)
N
N/* RBUF0 */
N
N#define CSL_MCASP_RBUF0_RBUF0_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF0_RBUF0_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF0_RBUF0_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF0_RESETVAL         (0x00000000u)
N
N/* RBUF1 */
N
N#define CSL_MCASP_RBUF1_RBUF1_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF1_RBUF1_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF1_RBUF1_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF1_RESETVAL         (0x00000000u)
N
N/* RBUF2 */
N
N#define CSL_MCASP_RBUF2_RBUF2_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF2_RBUF2_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF2_RBUF2_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF2_RESETVAL         (0x00000000u)
N
N/* RBUF3 */
N
N#define CSL_MCASP_RBUF3_RBUF3_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF3_RBUF3_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF3_RBUF3_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF3_RESETVAL         (0x00000000u)
N
N/* RBUF4 */
N
N#define CSL_MCASP_RBUF4_RBUF4_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF4_RBUF4_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF4_RBUF4_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF4_RESETVAL         (0x00000000u)
N
N/* RBUF5 */
N
N#define CSL_MCASP_RBUF5_RBUF5_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF5_RBUF5_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF5_RBUF5_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF5_RESETVAL         (0x00000000u)
N
N/* RBUF6 */
N
N#define CSL_MCASP_RBUF6_RBUF6_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF6_RBUF6_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF6_RBUF6_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF6_RESETVAL         (0x00000000u)
N
N/* RBUF7 */
N
N#define CSL_MCASP_RBUF7_RBUF7_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF7_RBUF7_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF7_RBUF7_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF7_RESETVAL         (0x00000000u)
N
N/* RBUF8 */
N
N#define CSL_MCASP_RBUF8_RBUF8_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF8_RBUF8_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF8_RBUF8_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF8_RESETVAL         (0x00000000u)
N
N/* RBUF9 */
N
N#define CSL_MCASP_RBUF9_RBUF9_MASK       (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF9_RBUF9_SHIFT      (0x00000000u)
N#define CSL_MCASP_RBUF9_RBUF9_RESETVAL   (0x00000000u)
N
N#define CSL_MCASP_RBUF9_RESETVAL         (0x00000000u)
N
N/* RBUF10 */
N
N#define CSL_MCASP_RBUF10_RBUF10_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF10_RBUF10_SHIFT    (0x00000000u)
N#define CSL_MCASP_RBUF10_RBUF10_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RBUF10_RESETVAL        (0x00000000u)
N
N/* RBUF11 */
N
N#define CSL_MCASP_RBUF11_RBUF11_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF11_RBUF11_SHIFT    (0x00000000u)
N#define CSL_MCASP_RBUF11_RBUF11_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RBUF11_RESETVAL        (0x00000000u)
N
N/* RBUF12 */
N
N#define CSL_MCASP_RBUF12_RBUF12_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF12_RBUF12_SHIFT    (0x00000000u)
N#define CSL_MCASP_RBUF12_RBUF12_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RBUF12_RESETVAL        (0x00000000u)
N
N/* RBUF13 */
N
N#define CSL_MCASP_RBUF13_RBUF13_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF13_RBUF13_SHIFT    (0x00000000u)
N#define CSL_MCASP_RBUF13_RBUF13_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RBUF13_RESETVAL        (0x00000000u)
N
N/* RBUF14 */
N
N#define CSL_MCASP_RBUF14_RBUF14_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF14_RBUF14_SHIFT    (0x00000000u)
N#define CSL_MCASP_RBUF14_RBUF14_RESETVAL (0x00000000u)
N
N#define CSL_MCASP_RBUF14_RESETVAL        (0x00000000u)
N
N/* RBUF15 */
N
N#define CSL_MCASP_RBUF15_RBUF15_MASK     (0xFFFFFFFFu)
N#define CSL_MCASP_RBUF15_RBUF15_SHIFT    (0x00000000u)
N#define CSL_MCASP_RBUF15_RBUF15_RESETVAL (0x00000000u)
N
N#define CSL_McASP_RBUF15_RESETVAL        (0x00000000u)
N
N#endif
L 41 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_uhpi.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_uhpi.h" 1
N#ifndef _CSLR_HPI_H_
N#define _CSLR_HPI_H_
N/*********************************************************************
N * Copyright (C) 2003-2004 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_hpi.h
N * 
N * \brief This file contains the Register Desciptions for HPI
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 PID;
N    volatile Uint32 PWREMU_MGMT;
N    volatile Uint32 GPINT_CTRL;
N    volatile Uint32 GPIO_EN;
N    volatile Uint32 GPIO_DIR1;
N    volatile Uint32 GPIO_DAT1;
N    volatile Uint32 GPIO_DIR2;
N    volatile Uint32 GPIO_DAT2;
N    volatile Uint32 GPIO_DIR3;
N    volatile Uint32 GPIO_DAT3;
N    volatile Uint32 RSVD0[2];
N    volatile Uint32 HPIC;
N    volatile Uint32 HPIAW;
N    volatile Uint32 HPIAR;
N} CSL_HpiRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* PID */
N
N#define CSL_HPI_PID_TYPE_MASK            (0x00FF0000u)
N#define CSL_HPI_PID_TYPE_SHIFT           (0x00000010u)
N#define CSL_HPI_PID_TYPE_RESETVAL        (0x00000001u)
N
N#define CSL_HPI_PID_CLASS_MASK           (0x0000FF00u)
N#define CSL_HPI_PID_CLASS_SHIFT          (0x00000008u)
N#define CSL_HPI_PID_CLASS_RESETVAL       (0x00000002u)
N
N#define CSL_HPI_PID_REV_MASK             (0x000000FFu)
N#define CSL_HPI_PID_REV_SHIFT            (0x00000000u)
N#define CSL_HPI_PID_REV_RESETVAL         (0x00000002u)
N
N#define CSL_HPI_PID_RESETVAL             (0x00010202u)
N
N/* PWREMU_MGMT */
N
N#define CSL_HPI_PWREMU_MGMT_SOFT_MASK    (0x00000002u)
N#define CSL_HPI_PWREMU_MGMT_SOFT_SHIFT   (0x00000001u)
N#define CSL_HPI_PWREMU_MGMT_SOFT_RESETVAL (0x00000000u)
N
N/*----SOFT Tokens----*/
N#define CSL_HPI_PWREMU_MGMT_SOFT_OFF     (0x00000000u)
N#define CSL_HPI_PWREMU_MGMT_SOFT_ON      (0x00000001u)
N
N#define CSL_HPI_PWREMU_MGMT_FREE_MASK    (0x00000001u)
N#define CSL_HPI_PWREMU_MGMT_FREE_SHIFT   (0x00000000u)
N#define CSL_HPI_PWREMU_MGMT_FREE_RESETVAL (0x00000000u)
N
N/*----FREE Tokens----*/
N#define CSL_HPI_PWREMU_MGMT_FREE_OFF     (0x00000000u)
N#define CSL_HPI_PWREMU_MGMT_FREE_ON      (0x00000001u)
N
N#define CSL_HPI_PWREMU_MGMT_RESETVAL     (0x00000000u)
N
N/* GPINT_CTRL */
N
N#define CSL_HPI_GPINT_CTRL_GPINT_INV2_MASK (0x00040000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV2_SHIFT (0x00000012u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV2_RESETVAL (0x00000000u)
N
N/*----GPINT_INV2 Tokens----*/
N#define CSL_HPI_GPINT_CTRL_GPINT_INV2_DISABLE (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV2_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPINT_CTRL_GPINT_INV1_MASK (0x00020000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV1_SHIFT (0x00000011u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV1_RESETVAL (0x00000000u)
N
N/*----GPINT_INV1 Tokens----*/
N#define CSL_HPI_GPINT_CTRL_GPINT_INV1_DISABLE (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV1_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPINT_CTRL_GPINT_INV0_MASK (0x00010000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV0_SHIFT (0x00000010u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV0_RESETVAL (0x00000000u)
N
N/*----GPINT_INV0 Tokens----*/
N#define CSL_HPI_GPINT_CTRL_GPINT_INV0_DISABLE (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_INV0_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPINT_CTRL_GPINT_EN2_MASK (0x00000004u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN2_SHIFT (0x00000002u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN2_RESETVAL (0x00000000u)
N
N/*----GPINT_EN2 Tokens----*/
N#define CSL_HPI_GPINT_CTRL_GPINT_EN2_DISABLE (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN2_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPINT_CTRL_GPINT_EN1_MASK (0x00000002u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN1_SHIFT (0x00000001u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN1_RESETVAL (0x00000000u)
N
N/*----GPINT_EN1 Tokens----*/
N#define CSL_HPI_GPINT_CTRL_GPINT_EN1_DISABLE (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN1_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPINT_CTRL_GPINT_EN0_MASK (0x00000001u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN0_SHIFT (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN0_RESETVAL (0x00000000u)
N
N/*----GPINT_EN0 Tokens----*/
N#define CSL_HPI_GPINT_CTRL_GPINT_EN0_DISABLE (0x00000000u)
N#define CSL_HPI_GPINT_CTRL_GPINT_EN0_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPINT_CTRL_RESETVAL      (0x00000000u)
N
N/* GPIO_EN */
N
N#define CSL_HPI_GPIO_EN_GPIO_EN16_MASK   (0x00010000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN16_SHIFT  (0x00000010u)
N#define CSL_HPI_GPIO_EN_GPIO_EN16_RESETVAL (0x00000000u)
N
N/*----GPIO_EN16 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN16_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN16_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN15_MASK   (0x00008000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN15_SHIFT  (0x0000000Fu)
N#define CSL_HPI_GPIO_EN_GPIO_EN15_RESETVAL (0x00000000u)
N
N/*----GPIO_EN15 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN15_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN15_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN14_MASK   (0x00004000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN14_SHIFT  (0x0000000Eu)
N#define CSL_HPI_GPIO_EN_GPIO_EN14_RESETVAL (0x00000000u)
N
N/*----GPIO_EN14 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN14_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN14_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN13_MASK   (0x00002000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN13_SHIFT  (0x0000000Du)
N#define CSL_HPI_GPIO_EN_GPIO_EN13_RESETVAL (0x00000000u)
N
N/*----GPIO_EN13 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN13_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN13_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN12_MASK   (0x00001000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN12_SHIFT  (0x0000000Cu)
N#define CSL_HPI_GPIO_EN_GPIO_EN12_RESETVAL (0x00000000u)
N
N/*----GPIO_EN12 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN12_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN12_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN11_MASK   (0x00000800u)
N#define CSL_HPI_GPIO_EN_GPIO_EN11_SHIFT  (0x0000000Bu)
N#define CSL_HPI_GPIO_EN_GPIO_EN11_RESETVAL (0x00000000u)
N
N/*----GPIO_EN11 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN11_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN11_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN10_MASK   (0x00000400u)
N#define CSL_HPI_GPIO_EN_GPIO_EN10_SHIFT  (0x0000000Au)
N#define CSL_HPI_GPIO_EN_GPIO_EN10_RESETVAL (0x00000000u)
N
N/*----GPIO_EN10 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN10_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN10_ENABLE (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN9_MASK    (0x00000200u)
N#define CSL_HPI_GPIO_EN_GPIO_EN9_SHIFT   (0x00000009u)
N#define CSL_HPI_GPIO_EN_GPIO_EN9_RESETVAL (0x00000000u)
N
N/*----GPIO_EN9 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN9_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN9_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN8_MASK    (0x00000100u)
N#define CSL_HPI_GPIO_EN_GPIO_EN8_SHIFT   (0x00000008u)
N#define CSL_HPI_GPIO_EN_GPIO_EN8_RESETVAL (0x00000000u)
N
N/*----GPIO_EN8 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN8_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN8_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN7_MASK    (0x00000080u)
N#define CSL_HPI_GPIO_EN_GPIO_EN7_SHIFT   (0x00000007u)
N#define CSL_HPI_GPIO_EN_GPIO_EN7_RESETVAL (0x00000000u)
N
N/*----GPIO_EN7 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN7_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN7_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN6_MASK    (0x00000040u)
N#define CSL_HPI_GPIO_EN_GPIO_EN6_SHIFT   (0x00000006u)
N#define CSL_HPI_GPIO_EN_GPIO_EN6_RESETVAL (0x00000000u)
N
N/*----GPIO_EN6 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN6_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN6_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN5_MASK    (0x00000020u)
N#define CSL_HPI_GPIO_EN_GPIO_EN5_SHIFT   (0x00000005u)
N#define CSL_HPI_GPIO_EN_GPIO_EN5_RESETVAL (0x00000000u)
N
N/*----GPIO_EN5 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN5_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN5_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN4_MASK    (0x00000010u)
N#define CSL_HPI_GPIO_EN_GPIO_EN4_SHIFT   (0x00000004u)
N#define CSL_HPI_GPIO_EN_GPIO_EN4_RESETVAL (0x00000000u)
N
N/*----GPIO_EN4 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN4_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN4_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN3_MASK    (0x00000008u)
N#define CSL_HPI_GPIO_EN_GPIO_EN3_SHIFT   (0x00000003u)
N#define CSL_HPI_GPIO_EN_GPIO_EN3_RESETVAL (0x00000000u)
N
N/*----GPIO_EN3 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN3_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN3_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN2_MASK    (0x00000004u)
N#define CSL_HPI_GPIO_EN_GPIO_EN2_SHIFT   (0x00000002u)
N#define CSL_HPI_GPIO_EN_GPIO_EN2_RESETVAL (0x00000000u)
N
N/*----GPIO_EN2 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN2_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN2_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN1_MASK    (0x00000002u)
N#define CSL_HPI_GPIO_EN_GPIO_EN1_SHIFT   (0x00000001u)
N#define CSL_HPI_GPIO_EN_GPIO_EN1_RESETVAL (0x00000000u)
N
N/*----GPIO_EN1 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN1_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN1_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_GPIO_EN0_MASK    (0x00000001u)
N#define CSL_HPI_GPIO_EN_GPIO_EN0_SHIFT   (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN0_RESETVAL (0x00000000u)
N
N/*----GPIO_EN0 Tokens----*/
N#define CSL_HPI_GPIO_EN_GPIO_EN0_DISABLE (0x00000000u)
N#define CSL_HPI_GPIO_EN_GPIO_EN0_ENABLE  (0x00000001u)
N
N#define CSL_HPI_GPIO_EN_RESETVAL         (0x00000000u)
N
N/* GPIO_DIR1 */
N
N#define CSL_HPI_GPIO_DIR1_DIR_MASK       (0xFFFFFFFFu)
N#define CSL_HPI_GPIO_DIR1_DIR_SHIFT      (0x00000000u)
N#define CSL_HPI_GPIO_DIR1_DIR_RESETVAL   (0x00000000u)
N
N/*----DIR Tokens----*/
N#define CSL_HPI_GPIO_DIR1_DIR_INPUT      (0x00000000u)
N#define CSL_HPI_GPIO_DIR1_DIR_OUTPUT     (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR1_RESETVAL       (0x00000000u)
N
N/* GPIO_DAT1 */
N
N#define CSL_HPI_GPIO_DAT1_DAT_MASK       (0xFFFFFFFFu)
N#define CSL_HPI_GPIO_DAT1_DAT_SHIFT      (0x00000000u)
N#define CSL_HPI_GPIO_DAT1_DAT_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT1_RESETVAL       (0x00000000u)
N
N/* GPIO_DIR2 */
N
N#define CSL_HPI_GPIO_DIR2_DIR14_MASK     (0x00004000u)
N#define CSL_HPI_GPIO_DIR2_DIR14_SHIFT    (0x0000000Eu)
N#define CSL_HPI_GPIO_DIR2_DIR14_RESETVAL (0x00000000u)
N
N/*----DIR14 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR14_INPUT    (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR14_OUTPUT   (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR13_MASK     (0x00002000u)
N#define CSL_HPI_GPIO_DIR2_DIR13_SHIFT    (0x0000000Du)
N#define CSL_HPI_GPIO_DIR2_DIR13_RESETVAL (0x00000000u)
N
N/*----DIR13 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR13_INPUT    (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR13_OUTPUT   (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR12_MASK     (0x00001000u)
N#define CSL_HPI_GPIO_DIR2_DIR12_SHIFT    (0x0000000Cu)
N#define CSL_HPI_GPIO_DIR2_DIR12_RESETVAL (0x00000000u)
N
N/*----DIR12 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR12_INPUT    (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR12_OUTPUT   (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR11_MASK     (0x00000800u)
N#define CSL_HPI_GPIO_DIR2_DIR11_SHIFT    (0x0000000Bu)
N#define CSL_HPI_GPIO_DIR2_DIR11_RESETVAL (0x00000000u)
N
N/*----DIR11 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR11_INPUT    (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR11_OUTPUT   (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR10_MASK     (0x00000400u)
N#define CSL_HPI_GPIO_DIR2_DIR10_SHIFT    (0x0000000Au)
N#define CSL_HPI_GPIO_DIR2_DIR10_RESETVAL (0x00000000u)
N
N/*----DIR10 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR10_INPUT    (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR10_OUTPUT   (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR9_MASK      (0x00000200u)
N#define CSL_HPI_GPIO_DIR2_DIR9_SHIFT     (0x00000009u)
N#define CSL_HPI_GPIO_DIR2_DIR9_RESETVAL  (0x00000000u)
N
N/*----DIR9 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR9_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR9_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR8_MASK      (0x00000100u)
N#define CSL_HPI_GPIO_DIR2_DIR8_SHIFT     (0x00000008u)
N#define CSL_HPI_GPIO_DIR2_DIR8_RESETVAL  (0x00000000u)
N
N/*----DIR8 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR8_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR8_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR7_MASK      (0x00000080u)
N#define CSL_HPI_GPIO_DIR2_DIR7_SHIFT     (0x00000007u)
N#define CSL_HPI_GPIO_DIR2_DIR7_RESETVAL  (0x00000000u)
N
N/*----DIR7 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR7_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR7_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR6_MASK      (0x00000040u)
N#define CSL_HPI_GPIO_DIR2_DIR6_SHIFT     (0x00000006u)
N#define CSL_HPI_GPIO_DIR2_DIR6_RESETVAL  (0x00000000u)
N
N/*----DIR6 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR6_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR6_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR5_MASK      (0x00000020u)
N#define CSL_HPI_GPIO_DIR2_DIR5_SHIFT     (0x00000005u)
N#define CSL_HPI_GPIO_DIR2_DIR5_RESETVAL  (0x00000000u)
N
N/*----DIR5 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR5_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR5_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR4_MASK      (0x00000010u)
N#define CSL_HPI_GPIO_DIR2_DIR4_SHIFT     (0x00000004u)
N#define CSL_HPI_GPIO_DIR2_DIR4_RESETVAL  (0x00000000u)
N
N/*----DIR4 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR4_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR4_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR3_MASK      (0x00000008u)
N#define CSL_HPI_GPIO_DIR2_DIR3_SHIFT     (0x00000003u)
N#define CSL_HPI_GPIO_DIR2_DIR3_RESETVAL  (0x00000000u)
N
N/*----DIR3 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR3_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR3_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR2_MASK      (0x00000004u)
N#define CSL_HPI_GPIO_DIR2_DIR2_SHIFT     (0x00000002u)
N#define CSL_HPI_GPIO_DIR2_DIR2_RESETVAL  (0x00000000u)
N
N/*----DIR2 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR2_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR2_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR1_MASK      (0x00000002u)
N#define CSL_HPI_GPIO_DIR2_DIR1_SHIFT     (0x00000001u)
N#define CSL_HPI_GPIO_DIR2_DIR1_RESETVAL  (0x00000000u)
N
N/*----DIR1 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR1_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR1_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_DIR0_MASK      (0x00000001u)
N#define CSL_HPI_GPIO_DIR2_DIR0_SHIFT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR0_RESETVAL  (0x00000000u)
N
N/*----DIR0 Tokens----*/
N#define CSL_HPI_GPIO_DIR2_DIR0_INPUT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR2_DIR0_OUTPUT    (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR2_RESETVAL       (0x00000000u)
N
N/* GPIO_DAT2 */
N
N#define CSL_HPI_GPIO_DAT2_DAT14_MASK     (0x00004000u)
N#define CSL_HPI_GPIO_DAT2_DAT14_SHIFT    (0x0000000Eu)
N#define CSL_HPI_GPIO_DAT2_DAT14_RESETVAL (0x00000000u)
N
N/*----DAT14 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT14_DISABLE  (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT14_ENABLE   (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT13_MASK     (0x00002000u)
N#define CSL_HPI_GPIO_DAT2_DAT13_SHIFT    (0x0000000Du)
N#define CSL_HPI_GPIO_DAT2_DAT13_RESETVAL (0x00000000u)
N
N/*----DAT13 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT13_DISABLE  (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT13_ENABLE   (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT12_MASK     (0x00001000u)
N#define CSL_HPI_GPIO_DAT2_DAT12_SHIFT    (0x0000000Cu)
N#define CSL_HPI_GPIO_DAT2_DAT12_RESETVAL (0x00000000u)
N
N/*----DAT12 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT12_DISABLE  (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT12_ENABLE   (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT11_MASK     (0x00000800u)
N#define CSL_HPI_GPIO_DAT2_DAT11_SHIFT    (0x0000000Bu)
N#define CSL_HPI_GPIO_DAT2_DAT11_RESETVAL (0x00000000u)
N
N/*----DAT11 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT11_DISABLE  (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT11_ENABLE   (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT10_MASK     (0x00000400u)
N#define CSL_HPI_GPIO_DAT2_DAT10_SHIFT    (0x0000000Au)
N#define CSL_HPI_GPIO_DAT2_DAT10_RESETVAL (0x00000000u)
N
N/*----DAT10 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT10_DISABLE  (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT10_ENABLE   (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT9_MASK      (0x00000200u)
N#define CSL_HPI_GPIO_DAT2_DAT9_SHIFT     (0x00000009u)
N#define CSL_HPI_GPIO_DAT2_DAT9_RESETVAL  (0x00000000u)
N
N/*----DAT9 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT9_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT9_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT8_MASK      (0x00000100u)
N#define CSL_HPI_GPIO_DAT2_DAT8_SHIFT     (0x00000008u)
N#define CSL_HPI_GPIO_DAT2_DAT8_RESETVAL  (0x00000000u)
N
N/*----DAT8 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT8_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT8_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT7_MASK      (0x00000080u)
N#define CSL_HPI_GPIO_DAT2_DAT7_SHIFT     (0x00000007u)
N#define CSL_HPI_GPIO_DAT2_DAT7_RESETVAL  (0x00000000u)
N
N/*----DAT7 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT7_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT7_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT6_MASK      (0x00000040u)
N#define CSL_HPI_GPIO_DAT2_DAT6_SHIFT     (0x00000006u)
N#define CSL_HPI_GPIO_DAT2_DAT6_RESETVAL  (0x00000000u)
N
N/*----DAT6 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT6_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT6_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT5_MASK      (0x00000020u)
N#define CSL_HPI_GPIO_DAT2_DAT5_SHIFT     (0x00000005u)
N#define CSL_HPI_GPIO_DAT2_DAT5_RESETVAL  (0x00000000u)
N
N/*----DAT5 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT5_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT5_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT4_MASK      (0x00000010u)
N#define CSL_HPI_GPIO_DAT2_DAT4_SHIFT     (0x00000004u)
N#define CSL_HPI_GPIO_DAT2_DAT4_RESETVAL  (0x00000000u)
N
N/*----DAT4 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT4_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT4_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT3_MASK      (0x00000008u)
N#define CSL_HPI_GPIO_DAT2_DAT3_SHIFT     (0x00000003u)
N#define CSL_HPI_GPIO_DAT2_DAT3_RESETVAL  (0x00000000u)
N
N/*----DAT3 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT3_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT3_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT2_MASK      (0x00000004u)
N#define CSL_HPI_GPIO_DAT2_DAT2_SHIFT     (0x00000002u)
N#define CSL_HPI_GPIO_DAT2_DAT2_RESETVAL  (0x00000000u)
N
N/*----DAT2 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT2_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT2_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT1_MASK      (0x00000002u)
N#define CSL_HPI_GPIO_DAT2_DAT1_SHIFT     (0x00000001u)
N#define CSL_HPI_GPIO_DAT2_DAT1_RESETVAL  (0x00000000u)
N
N/*----DAT1 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT1_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT1_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_DAT0_MASK      (0x00000001u)
N#define CSL_HPI_GPIO_DAT2_DAT0_SHIFT     (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT0_RESETVAL  (0x00000000u)
N
N/*----DAT0 Tokens----*/
N#define CSL_HPI_GPIO_DAT2_DAT0_DISABLE   (0x00000000u)
N#define CSL_HPI_GPIO_DAT2_DAT0_ENABLE    (0x00000001u)
N
N#define CSL_HPI_GPIO_DAT2_RESETVAL       (0x00000000u)
N
N/* GPIO_DIR3 */
N
N#define CSL_HPI_GPIO_DIR3_DIR31_MASK     (0x80000000u)
N#define CSL_HPI_GPIO_DIR3_DIR31_SHIFT    (0x0000001Fu)
N#define CSL_HPI_GPIO_DIR3_DIR31_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR30_MASK     (0x40000000u)
N#define CSL_HPI_GPIO_DIR3_DIR30_SHIFT    (0x0000001Eu)
N#define CSL_HPI_GPIO_DIR3_DIR30_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR29_MASK     (0x20000000u)
N#define CSL_HPI_GPIO_DIR3_DIR29_SHIFT    (0x0000001Du)
N#define CSL_HPI_GPIO_DIR3_DIR29_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR28_MASK     (0x10000000u)
N#define CSL_HPI_GPIO_DIR3_DIR28_SHIFT    (0x0000001Cu)
N#define CSL_HPI_GPIO_DIR3_DIR28_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR27_MASK     (0x08000000u)
N#define CSL_HPI_GPIO_DIR3_DIR27_SHIFT    (0x0000001Bu)
N#define CSL_HPI_GPIO_DIR3_DIR27_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR26_MASK     (0x04000000u)
N#define CSL_HPI_GPIO_DIR3_DIR26_SHIFT    (0x0000001Au)
N#define CSL_HPI_GPIO_DIR3_DIR26_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR25_MASK     (0x02000000u)
N#define CSL_HPI_GPIO_DIR3_DIR25_SHIFT    (0x00000019u)
N#define CSL_HPI_GPIO_DIR3_DIR25_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR24_MASK     (0x01000000u)
N#define CSL_HPI_GPIO_DIR3_DIR24_SHIFT    (0x00000018u)
N#define CSL_HPI_GPIO_DIR3_DIR24_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR23_MASK     (0x00800000u)
N#define CSL_HPI_GPIO_DIR3_DIR23_SHIFT    (0x00000017u)
N#define CSL_HPI_GPIO_DIR3_DIR23_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR22_MASK     (0x00400000u)
N#define CSL_HPI_GPIO_DIR3_DIR22_SHIFT    (0x00000016u)
N#define CSL_HPI_GPIO_DIR3_DIR22_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR21_MASK     (0x00200000u)
N#define CSL_HPI_GPIO_DIR3_DIR21_SHIFT    (0x00000015u)
N#define CSL_HPI_GPIO_DIR3_DIR21_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR20_MASK     (0x00100000u)
N#define CSL_HPI_GPIO_DIR3_DIR20_SHIFT    (0x00000014u)
N#define CSL_HPI_GPIO_DIR3_DIR20_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR19_MASK     (0x00080000u)
N#define CSL_HPI_GPIO_DIR3_DIR19_SHIFT    (0x00000013u)
N#define CSL_HPI_GPIO_DIR3_DIR19_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR18_MASK     (0x00040000u)
N#define CSL_HPI_GPIO_DIR3_DIR18_SHIFT    (0x00000012u)
N#define CSL_HPI_GPIO_DIR3_DIR18_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR17_MASK     (0x00020000u)
N#define CSL_HPI_GPIO_DIR3_DIR17_SHIFT    (0x00000011u)
N#define CSL_HPI_GPIO_DIR3_DIR17_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR16_MASK     (0x00010000u)
N#define CSL_HPI_GPIO_DIR3_DIR16_SHIFT    (0x00000010u)
N#define CSL_HPI_GPIO_DIR3_DIR16_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR15_MASK     (0x00008000u)
N#define CSL_HPI_GPIO_DIR3_DIR15_SHIFT    (0x0000000Fu)
N#define CSL_HPI_GPIO_DIR3_DIR15_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR14_MASK     (0x00004000u)
N#define CSL_HPI_GPIO_DIR3_DIR14_SHIFT    (0x0000000Eu)
N#define CSL_HPI_GPIO_DIR3_DIR14_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR13_MASK     (0x00002000u)
N#define CSL_HPI_GPIO_DIR3_DIR13_SHIFT    (0x0000000Du)
N#define CSL_HPI_GPIO_DIR3_DIR13_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR12_MASK     (0x00001000u)
N#define CSL_HPI_GPIO_DIR3_DIR12_SHIFT    (0x0000000Cu)
N#define CSL_HPI_GPIO_DIR3_DIR12_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR11_MASK     (0x00000800u)
N#define CSL_HPI_GPIO_DIR3_DIR11_SHIFT    (0x0000000Bu)
N#define CSL_HPI_GPIO_DIR3_DIR11_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR10_MASK     (0x00000400u)
N#define CSL_HPI_GPIO_DIR3_DIR10_SHIFT    (0x0000000Au)
N#define CSL_HPI_GPIO_DIR3_DIR10_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR9_MASK      (0x00000200u)
N#define CSL_HPI_GPIO_DIR3_DIR9_SHIFT     (0x00000009u)
N#define CSL_HPI_GPIO_DIR3_DIR9_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR8_MASK      (0x00000100u)
N#define CSL_HPI_GPIO_DIR3_DIR8_SHIFT     (0x00000008u)
N#define CSL_HPI_GPIO_DIR3_DIR8_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR7_MASK      (0x00000080u)
N#define CSL_HPI_GPIO_DIR3_DIR7_SHIFT     (0x00000007u)
N#define CSL_HPI_GPIO_DIR3_DIR7_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR6_MASK      (0x00000040u)
N#define CSL_HPI_GPIO_DIR3_DIR6_SHIFT     (0x00000006u)
N#define CSL_HPI_GPIO_DIR3_DIR6_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR5_MASK      (0x00000020u)
N#define CSL_HPI_GPIO_DIR3_DIR5_SHIFT     (0x00000005u)
N#define CSL_HPI_GPIO_DIR3_DIR5_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR4_MASK      (0x00000010u)
N#define CSL_HPI_GPIO_DIR3_DIR4_SHIFT     (0x00000004u)
N#define CSL_HPI_GPIO_DIR3_DIR4_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR3_MASK      (0x00000008u)
N#define CSL_HPI_GPIO_DIR3_DIR3_SHIFT     (0x00000003u)
N#define CSL_HPI_GPIO_DIR3_DIR3_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR2_MASK      (0x00000004u)
N#define CSL_HPI_GPIO_DIR3_DIR2_SHIFT     (0x00000002u)
N#define CSL_HPI_GPIO_DIR3_DIR2_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR1_MASK      (0x00000002u)
N#define CSL_HPI_GPIO_DIR3_DIR1_SHIFT     (0x00000001u)
N#define CSL_HPI_GPIO_DIR3_DIR1_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DIR3_DIR0_MASK      (0x00000001u)
N#define CSL_HPI_GPIO_DIR3_DIR0_SHIFT     (0x00000000u)
N#define CSL_HPI_GPIO_DIR3_DIR0_RESETVAL  (0x00000000u)
N
N/*----DIR Tokens----*/
N#define CSL_HPI_GPIO_DIR3_DIR_INPUT      (0x00000000u)
N#define CSL_HPI_GPIO_DIR3_DIR_OUTPUT     (0x00000001u)
N
N#define CSL_HPI_GPIO_DIR3_RESETVAL       (0x00000000u)
N
N/* GPIO_DAT3 */
N
N#define CSL_HPI_GPIO_DAT3_DAT31_MASK     (0x80000000u)
N#define CSL_HPI_GPIO_DAT3_DAT31_SHIFT    (0x0000001Fu)
N#define CSL_HPI_GPIO_DAT3_DAT31_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT30_MASK     (0x40000000u)
N#define CSL_HPI_GPIO_DAT3_DAT30_SHIFT    (0x0000001Eu)
N#define CSL_HPI_GPIO_DAT3_DAT30_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT29_MASK     (0x20000000u)
N#define CSL_HPI_GPIO_DAT3_DAT29_SHIFT    (0x0000001Du)
N#define CSL_HPI_GPIO_DAT3_DAT29_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT28_MASK     (0x10000000u)
N#define CSL_HPI_GPIO_DAT3_DAT28_SHIFT    (0x0000001Cu)
N#define CSL_HPI_GPIO_DAT3_DAT28_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT27_MASK     (0x08000000u)
N#define CSL_HPI_GPIO_DAT3_DAT27_SHIFT    (0x0000001Bu)
N#define CSL_HPI_GPIO_DAT3_DAT27_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT26_MASK     (0x04000000u)
N#define CSL_HPI_GPIO_DAT3_DAT26_SHIFT    (0x0000001Au)
N#define CSL_HPI_GPIO_DAT3_DAT26_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT25_MASK     (0x02000000u)
N#define CSL_HPI_GPIO_DAT3_DAT25_SHIFT    (0x00000019u)
N#define CSL_HPI_GPIO_DAT3_DAT25_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT24_MASK     (0x01000000u)
N#define CSL_HPI_GPIO_DAT3_DAT24_SHIFT    (0x00000018u)
N#define CSL_HPI_GPIO_DAT3_DAT24_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT23_MASK     (0x00800000u)
N#define CSL_HPI_GPIO_DAT3_DAT23_SHIFT    (0x00000017u)
N#define CSL_HPI_GPIO_DAT3_DAT23_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT22_MASK     (0x00400000u)
N#define CSL_HPI_GPIO_DAT3_DAT22_SHIFT    (0x00000016u)
N#define CSL_HPI_GPIO_DAT3_DAT22_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT21_MASK     (0x00200000u)
N#define CSL_HPI_GPIO_DAT3_DAT21_SHIFT    (0x00000015u)
N#define CSL_HPI_GPIO_DAT3_DAT21_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT20_MASK     (0x00100000u)
N#define CSL_HPI_GPIO_DAT3_DAT20_SHIFT    (0x00000014u)
N#define CSL_HPI_GPIO_DAT3_DAT20_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT19_MASK     (0x00080000u)
N#define CSL_HPI_GPIO_DAT3_DAT19_SHIFT    (0x00000013u)
N#define CSL_HPI_GPIO_DAT3_DAT19_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT18_MASK     (0x00040000u)
N#define CSL_HPI_GPIO_DAT3_DAT18_SHIFT    (0x00000012u)
N#define CSL_HPI_GPIO_DAT3_DAT18_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT17_MASK     (0x00020000u)
N#define CSL_HPI_GPIO_DAT3_DAT17_SHIFT    (0x00000011u)
N#define CSL_HPI_GPIO_DAT3_DAT17_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT16_MASK     (0x00010000u)
N#define CSL_HPI_GPIO_DAT3_DAT16_SHIFT    (0x00000010u)
N#define CSL_HPI_GPIO_DAT3_DAT16_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT15_MASK     (0x00008000u)
N#define CSL_HPI_GPIO_DAT3_DAT15_SHIFT    (0x0000000Fu)
N#define CSL_HPI_GPIO_DAT3_DAT15_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT14_MASK     (0x00004000u)
N#define CSL_HPI_GPIO_DAT3_DAT14_SHIFT    (0x0000000Eu)
N#define CSL_HPI_GPIO_DAT3_DAT14_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT13_MASK     (0x00002000u)
N#define CSL_HPI_GPIO_DAT3_DAT13_SHIFT    (0x0000000Du)
N#define CSL_HPI_GPIO_DAT3_DAT13_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT12_MASK     (0x00001000u)
N#define CSL_HPI_GPIO_DAT3_DAT12_SHIFT    (0x0000000Cu)
N#define CSL_HPI_GPIO_DAT3_DAT12_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT11_MASK     (0x00000800u)
N#define CSL_HPI_GPIO_DAT3_DAT11_SHIFT    (0x0000000Bu)
N#define CSL_HPI_GPIO_DAT3_DAT11_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT10_MASK     (0x00000400u)
N#define CSL_HPI_GPIO_DAT3_DAT10_SHIFT    (0x0000000Au)
N#define CSL_HPI_GPIO_DAT3_DAT10_RESETVAL (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT9_MASK      (0x00000200u)
N#define CSL_HPI_GPIO_DAT3_DAT9_SHIFT     (0x00000009u)
N#define CSL_HPI_GPIO_DAT3_DAT9_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT8_MASK      (0x00000100u)
N#define CSL_HPI_GPIO_DAT3_DAT8_SHIFT     (0x00000008u)
N#define CSL_HPI_GPIO_DAT3_DAT8_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT7_MASK      (0x00000080u)
N#define CSL_HPI_GPIO_DAT3_DAT7_SHIFT     (0x00000007u)
N#define CSL_HPI_GPIO_DAT3_DAT7_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT6_MASK      (0x00000040u)
N#define CSL_HPI_GPIO_DAT3_DAT6_SHIFT     (0x00000006u)
N#define CSL_HPI_GPIO_DAT3_DAT6_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT5_MASK      (0x00000020u)
N#define CSL_HPI_GPIO_DAT3_DAT5_SHIFT     (0x00000005u)
N#define CSL_HPI_GPIO_DAT3_DAT5_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT4_MASK      (0x00000010u)
N#define CSL_HPI_GPIO_DAT3_DAT4_SHIFT     (0x00000004u)
N#define CSL_HPI_GPIO_DAT3_DAT4_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT3_MASK      (0x00000008u)
N#define CSL_HPI_GPIO_DAT3_DAT3_SHIFT     (0x00000003u)
N#define CSL_HPI_GPIO_DAT3_DAT3_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT2_MASK      (0x00000004u)
N#define CSL_HPI_GPIO_DAT3_DAT2_SHIFT     (0x00000002u)
N#define CSL_HPI_GPIO_DAT3_DAT2_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT1_MASK      (0x00000002u)
N#define CSL_HPI_GPIO_DAT3_DAT1_SHIFT     (0x00000001u)
N#define CSL_HPI_GPIO_DAT3_DAT1_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_DAT0_MASK      (0x00000001u)
N#define CSL_HPI_GPIO_DAT3_DAT0_SHIFT     (0x00000000u)
N#define CSL_HPI_GPIO_DAT3_DAT0_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_GPIO_DAT3_RESETVAL       (0x00000000u)
N
N/* HPIC */
N
N#define CSL_HPI_HPIC_HPIA_RW_SEL_MASK    (0x00000800u)
N#define CSL_HPI_HPIC_HPIA_RW_SEL_SHIFT   (0x0000000Bu)
N#define CSL_HPI_HPIC_HPIA_RW_SEL_RESETVAL (0x00000000u)
N
N/*----HPIA_RW_SEL Tokens----*/
N#define CSL_HPI_HPIC_HPIA_RW_SEL_HPIA_R  (0x00000000u)
N#define CSL_HPI_HPIC_HPIA_RW_SEL_HPIA_W  (0x00000001u)
N
N#define CSL_HPI_HPIC_DUAL_HPIA_MASK      (0x00000200u)
N#define CSL_HPI_HPIC_DUAL_HPIA_SHIFT     (0x00000009u)
N#define CSL_HPI_HPIC_DUAL_HPIA_RESETVAL  (0x00000000u)
N
N/*----DUAL_HPIA Tokens----*/
N#define CSL_HPI_HPIC_DUAL_HPIA_DISABLE   (0x00000000u)
N#define CSL_HPI_HPIC_DUAL_HPIA_ENABLE    (0x00000001u)
N
N#define CSL_HPI_HPIC_HWOB_STAT_MASK      (0x00000100u)
N#define CSL_HPI_HPIC_HWOB_STAT_SHIFT     (0x00000008u)
N#define CSL_HPI_HPIC_HWOB_STAT_RESETVAL  (0x00000000u)
N
N#define CSL_HPI_HPIC_HPI_RST_MASK        (0x00000080u)
N#define CSL_HPI_HPIC_HPI_RST_SHIFT       (0x00000007u)
N#define CSL_HPI_HPIC_HPI_RST_RESETVAL    (0x00000001u)
N
N#define CSL_HPI_HPIC_XHPIA_MASK          (0x00000020u)
N#define CSL_HPI_HPIC_XHPIA_SHIFT         (0x00000005u)
N#define CSL_HPI_HPIC_XHPIA_RESETVAL      (0x00000000u)
N
N#define CSL_HPI_HPIC_FETCH_MASK          (0x00000010u)
N#define CSL_HPI_HPIC_FETCH_SHIFT         (0x00000004u)
N#define CSL_HPI_HPIC_FETCH_RESETVAL      (0x00000000u)
N
N#define CSL_HPI_HPIC_HRDY_MASK           (0x00000008u)
N#define CSL_HPI_HPIC_HRDY_SHIFT          (0x00000003u)
N#define CSL_HPI_HPIC_HRDY_RESETVAL       (0x00000000u)
N
N#define CSL_HPI_HPIC_HINT_MASK           (0x00000004u)
N#define CSL_HPI_HPIC_HINT_SHIFT          (0x00000002u)
N#define CSL_HPI_HPIC_HINT_RESETVAL       (0x00000000u)
N
N/*----HINT Tokens----*/
N#define CSL_HPI_HPIC_HINT_DISABLE        (0x00000001u)
N#define CSL_HPI_HPIC_HINT_ENABLE         (0x00000001u)
N
N#define CSL_HPI_HPIC_DSP_INT_MASK        (0x00000002u)
N#define CSL_HPI_HPIC_DSP_INT_SHIFT       (0x00000001u)
N#define CSL_HPI_HPIC_DSP_INT_RESETVAL    (0x00000000u)
N
N/*----DSP_INT Tokens----*/
N#define CSL_HPI_HPIC_DSP_INT_DISABLE     (0x00000000u)
N#define CSL_HPI_HPIC_DSP_INT_ENABLE      (0x00000001u)
N
N#define CSL_HPI_HPIC_HWOB_MASK           (0x00000001u)
N#define CSL_HPI_HPIC_HWOB_SHIFT          (0x00000000u)
N#define CSL_HPI_HPIC_HWOB_RESETVAL       (0x00000000u)
N
N/*----HWOB Tokens----*/
N#define CSL_HPI_HPIC_HWOB_DISABLE        (0x00000000u)
N#define CSL_HPI_HPIC_HWOB_ENABLE         (0x00000001u)
N
N#define CSL_HPI_HPIC_RESETVAL            (0x000000C0u)
N
N/* HPIAW */
N
N#define CSL_HPI_HPIAW_HPIAW31_MASK       (0x80000000u)
N#define CSL_HPI_HPIAW_HPIAW31_SHIFT      (0x0000001Fu)
N#define CSL_HPI_HPIAW_HPIAW31_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW30_MASK       (0x40000000u)
N#define CSL_HPI_HPIAW_HPIAW30_SHIFT      (0x0000001Eu)
N#define CSL_HPI_HPIAW_HPIAW30_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW29_MASK       (0x20000000u)
N#define CSL_HPI_HPIAW_HPIAW29_SHIFT      (0x0000001Du)
N#define CSL_HPI_HPIAW_HPIAW29_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW28_MASK       (0x10000000u)
N#define CSL_HPI_HPIAW_HPIAW28_SHIFT      (0x0000001Cu)
N#define CSL_HPI_HPIAW_HPIAW28_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW27_MASK       (0x08000000u)
N#define CSL_HPI_HPIAW_HPIAW27_SHIFT      (0x0000001Bu)
N#define CSL_HPI_HPIAW_HPIAW27_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW26_MASK       (0x04000000u)
N#define CSL_HPI_HPIAW_HPIAW26_SHIFT      (0x0000001Au)
N#define CSL_HPI_HPIAW_HPIAW26_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW25_MASK       (0x02000000u)
N#define CSL_HPI_HPIAW_HPIAW25_SHIFT      (0x00000019u)
N#define CSL_HPI_HPIAW_HPIAW25_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW24_MASK       (0x01000000u)
N#define CSL_HPI_HPIAW_HPIAW24_SHIFT      (0x00000018u)
N#define CSL_HPI_HPIAW_HPIAW24_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW23_MASK       (0x00800000u)
N#define CSL_HPI_HPIAW_HPIAW23_SHIFT      (0x00000017u)
N#define CSL_HPI_HPIAW_HPIAW23_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW22_MASK       (0x00400000u)
N#define CSL_HPI_HPIAW_HPIAW22_SHIFT      (0x00000016u)
N#define CSL_HPI_HPIAW_HPIAW22_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW21_MASK       (0x00200000u)
N#define CSL_HPI_HPIAW_HPIAW21_SHIFT      (0x00000015u)
N#define CSL_HPI_HPIAW_HPIAW21_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW20_MASK       (0x00100000u)
N#define CSL_HPI_HPIAW_HPIAW20_SHIFT      (0x00000014u)
N#define CSL_HPI_HPIAW_HPIAW20_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW19_MASK       (0x00080000u)
N#define CSL_HPI_HPIAW_HPIAW19_SHIFT      (0x00000013u)
N#define CSL_HPI_HPIAW_HPIAW19_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW18_MASK       (0x00040000u)
N#define CSL_HPI_HPIAW_HPIAW18_SHIFT      (0x00000012u)
N#define CSL_HPI_HPIAW_HPIAW18_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW17_MASK       (0x00020000u)
N#define CSL_HPI_HPIAW_HPIAW17_SHIFT      (0x00000011u)
N#define CSL_HPI_HPIAW_HPIAW17_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW16_MASK       (0x00010000u)
N#define CSL_HPI_HPIAW_HPIAW16_SHIFT      (0x00000010u)
N#define CSL_HPI_HPIAW_HPIAW16_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW15_MASK       (0x00008000u)
N#define CSL_HPI_HPIAW_HPIAW15_SHIFT      (0x0000000Fu)
N#define CSL_HPI_HPIAW_HPIAW15_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW14_MASK       (0x00004000u)
N#define CSL_HPI_HPIAW_HPIAW14_SHIFT      (0x0000000Eu)
N#define CSL_HPI_HPIAW_HPIAW14_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW13_MASK       (0x00002000u)
N#define CSL_HPI_HPIAW_HPIAW13_SHIFT      (0x0000000Du)
N#define CSL_HPI_HPIAW_HPIAW13_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW12_MASK       (0x00001000u)
N#define CSL_HPI_HPIAW_HPIAW12_SHIFT      (0x0000000Cu)
N#define CSL_HPI_HPIAW_HPIAW12_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW11_MASK       (0x00000800u)
N#define CSL_HPI_HPIAW_HPIAW11_SHIFT      (0x0000000Bu)
N#define CSL_HPI_HPIAW_HPIAW11_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW10_MASK       (0x00000400u)
N#define CSL_HPI_HPIAW_HPIAW10_SHIFT      (0x0000000Au)
N#define CSL_HPI_HPIAW_HPIAW10_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW9_MASK        (0x00000200u)
N#define CSL_HPI_HPIAW_HPIAW9_SHIFT       (0x00000009u)
N#define CSL_HPI_HPIAW_HPIAW9_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW8_MASK        (0x00000100u)
N#define CSL_HPI_HPIAW_HPIAW8_SHIFT       (0x00000008u)
N#define CSL_HPI_HPIAW_HPIAW8_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW7_MASK        (0x00000080u)
N#define CSL_HPI_HPIAW_HPIAW7_SHIFT       (0x00000007u)
N#define CSL_HPI_HPIAW_HPIAW7_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW6_MASK        (0x00000040u)
N#define CSL_HPI_HPIAW_HPIAW6_SHIFT       (0x00000006u)
N#define CSL_HPI_HPIAW_HPIAW6_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW5_MASK        (0x00000020u)
N#define CSL_HPI_HPIAW_HPIAW5_SHIFT       (0x00000005u)
N#define CSL_HPI_HPIAW_HPIAW5_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW4_MASK        (0x00000010u)
N#define CSL_HPI_HPIAW_HPIAW4_SHIFT       (0x00000004u)
N#define CSL_HPI_HPIAW_HPIAW4_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW3_MASK        (0x00000008u)
N#define CSL_HPI_HPIAW_HPIAW3_SHIFT       (0x00000003u)
N#define CSL_HPI_HPIAW_HPIAW3_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW2_MASK        (0x00000004u)
N#define CSL_HPI_HPIAW_HPIAW2_SHIFT       (0x00000002u)
N#define CSL_HPI_HPIAW_HPIAW2_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW1_MASK        (0x00000002u)
N#define CSL_HPI_HPIAW_HPIAW1_SHIFT       (0x00000001u)
N#define CSL_HPI_HPIAW_HPIAW1_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_HPIAW0_MASK        (0x00000001u)
N#define CSL_HPI_HPIAW_HPIAW0_SHIFT       (0x00000000u)
N#define CSL_HPI_HPIAW_HPIAW0_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAW_RESETVAL           (0x00000000u)
N
N/* HPIAR */
N
N#define CSL_HPI_HPIAR_HPIAR31_MASK       (0x80000000u)
N#define CSL_HPI_HPIAR_HPIAR31_SHIFT      (0x0000001Fu)
N#define CSL_HPI_HPIAR_HPIAR31_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR30_MASK       (0x40000000u)
N#define CSL_HPI_HPIAR_HPIAR30_SHIFT      (0x0000001Eu)
N#define CSL_HPI_HPIAR_HPIAR30_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR29_MASK       (0x20000000u)
N#define CSL_HPI_HPIAR_HPIAR29_SHIFT      (0x0000001Du)
N#define CSL_HPI_HPIAR_HPIAR29_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR28_MASK       (0x10000000u)
N#define CSL_HPI_HPIAR_HPIAR28_SHIFT      (0x0000001Cu)
N#define CSL_HPI_HPIAR_HPIAR28_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR27_MASK       (0x08000000u)
N#define CSL_HPI_HPIAR_HPIAR27_SHIFT      (0x0000001Bu)
N#define CSL_HPI_HPIAR_HPIAR27_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR26_MASK       (0x04000000u)
N#define CSL_HPI_HPIAR_HPIAR26_SHIFT      (0x0000001Au)
N#define CSL_HPI_HPIAR_HPIAR26_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR25_MASK       (0x02000000u)
N#define CSL_HPI_HPIAR_HPIAR25_SHIFT      (0x00000019u)
N#define CSL_HPI_HPIAR_HPIAR25_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR24_MASK       (0x01000000u)
N#define CSL_HPI_HPIAR_HPIAR24_SHIFT      (0x00000018u)
N#define CSL_HPI_HPIAR_HPIAR24_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR23_MASK       (0x00800000u)
N#define CSL_HPI_HPIAR_HPIAR23_SHIFT      (0x00000017u)
N#define CSL_HPI_HPIAR_HPIAR23_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR22_MASK       (0x00400000u)
N#define CSL_HPI_HPIAR_HPIAR22_SHIFT      (0x00000016u)
N#define CSL_HPI_HPIAR_HPIAR22_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR21_MASK       (0x00200000u)
N#define CSL_HPI_HPIAR_HPIAR21_SHIFT      (0x00000015u)
N#define CSL_HPI_HPIAR_HPIAR21_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR20_MASK       (0x00100000u)
N#define CSL_HPI_HPIAR_HPIAR20_SHIFT      (0x00000014u)
N#define CSL_HPI_HPIAR_HPIAR20_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR19_MASK       (0x00080000u)
N#define CSL_HPI_HPIAR_HPIAR19_SHIFT      (0x00000013u)
N#define CSL_HPI_HPIAR_HPIAR19_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR18_MASK       (0x00040000u)
N#define CSL_HPI_HPIAR_HPIAR18_SHIFT      (0x00000012u)
N#define CSL_HPI_HPIAR_HPIAR18_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR17_MASK       (0x00020000u)
N#define CSL_HPI_HPIAR_HPIAR17_SHIFT      (0x00000011u)
N#define CSL_HPI_HPIAR_HPIAR17_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR16_MASK       (0x00010000u)
N#define CSL_HPI_HPIAR_HPIAR16_SHIFT      (0x00000010u)
N#define CSL_HPI_HPIAR_HPIAR16_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR15_MASK       (0x00008000u)
N#define CSL_HPI_HPIAR_HPIAR15_SHIFT      (0x0000000Fu)
N#define CSL_HPI_HPIAR_HPIAR15_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR14_MASK       (0x00004000u)
N#define CSL_HPI_HPIAR_HPIAR14_SHIFT      (0x0000000Eu)
N#define CSL_HPI_HPIAR_HPIAR14_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR13_MASK       (0x00002000u)
N#define CSL_HPI_HPIAR_HPIAR13_SHIFT      (0x0000000Du)
N#define CSL_HPI_HPIAR_HPIAR13_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR12_MASK       (0x00001000u)
N#define CSL_HPI_HPIAR_HPIAR12_SHIFT      (0x0000000Cu)
N#define CSL_HPI_HPIAR_HPIAR12_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR11_MASK       (0x00000800u)
N#define CSL_HPI_HPIAR_HPIAR11_SHIFT      (0x0000000Bu)
N#define CSL_HPI_HPIAR_HPIAR11_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR10_MASK       (0x00000400u)
N#define CSL_HPI_HPIAR_HPIAR10_SHIFT      (0x0000000Au)
N#define CSL_HPI_HPIAR_HPIAR10_RESETVAL   (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR9_MASK        (0x00000200u)
N#define CSL_HPI_HPIAR_HPIAR9_SHIFT       (0x00000009u)
N#define CSL_HPI_HPIAR_HPIAR9_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR8_MASK        (0x00000100u)
N#define CSL_HPI_HPIAR_HPIAR8_SHIFT       (0x00000008u)
N#define CSL_HPI_HPIAR_HPIAR8_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR7_MASK        (0x00000080u)
N#define CSL_HPI_HPIAR_HPIAR7_SHIFT       (0x00000007u)
N#define CSL_HPI_HPIAR_HPIAR7_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR6_MASK        (0x00000040u)
N#define CSL_HPI_HPIAR_HPIAR6_SHIFT       (0x00000006u)
N#define CSL_HPI_HPIAR_HPIAR6_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR5_MASK        (0x00000020u)
N#define CSL_HPI_HPIAR_HPIAR5_SHIFT       (0x00000005u)
N#define CSL_HPI_HPIAR_HPIAR5_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR4_MASK        (0x00000010u)
N#define CSL_HPI_HPIAR_HPIAR4_SHIFT       (0x00000004u)
N#define CSL_HPI_HPIAR_HPIAR4_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR3_MASK        (0x00000008u)
N#define CSL_HPI_HPIAR_HPIAR3_SHIFT       (0x00000003u)
N#define CSL_HPI_HPIAR_HPIAR3_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR2_MASK        (0x00000004u)
N#define CSL_HPI_HPIAR_HPIAR2_SHIFT       (0x00000002u)
N#define CSL_HPI_HPIAR_HPIAR2_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR1_MASK        (0x00000002u)
N#define CSL_HPI_HPIAR_HPIAR1_SHIFT       (0x00000001u)
N#define CSL_HPI_HPIAR_HPIAR1_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_HPIAR0_MASK        (0x00000001u)
N#define CSL_HPI_HPIAR_HPIAR0_SHIFT       (0x00000000u)
N#define CSL_HPI_HPIAR_HPIAR0_RESETVAL    (0x00000000u)
N
N#define CSL_HPI_HPIAR_RESETVAL           (0x00000000u)
N
N#endif
L 42 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_icache.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_icache.h" 1
N#ifndef _CSLR_ICACHE_H_
N#define _CSLR_ICACHE_H_
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_icache.h
N * 
N * \brief This file contains the Register Desciptions for ICACHE
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    /** L1P Invalidate Start Address Register */
N    volatile Uint32 L1PISAR;
N    /** L1P Invalidate Control Register */
N    volatile Uint32 L1PICR;
N    /** Memory Control and Status Register */
N    volatile Uint32 MEMCSR;
N    volatile Uint32 RSVD0[1];
N    /** Program Counter Export Register */
N    volatile Uint32 PCER; 
N} CSL_IcacheRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/** L1PISAR - L1P Invalidate Start Address Register */
N
N#define CSL_ICACHE_L1PISAR_L1PISA_MASK     (0xFFFFFFFFu)
N#define CSL_ICACHE_L1PISAR_L1PISA_SHIFT    (0x00000000u)
N#define CSL_ICACHE_L1PISAR_L1PISA_RESETVAL (0x00000000u)
N
N#define CSL_ICACHE_L1PISAR_RESETVAL        (0x00000000u)
N
N/** L1PICR - L1P Invalidate Control Register */
N
N#define CSL_ICACHE_L1PICR_IP_MASK          (0x80000000u)
N#define CSL_ICACHE_L1PICR_IP_SHIFT         (0x0000001Fu)
N#define CSL_ICACHE_L1PICR_IP_RESETVAL      (0x00000000u)
N
N/**----IP Tokens----*/
N#define CSL_ICACHE_L1PICR_IP_CLEAR         (0x00000000u)
N#define CSL_ICACHE_L1PICR_IP_SET           (0x00000001u)
N
N#define CSL_ICACHE_L1PICR_INV_WORDCNT_MASK (0x0000FFFFu)
N#define CSL_ICACHE_L1PICR_INV_WORDCNT_SHIFT (0x00000000u)
N#define CSL_ICACHE_L1PICR_INV_WORDCNT_RESETVAL (0x00000000u)
N
N#define CSL_ICACHE_L1PICR_RESETVAL         (0x00000000u)
N
N/** MEMCSR - Memory Control and Status Register */
N
N#define CSL_ICACHE_MEMCSR_IFP_MASK         (0x00040000u)
N#define CSL_ICACHE_MEMCSR_IFP_SHIFT        (0x00000012u)
N#define CSL_ICACHE_MEMCSR_IFP_RESETVAL     (0x00000000u)
N
N/**----IFP Tokens----*/
N#define CSL_ICACHE_MEMCSR_IFP_NOERR        (0x00000000u)
N#define CSL_ICACHE_MEMCSR_IFP_ERR          (0x00000001u)
N
N#define CSL_ICACHE_MEMCSR_DWR_MASK         (0x00020000u)
N#define CSL_ICACHE_MEMCSR_DWR_SHIFT        (0x00000011u)
N#define CSL_ICACHE_MEMCSR_DWR_RESETVAL     (0x00000000u)
N
N/**----DWR Tokens----*/
N#define CSL_ICACHE_MEMCSR_DWR_NOWRITE      (0x00000000u)
N#define CSL_ICACHE_MEMCSR_DWR_WRITE        (0x00000001u)
N
N#define CSL_ICACHE_MEMCSR_RMA_MASK         (0x00010000u)
N#define CSL_ICACHE_MEMCSR_RMA_SHIFT        (0x00000010u)
N#define CSL_ICACHE_MEMCSR_RMA_RESETVAL     (0x00000000u)
N
N/**----RMA Tokens----*/
N#define CSL_ICACHE_MEMCSR_RMA_NOERR        (0x00000000u)
N#define CSL_ICACHE_MEMCSR_RMA_ERR          (0x00000001u)
N
N#define CSL_ICACHE_MEMCSR_P_MASK           (0x00000001u)
N#define CSL_ICACHE_MEMCSR_P_SHIFT          (0x00000000u)
N#define CSL_ICACHE_MEMCSR_P_RESETVAL       (0x00000001u)
N
N/**----P Tokens----*/
N#define CSL_ICACHE_MEMCSR_P_LP1            (0x00000000u)
N#define CSL_ICACHE_MEMCSR_P_CSP            (0x00000001u)
N
N#define CSL_ICACHE_MEMCSR_RESETVAL         (0x00000001u)
N
N/** PCER - Program Counter Export Register */
N
N#define CSL_ICACHE_PCER_PCE_MASK           (0xFFFFFFFFu)
N#define CSL_ICACHE_PCER_PCE_SHIFT          (0x00000000u)
N#define CSL_ICACHE_PCER_PCE_RESETVAL       (0x00000000u)
N
N#define CSL_ICACHE_PCER_RESETVAL           (0x00000000u)
N#endif
L 43 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N#include "cslr_dmax.h"
L 1 "C:\CCStudio_v3.1\C6000\csl\include\cslr_dmax.h" 1
N#ifndef _CSLR_DMAX_H_
N#define _CSLR_DMAX_H_
N/*********************************************************************
N * Copyright (C) 2003-2005 Texas Instruments Incorporated. 
N * All Rights Reserved 
N *********************************************************************/
N /** \file cslr_dmax.h
N * 
N * \brief This file contains the Register Desciptions for Dmax
N * 
N *********************************************************************/
N
N#include <cslr.h>
N
N#include <tistdtypes.h>
N
N/**************************************************************************\
N* Register Overlay Structure for HiPriorityEventTable 
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 EVENT0;
N    volatile Uint32 EVENT1;
N    volatile Uint32 EVENT2;
N    volatile Uint32 EVENT3;
N    volatile Uint32 EVENT4;
N    volatile Uint32 EVENT5;
N    volatile Uint32 EVENT6;
N    volatile Uint32 EVENT7;
N    volatile Uint32 EVENT8;
N    volatile Uint32 EVENT9;
N    volatile Uint32 EVENT10;
N    volatile Uint32 EVENT11;
N    volatile Uint32 EVENT12;
N    volatile Uint32 EVENT13;
N    volatile Uint32 EVENT14;
N    volatile Uint32 EVENT15;
N    volatile Uint32 EVENT16;
N    volatile Uint32 EVENT17;
N    volatile Uint32 EVENT18;
N    volatile Uint32 EVENT19;
N    volatile Uint32 EVENT20;
N    volatile Uint32 EVENT21;
N    volatile Uint32 EVENT22;
N    volatile Uint32 EVENT23;
N    volatile Uint32 EVENT24;
N    volatile Uint32 EVENT25;
N    volatile Uint32 EVENT26;
N    volatile Uint32 EVENT27;
N    volatile Uint32 EVENT28;
N    volatile Uint32 EVENT29;
N    volatile Uint32 EVENT30;
N    volatile Uint32 EVENT31;
N} CSL_DmaxHipriorityeventtableRegs;
N
N/**************************************************************************\
N* Register Overlay Structure for HiMaxPaRAM 
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 WORD0;
N    volatile Uint32 WORD1;
N    volatile Uint32 WORD2;
N    volatile Uint32 WORD3;
N    volatile Uint32 WORD4;
N    volatile Uint32 WORD5;
N    volatile Uint32 WORD6;
N    volatile Uint32 WORD7;
N    volatile Uint32 WORD8;
N    volatile Uint32 WORD9;
N    volatile Uint32 WORD10;
N} CSL_DmaxHimaxparamRegs;
N
N/**************************************************************************\
N* Register Overlay Structure for LoPriorityEventTable 
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 EVENT0;
N    volatile Uint32 EVENT1;
N    volatile Uint32 EVENT2;
N    volatile Uint32 EVENT3;
N    volatile Uint32 EVENT4;
N    volatile Uint32 EVENT5;
N    volatile Uint32 EVENT6;
N    volatile Uint32 EVENT7;
N    volatile Uint32 EVENT8;
N    volatile Uint32 EVENT9;
N    volatile Uint32 EVENT10;
N    volatile Uint32 EVENT11;
N    volatile Uint32 EVENT12;
N    volatile Uint32 EVENT13;
N    volatile Uint32 EVENT14;
N    volatile Uint32 EVENT15;
N    volatile Uint32 EVENT16;
N    volatile Uint32 EVENT17;
N    volatile Uint32 EVENT18;
N    volatile Uint32 EVENT19;
N    volatile Uint32 EVENT20;
N    volatile Uint32 EVENT21;
N    volatile Uint32 EVENT22;
N    volatile Uint32 EVENT23;
N    volatile Uint32 EVENT24;
N    volatile Uint32 EVENT25;
N    volatile Uint32 EVENT26;
N    volatile Uint32 EVENT27;
N    volatile Uint32 EVENT28;
N    volatile Uint32 EVENT29;
N    volatile Uint32 EVENT30;
N    volatile Uint32 EVENT31;
N} CSL_DmaxLopriorityeventtableRegs;
N
N/**************************************************************************\
N* Register Overlay Structure for LoMaxPaRAM 
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 WORD0;
N    volatile Uint32 WORD1;
N    volatile Uint32 WORD2;
N    volatile Uint32 WORD3;
N    volatile Uint32 WORD4;
N    volatile Uint32 WORD5;
N    volatile Uint32 WORD6;
N    volatile Uint32 WORD7;
N    volatile Uint32 WORD8;
N    volatile Uint32 WORD9;
N    volatile Uint32 WORD10;
N} CSL_DmaxLomaxparamRegs;
N
N/**************************************************************************\
N* Register Overlay Structure
X
N\**************************************************************************/
Ntypedef struct  {
N    volatile Uint32 RSVD0[2];
N    volatile Uint32 DEPR;
N    volatile Uint32 DEER;
N    volatile Uint32 DEDR;
N    volatile Uint32 DEHPR;
N    volatile Uint32 DELPR;
N    volatile Uint32 DEFR;
N    volatile Uint32 RSVD1[8];
N    volatile Uint32 DFSR0;
N    volatile Uint32 RSVD2[7];
N    volatile Uint32 DFSR1;
N    volatile Uint32 RSVD3[7];
N    volatile Uint32 DTCR0;
N    volatile Uint32 RSVD4[7];
N    volatile Uint32 DTCR1;
N    volatile Uint32 RSVD5[4202455];
N    CSL_DmaxHipriorityeventtableRegs HiPriorityEventTable;
N    volatile Uint32 RSVD6[8];
N    CSL_DmaxHimaxparamRegs HiMaxParam[8];
N    volatile Uint32 RSVD7[4194176];
N    CSL_DmaxLopriorityeventtableRegs LoPriorityEventTable;
N    volatile Uint32 RSVD8[8];
N    CSL_DmaxLomaxparamRegs LoMaxParam[8];
N} CSL_DmaxRegs;
N
N/**************************************************************************\
N* Field Definition Macros
X
N\**************************************************************************/
N
N/* DEPR */
N
N#define CSL_DMAX_DEPR_EP31_MASK          (0x80000000u)
N#define CSL_DMAX_DEPR_EP31_SHIFT         (0x0000001Fu)
N#define CSL_DMAX_DEPR_EP31_RESETVAL      (0x00000000u)
N
N/*----EP31 Tokens----*/
N#define CSL_DMAX_DEPR_EP31_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP31_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP30_MASK          (0x40000000u)
N#define CSL_DMAX_DEPR_EP30_SHIFT         (0x0000001Eu)
N#define CSL_DMAX_DEPR_EP30_RESETVAL      (0x00000000u)
N
N/*----EP30 Tokens----*/
N#define CSL_DMAX_DEPR_EP30_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP30_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP29_MASK          (0x20000000u)
N#define CSL_DMAX_DEPR_EP29_SHIFT         (0x0000001Du)
N#define CSL_DMAX_DEPR_EP29_RESETVAL      (0x00000000u)
N
N/*----EP29 Tokens----*/
N#define CSL_DMAX_DEPR_EP29_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP29_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP28_MASK          (0x10000000u)
N#define CSL_DMAX_DEPR_EP28_SHIFT         (0x0000001Cu)
N#define CSL_DMAX_DEPR_EP28_RESETVAL      (0x00000000u)
N
N/*----EP28 Tokens----*/
N#define CSL_DMAX_DEPR_EP28_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP28_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP27_MASK          (0x08000000u)
N#define CSL_DMAX_DEPR_EP27_SHIFT         (0x0000001Bu)
N#define CSL_DMAX_DEPR_EP27_RESETVAL      (0x00000000u)
N
N/*----EP27 Tokens----*/
N#define CSL_DMAX_DEPR_EP27_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP27_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP26_MASK          (0x04000000u)
N#define CSL_DMAX_DEPR_EP26_SHIFT         (0x0000001Au)
N#define CSL_DMAX_DEPR_EP26_RESETVAL      (0x00000000u)
N
N/*----EP26 Tokens----*/
N#define CSL_DMAX_DEPR_EP26_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP26_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP24_MASK          (0x01000000u)
N#define CSL_DMAX_DEPR_EP24_SHIFT         (0x00000018u)
N#define CSL_DMAX_DEPR_EP24_RESETVAL      (0x00000000u)
N
N/*----EP24 Tokens----*/
N#define CSL_DMAX_DEPR_EP24_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP24_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP23_MASK          (0x00800000u)
N#define CSL_DMAX_DEPR_EP23_SHIFT         (0x00000017u)
N#define CSL_DMAX_DEPR_EP23_RESETVAL      (0x00000000u)
N
N/*----EP23 Tokens----*/
N#define CSL_DMAX_DEPR_EP23_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP23_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP22_MASK          (0x00400000u)
N#define CSL_DMAX_DEPR_EP22_SHIFT         (0x00000016u)
N#define CSL_DMAX_DEPR_EP22_RESETVAL      (0x00000000u)
N
N/*----EP22 Tokens----*/
N#define CSL_DMAX_DEPR_EP22_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP22_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP21_MASK          (0x00200000u)
N#define CSL_DMAX_DEPR_EP21_SHIFT         (0x00000015u)
N#define CSL_DMAX_DEPR_EP21_RESETVAL      (0x00000000u)
N
N/*----EP21 Tokens----*/
N#define CSL_DMAX_DEPR_EP21_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP21_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP20_MASK          (0x00100000u)
N#define CSL_DMAX_DEPR_EP20_SHIFT         (0x00000014u)
N#define CSL_DMAX_DEPR_EP20_RESETVAL      (0x00000000u)
N
N/*----EP20 Tokens----*/
N#define CSL_DMAX_DEPR_EP20_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP20_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP19_MASK          (0x00080000u)
N#define CSL_DMAX_DEPR_EP19_SHIFT         (0x00000013u)
N#define CSL_DMAX_DEPR_EP19_RESETVAL      (0x00000000u)
N
N/*----EP19 Tokens----*/
N#define CSL_DMAX_DEPR_EP19_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP19_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP18_MASK          (0x00040000u)
N#define CSL_DMAX_DEPR_EP18_SHIFT         (0x00000012u)
N#define CSL_DMAX_DEPR_EP18_RESETVAL      (0x00000000u)
N
N/*----EP18 Tokens----*/
N#define CSL_DMAX_DEPR_EP18_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP18_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP17_MASK          (0x00020000u)
N#define CSL_DMAX_DEPR_EP17_SHIFT         (0x00000011u)
N#define CSL_DMAX_DEPR_EP17_RESETVAL      (0x00000000u)
N
N/*----EP17 Tokens----*/
N#define CSL_DMAX_DEPR_EP17_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP17_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP16_MASK          (0x00010000u)
N#define CSL_DMAX_DEPR_EP16_SHIFT         (0x00000010u)
N#define CSL_DMAX_DEPR_EP16_RESETVAL      (0x00000000u)
N
N/*----EP16 Tokens----*/
N#define CSL_DMAX_DEPR_EP16_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP16_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP15_MASK          (0x00008000u)
N#define CSL_DMAX_DEPR_EP15_SHIFT         (0x0000000Fu)
N#define CSL_DMAX_DEPR_EP15_RESETVAL      (0x00000000u)
N
N/*----EP15 Tokens----*/
N#define CSL_DMAX_DEPR_EP15_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP15_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP14_MASK          (0x00004000u)
N#define CSL_DMAX_DEPR_EP14_SHIFT         (0x0000000Eu)
N#define CSL_DMAX_DEPR_EP14_RESETVAL      (0x00000000u)
N
N/*----EP14 Tokens----*/
N#define CSL_DMAX_DEPR_EP14_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP14_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP13_MASK          (0x00002000u)
N#define CSL_DMAX_DEPR_EP13_SHIFT         (0x0000000Du)
N#define CSL_DMAX_DEPR_EP13_RESETVAL      (0x00000000u)
N
N/*----EP13 Tokens----*/
N#define CSL_DMAX_DEPR_EP13_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP13_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP12_MASK          (0x00001000u)
N#define CSL_DMAX_DEPR_EP12_SHIFT         (0x0000000Cu)
N#define CSL_DMAX_DEPR_EP12_RESETVAL      (0x00000000u)
N
N/*----EP12 Tokens----*/
N#define CSL_DMAX_DEPR_EP12_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP12_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP11_MASK          (0x00000800u)
N#define CSL_DMAX_DEPR_EP11_SHIFT         (0x0000000Bu)
N#define CSL_DMAX_DEPR_EP11_RESETVAL      (0x00000000u)
N
N/*----EP11 Tokens----*/
N#define CSL_DMAX_DEPR_EP11_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP11_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP10_MASK          (0x00000400u)
N#define CSL_DMAX_DEPR_EP10_SHIFT         (0x0000000Au)
N#define CSL_DMAX_DEPR_EP10_RESETVAL      (0x00000000u)
N
N/*----EP10 Tokens----*/
N#define CSL_DMAX_DEPR_EP10_SET_FALLING   (0x00000000u)
N#define CSL_DMAX_DEPR_EP10_SET_RISING    (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP9_MASK           (0x00000200u)
N#define CSL_DMAX_DEPR_EP9_SHIFT          (0x00000009u)
N#define CSL_DMAX_DEPR_EP9_RESETVAL       (0x00000000u)
N
N/*----EP9 Tokens----*/
N#define CSL_DMAX_DEPR_EP9_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP9_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP8_MASK           (0x00000100u)
N#define CSL_DMAX_DEPR_EP8_SHIFT          (0x00000008u)
N#define CSL_DMAX_DEPR_EP8_RESETVAL       (0x00000000u)
N
N/*----EP8 Tokens----*/
N#define CSL_DMAX_DEPR_EP8_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP8_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP7_MASK           (0x00000080u)
N#define CSL_DMAX_DEPR_EP7_SHIFT          (0x00000007u)
N#define CSL_DMAX_DEPR_EP7_RESETVAL       (0x00000000u)
N
N/*----EP7 Tokens----*/
N#define CSL_DMAX_DEPR_EP7_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP7_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP6_MASK           (0x00000040u)
N#define CSL_DMAX_DEPR_EP6_SHIFT          (0x00000006u)
N#define CSL_DMAX_DEPR_EP6_RESETVAL       (0x00000000u)
N
N/*----EP6 Tokens----*/
N#define CSL_DMAX_DEPR_EP6_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP6_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP5_MASK           (0x00000020u)
N#define CSL_DMAX_DEPR_EP5_SHIFT          (0x00000005u)
N#define CSL_DMAX_DEPR_EP5_RESETVAL       (0x00000000u)
N
N/*----EP5 Tokens----*/
N#define CSL_DMAX_DEPR_EP5_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP5_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP4_MASK           (0x00000010u)
N#define CSL_DMAX_DEPR_EP4_SHIFT          (0x00000004u)
N#define CSL_DMAX_DEPR_EP4_RESETVAL       (0x00000000u)
N
N/*----EP4 Tokens----*/
N#define CSL_DMAX_DEPR_EP4_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP4_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP3_MASK           (0x00000008u)
N#define CSL_DMAX_DEPR_EP3_SHIFT          (0x00000003u)
N#define CSL_DMAX_DEPR_EP3_RESETVAL       (0x00000000u)
N
N/*----EP3 Tokens----*/
N#define CSL_DMAX_DEPR_EP3_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP3_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP2_MASK           (0x00000004u)
N#define CSL_DMAX_DEPR_EP2_SHIFT          (0x00000002u)
N#define CSL_DMAX_DEPR_EP2_RESETVAL       (0x00000000u)
N
N/*----EP2 Tokens----*/
N#define CSL_DMAX_DEPR_EP2_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP2_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP1_MASK           (0x00000002u)
N#define CSL_DMAX_DEPR_EP1_SHIFT          (0x00000001u)
N#define CSL_DMAX_DEPR_EP1_RESETVAL       (0x00000000u)
N
N/*----EP1 Tokens----*/
N#define CSL_DMAX_DEPR_EP1_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP1_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_EP0_MASK           (0x00000001u)
N#define CSL_DMAX_DEPR_EP0_SHIFT          (0x00000000u)
N#define CSL_DMAX_DEPR_EP0_RESETVAL       (0x00000000u)
N
N/*----EP0 Tokens----*/
N#define CSL_DMAX_DEPR_EP0_SET_FALLING    (0x00000000u)
N#define CSL_DMAX_DEPR_EP0_SET_RISING     (0x00000001u)
N
N#define CSL_DMAX_DEPR_RESETVAL           (0x00000000u)
N
N/* DEER */
N
N#define CSL_DMAX_DEER_EE31_MASK          (0x80000000u)
N#define CSL_DMAX_DEER_EE31_SHIFT         (0x0000001Fu)
N#define CSL_DMAX_DEER_EE31_RESETVAL      (0x00000000u)
N
N/*----EE31 Tokens----*/
N#define CSL_DMAX_DEER_EE31_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE30_MASK          (0x40000000u)
N#define CSL_DMAX_DEER_EE30_SHIFT         (0x0000001Eu)
N#define CSL_DMAX_DEER_EE30_RESETVAL      (0x00000000u)
N
N/*----EE30 Tokens----*/
N#define CSL_DMAX_DEER_EE30_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE29_MASK          (0x20000000u)
N#define CSL_DMAX_DEER_EE29_SHIFT         (0x0000001Du)
N#define CSL_DMAX_DEER_EE29_RESETVAL      (0x00000000u)
N
N/*----EE29 Tokens----*/
N#define CSL_DMAX_DEER_EE29_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE28_MASK          (0x10000000u)
N#define CSL_DMAX_DEER_EE28_SHIFT         (0x0000001Cu)
N#define CSL_DMAX_DEER_EE28_RESETVAL      (0x00000000u)
N
N/*----EE28 Tokens----*/
N#define CSL_DMAX_DEER_EE28_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE27_MASK          (0x08000000u)
N#define CSL_DMAX_DEER_EE27_SHIFT         (0x0000001Bu)
N#define CSL_DMAX_DEER_EE27_RESETVAL      (0x00000000u)
N
N/*----EE27 Tokens----*/
N#define CSL_DMAX_DEER_EE27_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE26_MASK          (0x04000000u)
N#define CSL_DMAX_DEER_EE26_SHIFT         (0x0000001Au)
N#define CSL_DMAX_DEER_EE26_RESETVAL      (0x00000000u)
N
N/*----EE26 Tokens----*/
N#define CSL_DMAX_DEER_EE26_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE24_MASK          (0x01000000u)
N#define CSL_DMAX_DEER_EE24_SHIFT         (0x00000018u)
N#define CSL_DMAX_DEER_EE24_RESETVAL      (0x00000000u)
N
N/*----EE24 Tokens----*/
N#define CSL_DMAX_DEER_EE24_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE23_MASK          (0x00800000u)
N#define CSL_DMAX_DEER_EE23_SHIFT         (0x00000017u)
N#define CSL_DMAX_DEER_EE23_RESETVAL      (0x00000000u)
N
N/*----EE23 Tokens----*/
N#define CSL_DMAX_DEER_EE23_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE22_MASK          (0x00400000u)
N#define CSL_DMAX_DEER_EE22_SHIFT         (0x00000016u)
N#define CSL_DMAX_DEER_EE22_RESETVAL      (0x00000000u)
N
N/*----EE22 Tokens----*/
N#define CSL_DMAX_DEER_EE22_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE21_MASK          (0x00200000u)
N#define CSL_DMAX_DEER_EE21_SHIFT         (0x00000015u)
N#define CSL_DMAX_DEER_EE21_RESETVAL      (0x00000000u)
N
N/*----EE21 Tokens----*/
N#define CSL_DMAX_DEER_EE21_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE20_MASK          (0x00100000u)
N#define CSL_DMAX_DEER_EE20_SHIFT         (0x00000014u)
N#define CSL_DMAX_DEER_EE20_RESETVAL      (0x00000000u)
N
N/*----EE20 Tokens----*/
N#define CSL_DMAX_DEER_EE20_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE19_MASK          (0x00080000u)
N#define CSL_DMAX_DEER_EE19_SHIFT         (0x00000013u)
N#define CSL_DMAX_DEER_EE19_RESETVAL      (0x00000000u)
N
N/*----EE19 Tokens----*/
N#define CSL_DMAX_DEER_EE19_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE18_MASK          (0x00040000u)
N#define CSL_DMAX_DEER_EE18_SHIFT         (0x00000012u)
N#define CSL_DMAX_DEER_EE18_RESETVAL      (0x00000000u)
N
N/*----EE18 Tokens----*/
N#define CSL_DMAX_DEER_EE18_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE17_MASK          (0x00020000u)
N#define CSL_DMAX_DEER_EE17_SHIFT         (0x00000011u)
N#define CSL_DMAX_DEER_EE17_RESETVAL      (0x00000000u)
N
N/*----EE17 Tokens----*/
N#define CSL_DMAX_DEER_EE17_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE16_MASK          (0x00010000u)
N#define CSL_DMAX_DEER_EE16_SHIFT         (0x00000010u)
N#define CSL_DMAX_DEER_EE16_RESETVAL      (0x00000000u)
N
N/*----EE16 Tokens----*/
N#define CSL_DMAX_DEER_EE16_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE15_MASK          (0x00008000u)
N#define CSL_DMAX_DEER_EE15_SHIFT         (0x0000000Fu)
N#define CSL_DMAX_DEER_EE15_RESETVAL      (0x00000000u)
N
N/*----EE15 Tokens----*/
N#define CSL_DMAX_DEER_EE15_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE14_MASK          (0x00004000u)
N#define CSL_DMAX_DEER_EE14_SHIFT         (0x0000000Eu)
N#define CSL_DMAX_DEER_EE14_RESETVAL      (0x00000000u)
N
N/*----EE14 Tokens----*/
N#define CSL_DMAX_DEER_EE14_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE13_MASK          (0x00002000u)
N#define CSL_DMAX_DEER_EE13_SHIFT         (0x0000000Du)
N#define CSL_DMAX_DEER_EE13_RESETVAL      (0x00000000u)
N
N/*----EE13 Tokens----*/
N#define CSL_DMAX_DEER_EE13_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE12_MASK          (0x00001000u)
N#define CSL_DMAX_DEER_EE12_SHIFT         (0x0000000Cu)
N#define CSL_DMAX_DEER_EE12_RESETVAL      (0x00000000u)
N
N/*----EE12 Tokens----*/
N#define CSL_DMAX_DEER_EE12_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE11_MASK          (0x00000800u)
N#define CSL_DMAX_DEER_EE11_SHIFT         (0x0000000Bu)
N#define CSL_DMAX_DEER_EE11_RESETVAL      (0x00000000u)
N
N/*----EE11 Tokens----*/
N#define CSL_DMAX_DEER_EE11_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE10_MASK          (0x00000400u)
N#define CSL_DMAX_DEER_EE10_SHIFT         (0x0000000Au)
N#define CSL_DMAX_DEER_EE10_RESETVAL      (0x00000000u)
N
N/*----EE10 Tokens----*/
N#define CSL_DMAX_DEER_EE10_ENABLE        (0x00000001u)
N
N#define CSL_DMAX_DEER_EE9_MASK           (0x00000200u)
N#define CSL_DMAX_DEER_EE9_SHIFT          (0x00000009u)
N#define CSL_DMAX_DEER_EE9_RESETVAL       (0x00000000u)
N
N/*----EE9 Tokens----*/
N#define CSL_DMAX_DEER_EE9_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE8_MASK           (0x00000100u)
N#define CSL_DMAX_DEER_EE8_SHIFT          (0x00000008u)
N#define CSL_DMAX_DEER_EE8_RESETVAL       (0x00000000u)
N
N/*----EE8 Tokens----*/
N#define CSL_DMAX_DEER_EE8_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE7_MASK           (0x00000080u)
N#define CSL_DMAX_DEER_EE7_SHIFT          (0x00000007u)
N#define CSL_DMAX_DEER_EE7_RESETVAL       (0x00000000u)
N
N/*----EE7 Tokens----*/
N#define CSL_DMAX_DEER_EE7_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE6_MASK           (0x00000040u)
N#define CSL_DMAX_DEER_EE6_SHIFT          (0x00000006u)
N#define CSL_DMAX_DEER_EE6_RESETVAL       (0x00000000u)
N
N/*----EE6 Tokens----*/
N#define CSL_DMAX_DEER_EE6_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE5_MASK           (0x00000020u)
N#define CSL_DMAX_DEER_EE5_SHIFT          (0x00000005u)
N#define CSL_DMAX_DEER_EE5_RESETVAL       (0x00000000u)
N
N/*----EE5 Tokens----*/
N#define CSL_DMAX_DEER_EE5_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE4_MASK           (0x00000010u)
N#define CSL_DMAX_DEER_EE4_SHIFT          (0x00000004u)
N#define CSL_DMAX_DEER_EE4_RESETVAL       (0x00000000u)
N
N/*----EE4 Tokens----*/
N#define CSL_DMAX_DEER_EE4_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE3_MASK           (0x00000008u)
N#define CSL_DMAX_DEER_EE3_SHIFT          (0x00000003u)
N#define CSL_DMAX_DEER_EE3_RESETVAL       (0x00000000u)
N
N/*----EE3 Tokens----*/
N#define CSL_DMAX_DEER_EE3_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE2_MASK           (0x00000004u)
N#define CSL_DMAX_DEER_EE2_SHIFT          (0x00000002u)
N#define CSL_DMAX_DEER_EE2_RESETVAL       (0x00000000u)
N
N/*----EE2 Tokens----*/
N#define CSL_DMAX_DEER_EE2_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE1_MASK           (0x00000002u)
N#define CSL_DMAX_DEER_EE1_SHIFT          (0x00000001u)
N#define CSL_DMAX_DEER_EE1_RESETVAL       (0x00000000u)
N
N/*----EE1 Tokens----*/
N#define CSL_DMAX_DEER_EE1_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_EE0_MASK           (0x00000001u)
N#define CSL_DMAX_DEER_EE0_SHIFT          (0x00000000u)
N#define CSL_DMAX_DEER_EE0_RESETVAL       (0x00000000u)
N
N/*----EE0 Tokens----*/
N#define CSL_DMAX_DEER_EE0_ENABLE         (0x00000001u)
N
N#define CSL_DMAX_DEER_RESETVAL           (0x00000000u)
N
N/* DEDR */
N
N#define CSL_DMAX_DEDR_ED31_MASK          (0x80000000u)
N#define CSL_DMAX_DEDR_ED31_SHIFT         (0x0000001Fu)
N#define CSL_DMAX_DEDR_ED31_RESETVAL      (0x00000000u)
N
N/*----ED31 Tokens----*/
N#define CSL_DMAX_DEDR_ED31_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED30_MASK          (0x40000000u)
N#define CSL_DMAX_DEDR_ED30_SHIFT         (0x0000001Eu)
N#define CSL_DMAX_DEDR_ED30_RESETVAL      (0x00000000u)
N
N/*----ED30 Tokens----*/
N#define CSL_DMAX_DEDR_ED30_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED29_MASK          (0x20000000u)
N#define CSL_DMAX_DEDR_ED29_SHIFT         (0x0000001Du)
N#define CSL_DMAX_DEDR_ED29_RESETVAL      (0x00000000u)
N
N/*----ED29 Tokens----*/
N#define CSL_DMAX_DEDR_ED29_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED28_MASK          (0x10000000u)
N#define CSL_DMAX_DEDR_ED28_SHIFT         (0x0000001Cu)
N#define CSL_DMAX_DEDR_ED28_RESETVAL      (0x00000000u)
N
N/*----ED28 Tokens----*/
N#define CSL_DMAX_DEDR_ED28_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED27_MASK          (0x08000000u)
N#define CSL_DMAX_DEDR_ED27_SHIFT         (0x0000001Bu)
N#define CSL_DMAX_DEDR_ED27_RESETVAL      (0x00000000u)
N
N/*----ED27 Tokens----*/
N#define CSL_DMAX_DEDR_ED27_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED26_MASK          (0x04000000u)
N#define CSL_DMAX_DEDR_ED26_SHIFT         (0x0000001Au)
N#define CSL_DMAX_DEDR_ED26_RESETVAL      (0x00000000u)
N
N/*----ED26 Tokens----*/
N#define CSL_DMAX_DEDR_ED26_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED24_MASK          (0x01000000u)
N#define CSL_DMAX_DEDR_ED24_SHIFT         (0x00000018u)
N#define CSL_DMAX_DEDR_ED24_RESETVAL      (0x00000000u)
N
N/*----ED24 Tokens----*/
N#define CSL_DMAX_DEDR_ED24_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED23_MASK          (0x00800000u)
N#define CSL_DMAX_DEDR_ED23_SHIFT         (0x00000017u)
N#define CSL_DMAX_DEDR_ED23_RESETVAL      (0x00000000u)
N
N/*----ED23 Tokens----*/
N#define CSL_DMAX_DEDR_ED23_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED22_MASK          (0x00400000u)
N#define CSL_DMAX_DEDR_ED22_SHIFT         (0x00000016u)
N#define CSL_DMAX_DEDR_ED22_RESETVAL      (0x00000000u)
N
N/*----ED22 Tokens----*/
N#define CSL_DMAX_DEDR_ED22_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED21_MASK          (0x00200000u)
N#define CSL_DMAX_DEDR_ED21_SHIFT         (0x00000015u)
N#define CSL_DMAX_DEDR_ED21_RESETVAL      (0x00000000u)
N
N/*----ED21 Tokens----*/
N#define CSL_DMAX_DEDR_ED21_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED20_MASK          (0x00100000u)
N#define CSL_DMAX_DEDR_ED20_SHIFT         (0x00000014u)
N#define CSL_DMAX_DEDR_ED20_RESETVAL      (0x00000000u)
N
N/*----ED20 Tokens----*/
N#define CSL_DMAX_DEDR_ED20_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED19_MASK          (0x00080000u)
N#define CSL_DMAX_DEDR_ED19_SHIFT         (0x00000013u)
N#define CSL_DMAX_DEDR_ED19_RESETVAL      (0x00000000u)
N
N/*----ED19 Tokens----*/
N#define CSL_DMAX_DEDR_ED19_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED18_MASK          (0x00040000u)
N#define CSL_DMAX_DEDR_ED18_SHIFT         (0x00000012u)
N#define CSL_DMAX_DEDR_ED18_RESETVAL      (0x00000000u)
N
N/*----ED18 Tokens----*/
N#define CSL_DMAX_DEDR_ED18_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED17_MASK          (0x00020000u)
N#define CSL_DMAX_DEDR_ED17_SHIFT         (0x00000011u)
N#define CSL_DMAX_DEDR_ED17_RESETVAL      (0x00000000u)
N
N/*----ED17 Tokens----*/
N#define CSL_DMAX_DEDR_ED17_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED16_MASK          (0x00010000u)
N#define CSL_DMAX_DEDR_ED16_SHIFT         (0x00000010u)
N#define CSL_DMAX_DEDR_ED16_RESETVAL      (0x00000000u)
N
N/*----ED16 Tokens----*/
N#define CSL_DMAX_DEDR_ED16_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED15_MASK          (0x00008000u)
N#define CSL_DMAX_DEDR_ED15_SHIFT         (0x0000000Fu)
N#define CSL_DMAX_DEDR_ED15_RESETVAL      (0x00000000u)
N
N/*----ED15 Tokens----*/
N#define CSL_DMAX_DEDR_ED15_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED14_MASK          (0x00004000u)
N#define CSL_DMAX_DEDR_ED14_SHIFT         (0x0000000Eu)
N#define CSL_DMAX_DEDR_ED14_RESETVAL      (0x00000000u)
N
N/*----ED14 Tokens----*/
N#define CSL_DMAX_DEDR_ED14_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED13_MASK          (0x00002000u)
N#define CSL_DMAX_DEDR_ED13_SHIFT         (0x0000000Du)
N#define CSL_DMAX_DEDR_ED13_RESETVAL      (0x00000000u)
N
N/*----ED13 Tokens----*/
N#define CSL_DMAX_DEDR_ED13_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED12_MASK          (0x00001000u)
N#define CSL_DMAX_DEDR_ED12_SHIFT         (0x0000000Cu)
N#define CSL_DMAX_DEDR_ED12_RESETVAL      (0x00000000u)
N
N/*----ED12 Tokens----*/
N#define CSL_DMAX_DEDR_ED12_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED11_MASK          (0x00000800u)
N#define CSL_DMAX_DEDR_ED11_SHIFT         (0x0000000Bu)
N#define CSL_DMAX_DEDR_ED11_RESETVAL      (0x00000000u)
N
N/*----ED11 Tokens----*/
N#define CSL_DMAX_DEDR_ED11_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED10_MASK          (0x00000400u)
N#define CSL_DMAX_DEDR_ED10_SHIFT         (0x0000000Au)
N#define CSL_DMAX_DEDR_ED10_RESETVAL      (0x00000000u)
N
N/*----ED10 Tokens----*/
N#define CSL_DMAX_DEDR_ED10_DISABLE       (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED9_MASK           (0x00000200u)
N#define CSL_DMAX_DEDR_ED9_SHIFT          (0x00000009u)
N#define CSL_DMAX_DEDR_ED9_RESETVAL       (0x00000000u)
N
N/*----ED9 Tokens----*/
N#define CSL_DMAX_DEDR_ED9_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED8_MASK           (0x00000100u)
N#define CSL_DMAX_DEDR_ED8_SHIFT          (0x00000008u)
N#define CSL_DMAX_DEDR_ED8_RESETVAL       (0x00000000u)
N
N/*----ED8 Tokens----*/
N#define CSL_DMAX_DEDR_ED8_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED7_MASK           (0x00000080u)
N#define CSL_DMAX_DEDR_ED7_SHIFT          (0x00000007u)
N#define CSL_DMAX_DEDR_ED7_RESETVAL       (0x00000000u)
N
N/*----ED7 Tokens----*/
N#define CSL_DMAX_DEDR_ED7_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED6_MASK           (0x00000040u)
N#define CSL_DMAX_DEDR_ED6_SHIFT          (0x00000006u)
N#define CSL_DMAX_DEDR_ED6_RESETVAL       (0x00000000u)
N
N/*----ED6 Tokens----*/
N#define CSL_DMAX_DEDR_ED6_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED5_MASK           (0x00000020u)
N#define CSL_DMAX_DEDR_ED5_SHIFT          (0x00000005u)
N#define CSL_DMAX_DEDR_ED5_RESETVAL       (0x00000000u)
N
N/*----ED5 Tokens----*/
N#define CSL_DMAX_DEDR_ED5_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED4_MASK           (0x00000010u)
N#define CSL_DMAX_DEDR_ED4_SHIFT          (0x00000004u)
N#define CSL_DMAX_DEDR_ED4_RESETVAL       (0x00000000u)
N
N/*----ED4 Tokens----*/
N#define CSL_DMAX_DEDR_ED4_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED3_MASK           (0x00000008u)
N#define CSL_DMAX_DEDR_ED3_SHIFT          (0x00000003u)
N#define CSL_DMAX_DEDR_ED3_RESETVAL       (0x00000000u)
N
N/*----ED3 Tokens----*/
N#define CSL_DMAX_DEDR_ED3_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED2_MASK           (0x00000004u)
N#define CSL_DMAX_DEDR_ED2_SHIFT          (0x00000002u)
N#define CSL_DMAX_DEDR_ED2_RESETVAL       (0x00000000u)
N
N/*----ED2 Tokens----*/
N#define CSL_DMAX_DEDR_ED2_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED1_MASK           (0x00000002u)
N#define CSL_DMAX_DEDR_ED1_SHIFT          (0x00000001u)
N#define CSL_DMAX_DEDR_ED1_RESETVAL       (0x00000000u)
N
N/*----ED1 Tokens----*/
N#define CSL_DMAX_DEDR_ED1_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_ED0_MASK           (0x00000001u)
N#define CSL_DMAX_DEDR_ED0_SHIFT          (0x00000000u)
N#define CSL_DMAX_DEDR_ED0_RESETVAL       (0x00000000u)
N
N/*----ED0 Tokens----*/
N#define CSL_DMAX_DEDR_ED0_DISABLE        (0x00000001u)
N
N#define CSL_DMAX_DEDR_RESETVAL           (0x00000000u)
N
N/* DEHPR */
N
N#define CSL_DMAX_DEHPR_EHP31_MASK        (0x80000000u)
N#define CSL_DMAX_DEHPR_EHP31_SHIFT       (0x0000001Fu)
N#define CSL_DMAX_DEHPR_EHP31_RESETVAL    (0x00000000u)
N
N/*----EHP31 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP31_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP30_MASK        (0x40000000u)
N#define CSL_DMAX_DEHPR_EHP30_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_DEHPR_EHP30_RESETVAL    (0x00000000u)
N
N/*----EHP30 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP30_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP29_MASK        (0x20000000u)
N#define CSL_DMAX_DEHPR_EHP29_SHIFT       (0x0000001Du)
N#define CSL_DMAX_DEHPR_EHP29_RESETVAL    (0x00000000u)
N
N/*----EHP29 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP29_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP28_MASK        (0x10000000u)
N#define CSL_DMAX_DEHPR_EHP28_SHIFT       (0x0000001Cu)
N#define CSL_DMAX_DEHPR_EHP28_RESETVAL    (0x00000000u)
N
N/*----EHP28 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP28_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP27_MASK        (0x08000000u)
N#define CSL_DMAX_DEHPR_EHP27_SHIFT       (0x0000001Bu)
N#define CSL_DMAX_DEHPR_EHP27_RESETVAL    (0x00000000u)
N
N/*----EHP27 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP27_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP26_MASK        (0x04000000u)
N#define CSL_DMAX_DEHPR_EHP26_SHIFT       (0x0000001Au)
N#define CSL_DMAX_DEHPR_EHP26_RESETVAL    (0x00000000u)
N
N/*----EHP26 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP26_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP24_MASK        (0x01000000u)
N#define CSL_DMAX_DEHPR_EHP24_SHIFT       (0x00000018u)
N#define CSL_DMAX_DEHPR_EHP24_RESETVAL    (0x00000000u)
N
N/*----EHP24 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP24_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP23_MASK        (0x00800000u)
N#define CSL_DMAX_DEHPR_EHP23_SHIFT       (0x00000017u)
N#define CSL_DMAX_DEHPR_EHP23_RESETVAL    (0x00000000u)
N
N/*----EHP23 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP23_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP22_MASK        (0x00400000u)
N#define CSL_DMAX_DEHPR_EHP22_SHIFT       (0x00000016u)
N#define CSL_DMAX_DEHPR_EHP22_RESETVAL    (0x00000000u)
N
N/*----EHP22 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP22_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP21_MASK        (0x00200000u)
N#define CSL_DMAX_DEHPR_EHP21_SHIFT       (0x00000015u)
N#define CSL_DMAX_DEHPR_EHP21_RESETVAL    (0x00000000u)
N
N/*----EHP21 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP21_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP20_MASK        (0x00100000u)
N#define CSL_DMAX_DEHPR_EHP20_SHIFT       (0x00000014u)
N#define CSL_DMAX_DEHPR_EHP20_RESETVAL    (0x00000000u)
N
N/*----EHP20 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP20_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP19_MASK        (0x00080000u)
N#define CSL_DMAX_DEHPR_EHP19_SHIFT       (0x00000013u)
N#define CSL_DMAX_DEHPR_EHP19_RESETVAL    (0x00000000u)
N
N/*----EHP19 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP19_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP18_MASK        (0x00040000u)
N#define CSL_DMAX_DEHPR_EHP18_SHIFT       (0x00000012u)
N#define CSL_DMAX_DEHPR_EHP18_RESETVAL    (0x00000000u)
N
N/*----EHP18 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP18_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP17_MASK        (0x00020000u)
N#define CSL_DMAX_DEHPR_EHP17_SHIFT       (0x00000011u)
N#define CSL_DMAX_DEHPR_EHP17_RESETVAL    (0x00000000u)
N
N/*----EHP17 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP17_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP16_MASK        (0x00010000u)
N#define CSL_DMAX_DEHPR_EHP16_SHIFT       (0x00000010u)
N#define CSL_DMAX_DEHPR_EHP16_RESETVAL    (0x00000000u)
N
N/*----EHP16 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP16_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP15_MASK        (0x00008000u)
N#define CSL_DMAX_DEHPR_EHP15_SHIFT       (0x0000000Fu)
N#define CSL_DMAX_DEHPR_EHP15_RESETVAL    (0x00000000u)
N
N/*----EHP15 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP15_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP14_MASK        (0x00004000u)
N#define CSL_DMAX_DEHPR_EHP14_SHIFT       (0x0000000Eu)
N#define CSL_DMAX_DEHPR_EHP14_RESETVAL    (0x00000000u)
N
N/*----EHP14 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP14_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP13_MASK        (0x00002000u)
N#define CSL_DMAX_DEHPR_EHP13_SHIFT       (0x0000000Du)
N#define CSL_DMAX_DEHPR_EHP13_RESETVAL    (0x00000000u)
N
N/*----EHP13 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP13_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP12_MASK        (0x00001000u)
N#define CSL_DMAX_DEHPR_EHP12_SHIFT       (0x0000000Cu)
N#define CSL_DMAX_DEHPR_EHP12_RESETVAL    (0x00000000u)
N
N/*----EHP12 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP12_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP11_MASK        (0x00000800u)
N#define CSL_DMAX_DEHPR_EHP11_SHIFT       (0x0000000Bu)
N#define CSL_DMAX_DEHPR_EHP11_RESETVAL    (0x00000000u)
N
N/*----EHP11 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP11_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP10_MASK        (0x00000400u)
N#define CSL_DMAX_DEHPR_EHP10_SHIFT       (0x0000000Au)
N#define CSL_DMAX_DEHPR_EHP10_RESETVAL    (0x00000000u)
N
N/*----EHP10 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP10_SET         (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP9_MASK         (0x00000200u)
N#define CSL_DMAX_DEHPR_EHP9_SHIFT        (0x00000009u)
N#define CSL_DMAX_DEHPR_EHP9_RESETVAL     (0x00000000u)
N
N/*----EHP9 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP9_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP8_MASK         (0x00000100u)
N#define CSL_DMAX_DEHPR_EHP8_SHIFT        (0x00000008u)
N#define CSL_DMAX_DEHPR_EHP8_RESETVAL     (0x00000000u)
N
N/*----EHP8 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP8_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP7_MASK         (0x00000080u)
N#define CSL_DMAX_DEHPR_EHP7_SHIFT        (0x00000007u)
N#define CSL_DMAX_DEHPR_EHP7_RESETVAL     (0x00000000u)
N
N/*----EHP7 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP7_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP6_MASK         (0x00000040u)
N#define CSL_DMAX_DEHPR_EHP6_SHIFT        (0x00000006u)
N#define CSL_DMAX_DEHPR_EHP6_RESETVAL     (0x00000000u)
N
N/*----EHP6 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP6_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP5_MASK         (0x00000020u)
N#define CSL_DMAX_DEHPR_EHP5_SHIFT        (0x00000005u)
N#define CSL_DMAX_DEHPR_EHP5_RESETVAL     (0x00000000u)
N
N/*----EHP5 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP5_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP4_MASK         (0x00000010u)
N#define CSL_DMAX_DEHPR_EHP4_SHIFT        (0x00000004u)
N#define CSL_DMAX_DEHPR_EHP4_RESETVAL     (0x00000000u)
N
N/*----EHP4 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP4_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP3_MASK         (0x00000008u)
N#define CSL_DMAX_DEHPR_EHP3_SHIFT        (0x00000003u)
N#define CSL_DMAX_DEHPR_EHP3_RESETVAL     (0x00000000u)
N
N/*----EHP3 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP3_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP2_MASK         (0x00000004u)
N#define CSL_DMAX_DEHPR_EHP2_SHIFT        (0x00000002u)
N#define CSL_DMAX_DEHPR_EHP2_RESETVAL     (0x00000000u)
N
N/*----EHP2 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP2_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP1_MASK         (0x00000002u)
N#define CSL_DMAX_DEHPR_EHP1_SHIFT        (0x00000001u)
N#define CSL_DMAX_DEHPR_EHP1_RESETVAL     (0x00000000u)
N
N/*----EHP1 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP1_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_EHP0_MASK         (0x00000001u)
N#define CSL_DMAX_DEHPR_EHP0_SHIFT        (0x00000000u)
N#define CSL_DMAX_DEHPR_EHP0_RESETVAL     (0x00000000u)
N
N/*----EHP0 Tokens----*/
N#define CSL_DMAX_DEHPR_EHP0_SET          (0x00000001u)
N
N#define CSL_DMAX_DEHPR_RESETVAL          (0x00000000u)
N
N/* DELPR */
N
N#define CSL_DMAX_DELPR_ELP31_MASK        (0x80000000u)
N#define CSL_DMAX_DELPR_ELP31_SHIFT       (0x0000001Fu)
N#define CSL_DMAX_DELPR_ELP31_RESETVAL    (0x00000000u)
N
N/*----ELP31 Tokens----*/
N#define CSL_DMAX_DELPR_ELP31_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP30_MASK        (0x40000000u)
N#define CSL_DMAX_DELPR_ELP30_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_DELPR_ELP30_RESETVAL    (0x00000000u)
N
N/*----ELP30 Tokens----*/
N#define CSL_DMAX_DELPR_ELP30_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP29_MASK        (0x20000000u)
N#define CSL_DMAX_DELPR_ELP29_SHIFT       (0x0000001Du)
N#define CSL_DMAX_DELPR_ELP29_RESETVAL    (0x00000000u)
N
N/*----ELP29 Tokens----*/
N#define CSL_DMAX_DELPR_ELP29_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP28_MASK        (0x10000000u)
N#define CSL_DMAX_DELPR_ELP28_SHIFT       (0x0000001Cu)
N#define CSL_DMAX_DELPR_ELP28_RESETVAL    (0x00000000u)
N
N/*----ELP28 Tokens----*/
N#define CSL_DMAX_DELPR_ELP28_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP27_MASK        (0x08000000u)
N#define CSL_DMAX_DELPR_ELP27_SHIFT       (0x0000001Bu)
N#define CSL_DMAX_DELPR_ELP27_RESETVAL    (0x00000000u)
N
N/*----ELP27 Tokens----*/
N#define CSL_DMAX_DELPR_ELP27_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP26_MASK        (0x04000000u)
N#define CSL_DMAX_DELPR_ELP26_SHIFT       (0x0000001Au)
N#define CSL_DMAX_DELPR_ELP26_RESETVAL    (0x00000000u)
N
N/*----ELP26 Tokens----*/
N#define CSL_DMAX_DELPR_ELP26_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP24_MASK        (0x01000000u)
N#define CSL_DMAX_DELPR_ELP24_SHIFT       (0x00000018u)
N#define CSL_DMAX_DELPR_ELP24_RESETVAL    (0x00000000u)
N
N/*----ELP24 Tokens----*/
N#define CSL_DMAX_DELPR_ELP24_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP23_MASK        (0x00800000u)
N#define CSL_DMAX_DELPR_ELP23_SHIFT       (0x00000017u)
N#define CSL_DMAX_DELPR_ELP23_RESETVAL    (0x00000000u)
N
N/*----ELP23 Tokens----*/
N#define CSL_DMAX_DELPR_ELP23_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP22_MASK        (0x00400000u)
N#define CSL_DMAX_DELPR_ELP22_SHIFT       (0x00000016u)
N#define CSL_DMAX_DELPR_ELP22_RESETVAL    (0x00000000u)
N
N/*----ELP22 Tokens----*/
N#define CSL_DMAX_DELPR_ELP22_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP21_MASK        (0x00200000u)
N#define CSL_DMAX_DELPR_ELP21_SHIFT       (0x00000015u)
N#define CSL_DMAX_DELPR_ELP21_RESETVAL    (0x00000000u)
N
N/*----ELP21 Tokens----*/
N#define CSL_DMAX_DELPR_ELP21_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP20_MASK        (0x00100000u)
N#define CSL_DMAX_DELPR_ELP20_SHIFT       (0x00000014u)
N#define CSL_DMAX_DELPR_ELP20_RESETVAL    (0x00000000u)
N
N/*----ELP20 Tokens----*/
N#define CSL_DMAX_DELPR_ELP20_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP19_MASK        (0x00080000u)
N#define CSL_DMAX_DELPR_ELP19_SHIFT       (0x00000013u)
N#define CSL_DMAX_DELPR_ELP19_RESETVAL    (0x00000000u)
N
N/*----ELP19 Tokens----*/
N#define CSL_DMAX_DELPR_ELP19_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP18_MASK        (0x00040000u)
N#define CSL_DMAX_DELPR_ELP18_SHIFT       (0x00000012u)
N#define CSL_DMAX_DELPR_ELP18_RESETVAL    (0x00000000u)
N
N/*----ELP18 Tokens----*/
N#define CSL_DMAX_DELPR_ELP18_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP17_MASK        (0x00020000u)
N#define CSL_DMAX_DELPR_ELP17_SHIFT       (0x00000011u)
N#define CSL_DMAX_DELPR_ELP17_RESETVAL    (0x00000000u)
N
N/*----ELP17 Tokens----*/
N#define CSL_DMAX_DELPR_ELP17_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP16_MASK        (0x00010000u)
N#define CSL_DMAX_DELPR_ELP16_SHIFT       (0x00000010u)
N#define CSL_DMAX_DELPR_ELP16_RESETVAL    (0x00000000u)
N
N/*----ELP16 Tokens----*/
N#define CSL_DMAX_DELPR_ELP16_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP15_MASK        (0x00008000u)
N#define CSL_DMAX_DELPR_ELP15_SHIFT       (0x0000000Fu)
N#define CSL_DMAX_DELPR_ELP15_RESETVAL    (0x00000000u)
N
N/*----ELP15 Tokens----*/
N#define CSL_DMAX_DELPR_ELP15_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP14_MASK        (0x00004000u)
N#define CSL_DMAX_DELPR_ELP14_SHIFT       (0x0000000Eu)
N#define CSL_DMAX_DELPR_ELP14_RESETVAL    (0x00000000u)
N
N/*----ELP14 Tokens----*/
N#define CSL_DMAX_DELPR_ELP14_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP13_MASK        (0x00002000u)
N#define CSL_DMAX_DELPR_ELP13_SHIFT       (0x0000000Du)
N#define CSL_DMAX_DELPR_ELP13_RESETVAL    (0x00000000u)
N
N/*----ELP13 Tokens----*/
N#define CSL_DMAX_DELPR_ELP13_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP12_MASK        (0x00001000u)
N#define CSL_DMAX_DELPR_ELP12_SHIFT       (0x0000000Cu)
N#define CSL_DMAX_DELPR_ELP12_RESETVAL    (0x00000000u)
N
N/*----ELP12 Tokens----*/
N#define CSL_DMAX_DELPR_ELP12_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP11_MASK        (0x00000800u)
N#define CSL_DMAX_DELPR_ELP11_SHIFT       (0x0000000Bu)
N#define CSL_DMAX_DELPR_ELP11_RESETVAL    (0x00000000u)
N
N/*----ELP11 Tokens----*/
N#define CSL_DMAX_DELPR_ELP11_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP10_MASK        (0x00000400u)
N#define CSL_DMAX_DELPR_ELP10_SHIFT       (0x0000000Au)
N#define CSL_DMAX_DELPR_ELP10_RESETVAL    (0x00000000u)
N
N/*----ELP10 Tokens----*/
N#define CSL_DMAX_DELPR_ELP10_SET         (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP9_MASK         (0x00000200u)
N#define CSL_DMAX_DELPR_ELP9_SHIFT        (0x00000009u)
N#define CSL_DMAX_DELPR_ELP9_RESETVAL     (0x00000000u)
N
N/*----ELP9 Tokens----*/
N#define CSL_DMAX_DELPR_ELP9_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP8_MASK         (0x00000100u)
N#define CSL_DMAX_DELPR_ELP8_SHIFT        (0x00000008u)
N#define CSL_DMAX_DELPR_ELP8_RESETVAL     (0x00000000u)
N
N/*----ELP8 Tokens----*/
N#define CSL_DMAX_DELPR_ELP8_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP7_MASK         (0x00000080u)
N#define CSL_DMAX_DELPR_ELP7_SHIFT        (0x00000007u)
N#define CSL_DMAX_DELPR_ELP7_RESETVAL     (0x00000000u)
N
N/*----ELP7 Tokens----*/
N#define CSL_DMAX_DELPR_ELP7_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP6_MASK         (0x00000040u)
N#define CSL_DMAX_DELPR_ELP6_SHIFT        (0x00000006u)
N#define CSL_DMAX_DELPR_ELP6_RESETVAL     (0x00000000u)
N
N/*----ELP6 Tokens----*/
N#define CSL_DMAX_DELPR_ELP6_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP5_MASK         (0x00000020u)
N#define CSL_DMAX_DELPR_ELP5_SHIFT        (0x00000005u)
N#define CSL_DMAX_DELPR_ELP5_RESETVAL     (0x00000000u)
N
N/*----ELP5 Tokens----*/
N#define CSL_DMAX_DELPR_ELP5_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP4_MASK         (0x00000010u)
N#define CSL_DMAX_DELPR_ELP4_SHIFT        (0x00000004u)
N#define CSL_DMAX_DELPR_ELP4_RESETVAL     (0x00000000u)
N
N/*----ELP4 Tokens----*/
N#define CSL_DMAX_DELPR_ELP4_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP3_MASK         (0x00000008u)
N#define CSL_DMAX_DELPR_ELP3_SHIFT        (0x00000003u)
N#define CSL_DMAX_DELPR_ELP3_RESETVAL     (0x00000000u)
N
N/*----ELP3 Tokens----*/
N#define CSL_DMAX_DELPR_ELP3_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP2_MASK         (0x00000004u)
N#define CSL_DMAX_DELPR_ELP2_SHIFT        (0x00000002u)
N#define CSL_DMAX_DELPR_ELP2_RESETVAL     (0x00000000u)
N
N/*----ELP2 Tokens----*/
N#define CSL_DMAX_DELPR_ELP2_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP1_MASK         (0x00000002u)
N#define CSL_DMAX_DELPR_ELP1_SHIFT        (0x00000001u)
N#define CSL_DMAX_DELPR_ELP1_RESETVAL     (0x00000000u)
N
N/*----ELP1 Tokens----*/
N#define CSL_DMAX_DELPR_ELP1_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_ELP0_MASK         (0x00000001u)
N#define CSL_DMAX_DELPR_ELP0_SHIFT        (0x00000000u)
N#define CSL_DMAX_DELPR_ELP0_RESETVAL     (0x00000000u)
N
N/*----ELP0 Tokens----*/
N#define CSL_DMAX_DELPR_ELP0_SET          (0x00000001u)
N
N#define CSL_DMAX_DELPR_RESETVAL          (0x00000000u)
N
N/* DEFR */
N
N#define CSL_DMAX_DEFR_EF31_MASK          (0x80000000u)
N#define CSL_DMAX_DEFR_EF31_SHIFT         (0x0000001Fu)
N#define CSL_DMAX_DEFR_EF31_RESETVAL      (0x00000000u)
N
N/*----EF31 Tokens----*/
N#define CSL_DMAX_DEFR_EF31_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF30_MASK          (0x40000000u)
N#define CSL_DMAX_DEFR_EF30_SHIFT         (0x0000001Eu)
N#define CSL_DMAX_DEFR_EF30_RESETVAL      (0x00000000u)
N
N/*----EF30 Tokens----*/
N#define CSL_DMAX_DEFR_EF30_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF29_MASK          (0x20000000u)
N#define CSL_DMAX_DEFR_EF29_SHIFT         (0x0000001Du)
N#define CSL_DMAX_DEFR_EF29_RESETVAL      (0x00000000u)
N
N/*----EF29 Tokens----*/
N#define CSL_DMAX_DEFR_EF29_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF28_MASK          (0x10000000u)
N#define CSL_DMAX_DEFR_EF28_SHIFT         (0x0000001Cu)
N#define CSL_DMAX_DEFR_EF28_RESETVAL      (0x00000000u)
N
N/*----EF28 Tokens----*/
N#define CSL_DMAX_DEFR_EF28_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF27_MASK          (0x08000000u)
N#define CSL_DMAX_DEFR_EF27_SHIFT         (0x0000001Bu)
N#define CSL_DMAX_DEFR_EF27_RESETVAL      (0x00000000u)
N
N/*----EF27 Tokens----*/
N#define CSL_DMAX_DEFR_EF27_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF26_MASK          (0x04000000u)
N#define CSL_DMAX_DEFR_EF26_SHIFT         (0x0000001Au)
N#define CSL_DMAX_DEFR_EF26_RESETVAL      (0x00000000u)
N
N/*----EF26 Tokens----*/
N#define CSL_DMAX_DEFR_EF26_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF24_MASK          (0x01000000u)
N#define CSL_DMAX_DEFR_EF24_SHIFT         (0x00000018u)
N#define CSL_DMAX_DEFR_EF24_RESETVAL      (0x00000000u)
N
N/*----EF24 Tokens----*/
N#define CSL_DMAX_DEFR_EF24_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF23_MASK          (0x00800000u)
N#define CSL_DMAX_DEFR_EF23_SHIFT         (0x00000017u)
N#define CSL_DMAX_DEFR_EF23_RESETVAL      (0x00000000u)
N
N/*----EF23 Tokens----*/
N#define CSL_DMAX_DEFR_EF23_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF22_MASK          (0x00400000u)
N#define CSL_DMAX_DEFR_EF22_SHIFT         (0x00000016u)
N#define CSL_DMAX_DEFR_EF22_RESETVAL      (0x00000000u)
N
N/*----EF22 Tokens----*/
N#define CSL_DMAX_DEFR_EF22_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF21_MASK          (0x00200000u)
N#define CSL_DMAX_DEFR_EF21_SHIFT         (0x00000015u)
N#define CSL_DMAX_DEFR_EF21_RESETVAL      (0x00000000u)
N
N/*----EF21 Tokens----*/
N#define CSL_DMAX_DEFR_EF21_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF20_MASK          (0x00100000u)
N#define CSL_DMAX_DEFR_EF20_SHIFT         (0x00000014u)
N#define CSL_DMAX_DEFR_EF20_RESETVAL      (0x00000000u)
N
N/*----EF20 Tokens----*/
N#define CSL_DMAX_DEFR_EF20_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF19_MASK          (0x00080000u)
N#define CSL_DMAX_DEFR_EF19_SHIFT         (0x00000013u)
N#define CSL_DMAX_DEFR_EF19_RESETVAL      (0x00000000u)
N
N/*----EF19 Tokens----*/
N#define CSL_DMAX_DEFR_EF19_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF18_MASK          (0x00040000u)
N#define CSL_DMAX_DEFR_EF18_SHIFT         (0x00000012u)
N#define CSL_DMAX_DEFR_EF18_RESETVAL      (0x00000000u)
N
N/*----EF18 Tokens----*/
N#define CSL_DMAX_DEFR_EF18_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF17_MASK          (0x00020000u)
N#define CSL_DMAX_DEFR_EF17_SHIFT         (0x00000011u)
N#define CSL_DMAX_DEFR_EF17_RESETVAL      (0x00000000u)
N
N/*----EF17 Tokens----*/
N#define CSL_DMAX_DEFR_EF17_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF16_MASK          (0x00010000u)
N#define CSL_DMAX_DEFR_EF16_SHIFT         (0x00000010u)
N#define CSL_DMAX_DEFR_EF16_RESETVAL      (0x00000000u)
N
N/*----EF16 Tokens----*/
N#define CSL_DMAX_DEFR_EF16_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF15_MASK          (0x00008000u)
N#define CSL_DMAX_DEFR_EF15_SHIFT         (0x0000000Fu)
N#define CSL_DMAX_DEFR_EF15_RESETVAL      (0x00000000u)
N
N/*----EF15 Tokens----*/
N#define CSL_DMAX_DEFR_EF15_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF14_MASK          (0x00004000u)
N#define CSL_DMAX_DEFR_EF14_SHIFT         (0x0000000Eu)
N#define CSL_DMAX_DEFR_EF14_RESETVAL      (0x00000000u)
N
N/*----EF14 Tokens----*/
N#define CSL_DMAX_DEFR_EF14_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF13_MASK          (0x00002000u)
N#define CSL_DMAX_DEFR_EF13_SHIFT         (0x0000000Du)
N#define CSL_DMAX_DEFR_EF13_RESETVAL      (0x00000000u)
N
N/*----EF13 Tokens----*/
N#define CSL_DMAX_DEFR_EF13_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF12_MASK          (0x00001000u)
N#define CSL_DMAX_DEFR_EF12_SHIFT         (0x0000000Cu)
N#define CSL_DMAX_DEFR_EF12_RESETVAL      (0x00000000u)
N
N/*----EF12 Tokens----*/
N#define CSL_DMAX_DEFR_EF12_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF11_MASK          (0x00000800u)
N#define CSL_DMAX_DEFR_EF11_SHIFT         (0x0000000Bu)
N#define CSL_DMAX_DEFR_EF11_RESETVAL      (0x00000000u)
N
N/*----EF11 Tokens----*/
N#define CSL_DMAX_DEFR_EF11_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF10_MASK          (0x00000400u)
N#define CSL_DMAX_DEFR_EF10_SHIFT         (0x0000000Au)
N#define CSL_DMAX_DEFR_EF10_RESETVAL      (0x00000000u)
N
N/*----EF10 Tokens----*/
N#define CSL_DMAX_DEFR_EF10_CLEAR         (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF9_MASK           (0x00000200u)
N#define CSL_DMAX_DEFR_EF9_SHIFT          (0x00000009u)
N#define CSL_DMAX_DEFR_EF9_RESETVAL       (0x00000000u)
N
N/*----EF9 Tokens----*/
N#define CSL_DMAX_DEFR_EF9_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF8_MASK           (0x00000100u)
N#define CSL_DMAX_DEFR_EF8_SHIFT          (0x00000008u)
N#define CSL_DMAX_DEFR_EF8_RESETVAL       (0x00000000u)
N
N/*----EF8 Tokens----*/
N#define CSL_DMAX_DEFR_EF8_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF7_MASK           (0x00000080u)
N#define CSL_DMAX_DEFR_EF7_SHIFT          (0x00000007u)
N#define CSL_DMAX_DEFR_EF7_RESETVAL       (0x00000000u)
N
N/*----EF7 Tokens----*/
N#define CSL_DMAX_DEFR_EF7_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF6_MASK           (0x00000040u)
N#define CSL_DMAX_DEFR_EF6_SHIFT          (0x00000006u)
N#define CSL_DMAX_DEFR_EF6_RESETVAL       (0x00000000u)
N
N/*----EF6 Tokens----*/
N#define CSL_DMAX_DEFR_EF6_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF5_MASK           (0x00000020u)
N#define CSL_DMAX_DEFR_EF5_SHIFT          (0x00000005u)
N#define CSL_DMAX_DEFR_EF5_RESETVAL       (0x00000000u)
N
N/*----EF5 Tokens----*/
N#define CSL_DMAX_DEFR_EF5_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF4_MASK           (0x00000010u)
N#define CSL_DMAX_DEFR_EF4_SHIFT          (0x00000004u)
N#define CSL_DMAX_DEFR_EF4_RESETVAL       (0x00000000u)
N
N/*----EF4 Tokens----*/
N#define CSL_DMAX_DEFR_EF4_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF3_MASK           (0x00000008u)
N#define CSL_DMAX_DEFR_EF3_SHIFT          (0x00000003u)
N#define CSL_DMAX_DEFR_EF3_RESETVAL       (0x00000000u)
N
N/*----EF3 Tokens----*/
N#define CSL_DMAX_DEFR_EF3_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF2_MASK           (0x00000004u)
N#define CSL_DMAX_DEFR_EF2_SHIFT          (0x00000002u)
N#define CSL_DMAX_DEFR_EF2_RESETVAL       (0x00000000u)
N
N/*----EF2 Tokens----*/
N#define CSL_DMAX_DEFR_EF2_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF1_MASK           (0x00000002u)
N#define CSL_DMAX_DEFR_EF1_SHIFT          (0x00000001u)
N#define CSL_DMAX_DEFR_EF1_RESETVAL       (0x00000000u)
N
N/*----EF1 Tokens----*/
N#define CSL_DMAX_DEFR_EF1_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_EF0_MASK           (0x00000001u)
N#define CSL_DMAX_DEFR_EF0_SHIFT          (0x00000000u)
N#define CSL_DMAX_DEFR_EF0_RESETVAL       (0x00000000u)
N
N/*----EF0 Tokens----*/
N#define CSL_DMAX_DEFR_EF0_CLEAR          (0x00000001u)
N
N#define CSL_DMAX_DEFR_RESETVAL           (0x00000000u)
N
N/* DFSR0 */
N
N#define CSL_DMAX_DFSR0_FSC7_MASK         (0x00000080u)
N#define CSL_DMAX_DFSR0_FSC7_SHIFT        (0x00000007u)
N#define CSL_DMAX_DFSR0_FSC7_RESETVAL     (0x00000000u)
N
N/*----FSC7 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC7_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC6_MASK         (0x00000040u)
N#define CSL_DMAX_DFSR0_FSC6_SHIFT        (0x00000006u)
N#define CSL_DMAX_DFSR0_FSC6_RESETVAL     (0x00000000u)
N
N/*----FSC6 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC6_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC5_MASK         (0x00000020u)
N#define CSL_DMAX_DFSR0_FSC5_SHIFT        (0x00000005u)
N#define CSL_DMAX_DFSR0_FSC5_RESETVAL     (0x00000000u)
N
N/*----FSC5 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC5_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC4_MASK         (0x00000010u)
N#define CSL_DMAX_DFSR0_FSC4_SHIFT        (0x00000004u)
N#define CSL_DMAX_DFSR0_FSC4_RESETVAL     (0x00000000u)
N
N/*----FSC4 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC4_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC3_MASK         (0x00000008u)
N#define CSL_DMAX_DFSR0_FSC3_SHIFT        (0x00000003u)
N#define CSL_DMAX_DFSR0_FSC3_RESETVAL     (0x00000000u)
N
N/*----FSC3 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC3_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC2_MASK         (0x00000004u)
N#define CSL_DMAX_DFSR0_FSC2_SHIFT        (0x00000002u)
N#define CSL_DMAX_DFSR0_FSC2_RESETVAL     (0x00000000u)
N
N/*----FSC2 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC2_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC1_MASK         (0x00000002u)
N#define CSL_DMAX_DFSR0_FSC1_SHIFT        (0x00000001u)
N#define CSL_DMAX_DFSR0_FSC1_RESETVAL     (0x00000000u)
N
N/*----FSC1 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC1_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_FSC0_MASK         (0x00000001u)
N#define CSL_DMAX_DFSR0_FSC0_SHIFT        (0x00000000u)
N#define CSL_DMAX_DFSR0_FSC0_RESETVAL     (0x00000000u)
N
N/*----FSC0 Tokens----*/
N#define CSL_DMAX_DFSR0_FSC0_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR0_RESETVAL          (0x00000000u)
N
N/* DFSR1 */
N
N#define CSL_DMAX_DFSR1_FSC15_MASK        (0x00000080u)
N#define CSL_DMAX_DFSR1_FSC15_SHIFT       (0x00000007u)
N#define CSL_DMAX_DFSR1_FSC15_RESETVAL    (0x00000000u)
N
N/*----FSC15 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC15_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC14_MASK        (0x00000040u)
N#define CSL_DMAX_DFSR1_FSC14_SHIFT       (0x00000006u)
N#define CSL_DMAX_DFSR1_FSC14_RESETVAL    (0x00000000u)
N
N/*----FSC14 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC14_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC13_MASK        (0x00000020u)
N#define CSL_DMAX_DFSR1_FSC13_SHIFT       (0x00000005u)
N#define CSL_DMAX_DFSR1_FSC13_RESETVAL    (0x00000000u)
N
N/*----FSC13 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC13_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC12_MASK        (0x00000010u)
N#define CSL_DMAX_DFSR1_FSC12_SHIFT       (0x00000004u)
N#define CSL_DMAX_DFSR1_FSC12_RESETVAL    (0x00000000u)
N
N/*----FSC12 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC12_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC11_MASK        (0x00000008u)
N#define CSL_DMAX_DFSR1_FSC11_SHIFT       (0x00000003u)
N#define CSL_DMAX_DFSR1_FSC11_RESETVAL    (0x00000000u)
N
N/*----FSC11 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC11_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC10_MASK        (0x00000004u)
N#define CSL_DMAX_DFSR1_FSC10_SHIFT       (0x00000002u)
N#define CSL_DMAX_DFSR1_FSC10_RESETVAL    (0x00000000u)
N
N/*----FSC10 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC10_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC9_MASK         (0x00000002u)
N#define CSL_DMAX_DFSR1_FSC9_SHIFT        (0x00000001u)
N#define CSL_DMAX_DFSR1_FSC9_RESETVAL     (0x00000000u)
N
N/*----FSC9 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC9_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR1_FSC8_MASK         (0x00000001u)
N#define CSL_DMAX_DFSR1_FSC8_SHIFT        (0x00000000u)
N#define CSL_DMAX_DFSR1_FSC8_RESETVAL     (0x00000000u)
N
N/*----FSC8 Tokens----*/
N#define CSL_DMAX_DFSR1_FSC8_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DFSR1_RESETVAL          (0x00000000u)
N
N/* DTCR0 */
N
N#define CSL_DMAX_DTCR0_TCC7_MASK         (0x00000080u)
N#define CSL_DMAX_DTCR0_TCC7_SHIFT        (0x00000007u)
N#define CSL_DMAX_DTCR0_TCC7_RESETVAL     (0x00000000u)
N
N/*----TCC7 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC7_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC6_MASK         (0x00000040u)
N#define CSL_DMAX_DTCR0_TCC6_SHIFT        (0x00000006u)
N#define CSL_DMAX_DTCR0_TCC6_RESETVAL     (0x00000000u)
N
N/*----TCC6 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC6_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC5_MASK         (0x00000020u)
N#define CSL_DMAX_DTCR0_TCC5_SHIFT        (0x00000005u)
N#define CSL_DMAX_DTCR0_TCC5_RESETVAL     (0x00000000u)
N
N/*----TCC5 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC5_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC4_MASK         (0x00000010u)
N#define CSL_DMAX_DTCR0_TCC4_SHIFT        (0x00000004u)
N#define CSL_DMAX_DTCR0_TCC4_RESETVAL     (0x00000000u)
N
N/*----TCC4 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC4_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC3_MASK         (0x00000008u)
N#define CSL_DMAX_DTCR0_TCC3_SHIFT        (0x00000003u)
N#define CSL_DMAX_DTCR0_TCC3_RESETVAL     (0x00000000u)
N
N/*----TCC3 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC3_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC2_MASK         (0x00000004u)
N#define CSL_DMAX_DTCR0_TCC2_SHIFT        (0x00000002u)
N#define CSL_DMAX_DTCR0_TCC2_RESETVAL     (0x00000000u)
N
N/*----TCC2 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC2_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC1_MASK         (0x00000002u)
N#define CSL_DMAX_DTCR0_TCC1_SHIFT        (0x00000001u)
N#define CSL_DMAX_DTCR0_TCC1_RESETVAL     (0x00000000u)
N
N/*----TCC1 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC1_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_TCC0_MASK         (0x00000001u)
N#define CSL_DMAX_DTCR0_TCC0_SHIFT        (0x00000000u)
N#define CSL_DMAX_DTCR0_TCC0_RESETVAL     (0x00000000u)
N
N/*----TCC0 Tokens----*/
N#define CSL_DMAX_DTCR0_TCC0_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR0_RESETVAL          (0x00000000u)
N
N/* DTCR1 */
N
N#define CSL_DMAX_DTCR1_TCC15_MASK        (0x00000080u)
N#define CSL_DMAX_DTCR1_TCC15_SHIFT       (0x00000007u)
N#define CSL_DMAX_DTCR1_TCC15_RESETVAL    (0x00000000u)
N
N/*----TCC15 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC15_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC14_MASK        (0x00000040u)
N#define CSL_DMAX_DTCR1_TCC14_SHIFT       (0x00000006u)
N#define CSL_DMAX_DTCR1_TCC14_RESETVAL    (0x00000000u)
N
N/*----TCC14 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC14_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC13_MASK        (0x00000020u)
N#define CSL_DMAX_DTCR1_TCC13_SHIFT       (0x00000005u)
N#define CSL_DMAX_DTCR1_TCC13_RESETVAL    (0x00000000u)
N
N/*----TCC13 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC13_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC12_MASK        (0x00000010u)
N#define CSL_DMAX_DTCR1_TCC12_SHIFT       (0x00000004u)
N#define CSL_DMAX_DTCR1_TCC12_RESETVAL    (0x00000000u)
N
N/*----TCC12 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC12_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC11_MASK        (0x00000008u)
N#define CSL_DMAX_DTCR1_TCC11_SHIFT       (0x00000003u)
N#define CSL_DMAX_DTCR1_TCC11_RESETVAL    (0x00000000u)
N
N/*----TCC11 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC11_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC10_MASK        (0x00000004u)
N#define CSL_DMAX_DTCR1_TCC10_SHIFT       (0x00000002u)
N#define CSL_DMAX_DTCR1_TCC10_RESETVAL    (0x00000000u)
N
N/*----TCC10 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC10_CLEAR       (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC9_MASK         (0x00000002u)
N#define CSL_DMAX_DTCR1_TCC9_SHIFT        (0x00000001u)
N#define CSL_DMAX_DTCR1_TCC9_RESETVAL     (0x00000000u)
N
N/*----TCC9 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC9_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_DTCR1_TCC8_MASK         (0x00000001u)
N#define CSL_DMAX_DTCR1_TCC8_SHIFT        (0x00000000u)
N#define CSL_DMAX_DTCR1_TCC8_RESETVAL     (0x00000000u)
N
N/*----TCC8 Tokens----*/
N#define CSL_DMAX_DTCR1_TCC8_CLEAR        (0x00000001u)
N
N#define CSL_DMAX_CPUINT8_MASK            (0x00000100u)
N#define CSL_DMAX_CPUINT8_SHIFT           (0x00000008u)
N#define CSL_DMAX_CPUINT8_RESETVAL        (0x00000000u)
N
N#define CSL_DMAX_CPUINT7_MASK            (0x00000080u)
N#define CSL_DMAX_CPUINT7_SHIFT           (0x00000007u)
N#define CSL_DMAX_CPUINT7_RESETVAL        (0x00000000u)
N
N#define CSL_DMAX_DTCR1_RESETVAL          (0x00000000u)
N
N/* EVENT0 */
N
N#define CSL_DMAX_EVENT0_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT0_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT0_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT0_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT0_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT0_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT0_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT0_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT0_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT0_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT0_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT0_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT0_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT0_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT0_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT0_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT0_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT0_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT0_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT0_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT0_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT0_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT0_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT0_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT0_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT0_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT0_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT0_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT0_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT0_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT0_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT0_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT0_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT0_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT0_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT0_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT0_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT0_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT0_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT0_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT0_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT0_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT0_WMENAB_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT0_WMENAB_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT0_WMENAB_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_EVENT0_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT0_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT0_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT0_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT0_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT0_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT0_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT0_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT0_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT0_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT0_RESETVAL         (0x00000000u)
N
N/* EVENT1 */
N
N#define CSL_DMAX_EVENT1_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT1_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT1_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT1_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT1_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT1_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT1_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT1_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT1_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT1_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT1_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT1_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT1_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT1_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT1_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT1_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT1_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT1_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT1_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT1_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT1_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT1_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT1_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT1_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT1_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT1_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT1_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT1_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT1_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT1_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT1_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT1_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT1_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT1_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT1_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT1_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT1_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT1_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT1_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT1_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT1_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT1_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT1_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT1_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT1_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT1_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT1_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT1_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT1_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT1_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT1_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT1_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT1_RESETVAL         (0x00000000u)
N
N/* EVENT2 */
N
N#define CSL_DMAX_EVENT2_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT2_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT2_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT2_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT2_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT2_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT2_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT2_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT2_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT2_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT2_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT2_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT2_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT2_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT2_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT2_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT2_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT2_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT2_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT2_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT2_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT2_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT2_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT2_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT2_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT2_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT2_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT2_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT2_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT2_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT2_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT2_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT2_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT2_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT2_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT2_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT2_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT2_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT2_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT2_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT2_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT2_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT2_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT2_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT2_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT2_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT2_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT2_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT2_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT2_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT2_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT2_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT2_RESETVAL         (0x00000000u)
N
N/* EVENT3 */
N
N#define CSL_DMAX_EVENT3_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT3_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT3_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT3_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT3_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT3_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT3_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT3_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT3_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT3_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT3_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT3_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT3_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT3_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT3_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT3_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT3_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT3_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT3_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT3_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT3_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT3_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT3_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT3_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT3_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT3_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT3_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT3_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT3_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT3_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT3_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT3_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT3_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT3_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT3_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT3_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT3_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT3_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT3_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT3_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT3_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT3_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT3_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT3_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT3_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT3_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT3_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT3_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT3_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT3_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT3_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT3_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT3_RESETVAL         (0x00000000u)
N
N/* EVENT4 */
N
N#define CSL_DMAX_EVENT4_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT4_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT4_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT4_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT4_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT4_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT4_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT4_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT4_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT4_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT4_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT4_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT4_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT4_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT4_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT4_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT4_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT4_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT4_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT4_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT4_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT4_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT4_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT4_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT4_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT4_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT4_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT4_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT4_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT4_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT4_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT4_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT4_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT4_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT4_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT4_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT4_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT4_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT4_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT4_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT4_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT4_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT4_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT4_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT4_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT4_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT4_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT4_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT4_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT4_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT4_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT4_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT4_RESETVAL         (0x00000000u)
N
N/* EVENT5 */
N
N#define CSL_DMAX_EVENT5_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT5_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT5_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT5_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT5_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT5_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT5_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT5_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT5_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT5_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT5_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT5_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT5_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT5_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT5_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT5_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT5_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT5_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT5_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT5_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT5_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT5_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT5_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT5_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT5_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT5_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT5_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT5_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT5_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT5_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT5_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT5_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT5_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT5_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT5_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT5_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT5_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT5_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT5_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT5_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT5_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT5_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT5_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT5_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT5_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT5_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT5_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT5_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT5_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT5_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT5_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT5_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT5_RESETVAL         (0x00000000u)
N
N/* EVENT6 */
N
N#define CSL_DMAX_EVENT6_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT6_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT6_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT6_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT6_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT6_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT6_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT6_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT6_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT6_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT6_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT6_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT6_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT6_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT6_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT6_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT6_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT6_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT6_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT6_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT6_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT6_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT6_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT6_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT6_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT6_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT6_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT6_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT6_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT6_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT6_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT6_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT6_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT6_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT6_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT6_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT6_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT6_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT6_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT6_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT6_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT6_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT6_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT6_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT6_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT6_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT6_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT6_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT6_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT6_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT6_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT6_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT6_RESETVAL         (0x00000000u)
N
N/* EVENT7 */
N
N#define CSL_DMAX_EVENT7_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT7_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT7_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT7_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT7_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT7_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT7_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT7_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT7_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT7_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT7_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT7_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT7_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT7_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT7_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT7_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT7_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT7_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT7_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT7_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT7_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT7_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT7_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT7_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT7_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT7_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT7_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT7_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT7_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT7_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT7_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT7_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT7_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT7_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT7_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT7_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT7_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT7_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT7_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT7_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT7_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT7_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT7_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT7_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT7_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT7_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT7_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT7_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT7_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT7_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT7_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT7_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT7_RESETVAL         (0x00000000u)
N
N/* EVENT8 */
N
N#define CSL_DMAX_EVENT8_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT8_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT8_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT8_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT8_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT8_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT8_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT8_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT8_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT8_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT8_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT8_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT8_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT8_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT8_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT8_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT8_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT8_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT8_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT8_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT8_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT8_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT8_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT8_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT8_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT8_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT8_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT8_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT8_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT8_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT8_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT8_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT8_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT8_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT8_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT8_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT8_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT8_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT8_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT8_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT8_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT8_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT8_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT8_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT8_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT8_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT8_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT8_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT8_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT8_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT8_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT8_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT8_RESETVAL         (0x00000000u)
N
N/* EVENT9 */
N
N#define CSL_DMAX_EVENT9_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT9_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT9_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT9_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT9_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT9_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT9_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT9_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT9_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT9_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT9_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT9_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT9_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT9_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT9_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT9_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT9_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT9_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT9_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT9_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT9_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT9_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT9_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT9_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT9_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT9_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT9_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT9_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT9_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT9_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT9_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT9_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT9_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT9_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT9_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT9_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT9_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT9_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT9_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT9_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT9_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT9_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT9_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT9_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT9_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT9_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT9_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT9_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT9_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT9_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT9_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT9_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT9_RESETVAL         (0x00000000u)
N
N/* EVENT10 */
N
N#define CSL_DMAX_EVENT10_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT10_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT10_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT10_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT10_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT10_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT10_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT10_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT10_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT10_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT10_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT10_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT10_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT10_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT10_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT10_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT10_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT10_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT10_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT10_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT10_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT10_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT10_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT10_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT10_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT10_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT10_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT10_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT10_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT10_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT10_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT10_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT10_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT10_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT10_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT10_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT10_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT10_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT10_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT10_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT10_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT10_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT10_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT10_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT10_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT10_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT10_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT10_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT10_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT10_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT10_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT10_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT10_RESETVAL        (0x00000000u)
N
N/* EVENT11 */
N
N#define CSL_DMAX_EVENT11_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT11_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT11_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT11_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT11_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT11_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT11_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT11_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT11_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT11_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT11_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT11_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT11_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT11_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT11_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT11_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT11_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT11_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT11_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT11_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT11_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT11_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT11_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT11_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT11_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT11_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT11_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT11_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT11_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT11_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT11_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT11_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT11_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT11_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT11_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT11_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT11_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT11_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT11_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT11_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT11_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT11_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT11_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT11_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT11_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT11_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT11_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT11_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT11_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT11_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT11_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT11_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT11_RESETVAL        (0x00000000u)
N
N/* EVENT12 */
N
N#define CSL_DMAX_EVENT12_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT12_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT12_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT12_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT12_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT12_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT12_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT12_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT12_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT12_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT12_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT12_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT12_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT12_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT12_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT12_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT12_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT12_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT12_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT12_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT12_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT12_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT12_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT12_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT12_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT12_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT12_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT12_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT12_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT12_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT12_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT12_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT12_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT12_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT12_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT12_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT12_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT12_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT12_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT12_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT12_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT12_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT12_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT12_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT12_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT12_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT12_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT12_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT12_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT12_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT12_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT12_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT12_RESETVAL        (0x00000000u)
N
N/* EVENT13 */
N
N#define CSL_DMAX_EVENT13_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT13_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT13_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT13_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT13_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT13_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT13_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT13_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT13_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT13_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT13_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT13_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT13_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT13_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT13_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT13_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT13_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT13_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT13_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT13_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT13_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT13_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT13_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT13_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT13_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT13_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT13_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT13_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT13_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT13_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT13_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT13_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT13_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT13_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT13_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT13_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT13_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT13_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT13_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT13_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT13_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT13_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT13_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT13_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT13_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT13_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT13_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT13_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT13_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT13_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT13_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT13_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT13_RESETVAL        (0x00000000u)
N
N/* EVENT14 */
N
N#define CSL_DMAX_EVENT14_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT14_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT14_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT14_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT14_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT14_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT14_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT14_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT14_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT14_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT14_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT14_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT14_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT14_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT14_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT14_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT14_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT14_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT14_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT14_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT14_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT14_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT14_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT14_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT14_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT14_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT14_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT14_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT14_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT14_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT14_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT14_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT14_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT14_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT14_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT14_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT14_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT14_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT14_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT14_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT14_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT14_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT14_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT14_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT14_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT14_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT14_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT14_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT14_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT14_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT14_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT14_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT14_RESETVAL        (0x00000000u)
N
N/* EVENT15 */
N
N#define CSL_DMAX_EVENT15_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT15_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT15_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT15_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT15_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT15_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT15_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT15_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT15_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT15_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT15_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT15_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT15_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT15_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT15_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT15_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT15_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT15_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT15_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT15_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT15_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT15_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT15_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT15_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT15_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT15_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT15_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT15_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT15_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT15_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT15_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT15_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT15_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT15_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT15_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT15_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT15_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT15_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT15_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT15_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT15_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT15_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT15_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT15_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT15_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT15_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT15_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT15_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT15_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT15_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT15_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT15_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT15_RESETVAL        (0x00000000u)
N
N/* EVENT16 */
N
N#define CSL_DMAX_EVENT16_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT16_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT16_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT16_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT16_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT16_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT16_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT16_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT16_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT16_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT16_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT16_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT16_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT16_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT16_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT16_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT16_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT16_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT16_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT16_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT16_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT16_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT16_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT16_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT16_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT16_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT16_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT16_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT16_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT16_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT16_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT16_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT16_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT16_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT16_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT16_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT16_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT16_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT16_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT16_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT16_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT16_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT16_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT16_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT16_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT16_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT16_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT16_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT16_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT16_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT16_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT16_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT16_RESETVAL        (0x00000000u)
N
N/* EVENT17 */
N
N#define CSL_DMAX_EVENT17_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT17_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT17_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT17_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT17_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT17_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT17_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT17_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT17_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT17_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT17_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT17_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT17_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT17_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT17_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT17_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT17_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT17_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT17_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT17_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT17_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT17_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT17_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT17_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT17_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT17_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT17_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT17_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT17_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT17_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT17_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT17_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT17_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT17_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT17_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT17_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT17_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT17_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT17_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT17_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT17_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT17_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT17_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT17_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT17_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT17_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT17_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT17_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT17_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT17_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT17_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT17_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT17_RESETVAL        (0x00000000u)
N
N/* EVENT18 */
N
N#define CSL_DMAX_EVENT18_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT18_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT18_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT18_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT18_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT18_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT18_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT18_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT18_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT18_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT18_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT18_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT18_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT18_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT18_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT18_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT18_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT18_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT18_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT18_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT18_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT18_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT18_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT18_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT18_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT18_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT18_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT18_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT18_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT18_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT18_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT18_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT18_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT18_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT18_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT18_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT18_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT18_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT18_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT18_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT18_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT18_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT18_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT18_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT18_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT18_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT18_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT18_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT18_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT18_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT18_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT18_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT18_RESETVAL        (0x00000000u)
N
N/* EVENT19 */
N
N#define CSL_DMAX_EVENT19_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT19_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT19_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT19_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT19_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT19_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT19_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT19_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT19_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT19_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT19_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT19_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT19_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT19_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT19_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT19_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT19_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT19_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT19_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT19_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT19_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT19_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT19_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT19_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT19_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT19_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT19_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT19_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT19_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT19_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT19_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT19_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT19_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT19_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT19_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT19_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT19_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT19_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT19_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT19_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT19_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT19_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT19_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT19_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT19_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT19_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT19_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT19_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT19_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT19_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT19_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT19_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT19_RESETVAL        (0x00000000u)
N
N/* EVENT20 */
N
N#define CSL_DMAX_EVENT20_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT20_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT20_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT20_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT20_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT20_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT20_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT20_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT20_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT20_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT20_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT20_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT20_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT20_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT20_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT20_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT20_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT20_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT20_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT20_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT20_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT20_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT20_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT20_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT20_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT20_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT20_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT20_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT20_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT20_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT20_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT20_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT20_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT20_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT20_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT20_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT20_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT20_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT20_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT20_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT20_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT20_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT20_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT20_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT20_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT20_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT20_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT20_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT20_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT20_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT20_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT20_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT20_RESETVAL        (0x00000000u)
N
N/* EVENT21 */
N
N#define CSL_DMAX_EVENT21_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT21_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT21_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT21_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT21_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT21_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT21_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT21_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT21_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT21_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT21_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT21_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT21_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT21_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT21_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT21_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT21_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT21_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT21_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT21_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT21_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT21_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT21_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT21_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT21_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT21_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT21_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT21_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT21_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT21_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT21_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT21_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT21_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT21_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT21_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT21_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT21_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT21_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT21_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT21_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT21_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT21_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT21_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT21_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT21_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT21_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT21_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT21_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT21_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT21_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT21_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT21_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT21_RESETVAL        (0x00000000u)
N
N/* EVENT22 */
N
N#define CSL_DMAX_EVENT22_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT22_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT22_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT22_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT22_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT22_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT22_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT22_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT22_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT22_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT22_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT22_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT22_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT22_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT22_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT22_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT22_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT22_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT22_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT22_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT22_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT22_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT22_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT22_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT22_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT22_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT22_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT22_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT22_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT22_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT22_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT22_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT22_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT22_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT22_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT22_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT22_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT22_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT22_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT22_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT22_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT22_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT22_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT22_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT22_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT22_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT22_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT22_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT22_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT22_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT22_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT22_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT22_RESETVAL        (0x00000000u)
N
N/* EVENT23 */
N
N#define CSL_DMAX_EVENT23_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT23_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT23_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT23_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT23_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT23_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT23_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT23_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT23_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT23_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT23_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT23_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT23_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT23_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT23_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT23_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT23_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT23_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT23_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT23_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT23_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT23_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT23_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT23_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT23_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT23_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT23_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT23_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT23_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT23_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT23_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT23_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT23_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT23_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT23_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT23_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT23_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT23_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT23_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT23_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT23_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT23_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT23_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT23_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT23_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT23_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT23_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT23_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT23_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT23_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT23_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT23_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT23_RESETVAL        (0x00000000u)
N
N/* EVENT24 */
N
N#define CSL_DMAX_EVENT24_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT24_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT24_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT24_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT24_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT24_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT24_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT24_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT24_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT24_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT24_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT24_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT24_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT24_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT24_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT24_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT24_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT24_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT24_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT24_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT24_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT24_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT24_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT24_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT24_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT24_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT24_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT24_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT24_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT24_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT24_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT24_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT24_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT24_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT24_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT24_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT24_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT24_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT24_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT24_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT24_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT24_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT24_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT24_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT24_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT24_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT24_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT24_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT24_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT24_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT24_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT24_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT24_RESETVAL        (0x00000000u)
N
N/* EVENT25 */
N
N#define CSL_DMAX_EVENT25_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT25_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT25_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT25_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT25_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT25_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT25_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT25_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT25_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT25_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT25_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT25_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT25_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT25_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT25_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT25_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT25_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT25_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT25_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT25_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT25_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT25_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT25_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT25_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT25_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT25_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT25_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT25_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT25_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT25_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT25_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT25_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT25_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT25_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT25_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT25_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT25_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT25_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT25_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT25_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT25_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT25_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT25_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT25_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT25_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT25_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT25_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT25_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT25_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT25_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT25_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT25_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT25_RESETVAL        (0x00000000u)
N
N/* EVENT26 */
N
N#define CSL_DMAX_EVENT26_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT26_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT26_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT26_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT26_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT26_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT26_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT26_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT26_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT26_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT26_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT26_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT26_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT26_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT26_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT26_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT26_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT26_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT26_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT26_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT26_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT26_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT26_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT26_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT26_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT26_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT26_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT26_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT26_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT26_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT26_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT26_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT26_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT26_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT26_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT26_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT26_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT26_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT26_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT26_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT26_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT26_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT26_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT26_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT26_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT26_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT26_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT26_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT26_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT26_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT26_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT26_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT26_RESETVAL        (0x00000000u)
N
N/* EVENT27 */
N
N#define CSL_DMAX_EVENT27_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT27_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT27_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT27_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT27_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT27_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT27_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT27_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT27_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT27_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT27_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT27_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT27_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT27_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT27_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT27_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT27_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT27_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT27_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT27_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT27_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT27_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT27_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT27_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT27_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT27_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT27_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT27_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT27_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT27_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT27_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT27_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT27_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT27_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT27_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT27_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT27_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT27_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT27_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT27_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT27_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT27_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT27_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT27_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT27_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT27_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT27_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT27_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT27_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT27_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT27_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT27_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT27_RESETVAL        (0x00000000u)
N
N/* EVENT28 */
N
N#define CSL_DMAX_EVENT28_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT28_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT28_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT28_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT28_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT28_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT28_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT28_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT28_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT28_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT28_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT28_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT28_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT28_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT28_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT28_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT28_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT28_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT28_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT28_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT28_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT28_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT28_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT28_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT28_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT28_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT28_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT28_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT28_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT28_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT28_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT28_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT28_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT28_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT28_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT28_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT28_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT28_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT28_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT28_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT28_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT28_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT28_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT28_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT28_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT28_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT28_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT28_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT28_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT28_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT28_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT28_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT28_RESETVAL        (0x00000000u)
N
N/* EVENT29 */
N
N#define CSL_DMAX_EVENT29_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT29_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT29_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT29_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT29_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT29_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT29_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT29_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT29_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT29_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT29_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT29_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT29_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT29_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT29_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT29_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT29_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT29_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT29_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT29_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT29_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT29_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT29_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT29_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT29_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT29_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT29_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT29_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT29_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT29_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT29_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT29_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT29_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT29_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT29_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT29_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT29_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT29_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT29_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT29_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT29_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT29_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT29_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT29_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT29_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT29_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT29_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT29_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT29_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT29_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT29_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT29_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT29_RESETVAL        (0x00000000u)
N
N/* EVENT30 */
N
N#define CSL_DMAX_EVENT30_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT30_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT30_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT30_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT30_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT30_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT30_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT30_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT30_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT30_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT30_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT30_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT30_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT30_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT30_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT30_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT30_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT30_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT30_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT30_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT30_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT30_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT30_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT30_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT30_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT30_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT30_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT30_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT30_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT30_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT30_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT30_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT30_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT30_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT30_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT30_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT30_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT30_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT30_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT30_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT30_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT30_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT30_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT30_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT30_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT30_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT30_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT30_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT30_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT30_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT30_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT30_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT30_RESETVAL        (0x00000000u)
N
N/* EVENT31 */
N
N#define CSL_DMAX_EVENT31_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT31_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT31_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT31_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT31_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT31_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT31_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT31_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT31_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT31_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT31_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT31_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT31_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT31_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT31_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT31_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT31_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT31_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT31_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT31_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT31_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT31_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT31_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT31_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT31_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT31_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT31_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT31_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT31_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT31_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT31_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT31_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT31_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT31_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT31_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT31_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT31_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT31_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT31_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT31_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT31_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT31_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT31_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT31_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT31_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT31_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT31_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT31_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT31_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT31_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT31_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT31_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT31_RESETVAL        (0x00000000u)
N
N/* WORD0 */
N
N#define CSL_DMAX_WORD0_WORD0_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD0_WORD0_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD0_WORD0_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD0_RESETVAL          (0x00000000u)
N
N/* WORD1 */
N
N#define CSL_DMAX_WORD1_WORD1_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD1_WORD1_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD1_WORD1_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD1_RESETVAL          (0x00000000u)
N
N/* WORD2 */
N
N#define CSL_DMAX_WORD2_WORD2_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD2_WORD2_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD2_WORD2_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD2_RESETVAL          (0x00000000u)
N
N/* WORD3 */
N
N#define CSL_DMAX_WORD3_WORD3_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD3_WORD3_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD3_WORD3_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD3_RESETVAL          (0x00000000u)
N
N/* WORD4 */
N
N#define CSL_DMAX_WORD4_WORD4_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD4_WORD4_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD4_WORD4_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD4_RESETVAL          (0x00000000u)
N
N/* WORD5 */
N
N#define CSL_DMAX_WORD5_WORD5_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD5_WORD5_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD5_WORD5_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD5_RESETVAL          (0x00000000u)
N
N/* WORD6 */
N
N#define CSL_DMAX_WORD6_WORD6_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD6_WORD6_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD6_WORD6_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD6_RESETVAL          (0x00000000u)
N
N/* WORD7 */
N
N#define CSL_DMAX_WORD7_WORD7_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD7_WORD7_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD7_WORD7_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD7_RESETVAL          (0x00000000u)
N
N/* WORD8 */
N
N#define CSL_DMAX_WORD8_WORD8_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD8_WORD8_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD8_WORD8_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD8_RESETVAL          (0x00000000u)
N
N/* WORD9 */
N
N#define CSL_DMAX_WORD9_WORD9_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD9_WORD9_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD9_WORD9_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD9_RESETVAL          (0x00000000u)
N
N/* WORD10 */
N
N#define CSL_DMAX_WORD10_WORD10_MASK      (0xFFFFFFFFu)
N#define CSL_DMAX_WORD10_WORD10_SHIFT     (0x00000000u)
N#define CSL_DMAX_WORD10_WORD10_RESETVAL  (0x00000000u)
N
N#define CSL_DMAX_WORD10_RESETVAL         (0x00000000u)
N
N/* EVENT0 */
N
N#define CSL_DMAX_EVENT0_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT0_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT0_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT0_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT0_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT0_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT0_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT0_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT0_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT0_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT0_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT0_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT0_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT0_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT0_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT0_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT0_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT0_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT0_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT0_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT0_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT0_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT0_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT0_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT0_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT0_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT0_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT0_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT0_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT0_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT0_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT0_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT0_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT0_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT0_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT0_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT0_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT0_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT0_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT0_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT0_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT0_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT0_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT0_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT0_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT0_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT0_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT0_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT0_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT0_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT0_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT0_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT0_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT0_INT_INT9		(0x00000002u)
N#define CSL_DMAX_EVENT0_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT0_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT0_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT0_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT0_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT0_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT0_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT0_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT0_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT0_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT0_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT0_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT0_RESETVAL         (0x00000000u)
N
N/* EVENT1 */
N
N#define CSL_DMAX_EVENT1_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT1_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT1_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT1_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT1_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT1_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT1_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT1_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT1_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT1_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT1_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT1_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT1_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT1_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT1_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT1_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT1_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT1_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT1_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT1_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT1_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT1_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT1_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT1_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT1_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT1_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT1_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT1_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT1_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT1_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT1_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT1_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT1_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT1_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT1_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT1_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT1_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT1_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT1_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT1_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT1_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT1_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT1_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT1_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT1_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT1_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT1_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT1_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT1_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT1_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT1_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT1_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT1_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT1_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT1_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT1_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT1_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT1_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT1_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT1_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT1_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT1_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT1_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT1_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT1_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT1_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT1_RESETVAL         (0x00000000u)
N
N/* EVENT2 */
N
N#define CSL_DMAX_EVENT2_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT2_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT2_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT2_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT2_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT2_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT2_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT2_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT2_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT2_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT2_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT2_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT2_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT2_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT2_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT2_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT2_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT2_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT2_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT2_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT2_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT2_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT2_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT2_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT2_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT2_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT2_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT2_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT2_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT2_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT2_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT2_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT2_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT2_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT2_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT2_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT2_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT2_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT2_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT2_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT2_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT2_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT2_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT2_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT2_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT2_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT2_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT2_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT2_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT2_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT2_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT2_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT2_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT2_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT2_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT2_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT2_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT2_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT2_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT2_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT2_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT2_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT2_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT2_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT2_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT2_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT2_RESETVAL         (0x00000000u)
N
N/* EVENT3 */
N
N#define CSL_DMAX_EVENT3_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT3_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT3_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT3_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT3_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT3_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT3_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT3_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT3_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT3_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT3_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT3_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT3_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT3_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT3_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT3_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT3_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT3_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT3_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT3_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT3_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT3_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT3_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT3_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT3_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT3_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT3_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT3_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT3_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT3_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT3_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT3_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT3_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT3_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT3_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT3_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT3_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT3_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT3_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT3_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT3_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT3_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT3_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT3_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT3_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT3_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT3_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT3_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT3_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT3_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT3_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT3_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT3_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT3_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT3_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT3_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT3_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT3_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT3_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT3_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT3_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT3_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT3_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT3_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT3_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT3_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT3_RESETVAL         (0x00000000u)
N
N/* EVENT4 */
N
N#define CSL_DMAX_EVENT4_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT4_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT4_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT4_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT4_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT4_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT4_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT4_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT4_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT4_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT4_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT4_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT4_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT4_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT4_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT4_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT4_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT4_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT4_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT4_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT4_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT4_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT4_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT4_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT4_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT4_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT4_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT4_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT4_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT4_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT4_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT4_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT4_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT4_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT4_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT4_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT4_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT4_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT4_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT4_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT4_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT4_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT4_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT4_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT4_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT4_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT4_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT4_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT4_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT4_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT4_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT4_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT4_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT4_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT4_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT4_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT4_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT4_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT4_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT4_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT4_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT4_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT4_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT4_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT4_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT4_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT4_RESETVAL         (0x00000000u)
N
N/* EVENT5 */
N
N#define CSL_DMAX_EVENT5_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT5_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT5_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT5_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT5_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT5_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT5_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT5_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT5_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT5_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT5_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT5_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT5_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT5_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT5_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT5_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT5_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT5_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT5_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT5_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT5_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT5_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT5_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT5_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT5_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT5_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT5_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT5_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT5_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT5_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT5_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT5_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT5_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT5_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT5_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT5_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT5_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT5_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT5_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT5_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT5_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT5_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT5_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT5_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT5_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT5_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT5_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT5_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT5_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT5_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT5_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT5_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT5_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT5_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT5_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT5_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT5_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT5_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT5_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT5_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT5_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT5_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT5_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT5_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT5_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT5_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT5_RESETVAL         (0x00000000u)
N
N/* EVENT6 */
N
N#define CSL_DMAX_EVENT6_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT6_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT6_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT6_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT6_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT6_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT6_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT6_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT6_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT6_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT6_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT6_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT6_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT6_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT6_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT6_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT6_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT6_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT6_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT6_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT6_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT6_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT6_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT6_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT6_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT6_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT6_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT6_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT6_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT6_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT6_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT6_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT6_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT6_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT6_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT6_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT6_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT6_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT6_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT6_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT6_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT6_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT6_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT6_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT6_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT6_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT6_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT6_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT6_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT6_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT6_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT6_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT6_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT6_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT6_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT6_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT6_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT6_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT6_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT6_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT6_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT6_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT6_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT6_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT6_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT6_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT6_RESETVAL         (0x00000000u)
N
N/* EVENT7 */
N
N#define CSL_DMAX_EVENT7_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT7_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT7_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT7_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT7_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT7_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT7_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT7_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT7_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT7_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT7_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT7_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT7_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT7_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT7_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT7_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT7_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT7_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT7_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT7_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT7_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT7_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT7_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT7_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT7_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT7_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT7_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT7_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT7_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT7_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT7_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT7_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT7_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT7_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT7_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT7_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT7_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT7_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT7_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT7_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT7_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT7_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT7_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT7_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT7_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT7_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT7_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT7_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT7_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT7_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT7_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT7_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT7_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT7_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT7_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT7_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT7_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT7_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT7_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT7_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT7_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT7_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT7_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT7_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT7_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT7_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT7_RESETVAL         (0x00000000u)
N
N/* EVENT8 */
N
N#define CSL_DMAX_EVENT8_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT8_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT8_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT8_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT8_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT8_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT8_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT8_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT8_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT8_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT8_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT8_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT8_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT8_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT8_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT8_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT8_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT8_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT8_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT8_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT8_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT8_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT8_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT8_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT8_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT8_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT8_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT8_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT8_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT8_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT8_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT8_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT8_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT8_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT8_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT8_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT8_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT8_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT8_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT8_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT8_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT8_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT8_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT8_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT8_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT8_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT8_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT8_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT8_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT8_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT8_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT8_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT8_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT8_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT8_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT8_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT8_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT8_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT8_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT8_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT8_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT8_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT8_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT8_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT8_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT8_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT8_RESETVAL         (0x00000000u)
N
N/* EVENT9 */
N
N#define CSL_DMAX_EVENT9_QTSL_MASK        (0xC0000000u)
N#define CSL_DMAX_EVENT9_QTSL_SHIFT       (0x0000001Eu)
N#define CSL_DMAX_EVENT9_QTSL_RESETVAL    (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT9_QTSL_MOVE1_ELE   (0x00000000u)
N#define CSL_DMAX_EVENT9_QTSL_MOVE4_ELE   (0x00000001u)
N#define CSL_DMAX_EVENT9_QTSL_MOVE8_ELE   (0x00000002u)
N#define CSL_DMAX_EVENT9_QTSL_MOVE16_ELE  (0x00000003u)
N
N#define CSL_DMAX_EVENT9_SYNC_MASK        (0x20000000u)
N#define CSL_DMAX_EVENT9_SYNC_SHIFT       (0x0000001Du)
N#define CSL_DMAX_EVENT9_SYNC_RESETVAL    (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT9_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT9_SYNC_TRAN_COMPL  (0x00000001u)
N
N#define CSL_DMAX_EVENT9_TCC_MASK         (0x0F000000u)
N#define CSL_DMAX_EVENT9_TCC_SHIFT        (0x00000018u)
N#define CSL_DMAX_EVENT9_TCC_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT9_ATCINT_MASK      (0x00800000u)
N#define CSL_DMAX_EVENT9_ATCINT_SHIFT     (0x00000017u)
N#define CSL_DMAX_EVENT9_ATCINT_RESETVAL  (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT9_ATCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT9_ATCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT9_TCINT_MASK       (0x00400000u)
N#define CSL_DMAX_EVENT9_TCINT_SHIFT      (0x00000016u)
N#define CSL_DMAX_EVENT9_TCINT_RESETVAL   (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT9_TCINT_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT9_TCINT_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT9_RLOAD_MASK       (0x00100000u)
N#define CSL_DMAX_EVENT9_RLOAD_SHIFT      (0x00000014u)
N#define CSL_DMAX_EVENT9_RLOAD_RESETVAL   (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT9_RLOAD_DISABLE    (0x00000000u)
N#define CSL_DMAX_EVENT9_RLOAD_ENABLE     (0x00000001u)
N
N#define CSL_DMAX_EVENT9_CC_MASK          (0x000C0000u)
N#define CSL_DMAX_EVENT9_CC_SHIFT         (0x00000012u)
N#define CSL_DMAX_EVENT9_CC_RESETVAL      (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT9_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT9_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT9_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT9_ESIZE_MASK       (0x00030000u)
N#define CSL_DMAX_EVENT9_ESIZE_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT9_ESIZE_RESETVAL   (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT9_ESIZE_8BIT       (0x00000000u)
N#define CSL_DMAX_EVENT9_ESIZE_16BIT      (0x00000001u)
N#define CSL_DMAX_EVENT9_ESIZE_32BIT      (0x00000002u)
N
N#define CSL_DMAX_EVENT9_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT9_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT9_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT9_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT9_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT9_PTE_MASK         (0x00007F00u)
N#define CSL_DMAX_EVENT9_PTE_SHIFT        (0x00000008u)
N#define CSL_DMAX_EVENT9_PTE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_EVENT9_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT9_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT9_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT9_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT9_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT9_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT9_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT9_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT9_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT9_ETYPE_MASK       (0x0000001Fu)
N#define CSL_DMAX_EVENT9_ETYPE_SHIFT      (0x00000000u)
N#define CSL_DMAX_EVENT9_ETYPE_RESETVAL   (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT9_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT9_ETYPE_FIFOWRITE  (0x00000004u)
N#define CSL_DMAX_EVENT9_ETYPE_FIFOREAD   (0x00000005u)
N#define CSL_DMAX_EVENT9_ETYPE_CPUINT     (0x00000007u)
N
N#define CSL_DMAX_EVENT9_RESETVAL         (0x00000000u)
N
N/* EVENT10 */
N
N#define CSL_DMAX_EVENT10_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT10_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT10_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT10_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT10_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT10_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT10_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT10_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT10_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT10_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT10_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT10_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT10_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT10_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT10_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT10_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT10_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT10_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT10_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT10_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT10_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT10_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT10_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT10_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT10_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT10_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT10_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT10_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT10_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT10_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT10_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT10_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT10_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT10_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT10_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT10_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT10_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT10_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT10_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT10_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT10_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT10_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT10_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT10_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT10_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT10_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT10_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT10_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT10_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT10_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT10_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT10_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT10_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT10_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT10_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT10_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT10_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT10_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT10_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT10_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT10_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT10_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT10_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT10_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT10_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT10_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT10_RESETVAL        (0x00000000u)
N
N/* EVENT11 */
N
N#define CSL_DMAX_EVENT11_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT11_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT11_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT11_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT11_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT11_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT11_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT11_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT11_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT11_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT11_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT11_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT11_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT11_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT11_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT11_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT11_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT11_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT11_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT11_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT11_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT11_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT11_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT11_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT11_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT11_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT11_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT11_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT11_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT11_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT11_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT11_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT11_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT11_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT11_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT11_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT11_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT11_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT11_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT11_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT11_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT11_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT11_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT11_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT11_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT11_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT11_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT11_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT11_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT11_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT11_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT11_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT11_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT11_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT11_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT11_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT11_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT11_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT11_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT11_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT11_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT11_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT11_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT11_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT11_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT11_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT11_RESETVAL        (0x00000000u)
N
N/* EVENT12 */
N
N#define CSL_DMAX_EVENT12_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT12_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT12_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT12_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT12_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT12_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT12_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT12_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT12_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT12_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT12_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT12_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT12_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT12_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT12_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT12_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT12_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT12_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT12_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT12_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT12_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT12_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT12_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT12_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT12_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT12_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT12_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT12_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT12_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT12_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT12_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT12_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT12_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT12_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT12_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT12_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT12_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT12_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT12_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT12_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT12_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT12_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT12_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT12_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT12_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT12_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT12_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT12_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT12_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT12_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT12_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT12_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT12_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT12_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT12_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT12_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT12_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT12_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT12_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT12_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT12_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT12_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT12_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT12_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT12_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT12_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT12_RESETVAL        (0x00000000u)
N
N/* EVENT13 */
N
N#define CSL_DMAX_EVENT13_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT13_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT13_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT13_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT13_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT13_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT13_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT13_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT13_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT13_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT13_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT13_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT13_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT13_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT13_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT13_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT13_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT13_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT13_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT13_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT13_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT13_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT13_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT13_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT13_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT13_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT13_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT13_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT13_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT13_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT13_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT13_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT13_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT13_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT13_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT13_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT13_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT13_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT13_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT13_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT13_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT13_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT13_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT13_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT13_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT13_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT13_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT13_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT13_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT13_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT13_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT13_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT13_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT13_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT13_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT13_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT13_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT13_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT13_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT13_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT13_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT13_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT13_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT13_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT13_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT13_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT13_RESETVAL        (0x00000000u)
N
N/* EVENT14 */
N
N#define CSL_DMAX_EVENT14_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT14_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT14_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT14_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT14_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT14_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT14_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT14_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT14_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT14_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT14_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT14_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT14_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT14_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT14_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT14_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT14_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT14_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT14_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT14_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT14_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT14_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT14_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT14_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT14_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT14_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT14_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT14_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT14_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT14_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT14_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT14_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT14_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT14_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT14_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT14_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT14_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT14_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT14_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT14_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT14_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT14_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT14_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT14_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT14_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT14_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT14_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT14_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT14_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT14_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT14_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT14_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT14_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT14_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT14_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT14_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT14_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT14_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT14_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT14_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT14_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT14_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT14_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT14_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT14_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT14_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT14_RESETVAL        (0x00000000u)
N
N/* EVENT15 */
N
N#define CSL_DMAX_EVENT15_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT15_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT15_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT15_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT15_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT15_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT15_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT15_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT15_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT15_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT15_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT15_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT15_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT15_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT15_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT15_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT15_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT15_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT15_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT15_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT15_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT15_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT15_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT15_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT15_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT15_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT15_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT15_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT15_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT15_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT15_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT15_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT15_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT15_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT15_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT15_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT15_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT15_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT15_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT15_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT15_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT15_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT15_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT15_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT15_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT15_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT15_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT15_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT15_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT15_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT15_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT15_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT15_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT15_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT15_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT15_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT15_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT15_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT15_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT15_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT15_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT15_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT15_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT15_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT15_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT15_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT15_RESETVAL        (0x00000000u)
N
N/* EVENT16 */
N
N#define CSL_DMAX_EVENT16_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT16_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT16_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT16_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT16_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT16_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT16_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT16_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT16_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT16_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT16_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT16_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT16_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT16_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT16_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT16_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT16_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT16_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT16_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT16_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT16_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT16_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT16_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT16_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT16_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT16_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT16_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT16_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT16_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT16_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT16_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT16_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT16_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT16_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT16_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT16_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT16_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT16_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT16_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT16_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT16_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT16_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT16_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT16_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT16_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT16_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT16_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT16_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT16_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT16_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT16_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT16_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT16_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT16_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT16_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT16_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT16_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT16_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT16_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT16_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT16_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT16_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT16_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT16_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT16_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT16_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT16_RESETVAL        (0x00000000u)
N
N/* EVENT17 */
N
N#define CSL_DMAX_EVENT17_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT17_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT17_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT17_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT17_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT17_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT17_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT17_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT17_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT17_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT17_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT17_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT17_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT17_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT17_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT17_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT17_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT17_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT17_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT17_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT17_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT17_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT17_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT17_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT17_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT17_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT17_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT17_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT17_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT17_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT17_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT17_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT17_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT17_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT17_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT17_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT17_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT17_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT17_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT17_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT17_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT17_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT17_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT17_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT17_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT17_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT17_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT17_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT17_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT17_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT17_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT17_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT17_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT17_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT17_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT17_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT17_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT17_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT17_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT17_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT17_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT17_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT17_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT17_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT17_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT17_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT17_RESETVAL        (0x00000000u)
N
N/* EVENT18 */
N
N#define CSL_DMAX_EVENT18_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT18_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT18_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT18_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT18_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT18_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT18_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT18_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT18_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT18_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT18_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT18_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT18_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT18_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT18_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT18_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT18_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT18_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT18_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT18_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT18_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT18_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT18_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT18_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT18_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT18_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT18_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT18_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT18_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT18_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT18_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT18_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT18_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT18_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT18_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT18_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT18_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT18_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT18_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT18_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT18_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT18_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT18_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT18_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT18_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT18_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT18_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT18_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT18_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT18_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT18_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT18_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT18_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT18_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT18_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT18_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT18_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT18_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT18_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT18_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT18_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT18_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT18_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT18_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT18_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT18_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT18_RESETVAL        (0x00000000u)
N
N/* EVENT19 */
N
N#define CSL_DMAX_EVENT19_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT19_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT19_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT19_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT19_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT19_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT19_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT19_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT19_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT19_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT19_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT19_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT19_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT19_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT19_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT19_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT19_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT19_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT19_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT19_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT19_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT19_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT19_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT19_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT19_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT19_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT19_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT19_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT19_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT19_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT19_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT19_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT19_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT19_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT19_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT19_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT19_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT19_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT19_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT19_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT19_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT19_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT19_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT19_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT19_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT19_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT19_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT19_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT19_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT19_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT19_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT19_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT19_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT19_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT19_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT19_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT19_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT19_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT19_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT19_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT19_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT19_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT19_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT19_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT19_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT19_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT19_RESETVAL        (0x00000000u)
N
N/* EVENT20 */
N
N#define CSL_DMAX_EVENT20_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT20_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT20_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT20_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT20_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT20_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT20_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT20_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT20_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT20_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT20_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT20_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT20_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT20_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT20_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT20_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT20_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT20_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT20_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT20_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT20_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT20_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT20_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT20_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT20_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT20_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT20_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT20_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT20_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT20_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT20_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT20_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT20_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT20_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT20_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT20_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT20_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT20_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT20_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT20_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT20_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT20_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT20_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT20_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT20_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT20_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT20_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT20_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT20_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT20_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT20_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT20_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT20_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT20_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT20_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT20_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT20_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT20_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT20_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT20_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT20_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT20_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT20_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT20_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT20_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT20_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT20_RESETVAL        (0x00000000u)
N
N/* EVENT21 */
N
N#define CSL_DMAX_EVENT21_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT21_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT21_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT21_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT21_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT21_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT21_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT21_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT21_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT21_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT21_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT21_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT21_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT21_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT21_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT21_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT21_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT21_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT21_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT21_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT21_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT21_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT21_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT21_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT21_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT21_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT21_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT21_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT21_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT21_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT21_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT21_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT21_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT21_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT21_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT21_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT21_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT21_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT21_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT21_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT21_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT21_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT21_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT21_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT21_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT21_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT21_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT21_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT21_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT21_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT21_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT21_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT21_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT21_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT21_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT21_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT21_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT21_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT21_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT21_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT21_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT21_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT21_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT21_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT21_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT21_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT21_RESETVAL        (0x00000000u)
N
N/* EVENT22 */
N
N#define CSL_DMAX_EVENT22_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT22_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT22_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT22_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT22_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT22_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT22_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT22_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT22_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT22_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT22_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT22_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT22_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT22_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT22_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT22_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT22_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT22_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT22_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT22_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT22_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT22_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT22_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT22_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT22_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT22_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT22_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT22_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT22_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT22_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT22_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT22_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT22_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT22_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT22_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT22_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT22_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT22_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT22_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT22_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT22_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT22_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT22_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT22_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT22_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT22_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT22_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT22_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT22_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT22_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT22_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT22_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT22_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT22_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT22_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT22_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT22_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT22_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT22_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT22_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT22_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT22_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT22_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT22_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT22_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT22_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT22_RESETVAL        (0x00000000u)
N
N/* EVENT23 */
N
N#define CSL_DMAX_EVENT23_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT23_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT23_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT23_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT23_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT23_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT23_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT23_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT23_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT23_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT23_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT23_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT23_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT23_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT23_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT23_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT23_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT23_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT23_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT23_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT23_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT23_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT23_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT23_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT23_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT23_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT23_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT23_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT23_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT23_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT23_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT23_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT23_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT23_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT23_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT23_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT23_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT23_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT23_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT23_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT23_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT23_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT23_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT23_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT23_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT23_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT23_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT23_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT23_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT23_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT23_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT23_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT23_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT23_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT23_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT23_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT23_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT23_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT23_INT_INT15       (0x00000007u)
N
N
N#define CSL_DMAX_EVENT23_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT23_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT23_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT23_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT23_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT23_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT23_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT23_RESETVAL        (0x00000000u)
N
N/* EVENT24 */
N
N#define CSL_DMAX_EVENT24_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT24_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT24_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT24_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT24_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT24_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT24_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT24_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT24_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT24_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT24_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT24_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT24_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT24_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT24_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT24_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT24_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT24_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT24_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT24_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT24_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT24_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT24_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT24_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT24_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT24_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT24_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT24_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT24_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT24_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT24_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT24_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT24_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT24_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT24_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT24_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT24_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT24_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT24_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT24_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT24_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT24_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT24_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT24_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT24_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT24_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT24_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT24_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT24_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT24_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT24_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT24_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT24_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT24_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT24_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT24_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT24_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT24_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT24_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT24_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT24_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT24_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT24_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT24_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT24_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT24_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT24_RESETVAL        (0x00000000u)
N
N/* EVENT25 */
N
N#define CSL_DMAX_EVENT25_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT25_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT25_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT25_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT25_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT25_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT25_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT25_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT25_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT25_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT25_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT25_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT25_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT25_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT25_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT25_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT25_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT25_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT25_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT25_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT25_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT25_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT25_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT25_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT25_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT25_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT25_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT25_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT25_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT25_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT25_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT25_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT25_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT25_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT25_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT25_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT25_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT25_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT25_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT25_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT25_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT25_ESIZE_32BIT     (0x00000002u)
N
N
N#define CSL_DMAX_EVENT25_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT25_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT25_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT25_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT25_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT25_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT25_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT25_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT25_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT25_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT25_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT25_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT25_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT25_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT25_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT25_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT25_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT25_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT25_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT25_RESETVAL        (0x00000000u)
N
N/* EVENT26 */
N
N#define CSL_DMAX_EVENT26_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT26_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT26_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT26_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT26_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT26_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT26_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT26_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT26_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT26_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT26_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT26_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT26_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT26_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT26_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT26_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT26_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT26_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT26_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT26_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT26_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT26_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT26_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT26_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT26_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT26_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT26_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT26_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT26_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT26_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT26_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT26_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT26_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT26_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT26_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT26_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT26_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT26_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT26_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT26_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT26_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT26_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT26_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT26_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT26_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT26_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT26_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT26_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT26_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT26_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT26_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT26_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT26_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT26_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT26_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT26_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT26_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT26_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT26_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT26_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT26_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT26_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT26_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT26_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT26_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT26_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT26_RESETVAL        (0x00000000u)
N
N/* EVENT27 */
N
N#define CSL_DMAX_EVENT27_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT27_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT27_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT27_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT27_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT27_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT27_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT27_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT27_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT27_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT27_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT27_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT27_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT27_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT27_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT27_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT27_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT27_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT27_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT27_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT27_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT27_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT27_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT27_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT27_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT27_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT27_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT27_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT27_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT27_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT27_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT27_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT27_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT27_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT27_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT27_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT27_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT27_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT27_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT27_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT27_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT27_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT27_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT27_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT27_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT27_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT27_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT27_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT27_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT27_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT27_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT27_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT27_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT27_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT27_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT27_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT27_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT27_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT27_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT27_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT27_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT27_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT27_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT27_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT27_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT27_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT27_RESETVAL        (0x00000000u)
N
N/* EVENT28 */
N
N#define CSL_DMAX_EVENT28_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT28_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT28_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT28_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT28_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT28_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT28_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT28_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT28_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT28_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT28_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT28_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT28_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT28_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT28_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT28_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT28_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT28_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT28_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT28_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT28_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT28_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT28_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT28_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT28_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT28_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT28_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT28_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT28_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT28_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT28_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT28_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT28_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT28_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT28_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT28_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT28_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT28_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT28_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT28_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT28_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT28_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT28_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT28_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT28_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT28_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT28_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT28_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT28_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT28_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT28_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT28_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT28_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT28_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT28_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT28_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT28_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT28_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT28_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT28_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT28_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT28_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT28_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT28_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT28_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT28_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT28_RESETVAL        (0x00000000u)
N
N/* EVENT29 */
N
N#define CSL_DMAX_EVENT29_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT29_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT29_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT29_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT29_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT29_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT29_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT29_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT29_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT29_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT29_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT29_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT29_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT29_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT29_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT29_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT29_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT29_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT29_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT29_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT29_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT29_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT29_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT29_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT29_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT29_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT29_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT29_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT29_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT29_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT29_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT29_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT29_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT29_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT29_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT29_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT29_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT29_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT29_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT29_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT29_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT29_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT29_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT29_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT29_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT29_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT29_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT29_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT29_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT29_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT29_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT29_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT29_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT29_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT29_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT29_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT29_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT29_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT29_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT29_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT29_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT29_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT29_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT29_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT29_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT29_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT29_RESETVAL        (0x00000000u)
N
N/* EVENT30 */
N
N#define CSL_DMAX_EVENT30_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT30_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT30_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT30_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT30_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT30_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT30_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT30_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT30_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT30_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT30_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT30_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT30_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT30_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT30_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT30_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT30_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT30_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT30_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT30_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT30_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT30_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT30_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT30_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT30_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT30_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT30_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT30_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT30_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT30_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT30_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT30_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT30_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT30_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT30_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT30_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT30_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT30_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT30_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT30_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT30_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT30_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT30_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT30_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT30_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT30_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT30_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT30_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT30_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT30_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT30_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT30_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT30_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT30_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT30_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT30_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT30_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT30_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT30_INT_INT15       (0x00000007u)
N
N#define CSL_DMAX_EVENT30_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT30_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT30_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT30_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT30_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT30_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT30_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT30_RESETVAL        (0x00000000u)
N
N/* EVENT31 */
N
N#define CSL_DMAX_EVENT31_QTSL_MASK       (0xC0000000u)
N#define CSL_DMAX_EVENT31_QTSL_SHIFT      (0x0000001Eu)
N#define CSL_DMAX_EVENT31_QTSL_RESETVAL   (0x00000000u)
N
N/*----QTSL Tokens----*/
N#define CSL_DMAX_EVENT31_QTSL_MOVE1_ELE  (0x00000000u)
N#define CSL_DMAX_EVENT31_QTSL_MOVE4_ELE  (0x00000001u)
N#define CSL_DMAX_EVENT31_QTSL_MOVE8_ELE  (0x00000002u)
N#define CSL_DMAX_EVENT31_QTSL_MOVE16_ELE (0x00000003u)
N
N#define CSL_DMAX_EVENT31_SYNC_MASK       (0x20000000u)
N#define CSL_DMAX_EVENT31_SYNC_SHIFT      (0x0000001Du)
N#define CSL_DMAX_EVENT31_SYNC_RESETVAL   (0x00000000u)
N
N/*----SYNC Tokens----*/
N#define CSL_DMAX_EVENT31_SYNC_TRAN_COUNT0_ELE (0x00000000u)
N#define CSL_DMAX_EVENT31_SYNC_TRAN_COMPL (0x00000001u)
N
N#define CSL_DMAX_EVENT31_TCC_MASK        (0x0F000000u)
N#define CSL_DMAX_EVENT31_TCC_SHIFT       (0x00000018u)
N#define CSL_DMAX_EVENT31_TCC_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT31_ATCINT_MASK     (0x00800000u)
N#define CSL_DMAX_EVENT31_ATCINT_SHIFT    (0x00000017u)
N#define CSL_DMAX_EVENT31_ATCINT_RESETVAL (0x00000000u)
N
N/*----ATCINT Tokens----*/
N#define CSL_DMAX_EVENT31_ATCINT_DISABLE  (0x00000000u)
N#define CSL_DMAX_EVENT31_ATCINT_ENABLE   (0x00000001u)
N
N#define CSL_DMAX_EVENT31_TCINT_MASK      (0x00400000u)
N#define CSL_DMAX_EVENT31_TCINT_SHIFT     (0x00000016u)
N#define CSL_DMAX_EVENT31_TCINT_RESETVAL  (0x00000000u)
N
N/*----TCINT Tokens----*/
N#define CSL_DMAX_EVENT31_TCINT_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT31_TCINT_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT31_RLOAD_MASK      (0x00100000u)
N#define CSL_DMAX_EVENT31_RLOAD_SHIFT     (0x00000014u)
N#define CSL_DMAX_EVENT31_RLOAD_RESETVAL  (0x00000000u)
N
N/*----RLOAD Tokens----*/
N#define CSL_DMAX_EVENT31_RLOAD_DISABLE   (0x00000000u)
N#define CSL_DMAX_EVENT31_RLOAD_ENABLE    (0x00000001u)
N
N#define CSL_DMAX_EVENT31_CC_MASK         (0x000C0000u)
N#define CSL_DMAX_EVENT31_CC_SHIFT        (0x00000012u)
N#define CSL_DMAX_EVENT31_CC_RESETVAL     (0x00000000u)
N
N/*----CC Tokens----*/
N#define CSL_DMAX_EVENT31_CC_COUNT2_15_COUNT1_8_COUNT0_8 (0x00000000u)
N#define CSL_DMAX_EVENT31_CC_COUNT2_7_COUNT1_8_COUNT0_16 (0x00000001u)
N#define CSL_DMAX_EVENT31_CC_COUNT2_7_COUNT1_16_COUNT0_8 (0x00000002u)
N
N#define CSL_DMAX_EVENT31_ESIZE_MASK      (0x00030000u)
N#define CSL_DMAX_EVENT31_ESIZE_SHIFT     (0x00000010u)
N#define CSL_DMAX_EVENT31_ESIZE_RESETVAL  (0x00000000u)
N
N/*----ESIZE Tokens----*/
N#define CSL_DMAX_EVENT31_ESIZE_8BIT      (0x00000000u)
N#define CSL_DMAX_EVENT31_ESIZE_16BIT     (0x00000001u)
N#define CSL_DMAX_EVENT31_ESIZE_32BIT     (0x00000002u)
N
N#define CSL_DMAX_EVENT31_EWM_MASK       (0x00010000u)
N#define CSL_DMAX_EVENT31_EWM_SHIFT      (0x00000010u)
N#define CSL_DMAX_EVENT31_EWM_RESETVAL   (0x00000000u)
N
N/*------ WaterMark Enable Tokens -----*/
N#define CSL_DMAX_EVENT31_EWM_ONE        (0x00000001u)
N#define CSL_DMAX_EVENT31_EWM_ZERO       (0x00000000u)
N
N#define CSL_DMAX_EVENT31_PTE_MASK        (0x00007F00u)
N#define CSL_DMAX_EVENT31_PTE_SHIFT       (0x00000008u)
N#define CSL_DMAX_EVENT31_PTE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_EVENT31_INT_MASK        (0x00070000u)
N#define CSL_DMAX_EVENT31_INT_SHIFT       (0x00000010u)
N#define CSL_DMAX_EVENT31_INT_RESETVAL    (0x00000000u)
N
N/*---- INT TOKENS ----*/
N#define CSL_DMAX_EVENT31_INT_INT9		 (0x00000002u)
N#define CSL_DMAX_EVENT31_INT_INT10       (0x00000003u)
N#define CSL_DMAX_EVENT31_INT_INT11       (0x00000004u)
N#define CSL_DMAX_EVENT31_INT_INT12       (0x00000005u)
N#define CSL_DMAX_EVENT31_INT_INT13       (0x00000006u)
N#define CSL_DMAX_EVENT31_INT_INT15       (0x00000007u)
N
N
N#define CSL_DMAX_EVENT31_ETYPE_MASK      (0x0000001Fu)
N#define CSL_DMAX_EVENT31_ETYPE_SHIFT     (0x00000000u)
N#define CSL_DMAX_EVENT31_ETYPE_RESETVAL  (0x00000000u)
N
N/*----ETYPE Tokens----*/
N#define CSL_DMAX_EVENT31_ETYPE_GENERALXFR (0x00000003u)
N#define CSL_DMAX_EVENT31_ETYPE_FIFOWRITE (0x00000004u)
N#define CSL_DMAX_EVENT31_ETYPE_FIFOREAD  (0x00000005u)
N#define CSL_DMAX_EVENT31_ETYPE_CPUINT    (0x00000007u)
N
N#define CSL_DMAX_EVENT31_RESETVAL        (0x00000000u)
N
N/* WORD0 */
N
N#define CSL_DMAX_WORD0_WORD0_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD0_WORD0_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD0_WORD0_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD0_RESETVAL          (0x00000000u)
N
N/* WORD1 */
N
N#define CSL_DMAX_WORD1_WORD1_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD1_WORD1_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD1_WORD1_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD1_RESETVAL          (0x00000000u)
N
N/* WORD2 */
N
N#define CSL_DMAX_WORD2_WORD2_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD2_WORD2_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD2_WORD2_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD2_RESETVAL          (0x00000000u)
N
N/* WORD3 */
N
N#define CSL_DMAX_WORD3_WORD3_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD3_WORD3_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD3_WORD3_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD3_RESETVAL          (0x00000000u)
N
N/* WORD4 */
N
N#define CSL_DMAX_WORD4_WORD4_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD4_WORD4_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD4_WORD4_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD4_RESETVAL          (0x00000000u)
N
N/* WORD5 */
N
N#define CSL_DMAX_WORD5_WORD5_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD5_WORD5_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD5_WORD5_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD5_RESETVAL          (0x00000000u)
N
N/* WORD6 */
N
N#define CSL_DMAX_WORD6_WORD6_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD6_WORD6_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD6_WORD6_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD6_RESETVAL          (0x00000000u)
N
N/* WORD7 */
N
N#define CSL_DMAX_WORD7_WORD7_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD7_WORD7_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD7_WORD7_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD7_RESETVAL          (0x00000000u)
N
N/* WORD8 */
N
N#define CSL_DMAX_WORD8_WORD8_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD8_WORD8_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD8_WORD8_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD8_RESETVAL          (0x00000000u)
N
N/* WORD9 */
N
N#define CSL_DMAX_WORD9_WORD9_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_WORD9_WORD9_SHIFT       (0x00000000u)
N#define CSL_DMAX_WORD9_WORD9_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_WORD9_RESETVAL          (0x00000000u)
N
N/* WORD10 */
N
N#define CSL_DMAX_WORD10_WORD10_MASK      (0xFFFFFFFFu)
N#define CSL_DMAX_WORD10_WORD10_SHIFT     (0x00000000u)
N#define CSL_DMAX_WORD10_WORD10_RESETVAL  (0x00000000u)
N
N#define CSL_Dmax_WORD10_RESETVAL         (0x00000000u)
N
N/*=============================================================================
N* dMax Event Status Resgister Field Definitions
N*/
N
N#define CSL_DMAX_DESR_TCC15_MASK         (0x80000000u)
N#define CSL_DMAX_DESR_TCC15_SHIFT        (0x0000001Fu)
N#define CSL_DMAX_DESR_TCC15_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC14_MASK         (0x40000000u)
N#define CSL_DMAX_DESR_TCC14_SHIFT        (0x0000001Eu)
N#define CSL_DMAX_DESR_TCC14_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC13_MASK         (0x20000000u)
N#define CSL_DMAX_DESR_TCC13_SHIFT        (0x0000001Du)
N#define CSL_DMAX_DESR_TCC13_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC12_MASK         (0x10000000u)
N#define CSL_DMAX_DESR_TCC12_SHIFT        (0x0000001Cu)
N#define CSL_DMAX_DESR_TCC12_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC11_MASK         (0x08000000u)
N#define CSL_DMAX_DESR_TCC11_SHIFT        (0x0000001Bu)
N#define CSL_DMAX_DESR_TCC11_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC10_MASK         (0x04000000u)
N#define CSL_DMAX_DESR_TCC10_SHIFT        (0x0000001Au)
N#define CSL_DMAX_DESR_TCC10_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC9_MASK         (0x02000000u)
N#define CSL_DMAX_DESR_TCC9_SHIFT        (0x00000019u)
N#define CSL_DMAX_DESR_TCC9_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC8_MASK          (0x01000000u)
N#define CSL_DMAX_DESR_TCC8_SHIFT         (0x00000018u)
N#define CSL_DMAX_DESR_TCC8_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC7_MASK          (0x00008000u)
N#define CSL_DMAX_DESR_TCC7_SHIFT         (0x0000000Fu)
N#define CSL_DMAX_DESR_TCC7_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC6_MASK          (0x00004000u)
N#define CSL_DMAX_DESR_TCC6_SHIFT         (0x0000000Eu)
N#define CSL_DMAX_DESR_TCC6_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC5_MASK          (0x00002000u)
N#define CSL_DMAX_DESR_TCC5_SHIFT         (0x0000000Du)
N#define CSL_DMAX_DESR_TCC5_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC4_MASK          (0x00001000u)
N#define CSL_DMAX_DESR_TCC4_SHIFT         (0x0000000Cu)
N#define CSL_DMAX_DESR_TCC4_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC3_MASK          (0x00000800u)
N#define CSL_DMAX_DESR_TCC3_SHIFT         (0x0000000Bu)
N#define CSL_DMAX_DESR_TCC3_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC2_MASK          (0x00000400u)
N#define CSL_DMAX_DESR_TCC2_SHIFT         (0x0000000Au)
N#define CSL_DMAX_DESR_TCC2_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC1_MASK          (0x00000200u)
N#define CSL_DMAX_DESR_TCC1_SHIFT         (0x00000009u)
N#define CSL_DMAX_DESR_TCC1_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_TCC0_MASK          (0x00000100u)
N#define CSL_DMAX_DESR_TCC0_SHIFT         (0x00000008u)
N#define CSL_DMAX_DESR_TCC0_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_DESR_LBC_MASK           (0x00FF0000u)
N#define CSL_DMAX_DESR_LBC_SHIFT          (0x00000010u)
N#define CSL_DMAX_DESR_LBC_RESETVAL       (0x00000000u)
N
N#define CSL_DMAX_DESR_HBC_MASK           (0x000000FFu)
N#define CSL_DMAX_DESR_HBC_SHIFT          (0x00000000u)
N#define CSL_DMAX_DESR_HBC_RESETVAL       (0x00000000u)
N
N/*=============================================================================
N* dMax Parameter Entry Field Definitions
N*=============================================================================*/
N#define CSL_DMAX_GENERAL_SRCADDRACTIVE_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_GENERAL_SRCADDRACTIVE_SHIFT       (0x00000000u)
N#define CSL_DMAX_GENERAL_SRCADDRACTIVE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_GENERAL_DSTADDRACTIVE_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_GENERAL_DSTADDRACTIVE_SHIFT       (0x00000000u)
N#define CSL_DMAX_GENERAL_DSTADDRACTIVE_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_GENERAL_SRCRELOAD0_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_GENERAL_SRCRELOAD0_SHIFT       (0x00000000u)
N#define CSL_DMAX_GENERAL_SRCRELOAD0_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_GENERAL_DSTRELOAD0_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_GENERAL_DSTRELOAD0_SHIFT       (0x00000000u)
N#define CSL_DMAX_GENERAL_DSTRELOAD0_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_GENERAL_SRCRELOAD1_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_GENERAL_SRCRELOAD1_SHIFT       (0x00000000u)
N#define CSL_DMAX_GENERAL_SRCRELOAD1_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_GENERAL_DSTRELOAD1_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_GENERAL_DSTRELOAD1_SHIFT       (0x00000000u)
N#define CSL_DMAX_GENERAL_DSTRELOAD1_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_GENERAL_PP_MASK                (0x80000000u)
N#define CSL_DMAX_GENERAL_PP_SHIFT               (0x0000001Fu)
N#define CSL_DMAX_GENERAL_PP_RESETVAL            (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT2_CC11_MASK       (0x7F000000u)
N#define CSL_DMAX_GENERAL_COUNT2_CC11_SHIFT      (0x00000018u)
N#define CSL_DMAX_GENERAL_COUNT2_CC11_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT2_CC01_MASK       (0x7F000000u)
N#define CSL_DMAX_GENERAL_COUNT2_CC01_SHIFT      (0x00000018u)
N#define CSL_DMAX_GENERAL_COUNT2_CC01_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT2_CC10_MASK       (0x7F000000u)
N#define CSL_DMAX_GENERAL_COUNT2_CC10_SHIFT      (0x00000018u)
N#define CSL_DMAX_GENERAL_COUNT2_CC10_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT2_CC00_MASK       (0x7FFF0000u)
N#define CSL_DMAX_GENERAL_COUNT2_CC00_SHIFT      (0x00000010u)
N#define CSL_DMAX_GENERAL_COUNT2_CC00_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT1_CC01_MASK       (0x00FF0000u)
N#define CSL_DMAX_GENERAL_COUNT1_CC01_SHIFT      (0x00000010u)
N#define CSL_DMAX_GENERAL_COUNT1_CC01_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT1_CC10_MASK       (0x00FFFF00u)
N#define CSL_DMAX_GENERAL_COUNT1_CC10_SHIFT      (0x00000008u)
N#define CSL_DMAX_GENERAL_COUNT1_CC10_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT1_CC11_MASK       (0x00FF0000u)
N#define CSL_DMAX_GENERAL_COUNT1_CC11_SHIFT      (0x00000010u)
N#define CSL_DMAX_GENERAL_COUNT1_CC11_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT1_CC00_MASK       (0x0000FF00u)
N#define CSL_DMAX_GENERAL_COUNT1_CC00_SHIFT      (0x00000008u)
N#define CSL_DMAX_GENERAL_COUNT1_CC00_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT0_CC01_MASK       (0x0000FFFFu)
N#define CSL_DMAX_GENERAL_COUNT0_CC01_SHIFT      (0x00000000u)
N#define CSL_DMAX_GENERAL_COUNT0_CC01_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT0_CC10_MASK       (0x000000FFu)
N#define CSL_DMAX_GENERAL_COUNT0_CC10_SHIFT      (0x00000000u)
N#define CSL_DMAX_GENERAL_COUNT0_CC10_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT0_CC00_MASK       (0x000000FFu)
N#define CSL_DMAX_GENERAL_COUNT0_CC00_SHIFT      (0x00000000u)
N#define CSL_DMAX_GENERAL_COUNT0_CC00_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_COUNT0_CC11_MASK       (0x0000FFFFu)
N#define CSL_DMAX_GENERAL_COUNT0_CC11_SHIFT      (0x00000000u)
N#define CSL_DMAX_GENERAL_COUNT0_CC11_RESETVAL   (0x00000000u)
N
N#define CSL_DMAX_GENERAL_SRCINDEX0_MASK          (0x0000FFFFu)
N#define CSL_DMAX_GENERAL_SRCINDEX0_SHIFT         (0x00000000u)
N#define CSL_DMAX_GENERAL_SRCINDEX0_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_GENERAL_SRCINDEX1_MASK          (0x0000FFFFu)
N#define CSL_DMAX_GENERAL_SRCINDEX1_SHIFT         (0x00000000u)
N#define CSL_DMAX_GENERAL_SRCINDEX1_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_GENERAL_SRCINDEX2_MASK          (0x0000FFFFu)
N#define CSL_DMAX_GENERAL_SRCINDEX2_SHIFT         (0x00000000u)
N#define CSL_DMAX_GENERAL_SRCINDEX2_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_GENERAL_DSTINDEX0_MASK          (0xFFFF0000u)
N#define CSL_DMAX_GENERAL_DSTINDEX0_SHIFT         (0x00000010u)
N#define CSL_DMAX_GENERAL_DSTINDEX0_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_GENERAL_DSTINDEX1_MASK          (0xFFFF0000u)
N#define CSL_DMAX_GENERAL_DSTINDEX1_SHIFT         (0x00000010u)
N#define CSL_DMAX_GENERAL_DSTINDEX1_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_GENERAL_DSTINDEX2_MASK          (0xFFFF0000u)
N#define CSL_DMAX_GENERAL_DSTINDEX2_SHIFT         (0x00000010u)
N#define CSL_DMAX_GENERAL_DSTINDEX2_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_FIFOBASEADDR_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_FIFODESC_FIFOBASEADDR_SHIFT       (0x00000000u)
N#define CSL_DMAX_FIFODESC_FIFOBASEADDR_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_FMARK_MASK         (0x0000FFFFu)
N#define CSL_DMAX_FIFODESC_FMARK_SHIFT        (0x00000000u)
N#define CSL_DMAX_FIFODESC_FMARK_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_FMARK_MASK         (0x0000FFFFu)
N#define CSL_DMAX_FIFODESC_FMARK_SHIFT        (0x00000000u)
N#define CSL_DMAX_FIFODESC_FMARK_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_FMSC_MASK          (0x0F000000u)
N#define CSL_DMAX_FIFODESC_FMSC_SHIFT         (0x00000018u)
N#define CSL_DMAX_FIFODESC_FMSC_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_EMSC_MASK          (0x0F000000u)
N#define CSL_DMAX_FIFODESC_EMSC_SHIFT         (0x00000018u)
N#define CSL_DMAX_FIFODESC_EMSC_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_FIFOSIZE_MASK      (0x000FFFFFu)
N#define CSL_DMAX_FIFODESC_FIFOSIZE_SHIFT     (0x00000000u)
N#define CSL_DMAX_FIFODESC_FIFOSIZE_RESETVAL  (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_EFIELD_MASK        (0x01010101u)
N#define CSL_DMAX_FIFODESC_EFIELD_SHIFT       (0x00000000u)
N#define CSL_DMAX_FIFODESC_EFIELD_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_ESIZE_MASK         (0x03000000u)
N#define CSL_DMAX_FIFODESC_ESIZE_SHIFT        (0x00000018u)
N#define CSL_DMAX_FIFODESC_ESIZE_RESETVAL     (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_ESIZE_8BITS        (0x00000000u)
N#define CSL_DMAX_FIFODESC_ESIZE_16BITS       (0x00000001u)
N#define CSL_DMAX_FIFODESC_ESIZE_32BITS       (0x00000002u)
N
N#define CSL_DMAX_FIFODESC_RPTR_MASK          (0x000FFFFFu)
N#define CSL_DMAX_FIFODESC_RPTR_SHIFT         (0x00000000u)
N#define CSL_DMAX_FIFODESC_RPTR_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFODESC_WPTR_MASK          (0x000FFFFFu)
N#define CSL_DMAX_FIFODESC_WPTR_SHIFT         (0x00000000u)
N#define CSL_DMAX_FIFODESC_WPTR_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFORW_LINEARADDR_MASK      (0xFFFFFFFFu)
N#define CSL_DMAX_FIFORW_LINEARADDR_SHIFT     (0x00000000u)
N#define CSL_DMAX_FIFORW_LINEARADDR_RESETVAL  (0x00000000u)
N
N#define CSL_DMAX_FIFORW_COUNT0_MASK          (0x0000FFFFu)
N#define CSL_DMAX_FIFORW_COUNT0_SHIFT         (0x00000000u)
N#define CSL_DMAX_FIFORW_COUNT0_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFORW_COUNT1_MASK          (0x7FFF0000u)
N#define CSL_DMAX_FIFORW_COUNT1_SHIFT         (0x00000010u)
N#define CSL_DMAX_FIFORW_COUNT1_RESETVAL      (0x00000000u)
N
N#define CSL_DMAX_FIFORW_DTABPTR0_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_FIFORW_DTABPTR0_SHIFT       (0x00000000u)
N#define CSL_DMAX_FIFORW_DTABPTR0_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_FIFORW_DTABPTR1_MASK        (0xFFFFFFFFu)
N#define CSL_DMAX_FIFORW_DTABPTR1_SHIFT       (0x00000000u)
N#define CSL_DMAX_FIFORW_DTABPTR1_RESETVAL    (0x00000000u)
N
N#define CSL_DMAX_FIFORW_LINEARRELOAD0_MASK     (0xFFFFFFFFu)
N#define CSL_DMAX_FIFORW_LINEARRELOAD0_SHIFT    (0x00000000u)
N#define CSL_DMAX_FIFORW_LINEARRELOAD0_RESETVAL (0x00000000u)
N
N#define CSL_DMAX_FIFORW_LINEARRELOAD1_MASK     (0xFFFFFFFFu)
N#define CSL_DMAX_FIFORW_LINEARRELOAD1_SHIFT    (0x00000000u)
N#define CSL_DMAX_FIFORW_LINEARRELOAD1_RESETVAL (0x00000000u)
N
N
N#define CSL_DMAX_HIPRIORITY_EVENT         (0x10000000u)
N#define CSL_DMAX_LOPRIORITY_EVENT         (0x20000000u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT0_UID    (0x10000000u)
N#define CSL_DMAX_HIPRIORITY_EVENT1_UID    (0x10100001u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT2_UID    (0x10FF0002u)
N#define CSL_DMAX_HIPRIORITY_RTIREQ0_UID   (0x10FF0002u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT3_UID    (0x10FF0003u)
N#define CSL_DMAX_HIPRIORITY_RTIREQ1_UID   (0x10FF0003u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT4_UID    (0x10FF0004u)
N#define CSL_DMAX_HIPRIORITY_MCASP0TX_UID  (0x10FF0004u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT5_UID    (0x10FF0005u)
N#define CSL_DMAX_HIPRIORITY_MCASP0RX_UID  (0x10FF0005u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT6_UID    (0x10FF0006u)
N#define CSL_DMAX_HIPRIORITY_MCASP1TX_UID  (0x10FF0006u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT7_UID    (0x10FF0007u)
N#define CSL_DMAX_HIPRIORITY_MCASP1RX_UID  (0x10FF0007u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT8_UID    (0x10FF0008u)
N#define CSL_DMAX_HIPRIORITY_MCASP2TX_UID  (0x10FF0008u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT9_UID    (0x10FF0009u)
N#define CSL_DMAX_HIPRIORITY_MCASP2RX_UID  (0x10FF0009u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT10_UID   (0x1001000Au)
N#define CSL_DMAX_HIPRIORITY_EVENT11_UID   (0x1011000Bu)
N
N#define CSL_DMAX_HIPRIORITY_EVENT12_UID   (0x10FF000Cu)
N#define CSL_DMAX_HIPRIORITY_UHPIINT_UID   (0x10FF000Cu)
N
N#define CSL_DMAX_HIPRIORITY_EVENT13_UID   (0x10FF000Du)
N#define CSL_DMAX_HIPRIORITY_SPI0RX_UID    (0x10FF000Du)
N
N#define CSL_DMAX_HIPRIORITY_EVENT14_UID   (0x10FF000Eu)
N#define CSL_DMAX_HIPRIORITY_SPI1RX_UID    (0x10FF000Eu)
N
N#define CSL_DMAX_HIPRIORITY_EVENT15_UID   (0x10FF000Fu)
N#define CSL_DMAX_HIPRIORITY_RTIREQ2_UID   (0x10FF000Fu)
N
N#define CSL_DMAX_HIPRIORITY_EVENT16_UID   (0x10FF0010u)
N#define CSL_DMAX_HIPRIORITY_RTIREQ3_UID   (0x10FF0010u)
N
N
N#define CSL_DMAX_HIPRIORITY_EVENT17_UID   (0x10020011u)
N#define CSL_DMAX_HIPRIORITY_EVENT18_UID   (0x10120012u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT19_UID   (0x10FF0013u)
N#define CSL_DMAX_HIPRIORITY_I2C0XEVT_UID  (0x10FF0013u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT20_UID   (0x10FF0014U)
N#define CSL_DMAX_HIPRIORITY_I2C0REVT_UID  (0x10FF0014U)
N
N#define CSL_DMAX_HIPRIORITY_EVENT21_UID   (0x10FF0015u)
N#define CSL_DMAX_HIPRIORITY_I2C1XEVT_UID  (0x10FF0015u)
N
N
N#define CSL_DMAX_HIPRIORITY_EVENT22_UID   (0x10FF0016u)
N#define CSL_DMAX_HIPRIORITY_I2C1REVT_UID  (0x10FF0016u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT23_UID   (0x10030017u)
N#define CSL_DMAX_HIPRIORITY_EVENT24_UID   (0x10130018u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT26_UID   (0x10FF001Au)
N#define CSL_DMAX_HIPRIORITY_MCASP0ERR_UID (0x10FF001Au)
N
N#define CSL_DMAX_HIPRIORITY_EVENT27_UID   (0x10FF001Bu)
N#define CSL_DMAX_HIPRIORITY_MCASP1ERR_UID (0x10FF001Bu)
N
N#define CSL_DMAX_HIPRIORITY_EVENT28_UID   (0x10FF001Cu)
N#define CSL_DMAX_HIPRIORITY_MCASP2ERR_UID (0x10FF001Cu)
N
N#define CSL_DMAX_HIPRIORITY_EVENT29_UID   (0x10FF001Du)
N#define CSL_DMAX_HIPRIORITY_OVLREQ_UID    (0x10FF001Du)
N
N
N#define CSL_DMAX_HIPRIORITY_EVENT30_UID   (0x1014001Eu)
N#define CSL_DMAX_HIPRIORITY_EVENT31_UID   (0x1015001Fu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT0_UID    (0x20000000u)
N#define CSL_DMAX_LOPRIORITY_EVENT1_UID    (0x20100001u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT2_UID    (0x20FF0002u)
N#define CSL_DMAX_LOPRIORITY_RTIREQ0_UID   (0x20FF0002u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT3_UID    (0x20FF0003u)
N#define CSL_DMAX_LOPRIORITY_RTIREQ1_UID   (0x20FF0003u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT4_UID    (0x20FF0004u)
N#define CSL_DMAX_LOPRIORITY_MCASP0TX_UID  (0x20FF0004u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT5_UID    (0x20FF0005u)
N#define CSL_DMAX_LOPRIORITY_MCASP0RX_UID  (0x20FF0005u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT6_UID    (0x20FF0006u)
N#define CSL_DMAX_LOPRIORITY_MCASP1TX_UID  (0x20FF0006u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT7_UID    (0x20FF0007u)
N#define CSL_DMAX_LOPRIORITY_MCASP1RX_UID  (0x20FF0007u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT8_UID    (0x20FF0008u)
N#define CSL_DMAX_LOPRIORITY_MCASP2TX_UID  (0x20FF0008u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT9_UID    (0x20FF0009u)
N#define CSL_DMAX_LOPRIORITY_MCASP2RX_UID  (0x20FF0009u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT10_UID   (0x2001000Au)
N#define CSL_DMAX_LOPRIORITY_EVENT11_UID   (0x2011000Bu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT12_UID   (0x20FF000Cu)
N#define CSL_DMAX_LOPRIORITY_UHPIINT_UID   (0x20FF000Cu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT13_UID   (0x20FF000Du)
N#define CSL_DMAX_LOPRIORITY_SPI0RX_UID    (0x20FF000Du)
N
N#define CSL_DMAX_LOPRIORITY_EVENT14_UID   (0x20FF000Eu)
N#define CSL_DMAX_LOPRIORITY_SPI1RX_UID    (0x20FF000Eu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT15_UID   (0x20FF000Fu)
N#define CSL_DMAX_LOPRIORITY_RTIREQ2_UID   (0x20FF000Fu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT16_UID   (0x20FF0010u)
N#define CSL_DMAX_LOPRIORITY_RTIREQ3_UID   (0x20FF0010u)
N
N
N#define CSL_DMAX_LOPRIORITY_EVENT17_UID   (0x20020011u)
N#define CSL_DMAX_LOPRIORITY_EVENT18_UID   (0x20120012u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT19_UID   (0x20FF0013u)
N#define CSL_DMAX_LOPRIORITY_I2C0XEVT_UID  (0x20FF0013u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT20_UID   (0x20FF0014U)
N#define CSL_DMAX_LOPRIORITY_I2C0REVT_UID  (0x20FF0014U)
N
N#define CSL_DMAX_LOPRIORITY_EVENT21_UID   (0x20FF0015u)
N#define CSL_DMAX_LOPRIORITY_I2C1XEVT_UID  (0x20FF0015u)
N
N
N#define CSL_DMAX_LOPRIORITY_EVENT22_UID   (0x20FF0016u)
N#define CSL_DMAX_LOPRIORITY_I2C1REVT_UID  (0x20FF0016u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT23_UID   (0x20030017u)
N#define CSL_DMAX_LOPRIORITY_EVENT24_UID   (0x20130018u)
N
N#define CSL_DMAX_LOPRIORITY_EVENT26_UID   (0x20FF001Au)
N#define CSL_DMAX_LOPRIORITY_MCASP0ERR_UID (0x20FF001Au)
N
N#define CSL_DMAX_LOPRIORITY_EVENT27_UID   (0x20FF001Bu)
N#define CSL_DMAX_LOPRIORITY_MCASP1ERR_UID (0x20FF001Bu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT28_UID   (0x20FF001Cu)
N#define CSL_DMAX_LOPRIORITY_MCASP2ERR_UID (0x20FF001Cu)
N
N#define CSL_DMAX_LOPRIORITY_EVENT29_UID   (0x20FF001Du)
N#define CSL_DMAX_LOPRIORITY_OVLREQ_UID    (0x20FF001Du)
N
N
N#define CSL_DMAX_LOPRIORITY_EVENT30_UID   (0x2014001Eu)
N#define CSL_DMAX_LOPRIORITY_EVENT31_UID   (0x2015001Fu)
N
N/* Define dMax Hi and Lo Paramter Table Entry UIDs */
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY0_UID    (0x30000000u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY1_UID    (0x30000001u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY2_UID    (0x30000002u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY3_UID    (0x30000003u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY4_UID    (0x30000004u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY5_UID    (0x30000005u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY6_UID    (0x30000006u)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY7_UID    (0x30000007u)
N
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY0_UID    (0x40000000u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY1_UID    (0x40000001u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY2_UID    (0x40000002u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY3_UID    (0x40000003u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY4_UID    (0x40000004u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY5_UID    (0x40000005u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY6_UID    (0x40000006u)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY7_UID    (0x40000007u)
N
N#define CSL_DMAX_HIPRIORITY_EVENT_ANY				 (0x1000FFFFu)
N#define CSL_DMAX_LOPRIORITY_EVENT_ANY				 (0x2000FFFFu)
N#define CSL_DMAX_HIPRIORITY_PARAMETERENTRY_ANY		 (0x3000FFFFu)
N#define CSL_DMAX_LOPRIORITY_PARAMETERENTRY_ANY		 (0x4000FFFFu)
N#define CSL_DMAX_HI_PRIORITY                         (0x00000001u)
N
N#endif
L 44 "C:/CCStudio_v3.1/C6000/csl/include/soc.h" 2
N
N/*****************************************************************************\
N* Peripheral Instance counts
X
N\*****************************************************************************/
N/* Interrupt Event Ids */
N#define CSL_INTC_EVENTID_RESET           (0)      /**<External device Reset */
N                                                  /**< watchdog Reset */
N                                                  /**< Emulator Reset */
N#define CSL_INTC_EVENTID_NMI             (1)      /**< Dmax nmi output*/
N                                                  /**< EMIF mem_error_pls_int */
N                                                  /**< timeout error */
N#define CSL_INTC_EVENTID_RTI_INT_REQ0    (4)      /**< RTI_INT_REQ[0] */
N#define CSL_INTC_EVENTID_RTI_INT_OVL_REQ (5)      /**<RTI_INT_REQ[1]*/
N                                                  /**< RTI_INT_REQ[2]*/
N                                                  /**<RTI_INT_REQ[3]*/
N                                                  /**< RTI_OVL_REQ[0] */
N                                                  /**<RTI_OVL_REQ[1]*/
N#define CSL_INTC_EVENTID_UHPI            (6)      /**<UHPI_CPU_INT*/
N#define CSL_INTC_EVENTID_DMAXEVTOUT0     (7)      /**< dMAXEVTOUT[0]*/
N#define CSL_INTC_EVENTID_DMAXEVTOUT1     (8)      /**<dMAXEVTOUT[1]*/
N#define CSL_INTC_EVENTID_DMAXEVTOUT2     (9)      /**<dMAXEVTOUT[2] */
N#define CSL_INTC_EVENTID_DMAXEVTOUT3     (10)     /**<dMAXEVTOUT[3]*/
N#define CSL_INTC_EVENTID_DMAXEVTOUT4     (11)     /**< dMAXEVTOUT[4]*/
N#define CSL_INTC_EVENTID_DMAXEVTOUT5     (12)     /**<dMAXEVTOUT[5]*/
N#define CSL_INTC_EVENTID_DMAXEVTOUT6     (13)     /**<dMAXEVTOUT[6]*/
N#define CSL_INTC_EVENTID_I2C             (14)     /**<I2C0INTR*/
N                                                  /**<I2C1INTR*/
N#define CSL_INTC_EVENTID_SPI             (14)     /**< SPI0INT1*/
N                                                  /**< SPI1INT0*/
N                                                  /**< SPI0INT0*/
N                                                  /**<SPI1INT1 */
N#define CSL_INTC_EVENTID_DMAXEVTOUT7     (15)     /**<dMAXEVTOUT[7]*/
N/*****************************************************************************\
N* ADD Channel Instance count
X
N\*****************************************************************************/
N
N/*****************************************************************************\
N* Peripheral Overlay Structures
X
N\*****************************************************************************/
Ntypedef volatile CSL_McaspRegs	         *CSL_McaspRegsOvly;
Ntypedef volatile CSL_PllcRegs       	 *CSL_PllcRegsOvly;
Ntypedef volatile CSL_ChipRegs            *CSL_ChipRegsOvly;
Ntypedef volatile CSL_EmifRegs            *CSL_EmifRegsOvly;
Ntypedef volatile CSL_RtiRegs             *CSL_RtiRegsOvly;
Ntypedef volatile CSL_I2cRegs             *CSL_I2cRegsOvly;
Ntypedef volatile CSL_SpiRegs             *CSL_SpiRegsOvly;
Ntypedef volatile CSL_HpiRegs			 *CSL_UhpiRegsOvly;
Ntypedef volatile CSL_IcacheRegs          *CSL_IcacheRegsOvly;
Ntypedef volatile CSL_DmaxRegs			 *CSL_DmaxRegsOvly;
N
N/*****************************************************************************\
N* Peripheral Base Address
X
N\*****************************************************************************/
N#define CSL_MCASP_0_REGS                 ((CSL_McaspRegsOvly) 	0x44000000)
N#define CSL_MCASP_1_REGS                 ((CSL_McaspRegsOvly) 	0x45000000)
N#define CSL_MCASP_2_REGS                 ((CSL_McaspRegsOvly) 	0x46000000)
N#define CSL_PLLC_0_REGS               	 ((CSL_PllcRegsOvly) 	0x41000000)
N#define CSL_EMIF_0_REGS                  ((CSL_EmifRegsOvly) 	0xF0000000)
N#define CSL_CHIP_0_REGS                  ((CSL_ChipRegsOvly) 	0x20000000)
N#define CSL_RTI_0_REGS  				 ((CSL_RtiRegsOvly) 	0x42000000)
N#define CSL_EMIF_SDRAM_SPACE			 						0x80000000
N#define CSL_I2C_0_REGS  				 ((CSL_I2cRegsOvly) 	0x49000000)
N#define CSL_I2C_1_REGS  				 ((CSL_I2cRegsOvly) 	0x4A000000)
N#define CSL_SPI_0_REGS  				 ((CSL_SpiRegsOvly) 	0x47000000)
N#define CSL_SPI_1_REGS  				 ((CSL_SpiRegsOvly) 	0x48000000)
N#define CSL_UHPI_0_REGS					 ((CSL_UhpiRegsOvly)  	0x43000000)
N#define CSL_ICACHE_0_REGS                ((CSL_IcacheRegsOvly) 	0x20000000)
N#define CSL_DMAX_0_REGS					 ((CSL_DmaxRegsOvly)	0x60000000)
N
N/*****************************************************************************\
N* Peripheral Instance enumeration
X
N\*****************************************************************************/
N/** @brief Peripheral Instance for PLLC  */
N#define CSL_PLLC                             (0) /** Instance 1 of ARMPLLC*/
N
N/** @brief Peripheral Instance for RTI  */
N#define CSL_RTI			                     (0) /** Instance 1 of RTI*/
N
N/** @brief Peripheral Instance for EMIF     */
N#define CSL_EMIF                                (0) /** Instance 1 of EMIF   */
N
N/** @brief Peripheral Instance for Tmr0     */
N#define CSL_TMR_1                               (0) /** Instance 1 of Tmr    */
N
N/** @brief Peripheral Instance for Tmr1     */
N#define CSL_TMR_2                               (1) /** Instance 2 of Tmr    */
N
N/** @brief Peripheral Instance for Tmr2     */
N#define CSL_TMR_3                               (2) /** Instance 3 of Tmr    */
N
N/** @brief Peripheral Instance for WDT      */
N#define CSL_WDT                                 (0) /** Instance of WDT      */
N
N/** @brief Peripheral Instance for I2c0      */
N#define CSL_I2C_0                                 (0) /** Instance of I2c0      */
N
N/** @brief Peripheral Instance for I2c1      */
N#define CSL_I2C_1                                 (1) /** Instance of I2c1      */
N
N/** @brief Peripheral Instance for Spi0      */
N#define CSL_SPI_0                                 (0) /** Instance of Spi0      */
N
N/** @brief Peripheral Instance for Spi1      */
N#define CSL_SPI_1                                 (1) /** Instance of Spi1      */
N
N/** @brief Peripheral Instances for MCASP */
N#define CSL_MCASP_CNT                           (3) /** Instance 1 of MCASP */
N
N/** @brief Peripheral Instance for MCASP */
N#define CSL_MCASP_0                             (0) /** Instance 1 of MCASP */
N
N/** @brief Peripheral Instance for MCASP */
N#define CSL_MCASP_1                             (1) /** Instance 2 of MCASP */
N
N#ifndef C6722
N/** @brief Peripheral Instance for MCASP */
N#define CSL_MCASP_2                             (2) /** Instance 3 of MCASP */
N#endif 
N
N/** @brief Peripheral Instances for UHPI */
N#define CSL_UHPI                            	(0) /** Instance 1 of UHPI */
N
N/** @brief Peripheral Instance for L1P Cache      */
N#define CSL_ICACHE                               (0) /** Instance of L1P Cache  */
N
N/** @brief Peripheral Instance for DMAX  */
N#define CSL_DMAX                                (0) /** Instance of DMAX  */
N
N#endif
N
L 55 ".\csl_spi.h" 2
N#include <cslr_spi.h>
N
N/**************************************************************************\
N* SPI global macro declarations
X
N\**************************************************************************/
N
N
N/**************************************************************************\
N* SPI global typedef declarations
X
N\**************************************************************************/
N
N/** @brief Enumeration for control commands passed to @a CSL_spiHwControl()
N *
N * This is the set of commands that are passed to the @a CSL_spiHwControl()
N * with an optional argument type-casted to @a void* . The arguments to be
N * passed with each enumeration if any are specified next to the enumeration */
Ntypedef enum {
N	/**
N	* @brief   reset the SPI
N	* @param   (None)
N	*/
N	CSL_SPI_CMD_PRI_RESET       =  1,
N
N	/**
N	* @brief   enable DMA transaction capability for DMA in compatibility mode
N	* @param   (None)
N	*/
N	CSL_SPI_CMD_CPT_DMA_ENABLE  =  2,
N
N	/**
N	* @brief   enable DMA transaction capability for DMA in compatibility mode
N	* @param   (None)
N	*/
N	CSL_SPI_CMD_CPT_DMA_DISABLE =  3,
N
N	/**
N	* @brief   write data in argument to SPIDAT0 register for transmitting out
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_CPT_WRITE0      =  4,
N
N	/**
N	* @brief   write data in argument to SPIDAT1 register for transmitting out
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_CPT_WRITE1      =  5,
N
N	/**
N	* @brief   read the data in SPIBUF register to the argument
N	* @param   CSL_SpiCptData*
N	*/
N	CSL_SPI_CMD_CPT_READ        =  6,
N
N	/**
N	* @brief   enable the interrupts in the bit-vector argument
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_INT_ENABLE      =  7,
N
N	/**
N	* @brief   disable the interrupts in the bit-vector argument
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_INT_DISABLE     =  8,
N
N	/**
N	* @brief   set value passed in argument over pins configured as GPIO
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_PINS_VALUE      =  9,
N
N	/**
N	* @brief   set pins passed in bit-vector argument if configured as GPIO
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_PINS_SET        =  10,
N
N	/**
N	* @brief   clear pins passed in bit-vector argument if configured as GPIO
N	* @param   Uint16*
N	*/
N	CSL_SPI_CMD_PINS_CLEAR      =  11,
N
N	/**
N	* @brief   enable the data-transfer section of the SPI
N	* @param   (None)
N	*/
N	CSL_SPI_CMD_XFER_ENABLE     =  12,
N	/**
N	* @brief   disable the data-transfer section of the SPI
N	* @param   (None)
N	*/
N	CSL_SPI_CMD_XFER_DISABLE    =  13
N} CSL_SpiHwControlCmd;
N
N
N/** @brief Enumeration for queries passed to @a CSL_spiGetHwStatus()
N *
N * This is used to get the status of different operations or to get the
N * existing setup of SPI. The arguments to be passed with each enumeration
N * if any are specified next to the enumeration */
Ntypedef enum {
N	/**
N	* @brief   get the value present on the pins as a bit-vector
N	* @param   Uint16*
N	*/
N	CSL_SPI_QUERY_PINS_VALUE        =  1,
N
N	/**
N	* @brief   get value of highest priority int that has occured on INT0 line
N	* @param   CSL_SpiMbfInt*
N	*/
N	CSL_SPI_QUERY_INT_VECTOR0       =  2,
N
N	/**
N	* @brief   get value of highest priority int that has occured on INT1 line
N	* @param   CSL_SpiMbfInt*
N	*/
N	CSL_SPI_QUERY_INT_VECTOR1       =  3,
N                                        
N	/**
N	* @brief   get value of Flag status register
N	* @param   Uint8t*
N	*/    
N    CSL_SPI_QUERY_EVT_STATUS        =  4,
N
N	/**
N	* @brief   get the bit-vector of interrupts that have been enabled
N	* @param   Uint16*
N	*/
N	CSL_SPI_QUERY_INT_ENABLED       =  5,
N
N	/**
N	* @brief   get the status of whether DMA is enabled in compatibility mode
N	* @param   CSL_SpiCptDma*
N	*/
N	CSL_SPI_QUERY_CPT_DMA_ENABLED   =  6
N} CSL_SpiHwStatusQuery;
N
N/** @brief enumeration for Spi general interrupts */
Ntypedef enum {
N	/** interrupt on successful receive */
N	CSL_SPI_INT_RX       =  CSL_FMKT(SPI_SPIINT0_RXINTEN, ENABLE),
X	CSL_SPI_INT_RX       =  ((((0x00000001u)) << (0x00000008u)) & (0x00000100u)),
N	/** interrupt on receiver overrun */
N	CSL_SPI_INT_OVRN     =  CSL_FMKT(SPI_SPIINT0_OVRNINTEN, ENABLE),
X	CSL_SPI_INT_OVRN     =  ((((0x00000001u)) << (0x00000006u)) & (0x00000040u)),
N	/** interrupt on bit error */
N	CSL_SPI_INT_BITERR   =  CSL_FMKT(SPI_SPIINT0_BITERRENA, ENABLE),
X	CSL_SPI_INT_BITERR   =  ((((0x00000001u)) << (0x00000004u)) & (0x00000010u)),
N	/** interrupt on loss of synchronization between master & slave */
N	CSL_SPI_INT_DESYNC   =  CSL_FMKT(SPI_SPIINT0_DESYNCENA, ENABLE),
X	CSL_SPI_INT_DESYNC   =  ((((0x00000001u)) << (0x00000003u)) & (0x00000008u)),
N	/** interrupt on timeout error */
N	CSL_SPI_INT_TIMEOUT  =  CSL_FMKT(SPI_SPIINT0_TIMEOUTENA, ENABLE)
X	CSL_SPI_INT_TIMEOUT  =  ((((0x00000001u)) << (0x00000001u)) & (0x00000002u))
N} CSL_SpiInt;
N
N
N/** @brief enumeration for Spi status bits */
Ntypedef enum {
N	/** indicates that a word has been received in SPIBUF */
N	CSL_SPI_BUFSTATUS_RXINT   =  (1 << 7),
N	/** indicates that receive BUF is empty */
N	CSL_SPI_BUFSTATUS_RXEPTY  =  (1 << 6),
N	/** indicates that overrun occured/not */
N	CSL_SPI_BUFSTATUS_RXOVRN  =  (1 << 5),
N	/** indicates that transmit BUF is full */
N	CSL_SPI_BUFSTATUS_TXFULL  =  (1 << 4),
N	/** indicates that a bit error occurred during transaction */
N	CSL_SPI_BUFSTATUS_BITERR  =  (1 << 3),
N	/** indicates that desynchronization with slave detected */
N	CSL_SPI_BUFSTATUS_DESYNC  =  (1 << 2),
N	/** indicates timeout */
N	CSL_SPI_BUFSTATUS_TMOUT   =  (1 << 0)
N} CSL_SpiBufStatus;
N
N
N/** @brief enumeration to hold the chip select active between 2 transfers */
Ntypedef enum {
N	/** hold chip select active between consecutive transfers */
N	CSL_SPI_CSHOLD_YES  =  CSL_SPI_SPIDAT1_CSHOLD_YES,
X	CSL_SPI_CSHOLD_YES  =  (0x00000001u),
N	/** chip select to be inactivated after the each transfer */
N	CSL_SPI_CSHOLD_NO   =  CSL_SPI_SPIDAT1_CSHOLD_NO
X	CSL_SPI_CSHOLD_NO   =  (0x00000000u)
N} CSL_SpiCsHold;
N
N
N/** @brief enumeration to control applying the format delay to consecutive
N * transfers */
Ntypedef enum {
N	/** enable format delay between 2 consecutive transfers */
N	CSL_SPI_WDELAYEN_YES  =  CSL_SPI_SPIDAT1_WDEL_DELAY,
X	CSL_SPI_WDELAYEN_YES  =  (0x00000001u),
N	/** disable format delay between 2 consecutive transfers */
N	CSL_SPI_WDELAYEN_NO   =  CSL_SPI_SPIDAT1_WDEL_NODELAY
X	CSL_SPI_WDELAYEN_NO   =  (0x00000000u)
N} CSL_SpiWDelayEn;
N
N
N/** @brief enumeration to select the required data transfer format */
Ntypedef enum {
N	/** select format 0 */
N	CSL_SPI_FMTSEL_0  =  CSL_SPI_SPIDAT1_DFSEL_FMT0,
X	CSL_SPI_FMTSEL_0  =  (0x00000000u),
N	/** select format 1 */
N	CSL_SPI_FMTSEL_1  =  CSL_SPI_SPIDAT1_DFSEL_FMT1,
X	CSL_SPI_FMTSEL_1  =  (0x00000001u),
N	/** select format 2 */
N	CSL_SPI_FMTSEL_2  =  CSL_SPI_SPIDAT1_DFSEL_FMT2,
X	CSL_SPI_FMTSEL_2  =  (0x00000002u),
N	/** select format 3 */
N	CSL_SPI_FMTSEL_3  =  CSL_SPI_SPIDAT1_DFSEL_FMT3
X	CSL_SPI_FMTSEL_3  =  (0x00000003u)
N} CSL_SpiFmtSel;
N
N
N/** @brief enumeration to control the dependence of transfer in ENA signal in
N * master mode */
Ntypedef enum {
N	/** if in master mode; wait for ENA signal from slave */
N	CSL_SPI_WAITEN_YES  =  CSL_SPI_SPIFMT_WAITENA_YES,
X	CSL_SPI_WAITEN_YES  =  (0x00000001u),
N	/** do not wait for ENA signal from slave */
N	CSL_SPI_WAITEN_NO   =  CSL_SPI_SPIFMT_WAITENA_NO
X	CSL_SPI_WAITEN_NO   =  (0x00000000u)
N} CSL_SpiWaitEn;
N
N
N/** @brief enumeration to control the polarity of serial clock */
Ntypedef enum {
N	/** clock is low when inactive */
N	CSL_SPI_POLARITY_INACTIVELO = CSL_SPI_SPIFMT_POLARITY_INACTIVELO,
X	CSL_SPI_POLARITY_INACTIVELO = (0x00000000u),
N	/** clock is high when inactive */
N	CSL_SPI_POLARITY_INACTIVEHI = CSL_SPI_SPIFMT_POLARITY_INACTIVEHI
X	CSL_SPI_POLARITY_INACTIVEHI = (0x00000001u)
N} CSL_SpiClkPolarity;
N
N
N/** @brief enumeration to control phase relationship between data & clock */
Ntypedef enum {
N	/** data & clock in phase */
N	CSL_SPI_PHASE_IN   =  CSL_SPI_SPIFMT_PHASE_IN,
X	CSL_SPI_PHASE_IN   =  (0x00000000u),
N	/** data 1/2 cycle before clock */
N	CSL_SPI_PHASE_OUT  =  CSL_SPI_SPIFMT_PHASE_OUT
X	CSL_SPI_PHASE_OUT  =  (0x00000001u)
N} CSL_SpiClkPhase;
N
N
N/** @brief enumeration to control direction of the word during transfer */
Ntypedef enum {
N	/** transfer MSB first */
N	CSL_SPI_SHDIR_MSBFIRST  =  CSL_SPI_SPIFMT_SHIFTDIR_MSBFIRST,
X	CSL_SPI_SHDIR_MSBFIRST  =  (0x00000000u),
N	/** transfer LSB first */
N	CSL_SPI_SHDIR_LSBFIRST  =  CSL_SPI_SPIFMT_SHIFTDIR_LSBFIRST
X	CSL_SPI_SHDIR_LSBFIRST  =  (0x00000001u)
N} CSL_SpiShDir;
N
N
N/** @brief enumeration tocontrol the operating mode of Spi */
Ntypedef enum {
N	/** operate as master */
N	CSL_SPI_OPMOD_MASTER  =  ((CSL_SPI_SPIGCR1_CLKMOD_MASTERMODE << 1) |
X	CSL_SPI_OPMOD_MASTER  =  (((0x00000001u) << 1) |
N				 CSL_SPI_SPIGCR1_MASTER_YES),
X				 (0x00000001u)),
N	/** operate as slave */
N	CSL_SPI_OPMOD_SLAVE   =  ((CSL_SPI_SPIGCR1_CLKMOD_SLAVEMODE << 1) |
X	CSL_SPI_OPMOD_SLAVE   =  (((0x00000000u) << 1) |
N				 CSL_SPI_SPIGCR1_MASTER_NO)
X				 (0x00000000u))
N} CSL_SpiOpMod;
N
N
N/** @brief enumeration to control the SPIENA status when inactive */
Ntypedef enum {
N	/** force SPIENA signal high-z when inactive */
N	CSL_SPI_ENAHIZ_YES  =  CSL_SPI_SPIINT0_ENABLEHIGHZ_ENABLE,
X	CSL_SPI_ENAHIZ_YES  =  (0x00000001u),
N	/** keep SPIENA signal a value when inactive */
N	CSL_SPI_ENAHIZ_NO   =  CSL_SPI_SPIINT0_ENABLEHIGHZ_DISABLE
X	CSL_SPI_ENAHIZ_NO   =  (0x00000000u)
N} CSL_SpiEnaHiZ;
N
N
Ntypedef enum {
N	/* operate on functionality register */
N	CSL_SPI_GPIOTYPE_FUNC      =  0,
N	/* operate on direction register */
N	CSL_SPI_GPIOTYPE_DIR       =  1
N} CSL_SpiGpioType;
N
N
N/** @brief enumeartion for Spi serial communication pins */
Ntypedef enum {
N	/** SOMI pin */
N	CSL_SPI_PINTYPE_SOMI  =  CSL_FMKT(SPI_SPIPC0_SOMIFUN, SPI),
X	CSL_SPI_PINTYPE_SOMI  =  ((((0x00000001u)) << (0x0000000Bu)) & (0x00000800u)),
N	/** SIMO pin */
N	CSL_SPI_PINTYPE_SIMO  =  CSL_FMKT(SPI_SPIPC0_SIMOFUN, SPI),
X	CSL_SPI_PINTYPE_SIMO  =  ((((0x00000001u)) << (0x0000000Au)) & (0x00000400u)),
N	/** CLK pin */
N	CSL_SPI_PINTYPE_CLK   =  CSL_FMKT(SPI_SPIPC0_CLKFUN, SPI),
X	CSL_SPI_PINTYPE_CLK   =  ((((0x00000001u)) << (0x00000009u)) & (0x00000200u)),
N	/** ENA pin */
N	CSL_SPI_PINTYPE_ENA   =  CSL_FMKT(SPI_SPIPC0_ENABLEFUN, SPI),
X	CSL_SPI_PINTYPE_ENA   =  ((((0x00000001u)) << (0x00000008u)) & (0x00000100u)),
N	/** SCS pin */
N	CSL_SPI_PINTYPE_SCS  =  CSL_FMKT(SPI_SPIPC0_SCSFUN0, SPI)
X	CSL_SPI_PINTYPE_SCS  =  ((((0x00000001u)) << (0x00000000u)) & (0x00000001u))
N} CSL_SpiPinType;
N
N
N/** @brief enumeration to control DMA enabling in compatibility mode */
Ntypedef enum {
N	/** enable dma servicing in compatibility mode */
N	CSL_SPI_CPTDMA_ENABLE   =  CSL_SPI_SPIINT0_DMAREQEN_ENABLE,
X	CSL_SPI_CPTDMA_ENABLE   =  (0x00000001u),
N	/** disable dma servicing in compatibility mode */
N	CSL_SPI_CPTDMA_DISABLE  =  CSL_SPI_SPIINT0_DMAREQEN_DISABLE
X	CSL_SPI_CPTDMA_DISABLE  =  (0x00000000u)
N} CSL_SpiCptDma;
N
N
N/** @brief enumeration to control reset of transfer mechnism of Spi */
Ntypedef enum {
N	/** enable spi to begin transfers */
N	CSL_SPI_XFEREN_DISABLE  =  CSL_SPI_SPIGCR1_ENABLE_DISABLE,
X	CSL_SPI_XFEREN_DISABLE  =  (0x00000000u),
N	/** hold spi transfer mechanism in reset */
N	CSL_SPI_XFEREN_ENABLE   =  CSL_SPI_SPIGCR1_ENABLE_ENABLE
X	CSL_SPI_XFEREN_ENABLE   =  (0x00000001u)
N} CSL_SpiXferEn;
N
N
N/** @brief this object contains the reference to the instance of SPI
N * opened using the @a CSL_spiOpen()
N *
N * An object related to this structure is passed to all SPI CSL APIs
N * as the first argument */
Ntypedef struct CSL_SpiObj {
N	/** This is a pointer to the registers of the instance of SPI referred
N	* to by this object */
N	CSL_SpiRegsOvly  regs;
N	/** This is the instance of SPI being referred to by this object */
N	CSL_InstNum       perNum;
N} CSL_SpiObj;
N
N
N/** @brief This will have the base-address information for the peripheral
N *  instance
N */
Ntypedef struct {
N	/** Base-address of the Configuration registers of SPI.
N	*/
N	CSL_SpiRegsOvly regs;
N} CSL_SpiBaseAddress;
N
N/** @brief SPI specific parameters. Present implementation doesn't have
N *  any specific parameters.
N */
Ntypedef struct {
N	/** Bit mask to be used for module specific parameters.
N	*  The below declaration is just a place-holder for future
N	*  implementation.
N	*/
N	CSL_BitMask16   flags;
N} CSL_SpiParam;
N
N/** @brief SPI specific context information. Present implementation doesn't
N *  have any Context information.
N */
N
Ntypedef struct {
N	/** Context information of SPI.
N	*  The below declaration is just a place-holder for future
N	*  implementation.
N	*/
N	Uint16  contextInfo;
N} CSL_SpiContext;
N
N
Ntypedef struct  {
N	volatile Uint32 SPIGCR0;
N	volatile Uint32 SPIGCR1;
N	volatile Uint32 SPIINT0;
N	volatile Uint32 SPILVL;
N	volatile Uint32 SPIFLG;
N	volatile Uint32 SPIPC0;
N	volatile Uint32 SPIPC1;
N	volatile Uint32 SPIPC2;
N	volatile Uint32 SPIPC3;
N	volatile Uint32 SPIPC4;
N	volatile Uint32 SPIPC5;
N	volatile Uint32 SPIDAT0;
N	volatile Uint32 SPIDAT1;
N	volatile Uint32 SPIBUF;
N	volatile Uint32 SPIEMU;
N	volatile Uint32 SPIDELAY;
N	volatile Uint32 SPIDEF;
N	volatile Uint32 SPIFMT[4];
N	volatile Uint32 TGINTVEC[2];
N} CSL_SpiConfig;
N
N/** Default Values for Config structure */
N#define CSL_SPI_CONFIG_DEFAULTS {     \
N        CSL_SPI_SPIGCR0_RESETVAL,     \
N        CSL_SPI_SPIGCR1_RESETVAL,     \
N        CSL_SPI_SPIINT0_RESETVAL,     \
N        CSL_SPI_SPILVL_RESETVAL,      \
N        CSL_SPI_SPIFLG_RESETVAL,      \
N        CSL_SPI_SPIPC0_RESETVAL,      \
N        CSL_SPI_SPIPC1_RESETVAL,      \
N        CSL_SPI_SPIPC2_RESETVAL,      \
N        CSL_SPI_SPIPC3_RESETVAL,      \
N        CSL_SPI_SPIPC4_RESETVAL,      \
N        CSL_SPI_SPIPC5_RESETVAL,      \
N        CSL_SPI_SPIDAT0_RESETVAL,     \
N        CSL_SPI_SPIDAT1_RESETVAL,     \
N        CSL_SPI_SPIBUF_RESETVAL,      \
N        CSL_SPI_SPIEMU_RESETVAL,      \
N        CSL_SPI_SPIDELAY_RESETVAL,    \
N        CSL_SPI_SPIDEF_RESETVAL,      \
N        CSL_SPI_SPIFMT_RESETVAL,      \
N        CSL_SPI_TGINTVECT_RESETVAL    \
N}
X#define CSL_SPI_CONFIG_DEFAULTS {             CSL_SPI_SPIGCR0_RESETVAL,             CSL_SPI_SPIGCR1_RESETVAL,             CSL_SPI_SPIINT0_RESETVAL,             CSL_SPI_SPILVL_RESETVAL,              CSL_SPI_SPIFLG_RESETVAL,              CSL_SPI_SPIPC0_RESETVAL,              CSL_SPI_SPIPC1_RESETVAL,              CSL_SPI_SPIPC2_RESETVAL,              CSL_SPI_SPIPC3_RESETVAL,              CSL_SPI_SPIPC4_RESETVAL,              CSL_SPI_SPIPC5_RESETVAL,              CSL_SPI_SPIDAT0_RESETVAL,             CSL_SPI_SPIDAT1_RESETVAL,             CSL_SPI_SPIBUF_RESETVAL,              CSL_SPI_SPIEMU_RESETVAL,              CSL_SPI_SPIDELAY_RESETVAL,            CSL_SPI_SPIDEF_RESETVAL,              CSL_SPI_SPIFMT_RESETVAL,              CSL_SPI_TGINTVECT_RESETVAL    }
N    
N/** @brief a pointer to @a CSL_SpiObj; this is passed to all SPI CSL
N * APIs */
Ntypedef struct CSL_SpiObj *CSL_SpiHandle;
N
N
N/** @brief sets up the properties if the pins of Spi
N *
N * This object is used to setup or get the setup of the pins in Spi */
Ntypedef struct CSL_SpiHwSetupPins {
N	/** decides if the pins will be Spi or GPIO */
N	Uint16  func;
N	/** if GPIO, decides the directions of the pins */
N	Uint16  dir;
N} CSL_SpiHwSetupPins;
N
N
N/** @brief sets up the format selection for a set of transfers
N *
N * This object is used to setup or get the setup of the format selection
N * for a set of transfers */
Ntypedef struct CSL_SpiHwSetupFmtCtrl {
N	/** decides if chip select is to be held active between transfers */
N	CSL_SpiCsHold    csHold;
N	/** decides if delay specified in the selected format must be allowed
N	* between 2 consecutive transfers */
N	CSL_SpiWDelayEn  wDel;
N	/** decides which format to select */
N	CSL_SpiFmtSel    fmtSel;
N	/** defines the chip select that will be activated for the transfer */
N	Uint8               cSel;
N} CSL_SpiHwSetupFmtCtrl;
N
N
N/** @brief sets up the Spi for compatibility mode
N *
N * This structure is used to setup or get the setup of Spi in comaptibility
N * mode */
Ntypedef struct CSL_SpiHwSetupCpt {
N	/** selects if interrupts should go to lines INT0 or INT1 */
N	Uint32                    *lvl;
N	/** selects the format & associated controls */
N	CSL_SpiHwSetupFmtCtrl  *fmtCtrlPtr;
N} CSL_SpiHwSetupCpt;
N
N
N/** @brief sets up the a formatting for an outgoing word
N *
N * This object is used to set up or get the setup of the format registers in
N * Spi */
Ntypedef struct CSL_SpiHwSetupPriFmt {
N	/** delay between 2 consecutive words */
N	Uint8             wDelay;
N	/** the factor with which to multiply functional clock in order to get the
N	* serial clock */
N	Uint8             preScale;
N	/** the length of the word to be transmitted and/or received */
N	Uint8             charLen;
N	/** if in master mode; whether Spi should wait for ENA from slave */
N	CSL_SpiWaitEn  waitEna;
N	/** whether clock should be high or low when inactive */
N	CSL_SpiClkPolarity  polarity;
N	/** whether data should be in phase of 1/2 cycle ahead of the clock */
N	CSL_SpiClkPhase   phase;
N	/** whether LSB or MSB should be shifted first */
N	CSL_SpiShDir   shiftDir;
N} CSL_SpiHwSetupPriFmt;
N
N
N/** @brief sets up the parameters to be setup in priority mode
N *
N * This object is used to setup or get the setup of the parameters to be setup
N * in priority mode */
Ntypedef struct CSL_SpiHwSetupPri {
N	/** array of pointers to structures of formats of an outgoing word */
N	CSL_SpiHwSetupPriFmt  *fmt[4];
N} CSL_SpiHwSetupPri;
N
N
N/** @brief sets up the parameters that are needed by multi-buffer as well as
N * compatibility modes
N *
N * This objetc is used to set up or get the setup of parameters that are needed
N * by multi-buffer as well as compatibility modes */
Ntypedef struct CSL_SpiHwSetupGen {
N	/** master or slave mode */
N	CSL_SpiOpMod      opMode;
N	/** whether ENA signal should be tristated when inactive or if it should
N	* bear a value */
N	CSL_SpiEnaHiZ     enaHiZ;
N	/** the default value on Chip select when inactive */
N	Uint8                csDefault;
N	/** Chip-select-active-to-transmit-start-delay */
N	Uint8                c2tDelay;
N	/** Transmit-end-to-chip-select-inactive-delay */
N	Uint8                t2cDelay;
N	/** Transmit-data-finished-to-ENA-pin-inactive-time-out */
N	Uint8                t2eTmout;
N	/** Chip-select-active-to-ENA-signal-active-time-out */
N	Uint8                c2eTmout;
N} CSL_SpiHwSetupGen;
N
N
N/** @brief main structure that is used to setup the SPI
N *
N * This structure is used to setup or obtain the existing setup of SPI
N * using @a CSL_spiHwSetup() & @a CSL_spiGetHwStatus() functions
N * respectively. If a particular member pointer is null, then these functions
N * do not setup or get the setup of the corresponding part of SPI
N * respectively */
Ntypedef struct CSL_SpiHwSetup {
N	/** This pointer to @a CSL_SpiHwSetupCommon is used to hold
N	* information on the common part of the SPI setup */
N	CSL_SpiHwSetupGen   *genPtr;
N	/** This pointer to @a CSL_SpiHwSetupFifo is used to hold information
N	* on the data FIFO part of the SPI setup */
N	CSL_SpiHwSetupPri   *priPtr;
N	/** This pointer to @a CSL_SpiHwSetupSdio is used to hold information
N	* on the SDIO part of the SPI setup */
N	CSL_SpiHwSetupCpt   *cptPtr;
N	/** This pointer to @a CSL_SpiHwSetupSdio is used to hold information
N	* on the SPI part of the SPI setup */
N	CSL_SpiHwSetupPins  *pinsPtr;
N} CSL_SpiHwSetup;
N
N
N/** @brief gets the information for interrupt vectors */
Ntypedef struct CSL_SpiIntVec {
N	/** interrupt vector number */
N	Uint8  intVal;
N} CSL_SpiIntVec;
N
N
N/** @brief gets the status of buffer after a transfer */
Ntypedef struct CSL_SpiBufStat {
N	/** status as a bit-vector of the different events */
N	Uint8  status;
N} CSL_SpiBufStat;
N
N
Ntypedef struct CSL_SpiCptData {
N	/** Place to hold the data */
N	Uint16            data;
N	/** Place to hold the status */
N	CSL_SpiBufStat *bufStat;
N} CSL_SpiCptData;
N
N
N/** default setting for @a CSL_SpiHwSetup */
N#define CSL_SPI_HWSETUP_DEFAULTS { 		\
N	NULL,                             	\
N	NULL,                             	\
N	NULL,                             	\
N	NULL                              	\
N}
X#define CSL_SPI_HWSETUP_DEFAULTS { 			NULL,                             		NULL,                             		NULL,                             		NULL                              	}
N
N
N/** default setting for @a CSL_SpiHwSetupGen */
N#define CSL_SPI_HWSETUP_GEN_DEFAULTS {		\
N	CSL_SPI_OPMOD_SLAVE,               	\
N	CSL_SPI_ENAHIZ_NO,                 	\
N	0,                                  	\
N	0,                                  	\
N	0,                                  	\
N	0,                                  	\
N	0                                   	\
N}
X#define CSL_SPI_HWSETUP_GEN_DEFAULTS {			CSL_SPI_OPMOD_SLAVE,               		CSL_SPI_ENAHIZ_NO,                 		0,                                  		0,                                  		0,                                  		0,                                  		0                                   	}
N
N
N/** default setting for @a CSL_SpiHwSetupPri */
N#define CSL_SPI_HWSETUP_PRI_DEFAULTS { 	\
N	NULL,                           \
N	NULL,                           \
N	NULL,                           \
N	NULL                            \
N}
X#define CSL_SPI_HWSETUP_PRI_DEFAULTS { 		NULL,                           	NULL,                           	NULL,                           	NULL                            }
N	
N
N/** default setting for @a CSL_SpiHwSetupPriFmt */
N#define CSL_SPI_HWSETUP_PRI_FMT_DEFAULTS { \
N	0,                                     \
N	0,                                     \
N	0,                                     \
N	CSL_SPI_WAITEN_NO,                     \
N	CSL_SPI_PHASE_IN,                      \
N	CSL_SPI_SHDIR_LSBFIRST                 \
N}
X#define CSL_SPI_HWSETUP_PRI_FMT_DEFAULTS { 	0,                                     	0,                                     	0,                                     	CSL_SPI_WAITEN_NO,                     	CSL_SPI_PHASE_IN,                      	CSL_SPI_SHDIR_LSBFIRST                 }
N
N
N/** default setting for @a CSL_SpiHwSetupCpt */
N#define CSL_SPI_HWSETUP_CPT_DEFAULTS { 		\
N	NULL,                             	\
N	NULL                                	\
N}
X#define CSL_SPI_HWSETUP_CPT_DEFAULTS { 			NULL,                             		NULL                                	}
N
N
N/** default setting for @a CSL_SpiHwSetupFmtCtrl */
N#define CSL_SPI_HWSETUP_FMTCTRL_DEFAULTS { 	\
N	CSL_SPI_CSHOLD_NO,                     	\
N	CSL_SPI_WDELAYEN_NO,                   	\
N	CSL_SPI_FMTSEL_0,                      	\
N	0,                                     	\
N}
X#define CSL_SPI_HWSETUP_FMTCTRL_DEFAULTS { 		CSL_SPI_CSHOLD_NO,                     		CSL_SPI_WDELAYEN_NO,                   		CSL_SPI_FMTSEL_0,                      		0,                                     	}
N
N
N/** default setting for @a CSL_SpiHwSetupPins */
N#define CSL_SPI_HWSETUP_PINS_DEFAULTS { 	\
N	NULL,                               	\
N	NULL                                	\
N}
X#define CSL_SPI_HWSETUP_PINS_DEFAULTS { 		NULL,                               		NULL                                	}
N
N/** ===========================================================================
N *   @func CSL_spiOpen
N *
N *   @desc
N *        This function populates the peripheral data object for the instance
N *        and returns a handle to the instance.
N *        The open call sets up the data structures for the particular instance
N *        of SPI device. The device can be re-opened anytime after it has been
N *        normally closed if so required. SPI Hardware setup will be performed
N *        at the end of the open call only if the HwSetup Pointer supplied was
N *        non-NULL. The handle returned by this call is input as an essential
N *        argument for rest of the APIs described for this module.
N *
N *   @arg pSpiObj
N *        Pointer to the SPI instance object
N *
N *   @arg spiNum
N *        Instance of the SPI to be opened.
N *
N *   @arg pSpiParam
N *        Pointer to module specific parameters
N *
N *   @arg pStatus
N *        pointer for returning status of the function call
N *
N *   @ret CSL_SpiHandle
N *        Valid SPI instance handle will be returned if status value is
N *        equal to CSL_SOK.
N *
N *   @eg
N *        CSL_Status        status;
N *        CSL_SpiObj        spiObj;
N *        CSL_SpiHandle     hSpi;
N *
N *        hSpi = CSL_spiOpen (&spiObj,
N *                            CSL_SPI_0,
N *                            NULL,
N *                            &status
N *                            );
N *
N * ===========================================================================
N */
N/** @brief opens if possible the instance of SPI requested */
NCSL_SpiHandle CSL_spiOpen(
N	/** pointer to the object that holds reference to the instance of SPI
N	* requested after the call */
N	CSL_SpiObj                            *hSpiObj,
N	/** instance of SPI to which a handle is requested */
N	CSL_InstNum                           spiNum,
N	/** specifies if SPI should be opened with excusive or share access to
N	* the associate pins */
N	CSL_SpiParam                          *pSpiParam,
N	/** This returns the status (success/errors) of the call */
N	CSL_Status                            *status
N);
N
N/** ===========================================================================
N *   @func CSL_spiClose
N *
N *   @b Description
N *   @n Unreserves the SPI identified by the handle.
N *
N *   @arg  hSpi
N           Handle to the Spi instance
N *
N *   @ret CSL_Status
N *         CSL_SOK            - Close successful
N *         CSL_ESYS_BADHANDLE - Invalid handle
N *
N *   <b> Pre Condition </b>
N *   @n  Both @a CSL_spiInit() and @a CSL_spiOpen() must be called successfully
N *       in that order before @a CSL_spiClose() can be called.
N *
N *   <b> Post Condition </b>
N *   @n  None.
N *
N *   @b Example
N *   @verbatim
N        CSL_SpiHandle       hSpi;
N        ...
N        status = CSL_spiClose (hSpi);
N        ...
N     @endverbatim
N * =============================================================================
N */
NCSL_Status  CSL_spiClose(
N    /** Pointer to the object that holds reference to the
N    *  instance of SPI requested after the call
N    */
N
N    CSL_SpiHandle                         hSpi
N);
N
N/** ============================================================================
N *   @n@b CSL_spiHwSetup
N *
N *   @b Description
N *   @n It configures the SPI registers as per the values passed
N *      in the hardware setup structure.
N *
N *   @b Arguments
N *   @verbatim
N            hSpi            Handle to the Spi instance
N 
N            setup         Pointer to harware setup structure
N 
N     @endverbatim
N *
N *   <b> Return Value </b>  CSL_Status
N *   @li                    CSL_SOK             - Hardware setup successful
N *   @li                    CSL_ESYS_BADHANDLE  - Invalid handle
N *   @li                    CSL_ESYS_INVPARAMS  - Hardware structure is not
N                                                  properly initialized
N *
N *   <b> Pre Condition </b>
N *   @n  None
N *
N *   <b> Post Condition </b>
N *   @n  SPI controller registers are configured according 
N *       to the hardware setup parameters
N *
N *   @b Modifies
N *   @n SPI controller registers
N *
N *   @b Example
N *   @verbatim
N            CSL_SpiHandle   hSpi;
N            CSL_SpiHwSetup  hwSetup;
N            CSL_status      status;
N
N            ...
N            
N            status = CSL_spiHwSetup(hSpi, &hwSetup);
N            
N            
N     @endverbatim
N * ===========================================================================
N */
N/** @brief programs the SPI to a useful state as specified */
NCSL_Status  CSL_spiHwSetup(
N    /** pointer to the object that holds reference to the instance of SPI
N    * requested after the call */
N    CSL_SpiHandle                         hSpi,
N    /** pointer to setup structure which contains the information to program
N    * SPI to a useful state */
N    CSL_SpiHwSetup                        *setup
N);
N
N/** ============================================================================
N *   @n@b CSL_spiGetHwSetup
N *
N *   @b Description
N *   @n It retrives the hardware setup parameters of the SPI instance
N *      specified by the given handle.
N *
N *   @b Arguments
N *   @verbatim
N            hSpi        Handle to the SPI intance
N 
N            hwSetup      Pointer to the harware setup structure
N 
N     @endverbatim
N *
N *   <b> Return Value </b>  CSL_Status
N *   @li                    CSL_SOK             - Retrieving the hardware setup
N *                                                parameters is successful
N *   @li                    CSL_ESYS_BADHANDLE  - The handle is passed is
N *                                                invalid
N *   @li                    CSL_ESYS_INVPARAMS  - Invalid parameter
N *
N *   <b> Pre Condition </b>
N *   @n  None
N *
N *   <b> Post Condition </b>
N *   @n  Hardware setup parameters are returned in the hwSetup variable
N *
N *   @b Modifies
N *   @n hwSetup variables
N *
N *   @b Example
N *   @verbatim
N            CSL_SpiHandle   hSpi;
N            CSL_SpiHwSetup  hwSetup;
N
N            ...
N            
N            status = CSL_SpiGetHwSetup(hSpi, &hwSetup);
N            
N            ...
N            
N     @endverbatim
N * ===========================================================================
N */
NCSL_Status  CSL_spiGetHwSetup(
N    /** pointer to the object that holds reference to the
N    * instance of SPI requested after the call */
N    CSL_SpiHandle                         hSpi,
N    /** the query to this API which indicates the status/setup
N    * to be returned */
N    CSL_SpiHwSetup                        *setup
N);
N
N/** ============================================================================
N *   @n@b CSL_spiHwControl
N *
N *   @b Description
N *   @n Takes a command of SPI with an optional argument & implements it.
N *
N *   @b Arguments
N *   @verbatim
N            hSpi        Handle to the SPI instance
N
N            cmd             The command to this API indicates the action to be
N                            taken on SPI.
N
N            arg             An optional argument.
N
N     @endverbatim
N *
N *   <b> Return Value </b>  CSL_Status
N *   @li         CSL_SOK               - Status info return successful.
N *   @li         CSL_ESYS_BADHANDLE    - Invalid handle
N *   @li         CSL_ESYS_INVCMD       - Invalid command
N *   @li         CSL_ESYS_INVPARAMS    - Invalid parameter
N *   @li         CSL_ESYS_NOTSUPPORTED - Action Not Supported
N *
N *   <b> Pre Condition </b>
N *   @n  None
N *
N *   <b> Post Condition </b>
N *   @n  None
N *
N *   @b Modifies
N *   @n The hardware registers of SPI.
N *
N *   @b Example
N *   @verbatim
N        CSL_SpiHandle         hSpi;
N        CSL_SpiHwControlCmd   cmd=CSL_SPI_CMD_CPT_DMA_ENABLE;
N        void                      arg;
N
N        status = CSL_spiHwControl (hSpi, cmd, &arg);
N
N     @endverbatim
N * =============================================================================
N */
N/** @brief controls the different operations that can be performed by
N * SPI */
NCSL_Status  CSL_spiHwControl(
N    /** pointer to the object that holds reference to the instance of SPI
N    * requested after the call */
N    CSL_SpiHandle                         hSpi,
N    /** the command to this API which indicates the action to be taken */
N    CSL_SpiHwControlCmd                   cmd,
N    /** an optional argument @a void* casted */
N    void                                     *arg
N);
N
N
N/** ============================================================================
N *   @n@b CSL_spiInit
N *
N *   @b Description
N *   @n This is the initialization function for the SPI. This function is 
N *   idempotent in that calling it many times is same as calling it once. This 
N *   function does not modify any registers or check status. It returns status 
N *   CSL_SOK. It has been kept for future use.
N *
N *   @b Arguments
N     @verbatim
N            pContext   Context information for the instance. Should be NULL
N     @endverbatim
N *
N *   <b> Return Value </b>  CSL_Status
N *   @li                    CSL_SOK - Always returns
N *
N *   <b> Pre Condition </b>
N *   @n  CSL_sysInit() must be called. 
N *
N *   <b> Post Condition </b>
N *   @n  None
N *
N *   @b Modifies
N *   @n  None
N *
N *   @b Example
N *   @verbatim
N		
N	CSL_Status 	Status		
N	Status = CSL_spiInit();
N
N   @endverbatim
N *  ===========================================================================
N */
NCSL_Status  CSL_spiInit(
N    CSL_SpiContext * pContext
N);
N
N
N/** ===========================================================================
N *   @func CSL_spiHwSetupRaw
N *
N *   @desc
N *       This function configures the registers of SPI as per the values given
N *       in the Config structure.
N *
N *   @arg hSpi
N *        Handle to the SPI instance
N *
N *   @arg hwConfig
N *        Pointer to SPI config structure
N *
N *   @ret CSL_Status
N *         CSL_SOK             - Configuration successful
N *         CSL_ESYS_BADHANDLE  - Invalid handle
N *
N *   @eg
N *
N *        CSL_Status            status;
N *        CSL_SpiConfig     hwConfig;
N *
N *        status = CSL_spiHwsetupRaw (hSpi, &hwConfig);
N *
N * ===========================================================================
N */
N
Nextern CSL_Status  CSL_spiHwSetupRaw (
N    CSL_SpiHandle           hSpi,
N    CSL_SpiConfig *         config
N);
N
N/** ============================================================================
N *   @n@b CSL_spiGetHwStatus
N *
N *   @b Description
N *   @n Gets the status of the different settings of SPI instance.
N *
N *   @b Arguments
N *   @verbatim
N            hSpi      Handle to the SPI instance
N
N            query      The query to this API of SPI which indicates the
N                       status to be returned.
N
N            response   Placeholder to return the status.
N
N     @endverbatim
N *
N *   <b> Return Value </b>  CSL_Status
N *   @li                    CSL_SOK             - Status info return successful
N *   @li                    CSL_ESYS_BADHANDLE   - Invalid handle
N *   @li                    CSL_ESYS_INVQUERY    - Invalid query command
N *   @li                    CSL_ESYS_INVPARAMS   - Invalid parameter
N *   @li                    CSL_ESYS_NOTSUPPORTED- Action Not Supported
N *  
N *   <b> Pre Condition </b>
N *   @n  None
N *
N *   <b> Post Condition </b>
N *   @n  None
N *
N *   @b Modifies
N *   @n None
N *
N *   @b Example
N *   @verbatim
N        CSL_SpiHandle          hSpi;
N        CSL_SpiHwStatusQuery   query=CSL_SPI_QUERY_INT_VECTOR0;
N        CSL_SpiIntVec                   reponse;
N
N        status = CSL_spiGetHwStatus (hSpi, query, &response);
N
N     @endverbatim
N * =============================================================================
N */
NCSL_Status  CSL_spiGetHwStatus(
N    /** pointer to the object that holds reference to the instance of SPI
N    * requested after the call */
N    CSL_SpiHandle                         hSpi,
N    /** the query to this API which indicates the status/setup to be
N    * returned */
N    CSL_SpiHwStatusQuery                  query,
N    /** placeholder to return the status; @a void* casted */
N    void                                     *response
N);
N
N/** ===========================================================================
N *   @n@b CSL_spiGetBaseAddress
N *
N *   @b Description
N *   @n  Function to get the base address of the peripheral instance.
N *       This function is used for getting the base address of the peripheral
N *       instance. This function will be called inside the CSL_spiOpen()
N *       function call. This function is open for re-implementing if the user
N *       wants to modify the base address of the peripheral object to point to
N *       a different location and there by allow CSL initiated write/reads into
N *       peripheral MMR's go to an alternate location.
N *
N *   @b Arguments
N *   @verbatim
N            spiNum          Specifies the instance of SPI to be opened.
N
N            pSpiParam       Module specific parameters.
N
N            pBaseAddress    Pointer to baseaddress structure containing base
N                            address details.
N
N     @endverbatim
N *
N *   <b> Return Value </b>  CSL_Status
N *   @li                    CSL_OK             Open call is successful
N *   @li                    CSL_ESYS_FAIL      The instance number is invalid.
N *	 @li					CSL_ESYS_INVPARAMS Invalid Parameters passed
N *
N *   <b> Pre Condition </b>
N *   @n  None
N *
N *   <b> Post Condition </b>
N *   @n  Base Address structure is populated
N *
N *   @b Modifies
N *   @n    1. The status variable
N *
N *         2. Base address structure is modified.
N *
N *   @b Example
N *   @verbatim
N        CSL_Status              status;
N        CSL_SpiBaseAddress  baseAddress;
N
N       ...
N      status = CSL_spiGetBaseAddress(CSL_SPI_0, NULL, &baseAddress);
N
N    @endverbatim
N * ============================================================================
N */
Nextern CSL_Status   CSL_spiGetBaseAddress (
N    CSL_InstNum            spiNum,
N    CSL_SpiParam *         pSpiParam,
N    CSL_SpiBaseAddress *   pBaseAddress
N);
N
N#ifdef __cplusplus
S}
N#endif
N
N#endif /* _CSL_SPI_H_ */
L 73 "progSpi.c" 2
N
N
N/**============================================================================
N SPI Commands
N*=============================================================================*/
N 
N
N#define SPI_WRITE_CMD  0x02   
N#define SPI_WREN_CMD   0x06
N#define SPI_READ_CMD   0x03
N#define SPI_WRDI_CMD   0x04
N#define SPI_RDSR_CMD   0x05
N
N#define SPI_RXEMPTY       0x80000000
N#define SPI_TXFULL        0x20000000
N#define SPI_DATABITS      0x0000FFFF 
N#define SPI_ENABLE        0x01000000
N#define SPI_WRITE_MASK    0xFFFF
N#define BITS_PER_SHOT     16
N
N
N/**============================================================================
N  Function prototypes
N*=============================================================================*/
N
Nunsigned int spiReadStatus(CSL_SpiHandle  hSpi);
Nunsigned int spiReadWord(CSL_SpiHandle  hSpi, unsigned int *addr);
Nunsigned int spiWriteEnable(CSL_SpiHandle  hSpi);
Nunsigned int spiWriteDisable(CSL_SpiHandle  hSpi);
Nunsigned int spiWriteWord(CSL_SpiHandle  hSpi, unsigned int data, unsigned int addr);
Nextern void TIBootSetup(void);
N/**============================================================================
N  Global Symbol Declarations
N*=============================================================================*/
N
NFILE           *aisIn;
Nchar           *fileName = "..\\..\\blinkLed4\\blinkLed4.ais";
Nunsigned int   writeVal;
Nunsigned short write_val;
Nunsigned int   readVal;
N
Nunsigned int   eepromAddr;
NCSL_Status     status, status0, status1, status2;
Nunsigned short eepromCmd;
Nunsigned short wordCnt, errCnt;
Nunsigned int   readWord,writeVal;
Nunsigned int   spi_cmd;
N
Nunsigned int   aisData[2048];
N
NCSL_SpiCptData bufData;
NCSL_SpiObj     mySpiObj;
NCSL_SpiHandle  hSpi;
NCSL_SpiConfig  mySpiCfg = CSL_SPI_CONFIG_DEFAULTS;
XCSL_SpiConfig  mySpiCfg = { (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x00000000u), (0x80000000u), (0x00000000u), (0x00000000u), (0x00000001u), (0x00000000u), (0x00000000u) };
N
Nvoid main(void) {
N    int i;
N
N	/* Configure PLL */
N
N	TIBootSetup();
N
N    /* CSL Initialization */
N	CSL_chipInit(NULL);
X	CSL_chipInit(0);
N
N	/* Initialize CSL SPi Module */
N	CSL_spiInit(NULL);
X	CSL_spiInit(0);
N
N	/* Open Resource for SPI0 */
N	hSpi = CSL_spiOpen(&mySpiObj, CSL_SPI_0, NULL, &status);
X	hSpi = CSL_spiOpen(&mySpiObj, (0), 0, &status);
N	
N	if (status == CSL_SOK) {
X	if (status == (1)) {
N		/*=========================
N		 * Configure SPI
N		 * SPIPC0   = 0x00000E00
N		 * SPIPC1   = 0x00000001
N		 * SPIGCR1  = 0x00000003
N		 * SPIFMT0  = 0x0002FF10
N		 * SPIDELAY = 0x06021030
N		 * SPIPC3   = 0x00000001
N		 *========================*/     
N		hSpi->regs->SPIGCR0 = 1;   
N		hSpi->regs->SPIPC0 = 0x00000E00;
N		                  // ((CSL_SPI_SPIPC0_SOMIFUN_SPI << CSL_SPI_SPIPC0_SOMIFUN_SHIFT) |
N		                  // (CSL_SPI_SPIPC0_SIMOFUN_SPI << CSL_SPI_SPIPC0_SIMOFUN_SHIFT) |
N		                  // (CSL_SPI_SPIPC0_CLKFUN_SPI << CSL_SPI_SPIPC0_CLKFUN_SHIFT));
N		                  
N		hSpi->regs->SPIPC1 =  0x00000001; 
N		                   //(CSL_SPI_SPIPC1_SCSDIR0_OUT << CSL_SPI_SPIPC1_SCSDIR0_SHIFT);
N		
N		hSpi->regs->SPIGCR1 = 0x00000003;
N		                    //((CSL_SPI_SPIGCR1_CLKMOD_INTERNAL << CSL_SPI_SPIGCR1_CLKMOD_SHIFT) |
N		                    //(CSL_SPI_SPIGCR1_MASTER_YES << CSL_SPI_SPIGCR1_MASTER_SHIFT));
N		                    
N	    hSpi->regs->SPIFMT[0] = 0x0002FF10;
N//	    hSpi->regs->SPIFMT[0] = 0x0002FF08;
N
N		                      //((0x10 << CSL_SPI_SPIFMT_CHARLEN_SHIFT)|
N		                      //(0XFF << CSL_SPI_SPIFMT_PRESCALE_SHIFT) |
N		                      //(CSL_SPI_SPIFMT_POLARITY_INACTIVELO  << CSL_SPI_SPIFMT_POLARITY_SHIFT));
N		                    
N		hSpi->regs->SPIDELAY = 0x06021030;
N		                      //((0x30 << CSL_SPI_SPIDELAY_C2EDELAY_SHIFT) |
N		                      //(0x10 << CSL_SPI_SPIDELAY_T2EDELAY_SHIFT) |
N		                      //(0x2 << CSL_SPI_SPIDELAY_T2CDELAY_SHIFT) |
N		                      //(0x06 << CSL_SPI_SPIDELAY_C2TDELAY_SHIFT));
N		                     
N		hSpi->regs->SPIPC3 = 0x00000001;
N		                     //CSL_SPI_SPIPC3_SCSDOUT0_HI << CSL_SPI_SPIPC3_SCSDOUT0_SHIFT;
N		
N		hSpi->regs->SPIGCR1 |= SPI_ENABLE;
X		hSpi->regs->SPIGCR1 |= 0x01000000;
N		
N		
N		// Read SPI Status Word //
N		eepromAddr = 0;
N		errCnt = 1;
N		
N			/* Open AIS file for reading */		
N	    aisIn = fopen(fileName,"r");
N		            
N	    if (aisIn != NULL) 
X	    if (aisIn != 0) 
N	    { 
N	       eepromAddr = 0;
N	       status = 0;
N		   wordCnt = 0;
N		   errCnt = 0;
N	       printf ("Programming SPI Device\n");
N
N	       while ((fscanf(aisIn, "%x", &writeVal)!=EOF)) 
X	       while ((fscanf(aisIn, "%x", &writeVal)!=(-1))) 
N	       {
N		
N		      aisData[wordCnt] = writeVal;
N 
N              status = spiWriteEnable(hSpi);
N			  asm("\t nop 5"); 
N			          
N		      status = spiWriteWord(hSpi, writeVal, eepromAddr);
N			
N
N		      eepromAddr += 4;		 
N
N			  ++wordCnt;
N           }
N
N           printf ("SPI Progamming complete\n");
N		   spiWriteDisable(hSpi);
N
N            eepromAddr = 0;
N
N            printf ("\tVerifying .... \n");
N
N            for(i=0;i<wordCnt;++i) 
N            {
N		       readWord = spiReadWord(hSpi, &eepromAddr);
N			   if (readWord != aisData[i])
N			   {
N		           printf ("\t\tError at address[0x%08X], Wrote = 0x%08X, Read = 0x%08X\n", 
N		                  eepromAddr, aisData[i], readWord);
N						  errCnt++;
N			   }
N			   eepromAddr += 4;
N		    }			   
N              
N       } 
N       else 
N       {
N	       printf ("Could not open AIS file for reading\n");
N       }
N           
N	   if (errCnt == 0) 
N	   {
N	     printf("Verification Complete - Program Successful\n");
N	   } 
N	   else
N	   {
N	     printf("!!!Warning : SPI Not Programmed\n");
N	   }
N	}
N}
N
N
Nunsigned int spiReadStatus(CSL_SpiHandle  hSpi){
N
N	unsigned int noElements = 1;
N	unsigned int read_value=0;
N	unsigned int count=0;
N	unsigned int shiftWriteBits = 16;
N	unsigned int spi_cmd;
N
N    spi_cmd = SPI_RDSR_CMD << 24;
X    spi_cmd = 0x05 << 24;
N	
N	while(noElements--)
N	{
N
N		hSpi->regs->SPIPC3 =  0x0; //Make chip select low
N
N        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
X        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & 0xFFFF );
N		hSpi->regs->SPIDAT0 = write_val; //((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
N		
N		while(hSpi->regs->SPIBUF & SPI_RXEMPTY);  ////Wait      	
X		while(hSpi->regs->SPIBUF & 0x80000000);  
N		hSpi->regs->SPIPC3 =  0x1;     // SCS is output pin     
N		                	
N		read_value |= ( ((hSpi->regs->SPIBUF) & SPI_DATABITS) & 0xff )<<(count);
X		read_value |= ( ((hSpi->regs->SPIBUF) & 0x0000FFFF) & 0xff )<<(count);
N		count+=8;			
N		spi_cmd += 256;   //i.e. (1 << 8);					
N	}
N	
N	return read_value;																																						
N}
N
N
Nunsigned int spiReadWord(CSL_SpiHandle  hSpi, unsigned int *addr){
N
N	unsigned int noElements = 4;
N	unsigned int read_value=0;
N	unsigned int count=0;
N	unsigned int shiftWriteBits = 16;
N	unsigned int spi_cmd;
N	unsigned int spiAddr;
N
N    spi_cmd = SPI_READ_CMD << 24;
X    spi_cmd = 0x03 << 24;
N	spiAddr = *addr;
N	spi_cmd |= (spiAddr << 8);
N	
N	while(noElements--)
N	{
N
N
N		hSpi->regs->SPIPC3 =  0x0; //Make chip select low
N
N        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
X        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & 0xFFFF );
N		hSpi->regs->SPIDAT0 = write_val; //((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
N		
N		while((hSpi->regs->SPIBUF) & SPI_TXFULL);
X		while((hSpi->regs->SPIBUF) & 0x20000000);
N
N		while(hSpi->regs->SPIBUF & SPI_RXEMPTY);  ////Wait      	
X		while(hSpi->regs->SPIBUF & 0x80000000);  
N
N        write_val = spi_cmd & 0xffff ;//| ((localData >> 24) & 0xFF);
N		hSpi->regs->SPIDAT0 = write_val; // Write next data
N
N		while(hSpi->regs->SPIBUF & SPI_RXEMPTY);  ////Wait      	
X		while(hSpi->regs->SPIBUF & 0x80000000);  
N		hSpi->regs->SPIPC3 =  0x1;     // SCS is output pin     
N		                	
N		read_value |= ( ((hSpi->regs->SPIBUF) & SPI_DATABITS) & 0xff )<<(count);
X		read_value |= ( ((hSpi->regs->SPIBUF) & 0x0000FFFF) & 0xff )<<(count);
N		count+=8;			
N		spi_cmd += 256;  //i.e. (1 << 8);					
N	}
N	
N	return read_value;																																						
N}
N
Nunsigned int spiWriteEnable(CSL_SpiHandle  hSpi){
N
N	unsigned int shiftWriteBits = 16;
N	unsigned int spi_cmd;
N
N    spi_cmd = SPI_WREN_CMD << 24;
X    spi_cmd = 0x06 << 24;
N	
N
N		hSpi->regs->SPIPC3 =  0x0; //Make chip select low
N
N        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
X        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & 0xFFFF );
N		hSpi->regs->SPIDAT0 = write_val; //((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
N		
N		while((hSpi->regs->SPIBUF) & SPI_TXFULL);
X		while((hSpi->regs->SPIBUF) & 0x20000000);
N		
N		hSpi->regs->SPIDAT0 = spi_cmd & 0x0000ffff; // Write next data
N		while(hSpi->regs->SPIBUF & SPI_RXEMPTY);  ////Wait      	
X		while(hSpi->regs->SPIBUF & 0x80000000);  
N		hSpi->regs->SPIPC3 =  0x1;     // SCS is output pin     
N		                						
N	
N	return 0;																																						
N}
N
N
Nunsigned int spiWriteDisable(CSL_SpiHandle  hSpi){
N
N	unsigned int shiftWriteBits = 16;
N	unsigned int spi_cmd;
N
N    spi_cmd = SPI_WRDI_CMD << 24;
X    spi_cmd = 0x04 << 24;
N	
N
N		hSpi->regs->SPIPC3 =  0x0; //Make chip select low
N
N        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
X        write_val = (unsigned short)((spi_cmd >> shiftWriteBits) & 0xFFFF );
N		hSpi->regs->SPIDAT0 = write_val; //((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
N		
N		while((hSpi->regs->SPIBUF) & SPI_TXFULL);
X		while((hSpi->regs->SPIBUF) & 0x20000000);
N		
N		hSpi->regs->SPIDAT0 = spi_cmd & 0x0000ffff; // Write next data
N		while(hSpi->regs->SPIBUF & SPI_RXEMPTY);  ////Wait      	
X		while(hSpi->regs->SPIBUF & 0x80000000);  
N		hSpi->regs->SPIPC3 =  0x1;     // SCS is output pin     
N		                						
N	
N	return 0;																																						
N}
N
N
N
Nunsigned int spiWriteWord(CSL_SpiHandle  hSpi, unsigned int data, unsigned int addr){
N
N	unsigned int spiAddr;
N	unsigned int localData;
N	unsigned int i;
N
N	spiAddr = addr;
N	localData = data;
N
N 	 
N    for(i=0; i< 4; ++i)
N	{
N	  status = spiWriteEnable(hSpi);
N	  asm("\t nop 5");  
N	  
N	  hSpi->regs->SPIPC3 =  0x0; //Make chip select low
N
N      write_val = ((SPI_WRITE_CMD << 8) | ((spiAddr & 0xFF00) >> 8)) & 0xFFFF;
X      write_val = ((0x02 << 8) | ((spiAddr & 0xFF00) >> 8)) & 0xFFFF;
N	  hSpi->regs->SPIDAT0 = write_val; //((spi_cmd >> shiftWriteBits) & SPI_WRITE_MASK );
N	
N	  while((hSpi->regs->SPIBUF) & SPI_TXFULL);
X	  while((hSpi->regs->SPIBUF) & 0x20000000);
N      while((hSpi->regs->SPIBUF) & SPI_RXEMPTY);
X      while((hSpi->regs->SPIBUF) & 0x80000000);
N	
N      write_val = (spiAddr & 0xff) << 8 | (localData & 0xff);//| ((localData >> 24) & 0xFF);
N      hSpi->regs->SPIDAT0 = write_val; // Write next data
N
N      while((hSpi->regs->SPIBUF) & SPI_RXEMPTY);
X      while((hSpi->regs->SPIBUF) & 0x80000000);
N
N      write_val = (((spiAddr & 0xFF) << 8) | (localData & 0xff));//| ((localData >> 24) & 0xFF);
N      hSpi->regs->SPIDAT0 = write_val; // Write next data
N
N      asm ("\t nop 5");
N
N	  hSpi->regs->SPIPC3 =  0x1;     // SCS is output pin
N
N      asm ("\t nop 5");
N
N      status2 = 1;
N 		  
N	  while(status2)
N	  {
N 	      status2 = spiReadStatus(hSpi);
N	      status2 &= 1;
N 	  }
N			
N      spiAddr += 1;
N	  localData = localData >> 8;
N
N    }		                			
N	return 0;																																						
N}
